#pragma once
#include "armbase.h"

class APIBacesArm :
	public ArmBase
{
public:
	APIBacesArm(void);
	virtual ~APIBacesArm(void);

	virtual bool ConnectToArm(const int dof);
	virtual BOOL DisconnectFromHardware();

	virtual void DoPostInitOperations();

	virtual int GetButtonCount();

	virtual BOOL GetAllData();
	virtual BOOL GetPos();	// and button states
	virtual BOOL GetJoints(bool simulate=true);

	virtual void DoCal();
	virtual void ProbeCalSet();

	virtual BOOL IsAPIBacesAxxis() {return TRUE;}

	///////////////////////////////////////////////
	// hardware interface level....
private:

	DWORD buttontime;
	BOOL LongDown;

	bool CreateBacesInstance();
	BOOL ReleaseBacesInstance();

	int OpenCommPort(CString port);
	int CloseCommPort();
	
	int ReadParamFile(CString path);
	int ResetBacesEncoders();

	int ReadPositionAndButtonStates();
	int ReadPositionAndButtonStatesAndProbeDiameter();
	int ReadJointAngles();
};
