#include "stdafx.h"
#include "ArmPoint.h"
#include "../DPCMM.h"
#include "../ArmBase.h"

ArmPoint::ArmPoint(void)
{
	Joints.Create(app.pA->DOF);
}

ArmPoint::ArmPoint(const ArmPoint& aPt)
{
	operator=(aPt);
}
ArmPoint::ArmPoint(const Vector& pt, const Vector& norm, const GenVec& jts)
{
	ArmPoint ap;

	ap.x = pt.x;
	ap.y = pt.y;
	ap.z = pt.z;

	ap.Normal = norm;
	ap.Joints.Create(app.pA->DOF);
	ap.Joints = jts;

	operator=(ap);
}

ArmPoint::~ArmPoint(void)
{
}

void ArmPoint::operator=(const ArmPoint& r)
{
	Vector::operator=(r);

	Normal = r.Normal;
	Joints = r.Joints;
}

Vector ArmPoint::GetPoint()
{
	Vector pt(x,y,z);
	return pt;
}

void ArmPoint::Debug()
{   
	TRACE(_T("ArmPoint:  ( %f, %f, %f )\n"),x,y,z);
	TRACE(_T("Normal:  ( %f, %f, %f )\n"),Normal.x,Normal.y,Normal.z);
	TRACE(_T("Joints:\n"));
	Joints.Debug();
}

void ArmPoint::Serialize(CArchive& ar)
{
	Vector::Serialize(ar);
	Joints.Serialize(ar);
	Normal.Serialize(ar);

	BYTE Schema = 0;
	BYTE LoadSchema = 0;
	if (ar.IsStoring())
	{ 
		ar << Schema;
	}
	else
	{
		ar >> LoadSchema;
	}
} 
IMPLEMENT_SERIAL( ArmPoint, Vector, 0 );