#pragma once
#include "afx.h"
#include "ArmPoint.h"

class ArmPointArray :
	public CObject
{
public:
	ArmPointArray(void);
	virtual ~ArmPointArray(void);

	CTypedPtrArray <CObArray, ArmPoint*> P;		

	ArmPoint* operator[](INT_PTR key) const
	{
		return P[key];
	}
	ArmPoint& Get(INT_PTR key) const
	{
		return *P[key];
	}
	INT_PTR Add(const ArmPoint& aPt);	// adds a new copy of this ArmPoint to the array... not too efficient.
	void Append(const ArmPointArray& other);		// copy other array and add to current.
	INT_PTR GetSize() const
	{return P.GetSize();}
	INT_PTR GetUpperBound() const
	{return P.GetUpperBound();}

	void Scale(double s);
	void Average( Vector* avg ) const;
	Vector Average() const;
	BOOL StandardDeviationMeanZero( Vector* stddev );

	void Copy( ArmPointArray* pDest) const;
	virtual ArmPointArray& operator=(const ArmPointArray& vec);
	void SetFromVectorArray(const VectorArray& Input, const Transform& objectToInstrument);	// NO normal or joint angle info
	void Clear();

	INT_PTR GetVectorArrayofPoints(VectorArray& pts);
	INT_PTR GetVectorArrayofNormals(VectorArray& norms);

	virtual void Serialize(CArchive& ar);	
protected:
	DECLARE_SERIAL( ArmPointArray );
};
