#pragma once
#include "afx.h"

class JointValues;
class NamedJointSet;

class ArticulatedArmWrapper :
	public CObject
{
public:
	ArticulatedArmWrapper(void);
	virtual ~ArticulatedArmWrapper(void);

	bool GetArmTransform(Transform& t);
	bool DriveToArmTransform(const Transform& t);
	bool GetArmJointValues(GenVec& jv);
	bool DriveToArmJointValues(const GenVec& jv);
	bool DriveToNamedJtSet(const CString& name);

	void PopJtDrive();
	void PopFrameDrive();
	void ManageJtSets();

	bool AddNamedJtSet(const GenVec& jv);	// contains ui to set name
	bool GetJointSetNames(CStringArray& names);
	bool GetJointSetFromName(const CString& name, NamedJointSet& njs) const;
	bool GetJointSetIndexFromName(const CString& name, int& index) const;
	bool RemoveJointSet(const int& index);
	void ClearJointSets();

	CTypedPtrArray<CObArray, NamedJointSet*> JointSetArray;
	void Serialize(CArchive& ar);	
protected:
	DECLARE_SERIAL( ArticulatedArmWrapper );
};
