// C:\_Bruce\@Projects\PCMM Arms\Articulated\DFrameDrive.cpp : implementation file
//

#include "stdafx.h"
#include "../DPCMM.h"
#include "DFrameDrive.h"
#include ".\dframedrive.h"
#include "ArticulatedArmWrapper.h"

// DFrameDrive dialog

IMPLEMENT_DYNAMIC(DFrameDrive, CDialog)
DFrameDrive::DFrameDrive(ArticulatedArmWrapper& _parent)
: parent(_parent)
, posX(0)
, posY(0)
, posZ(0)
, rotX(0)
, rotY(0)
, rotZ(0)
, posInc(5)
, rotInc(3)
{
}

DFrameDrive::~DFrameDrive()
{
}

void DFrameDrive::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_Y, posY);
	DDX_Text(pDX, IDC_EDIT_X, posX);
	DDX_Text(pDX, IDC_EDIT_Z, posZ);
	DDX_Text(pDX, IDC_EDIT_RX, rotX);
	DDX_Text(pDX, IDC_EDIT_RY, rotY);
	DDX_Text(pDX, IDC_EDIT_RZ, rotZ);
	DDX_Text(pDX, IDC_EDIT_LIN_INC, posInc);
	DDX_Text(pDX, IDC_EDIT_ANG_INC, rotInc);
}


BEGIN_MESSAGE_MAP(DFrameDrive, CDialog)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_X, OnDeltaposSpinX)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_Y, OnDeltaposSpinY)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_Z, OnDeltaposSpinZ)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RX, OnDeltaposSpinRx)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RY, OnDeltaposSpinRy)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RZ, OnDeltaposSpinRz)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnBnClickedButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnBnClickedButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnBnClickedButtonRead)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, OnBnClickedButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_FRAME_TO_SA, OnBnClickedButtonFrameToSa)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULT, OnBnClickedButtonDefault)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, OnBnClickedButtonApply)
END_MESSAGE_MAP()


// DFrameDrive message handlers

BOOL DFrameDrive::OnInitDialog()
{
	CDialog::OnInitDialog();

	// set dlg icon to match main dlg...
	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);

	//motors_button.SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_STOP));

	OnBnClickedButtonRead();	// display current values

	//CStringArray velocities;
	//if(parent.GetTextForVelocitySet(velocities))
	//	for(int j=0; j<velocities.GetSize(); j++)
	//		velCombo.AddString(velocities.GetAt(j));

	//CString velUnit;
	//parent.GetTextForVelocitySetLabel(velUnit);
	//velSetLabel.SetWindowText(velUnit);

	//velCombo.SetCurSel(velocityIndex);

	TRANSLATE_DIALOG;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void DFrameDrive::OnDeltaposSpinX(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	posX -= (double)pNMUpDown->iDelta*posInc;
	UpdateData(FALSE);	
	*pResult = 0;
}

void DFrameDrive::OnDeltaposSpinY(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	posY -= (double)pNMUpDown->iDelta*posInc;
	UpdateData(FALSE);
	*pResult = 0;
}

void DFrameDrive::OnDeltaposSpinZ(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	posZ -= (double)pNMUpDown->iDelta*posInc;
	UpdateData(FALSE);
	*pResult = 0;
}

void DFrameDrive::OnDeltaposSpinRx(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	rotX -= (double)pNMUpDown->iDelta*rotInc;
	UpdateData(FALSE);
	*pResult = 0;
}

void DFrameDrive::OnDeltaposSpinRy(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	rotY -= (double)pNMUpDown->iDelta*rotInc;
	UpdateData(FALSE);
	*pResult = 0;
}

void DFrameDrive::OnDeltaposSpinRz(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	rotZ -= (double)pNMUpDown->iDelta*rotInc;
	UpdateData(FALSE);
	*pResult = 0;
}

void DFrameDrive::OnBnClickedButtonStop()
{
	// TODO: Add your control notification handler code here
}

void DFrameDrive::OnBnClickedButtonReset()
{
	// TODO: Add your control notification handler code here
}

void DFrameDrive::OnBnClickedButtonRead()
{
	Transform t;
	if(!parent.GetArmTransform(t))
		return;
	Vector pos, rot;
	t.GetTranslation(&pos);
	t.GetRotation(&rot);
	posX = pos.x;
	posY = pos.y;
	posZ = pos.z;
	rotX = rot.x;
	rotY = rot.y;
	rotZ = rot.z;
	UpdateData(FALSE);
}

void DFrameDrive::OnBnClickedButtonWrite()
{
	UpdateData();
	Vector pos(posX, posY, posZ);
	Vector rot(rotX, rotY, rotZ);
	Transform t;
	t.SetTranslation(pos);
	t.SetRotation(rot);
	if(!parent.DriveToArmTransform(t))
		AfxMessageBox(_T("Could not drive to frame position."), MB_ICONERROR);
}

void DFrameDrive::OnBnClickedButtonFrameToSa()
{
	// TODO: Add your control notification handler code here
}

void DFrameDrive::OnBnClickedButtonDefault()
{
	OnBnClickedButtonApply();
}

void DFrameDrive::OnBnClickedButtonApply()
{
	// TODO: Add your control notification handler code here
}
