// C:\_Bruce\@Projects\PCMM Arms\Articulated\DManageJtSets.cpp : implementation file
//

#include "stdafx.h"
#include "../DPCMM.h"
#include "DManageJtSets.h"
#include ".\dmanagejtsets.h"
#include "ArticulatedArmWrapper.h"

// DManageJtSets dialog

IMPLEMENT_DYNAMIC(DManageJtSets, CDialog)
DManageJtSets::DManageJtSets(ArticulatedArmWrapper& _parent)
: parent(_parent)
{
}

DManageJtSets::~DManageJtSets()
{
}

void DManageJtSets::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_JT_SETS, list);
}


BEGIN_MESSAGE_MAP(DManageJtSets, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_ITERATE_ALL, OnBnClickedButtonIterateAll)
	ON_BN_CLICKED(IDC_BUTTON_ITERATE_SELECTED, OnBnClickedButtonIterateSelected)
	ON_BN_CLICKED(IDC_DELETE_SEL, OnBnClickedDeleteSel)
	ON_BN_CLICKED(IDC_DELETE_ALL, OnBnClickedDeleteAll)
END_MESSAGE_MAP()


// DManageJtSets message handlers

BOOL DManageJtSets::OnInitDialog()
{
	CDialog::OnInitDialog();

	// set dlg icon to match main dlg...
	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);

	UpdateList();

	TRANSLATE_DIALOG;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void DManageJtSets::UpdateList()
{
	list.ResetContent();
	CStringArray names;
	if(parent.GetJointSetNames(names))
		for(int i=0; i<names.GetSize(); i++)
			list.AddString(names.GetAt(i));
}

void DManageJtSets::OnBnClickedButtonIterateAll()
{
	int ct = list.GetCount();
	CString name;
	for(int i=0; i<ct; i++)
	{
		list.GetText(i, name);
		parent.DriveToNamedJtSet(name);
	}
}

void DManageJtSets::OnBnClickedButtonIterateSelected()
{
	int ct = list.GetCount();
	CString name;
	for(int i=0; i<ct; i++)
	{
		if(list.GetSel(i)<=0)
			continue;
		list.GetText(i, name);
		parent.DriveToNamedJtSet(name);
	}
}

void DManageJtSets::OnBnClickedDeleteSel()
{
	int ct = list.GetCount();
	int idx = list.GetCurSel();
	if(idx < 0 || idx > list.GetCount()-1)
		return;
	int riIndex = -1;
	CString name;
	list.GetText(idx, name);
	if(parent.GetJointSetIndexFromName(name, riIndex))
		parent.RemoveJointSet(riIndex);
	UpdateList();
}

void DManageJtSets::OnBnClickedDeleteAll()
{
	parent.ClearJointSets();
	UpdateList();
}
