#pragma once
#include "afx.h"

class JointValues :
	public CObject
{
private:
	enum	{ num_joints = 7 };	

public:
	JointValues(void);
	JointValues( const JointValues& jnt );
	virtual ~JointValues(void);

	virtual JointValues& operator=(const JointValues& jnt);
	void operator-=(const JointValues& jnt);
	void operator+=(const JointValues& jnt);
	void operator*=(const double& mult);

	double operator[](int idx) const;
	double GetValue(int idx) const;
	void SetValue(int idx, double value);
	void SetAll(double value);
	int GetSize() const;

	void GetAsGenVec(GenVec& gv);
	void SetFromGenVec(const GenVec& gv);

	void GetAsCommaDelimitedCstring(CString& jts);
	bool SetFromCommaDelimitedCString(const CString& jts);

	virtual void Debug();

	void Serialize(CArchive& ar);	

protected:
	DECLARE_SERIAL( JointValues );

	double val[num_joints];		// degrees
};
