#include "stdafx.h"
#include "RomerArm.h"
#include ".\cimcorewindowsmessenger.h"

IMPLEMENT_DYNAMIC(CimCoreWindowsMessenger, CWnd)
CimCoreWindowsMessenger::CimCoreWindowsMessenger(RomerArm* _owner)
: owner(*_owner)
{
	windowValid = false;
}

CimCoreWindowsMessenger::~CimCoreWindowsMessenger(void)
{
}

bool CimCoreWindowsMessenger::MakeValidWindow()
{
	// create our window
	CString strClassName;
	strClassName = AfxRegisterWndClass( NULL, 0, 0, 0 );
	if ( !CreateEx(0, strClassName, _T("CimCoreWinMessengerWnd"), WS_POPUP, 0, 0, 0, 0, NULL, NULL) )
		return false;
	windowValid = true;
	return true;
}

BEGIN_MESSAGE_MAP(CimCoreWindowsMessenger, CWnd)
END_MESSAGE_MAP()

LRESULT CimCoreWindowsMessenger::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message == CLOSE_SCAN_DLG)
		owner.trackScanDlg.CloseDialog();

	if(message == SEND_BUFFERED_DATA_AND_RECONNECT)
		owner.SendBufferedCloudDataAndReconnect();

	if(message == UPDATE_SCAN_DLG)
		owner.OnUpdateScanDlg();

	return CWnd::WindowProc(message, wParam, lParam);
}
