// CircleObj.cpp: implementation of the CircleObj class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CircleObj.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CircleObj::CircleObj()
{
	maxerr = 0.0;
}

CircleObj::~CircleObj()
{

}

BOOL CircleObj::ComputeCircle(VectorArray* pVA,int InsideOutsideNeither)
{
	if(pVA->GetSize()<3)
	{
		//pRomerDlg->Beep(CALC_OK);
		return FALSE;
	}
	OptimizationParameters opt;
	// circle FIT
	FitCircle fc;
	fc.pPoints = pVA;
	fc.pOpt = &opt;

	// 2001.02.14 this isn't working, so the radius is just hard-coded below
/*	if(app.saarm.Data.LockCircles)
	{
		fc.VaryRad = FALSE;
		if(InsideOutsideNeither == 0) //inside
			fc.Radius = (app.saarm.Data.CircleLockVal-(app.saarm.Data.TipDia/2.0));
		else if(InsideOutsideNeither == 1) //outside
			fc.Radius = (app.saarm.Data.CircleLockVal+(app.saarm.Data.TipDia/2.0));
		else if(InsideOutsideNeither == 2) //neither
			fc.Radius = app.saarm.Data.CircleLockVal;
	}
*/
	Vector stat;
	if(!( fc.Calculate(&stat) ))		// run optimization.
		return FALSE;
	
	//display residuals	
//	Vector CenterXYZ;
//	CenterXYZ = fc.Center;
//	CenterXYZ.Scale(app.saarm.units.UnitToMeters[DISTUNITS_IN]);
//	double radmeters = fc.Radius*app.saarm.units.UnitToMeters[DISTUNITS_IN];
//	stat.Scale(app.saarm.units.UnitToMeters[DISTUNITS_IN]);

	Vector AveDir = app.pA->ComputeAvgDirection();

	if(AveDir.Dot(fc.Normal)>0)
		fc.Normal.Scale(-1.0);

	center = fc.Center;
	radius = fc.Radius;
	normal = fc.Normal;
	rmserr = stat.z;
	maxerr = stat.x;

	// make the frame (transform) to send
	Vector ZAxis(fc.Normal);

	Vector Origin(center);
	Vector Temp;
	Temp = *pVA->P[0];
//	Temp.Scale(app.saarm.units.UnitToMeters[DISTUNITS_IN]);
	Temp.Sub(center);
	Temp.Normalize();
	Vector YAxis;
	YAxis.Cross(ZAxis,Temp);
	YAxis.Normalize();
	Vector XAxis;
	XAxis.Cross(YAxis,ZAxis);
	XAxis.Normalize();
	t.SetRotation(XAxis,YAxis,ZAxis);
	t.SetTranslation(Origin);

	TRACE3("CircleObj, Center: X=%f,Y=%f,Z=%f", center.x,center.y,center.z);

	Vector CenterDisplay;
	app.saarm.InstToWorking.Multiply(center, &CenterDisplay);
	CenterDisplay.Scale(1.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);

	centerinfo.Format(_T("Center: %f, %f, %f %s"), CenterDisplay.x, CenterDisplay.y, CenterDisplay.z,
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	normalinfo.Format(_T("Normal: %f, %f, %f"), normal.x, normal.y, normal.z);

	switch(InsideOutsideNeither)
	{
	case 0:
		{
			radius += app.saarm.Data.TipDia/2.0;
			break;
		}
	case 1:
		{
			radius -= app.saarm.Data.TipDia/2.0;
			break;
		}
	case 2:
		{
			break;
		}
	}
	if( app.saarm.Data.LockCircles )
	{
		radius = app.saarm.Data.CircleLockVal;	// code above doesn't work, just set the radius for now
		radiusinfo.Format(_T("Radius[locked]: %f %s"),
			radius/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	}
	else
		radiusinfo.Format(_T("Radius: %f %s"),
			radius/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);

	maxerrinfo.Format(_T("MaxErr: %f"),
		maxerr/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);
	rmserrinfo.Format(_T("RMSErr: %f %s"), 
		rmserr/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);

	return TRUE;
}
