//HEADER FILE
#define ASCII_XON       0x11
#define ASCII_XOFF      0x13

#define UPDATE 0
#define REGVAR 1
#define REGFNC 2
#define ENDREG 3

#define NORMAL_TRIGGER_MODE  0
#define VOLTAGE_TRIGGER_MODE 1
#define BALLBAR_TRIGGER_MODE 2

#define CMM_UPDATE_DETECT  0x01
#define CMM_TIMEOUT_DETECT 0x02
#define CMM_ERROR_DETECT   0x04
#define CMM_MOUSE_DETECT   0x08

#define DLL_OPEN_CMM			1
#define DLL_CLOSE_CMM			2
#define DLL_ARM_INFO			3
#define DLL_PROBE_DIAM			4
#define DLL_POS_UPDATE			5
#define DLL_END_UPDATE			6
#define DLL_DIALOG_CMM			7
#define DLL_TOOLBAR_INFO		8
#define DLL_CALIBRATE_DIALOG    9 
#define DLL_CALIBRATE_ENTER		10
#define DLL_CALIBRATE_HOLE		11
#define DLL_CALIBRATE_SPHERE	12
#define DLL_SET_PROBE			13
#define MOUSE_MODE_ON			14
#define MOUSE_MODE_OFF			15
#define KEY_MODE_ON				16
#define KEY_MODE_OFF			17
#define DLL_SETTINGS_DIALOG		18
#define DLL_TEMPERATURE_DIALOG	19
#define DLL_ANGLES_DIALOG		20
#define DLL_TERMINAL_DIALOG		21
#define DLL_HELP_DIALOG			22
#define DLL_UNITS_IN			23
#define DLL_UNITS_MM			24


#define MAX(a,b) ((a)>(b) ? (a): (b))
#define MIN(a,b) ((a)<(b) ? (a): (b))

#define WINPROC LRESULT CALLBACK
#define WINDOWS_PARAMS HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam

#define M_PI 3.14159265358979323846

#define BACKBUTTON_CENTERS   0
#define BACKBUTTON_AS_RIGHT  1
#define BACKBUTTON_AS_CENTER 2

#define FLIP_HORZ 0x1
#define FLIP_VERT 0x2
#define SWAP_AXIS 0x4

//*********
//TYPE DEFS
//*********
struct PositionUpdate{
	int 		nType;		// = DLL_POS_UPDATE;
	char		cUpdateFlag;
	unsigned	uFnumber;
	char		cFrontButton;
	char		cBackButton;
	double		lfPosition[8];
	HANDLE		hPositionUpdateEvent;
};

struct float_transform{
	float position_vector[3];
	float euler[3];
};

struct vArmInfo{
	int	   nFuncType;
	char   sArmData[32];
	char   sCalibrationDate[32];
	int	   nSerindVersion;
	float  fUnits;
};

struct vProbeDiam{
	int    nFuncType;
	double lfEndEffectorXYZ[4][3];	
	double lfEndEffectorDiameter[4];
	double lfEndEffectorError;
	int    nCurrentEndEffector;
};

struct vOpenInfo{
	int  nFuncType;
	HWND hWnd;
	TCHAR sSaveDir[128];
	void (*HelpCallBack)();
};

struct vKeyMode{
	int nFuncType;
	int nFrontButton;
	int nBackButton;
};

struct vToolBarButton{
	TCHAR strName[32];
	int (*func)(HWND);
};

struct vToolBarInfo{
	int nFuncType;
	int nNumFunctions;
	struct vToolBarButton *pButtons;
};

struct vChangeProbe {
	int nFuncType;    // = DLL_SET_PROBE;
	int nProbe;
	double lfDiameter;
};



