// DAutoProxMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DPCMM.h"
#include "DAutoProxMeas.h"


// DAutoProxMeas dialog


DAutoProxMeas::DAutoProxMeas(CWnd* pParent /*=NULL*/)
: DGenMeas(DAutoProxMeas::IDD, pParent)
{
	simCtr = 0;
}

DAutoProxMeas::~DAutoProxMeas()
{
}

void DAutoProxMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_AUTOPROX_TIP_TEXT, tipTextCtrl);
}


BEGIN_MESSAGE_MAP(DAutoProxMeas, DGenMeas)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// DAutoProxMeas message handlers

BOOL DAutoProxMeas::Init() 
{
	sendfromdlg = TRUE;
	guidedmeas = TRUE;
	autoproxmeas = TRUE;

	CString tipText;
	if (!app.saarm.Data.useShankForAutoProxMeas)
	{
		tipText.Format(_T("Tip Dia: %f %s"),
			app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	}
	else
	{
		tipText.Format(_T("Shank Dia: %f %s"),
			app.saarm.Data.shankRadius*2.0/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	}
	tipTextCtrl.SetWindowText(tipText);

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;
}

BOOL DAutoProxMeas::ProcessNewData(int inc)
{
	currXYZ.x = app.pA->X;
	currXYZ.y = app.pA->Y;
	currXYZ.z = app.pA->Z;

	if(!app.pA->ConnectedToArm)
	{
		simCtr++;
		if(simCtr % 10 == 0)
		{
			if(simData.GetSize() > 0)
			{
				HoseData(simData.Get(0), currXYZ);
				simData.P.RemoveAt(0);
			}
		}
	}
	CString targ;
	double dist = 0.0;
	double tol = 0.0;
	Vector resVecOrg, resVecEnd;
	bool isVecPos = false;
	Vector currXYZInches = currXYZ;
	currXYZInches.Scale(app.saarm.LocalToInches);
	Vector goalPointForWatch, measPointForWatch, closestNomPt, closestNomVector;

	if (!app.saarm.Data.useShankForAutoProxMeas)
	{
		bool ckOK = samp.CheckPoint(currXYZInches, app.saarm.Data.TipDia*app.saarm.LocalToInches/2.0, 
			true, samp.measureOnce ? true : false, true,
			targ, dist, tol, closestNomPt,closestNomVector, resVecOrg, resVecEnd, isVecPos, 
			goalPointForWatch, measPointForWatch);
		//TRACE3("pt '%s', dist=%f, tol=%f\n", targ, dist, tol);
		//double dummyProxTol, dummyAxisTol, workingFieldTol;
		//samp.GetTolerances(dummyProxTol, dummyAxisTol, workingFieldTol);
		//app.saarm.Data.GoodProximity = tol * app.saarm.InchesToLocal;
		//app.saarm.Data.proxWorkingField = workingFieldTol * app.saarm.InchesToLocal;
		//app.saarm.SetScreamerParams();

		app.saarm.ScreamThis(dist * app.saarm.InchesToLocal);
		if(inc != 0)	// 2007.08.13 - then the user has hit the meas button, and we now want to support forcing meas with the arm button
			ckOK = true;
		if(ckOK)
		{
			app.pA->MeasToSpan(currXYZ, samp.destGroup, targ);
			MessageBeep(MB_ICONASTERISK);
		}
	}
	else
	{
		Vector probeVec(app.pA->II, app.pA->JJ, app.pA->KK);
		double shankRadInches = app.saarm.Data.shankRadius / app.saarm.InchesToLocal;
		bool ckOK = samp.CheckShankVector(currXYZInches, probeVec, shankRadInches,
			true, samp.measureOnce ? true : false, true,
			targ, dist, tol, closestNomPt, closestNomVector, resVecOrg, resVecEnd, isVecPos,
			goalPointForWatch, measPointForWatch);

		app.saarm.ScreamThis(dist * app.saarm.InchesToLocal);
		if(inc != 0)
			ckOK = true;
		if(ckOK)
		{
			resVecEnd.Scale(app.saarm.InchesToLocal);
			app.pA->MeasToSpan(resVecEnd, samp.destGroup, targ);
			MessageBeep(MB_ICONASTERISK);
		}
	}

	return TRUE;
}

void DAutoProxMeas::SetSimulationDataArray(const VectorArray& _simData)
{
	simData = _simData;
	//for(int i=0; i<simData.GetSize(); i++)
	//	simData.Get(i).Debug();
}

void DAutoProxMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if(app.saarm.units.toolBarModeOn)
		ShowWindow(SW_MINIMIZE); //SW_HIDE
	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DAutoProxMeas"),this);	
}

void DAutoProxMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DAutoProxMeas"),this);

	DGenMeas::OnDestroy();
}
