#pragma once

#include "Resource.h"
#include "DGenMeas.h"
#include "afxwin.h"
#include "afxcmn.h"

// DAvgPointsMeas dialog

class DAvgPointsMeas : public DGenMeas
{
	DECLARE_DYNAMIC(DAvgPointsMeas)

public:
	DAvgPointsMeas(CWnd* pParent = NULL);   // standard constructor
	virtual ~DAvgPointsMeas();

	virtual BOOL Init();
	virtual BOOL ProcessNewData(int inc);
	void UpdateFields();
	virtual void SetStreamIndicator(BOOL strm);
	virtual void ProcessAccept();

	void UpdateSamplesInfo();
	void ClearFields();

	// simulation mode
	virtual BOOL MakeFakeData(int step);

	CString AvgXText;
	CString AvgYText;
	CString AvgZText;

// Dialog Data
	enum { IDD = IDD_AVGPOINTMEAS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDestroy();
	CButton B1short_button;
	CButton B1long_button;
	CButton B2short_button;
	CButton B2long_button;
	CString tip;
	afx_msg void OnBnClickedButtonOneshort();
	afx_msg void OnBnClickedButtonOnelong2();
	afx_msg void OnBnClickedButtonTwoshort();
	afx_msg void OnBnClickedButtonTwolong();
	NewColorStatic StreamIndicator;
	CStatic pointInfoStatic;

private:
	int pointsMeasured;
	int samplesTaken;
	Vector currentPoint;
public:
	CProgressCtrl prog_samples;
	CStatic samplesStatic;
	afx_msg void OnBnClickedDefault();
	CStatic rmsErrStatic;
};
