// DCalFaro.cpp : implementation file
//

#include "stdafx.h"
#include "DPCMM.h"
#include "DPCMMDlg.h"
#include "DCalFaro.h"

#include "Example.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DCalFaro dialog


DCalFaro::DCalFaro(CWnd* pParent /*=NULL*/)
	: CDialog(DCalFaro::IDD, pParent)
{
	//{{AFX_DATA_INIT(DCalFaro)
	//}}AFX_DATA_INIT
}


void DCalFaro::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DCalFaro)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DCalFaro, CDialog)
	//{{AFX_MSG_MAP(DCalFaro)
	ON_BN_CLICKED(IDC_PROBECAL, OnProbeCal)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DCalFaro message handlers

BOOL DCalFaro::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//LOAD THE FaroArm DLL AND MAP CmmSpecific
	hCommLib = LoadLibrary(_T("FaroArm.dll"));
	if(hCommLib)
	{
		TRACE0("Right, go!\n");
		CmmSpecific = (BOOL (*)(VOID *))GetProcAddress(hCommLib,"CmmSpecific");
	}
	if(CmmSpecific == NULL)
	{
		TRACE0("Ah crap!\n");
		CmmSpecific = (BOOL (*)(VOID *))FalseSpecific;
	}

	if((hCommLib == NULL)||(CmmSpecific == NULL)){
		AfxMessageBox(Tr("FaroArm.dll not found"));
	}

	bOnLine = FALSE;
	if(bOnLine == FALSE)
	{
		struct vOpenInfo vTemp = {DLL_OPEN_CMM, m_hWnd, _T("\0"), CallHelp};
		DWORD dwInTime = GetTickCount();
		lstrcpy(vTemp.sSaveDir, CA2T(sExecutionDirectory));
		do{
			if(bOnLine = (TRUE == CmmSpecific((void *)&vTemp))) break;
		}while((GetTickCount() - dwInTime) < 1000);

		if(bOnLine == FALSE) 
		{
			AfxMessageBox(Tr("Open failed"));
			return FALSE;
		}
	}

	TCHAR sTemp[128];
	struct vArmInfo vInfo = {DLL_ARM_INFO};
	CmmSpecific((void *)&vInfo);

	SetDlgItemText(IDC_SN, CA2T(vInfo.sArmData));
	SetDlgItemText(IDC_CD, CA2T(vInfo.sCalibrationDate));
	wsprintf(sTemp,_T("%3.2f"),(float)vInfo.nSerindVersion / 100.0f);
	SetDlgItemText(IDC_VN, sTemp);
//	sprintf(sTemp,"%f",vInfo.fUnits);
//	SetDlgItemText(IDC_UN, sTemp);	

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	TRANSLATE_DIALOG;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
BOOL FalseSpecific(void *ptr)
{
	return(FALSE);
}
void CallHelp()
{	
//	WinHelp(NULL, "cmmfaro.hlp", HELP_CONTENTS, 0L);
}

void DCalFaro::OnProbeCal() 
{
	int nTemp = DLL_CALIBRATE_DIALOG;
	switch(CmmSpecific((void *)&nTemp)){
		case DLL_CALIBRATE_HOLE:
			nTemp = DLL_CALIBRATE_HOLE;
			if(TRUE == CmmSpecific((void *)&nTemp)){
				nTemp = DLL_CALIBRATE_DIALOG;
				CmmSpecific((void *)&nTemp);
			}
		break;
		case DLL_CALIBRATE_SPHERE:
			nTemp = DLL_CALIBRATE_SPHERE;
			if(TRUE == CmmSpecific((void *)&nTemp)){
				nTemp = DLL_CALIBRATE_DIALOG;
				CmmSpecific((void *)&nTemp);
			}
		break;
		case DLL_CALIBRATE_ENTER:
			nTemp = DLL_CALIBRATE_ENTER;
			if(TRUE == CmmSpecific((void *)&nTemp)){
				nTemp = DLL_CALIBRATE_DIALOG;
				CmmSpecific((void *)&nTemp);
			}
		break;
	}
}

void DCalFaro::OnDestroy() 
{	
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DCalFaro"),this);

	int nTemp = DLL_CLOSE_CMM;
	CmmSpecific((void *)&nTemp);

	if(hCommLib) FreeLibrary(hCommLib);
	hCommLib = NULL;

	CDialog::OnDestroy();
}

void DCalFaro::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void DCalFaro::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DCalFaro"),this);	
}