// DCircleMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DCircleMeas.h"
#include ".\dcirclemeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DCircleMeas dialog


DCircleMeas::DCircleMeas(CWnd* pParent /*=NULL*/)
: DGenMeas(DCircleMeas::IDD, pParent)
{
	title.Format(Tr("Circle Measurement"));
	//{{AFX_DATA_INIT(DCircleMeas)
	Group = _T("");
	inoutface = -1;
	Target = _T("");
	//}}AFX_DATA_INIT
}


void DCircleMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DCircleMeas)
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDC_SAMPLES, Samples);
	DDX_Control(pDX, IDC_RMSERR, RMSErr);
	DDX_Control(pDX, IDC_RADIUS, Radius);
	DDX_Control(pDX, IDC_NORMAL, Normal);
	DDX_Control(pDX, IDC_MAXERR, MaxErr);
	DDX_Control(pDX, IDC_CENTER, Center);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Radio(pDX, IDC_RADIO1, inoutface);
	DDX_Text(pDX, IDC_TEDIT, Target);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_EVAL, eval_message);
}


BEGIN_MESSAGE_MAP(DCircleMeas, DGenMeas)
	//{{AFX_MSG_MAP(DCircleMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULT, OnButtonDefault)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DCircleMeas message handlers

BOOL DCircleMeas::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	OKButton.EnableWindow(FALSE);
	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);

	SetWindowText(title);
	
	SetGTNames();
	inoutface = app.saarm.Data.inoutface;
	UpdateData(FALSE);
//	MessageBeep(-1);
	DGenMeas::Init();	// call Base class Init for translation, etc.
	return TRUE;
}
void DCircleMeas::SetGTNames()
{
	if(ShowGpTarg)
	{
		Group = app.saarm.Data.Group;
		GroupCtrl.SetWindowText(Group);
		Target = app.saarm.Data.Target;
		TargCtrl.SetWindowText(Target);
	}
	else
	{
		GroupCtrl.ShowWindow(SW_HIDE);
		TargCtrl.ShowWindow(SW_HIDE);
	}
}

BOOL DCircleMeas::ProcessNewData(int inc)
{
	CString m;
	m.Format(_T("%d Samples"), ctr+1);
	Samples.SetWindowText(m);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3 )//|| inc <= 0 )
	{
		Center.SetWindowText(Tr("Center"));
		Normal.SetWindowText(Tr("Normal"));
		Radius.SetWindowText(Tr("Radius"));
		MaxErr.SetWindowText(Tr("Max Err"));
		RMSErr.SetWindowText(Tr("RMS Err"));
		OKButton.EnableWindow(FALSE);
		enoughdata = FALSE;
		return FALSE;
	}

	PauseMeasTimer();
	eval_message.SetWindowText(_T("Fitting Circle, Please Wait"));
	UpdateData(TRUE);	// allow user to change inoutface on the fly
	VectorArray pts;
	if(app.pA->DataArray[app.pA->StepIndex]->GetVectorArrayofPoints(pts) <= 0)
		return FALSE;
	if( !Circle.ComputeCircle(&pts, inoutface) )
		return FALSE;

	enoughdata = TRUE;
	OKButton.EnableWindow();
	
	Center.SetWindowText(Circle.centerinfo);
	Normal.SetWindowText(Circle.normalinfo);
	Radius.SetWindowText(Circle.radiusinfo);
	MaxErr.SetWindowText(Circle.maxerrinfo);
	RMSErr.SetWindowText(Circle.rmserrinfo);

	center = Circle.center;
	rad = Circle.radius;
	t = Circle.t;
	rmserr = Circle.rmserr;
	maxerr = Circle.maxerr;
	eval_message.SetWindowText(_T(""));
	ResumeMeasTimer();

	return TRUE;
}

void DCircleMeas::ProcessAccept()
{
	if(!enoughdata)
	{
		app.saarm.TTS.TextToSpeech(_T("Not enough app.saarm.Data."));
		ProcessingAccept = FALSE;
		return;
	}

	UpdateData(TRUE);

//	CString m;
//	m.Format("Center: X=%f,Y=%f,Z=%f\nRadius: %f", center.x, center.y, center.z, rad);
//	AfxMessageBox(m);
	
	if(app.saarm.Data.geomName.IsEmpty())
	{
		name.Format(_T("%s_%s"), Group, Target);
	}
	else
	{
		name = app.saarm.Data.geomName;
		app.pA->IncrementName(app.saarm.Data.geomName);
	}

	CString s;
	notes.RemoveAll();

	s.Format(_T("User: %s"), app.saarm.Data.UserName);//, app.saarm.Data.SpanPort);
	notes.Add(s);

	s.Format(_T("Circle fit %s  %d samples"), name,
		app.pA->DataArray[app.pA->StepIndex]->P.GetSize());
	notes.Add(s);
	notes.Add(Circle.radiusinfo);
	switch(inoutface)
	{
	case 0:
		{
			s.Format(_T("Measured Inside Radius"));
			notes.Add(s);
			break;
		}
	case 1:
		{
			s.Format(_T("Measured Outside Radius"));
			notes.Add(s);
			break;
		}
	case 2:
		{
			s.Format(_T("Measured on Face Radius"));
			notes.Add(s);
			break;
		}
	default:
		break;
	}
	notes.Add(Circle.rmserrinfo);

	app.pA->X = Circle.center.x;
	app.pA->Y = Circle.center.y;
	app.pA->Z = Circle.center.z;

	CString tName;
	tName.Format(_T("%s"), app.saarm.Data.Target);

	if( app.saarm.Data.SendGeom )
	{
		TRACE0("Sending Circle\n");
		app.saarm.SockGeom.SendCircle(t, rad, name, notes);
		TRACE0("Circle Sent\n");
	}

	app.saarm.Data.measCommentArray.RemoveAll();
	app.saarm.Data.measCommentArray.Append(notes);

	//app.saarm.Data.Target.Format(_T("CircleCenter"));
	center.Scale(1.0/app.saarm.GetInstrumentScaleFactor());
	app.pA->MeasToSpan(center, true, false, false);

	if( app.saarm.Data.FirePointsToo )
	{
		CString tempGName = app.saarm.Data.Group;
		app.saarm.Data.Group.Format(_T("%s_%s-Meas"), tempGName, tName);
		app.pA->ScaleDataArrays(1.0/app.saarm.GetInstrumentScaleFactor());
		app.pA->MeasToSpan(app.pA->DataArray[0], tName);
		app.saarm.Data.Group = tempGName;
	}
	if(app.saarm.Data.incrementgroup)
	{
		app.saarm.Data.Target.Format(_T("P1"));
		app.pA->IncrementName(app.saarm.Data.Group, 1);
	}

	app.pA->DataArray[0]->Clear();
	ctr = -1;
	ProcessNewData(0);

	app.pA->SetDisplayData();

	ProcessingAccept = FALSE;
}

BOOL DCircleMeas::MakeFakeData(int step)
{
	TRACE0("Make fake circle data!!\n");
	Vector XYZ(0.7, 0.7, 0.0), newXYZ;
	double rho, theta, phi;

	ProcessWaitingMessages();
	Delay(0.0005);

	if(app.StopNow)
		return FALSE;			

	rho = 0.2;		// the radius of the circle!!
	phi = 180.0*((double)rand())/((double)RAND_MAX);
	theta = 0.0;

	Vector dhv(rho, theta, phi);
	Vector xyz;
	dhv.RTPtoXYZ(&xyz);

	newXYZ = XYZ;
	newXYZ.Add(xyz);
	app.pA->X = newXYZ.x;
	app.pA->Y = newXYZ.y;
	app.pA->Z = newXYZ.z;

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DCircleMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DCircleMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DCircleMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DCircleMeas::OnButtonOneshort() 
{
	SetB1Short();
}

void DCircleMeas::OnButtonDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DCircleMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DCircleMeas"),this);	
}
void DCircleMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DCircleMeas"),this);
	
	DGenMeas::OnDestroy();
}

void DCircleMeas::OnBnClickedOk()
{
	ProcessAccept();
}
