// DEasyPadLocPts.cpp : implementation file
//

#include "stdafx.h"
#include "DPCMM.h"
#include "DEasyPadLocPts.h"
#include "SA Easy Pad/EasyPadArmInterface.h"

// DEasyPadLocPts dialog

IMPLEMENT_DYNAMIC(DEasyPadLocPts, CDialog)

DEasyPadLocPts::DEasyPadLocPts(CWnd* pParent /*=NULL*/)
	: DGenMeas(DEasyPadLocPts::IDD, pParent)
{

}



void DEasyPadLocPts::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_LOC_PT, padView);
	DDX_Control(pDX, IDC_STATIC_MEAS_TEXT, measPointText);
}


BEGIN_MESSAGE_MAP(DEasyPadLocPts, DGenMeas)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_PADTEST, &DEasyPadLocPts::OnBnClickedButtonPadtest)
	ON_BN_CLICKED(IDC_BUTTON_ARM_PAD_OFF, &DEasyPadLocPts::OnBnClickedButtonArmPadOff)
END_MESSAGE_MAP()


// DEasyPadLocPts message handlers

BOOL DEasyPadLocPts::Init()
{
	//TipText.Format(_T("Tip Dia: %f %s"), 
	//	app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
	//	app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	//Tip.SetWindowText(TipText);

	//SetWindowText(title);

	app.controlPad.ClearCalPts();
	app.pA->ClearVectorArray();

	SetUIForCalPt(0);

	DGenMeas::Init();	// call Base class Init for translation, etc.
	return TRUE;
}

BOOL DEasyPadLocPts::ProcessNewData(int inc)
{
	CString m;
	m.Format(_T("%d Samples"), ctr+1);

	TRACE3("DEasyPadLocPts new data, inc = %d, data size = %d, ctr = %d\n", inc, app.pA->DataArray[0]->P.GetSize(), ctr);

	if(app.pA->DataArray[0]->P.GetSize() >= 3 && inc == 1)
	{
		app.pA->ScaleDataArrays(app.saarm.LocalToInches);

		for (INT_PTR i=0; i<3; i++)
		{
			app.controlPad.AddCalPt(*app.pA->DataArray[0]->P.GetAt(i), app.saarm.Data.TipDia*app.saarm.LocalToInches/2.0);
		}

		if(!app.controlPad.CalibratePad())
		{
			AfxMessageBox(Tr("Pad Cal failed. Try again."), MB_ICONERROR);
			app.controlPad.ClearCalPts();
			app.pA->ClearVectorArray();
			SetUIForCalPt(app.pA->DataArray[0]->P.GetSize());
			return FALSE;
		}
		else
			BaseOnOK();
	}
	else
	{
		SetUIForCalPt(app.pA->DataArray[0]->P.GetSize());
	}
	return TRUE;
}

void DEasyPadLocPts::SetUIForCalPt(INT_PTR ptArraySize)
{
	HBITMAP hBit;
	CString m;
	
	if(ptArraySize <= 0)
	{
		m.Format(Tr("Measure Location Point A"));
		hBit = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_EASYPAD1_PT1));
	}
	else 	if(ptArraySize == 1)
	{
		m.Format(Tr("Measure Location Point B"));
		hBit = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_EASYPAD1_PT2));
	}
	else 	if(ptArraySize == 2)
	{
		m.Format(Tr("Measure Location Point C"));
		hBit = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_EASYPAD1_PT3));
	}
	else
		return;
	
	measPointText.SetWindowText(m);
	padView.SetBitmap(hBit);
}

void DEasyPadLocPts::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DEasyPadLoc"),this);	
}

void DEasyPadLocPts::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DEasyPadLoc"),this);

	DGenMeas::OnDestroy();
}

void DEasyPadLocPts::OnBnClickedButtonPadtest()
{
	CAppLauncher al;
	CString path(app.m_pszHelpFilePath);
	int slash = path.ReverseFind('\\');
	CString pdfPath;
	pdfPath = path.Left(slash);
	pdfPath += _T("\\PrintableSAPad.pdf");
	if(!al.Launch(pdfPath, NULL, NULL, SW_SHOW, al.APPLAUNCH_SYNC, FALSE))	// APPLAUNCH_SYNC - don't return till spawned app is done, FALSE - don't run this app's message pump while spawned app is running
	{
		AfxMessageBox(_T("Could not open the pad pdf.  Please make sure you have Acrobat Reader installed."), MB_ICONINFORMATION);
	}
}

void DEasyPadLocPts::OnBnClickedButtonArmPadOff()
{
	OnCancel();
}
