// DGenMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DGenMeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DGenMeas dialog

DGenMeas::DGenMeas(UINT a,CWnd* pParent)
	: CDialog(a,pParent)
{
	ShowGpTarg = TRUE;
	framemode = FALSE;
	// graphic model update parameters
	timeBetweenModelUpdates = 5.0; // seconds
	timerPeriodsBetweenModelUpdates = DWORD(timeBetweenModelUpdates/app.saarm.Data.meastimerperiodsec);
	timerPeroidsPassed = 0;
	ptCount = 0;

	//{{AFX_DATA_INIT(DGenMeas)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void DGenMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DGenMeas)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DGenMeas, CDialog)
	//{{AFX_MSG_MAP(DGenMeas)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DGenMeas message handlers

BOOL DGenMeas::OnInitDialog() 
{
	CDialog::OnInitDialog();

	app.pA->ClearButtonState();

	mousewason = FALSE;
	if(app.pA->IsRemoteMouseEnabled())
	{
		mousewason = TRUE;
		app.pA->RemoteMouse(FALSE);
	}
	if( !app.pA->ConnectedToArm )
		app.pA->buttonstate = 0;

	ProcessingAccept = FALSE;
	streaming = FALSE;
	streamstarted = FALSE;
	sendfromdlg = FALSE;
	ctr = 0;
	enoughdata = FALSE;
	sendupdates = FALSE;
	guidedmeas = FALSE;
	avgptsmeas = FALSE;
	autoproxmeas = FALSE;
	app.StopNow = FALSE;

	app.pA->DataArray.Add(new ArmPointArray);

	if(!app.pA->IsProbeValid())
	{
		CString m;
		m.Format(_T("Current Probe is either invalid, or has not been calibrated.\nYou must select a valid probe."));
		AfxMessageBox(m, MB_ICONSTOP);
		return FALSE;
	}
	
	Init();


	app.pA->Measuring = TRUE;
	Delay(0.25,TRUE);	// 2001.11.19 saw a case where meastimer did not seem to get started
	SetTimer(MEASTIMER, (int)(1000.0*app.saarm.Data.meastimerperiodsec), NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL DGenMeas::Init()
{
	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	TRANSLATE_DIALOG;
	return TRUE;
}

void DGenMeas::SetGTNames()
{
//	Group = app.saarm.Data.Group;
//	Target = app.saarm.Data.Target;
//	UpdateData(FALSE);
}

void DGenMeas::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == MEASTIMER )
	{
		if(app.StopNow)
			OnCancel();
		if( GetArmData() )
		{
			ProcessButtonHit(app.pA->buttonstate);
			app.pA->CheckPad();
		}
	}
	
	CDialog::OnTimer(nIDEvent);
}
void DGenMeas::PauseMeasTimer()
{
	KillTimer(MEASTIMER);
}
void DGenMeas::ResumeMeasTimer()
{
	SetTimer(MEASTIMER, (int)(1000.0*app.saarm.Data.meastimerperiodsec), NULL);
}

BOOL DGenMeas::GetArmData()
{
	KillTimer(MEASTIMER);
	if( !app.pA->GetAllData() )
	{
		// 2001.03.23 begin
		//if( app.pA->IsRomer() || app.pA->IsFaroUSB() )	// Romer needs to keep checking for joint limit condition!!
			SetTimer(MEASTIMER, (int)(1000.0*app.saarm.Data.meastimerperiodsec), NULL);
		// 2001.03.23 end
		return FALSE;
	}
	if( !app.pA->ConnectedToArm && !autoproxmeas)
		MakeFakeData(app.pA->StepIndex);

	// graphic model updates...
	if(!guidedmeas && !autoproxmeas)
		timerPeroidsPassed++;
	if(timerPeroidsPassed >= timerPeriodsBetweenModelUpdates)
	{
		timerPeroidsPassed = 0;
		app.pA->CheckAndUpdateModelInfo();
	}
	
	//CString m;
	//m.Format("Current Arm Data: X=%f, Y=%f, Z=%f",
	//	app.pA->X*app.saarm.LocalToInches,app.pA->Y*app.saarm.LocalToInches,app.pA->Z*app.saarm.LocalToInches);
	//TRACE1("%s\n",m);

	SetTimer(MEASTIMER, (int)(1000.0*app.saarm.Data.meastimerperiodsec), NULL);
	return TRUE;
}

BOOL DGenMeas::ProcessNewData(int inc)
{
	TRACE("Base class ProcessNewData called!\n");
	return FALSE;
}
void DGenMeas::SendRemainingData()
{
	TRACE("Base class SendRemainingData called!\n");
}
void DGenMeas::ProcessUpdate()
{
	TRACE("Base class ProcessUpdate called!\n");
}

BOOL DGenMeas::MakeFakeData(int step)
{
	TRACE("Base class MakeFakeData called!\n");
	return FALSE;
}
void DGenMeas::HoseData(const Vector& xyzDataIn, Vector& xyzDataOut)
{
	double dResolution = 0.001*app.saarm.InchesToLocal;

	RandomDataGenerator rdg;
	xyzDataOut.x = xyzDataIn.x + rdg.GaussianRandom()*dResolution;
	xyzDataOut.y = xyzDataIn.y + rdg.GaussianRandom()*dResolution;
	xyzDataOut.z = xyzDataIn.z + rdg.GaussianRandom()*dResolution;
}

void DGenMeas::ProcessAccept() 
{
	app.pA->DataArray.Add(new ArmPointArray);
	app.pA->StepIndex++;
	ProcessingAccept = FALSE;
}

void DGenMeas::ProcessButtonHit(WORD state) 
{
	//TRACE(_T("button state = %d, lobyte = %d, shifted hibyte = %d\n"), state, LOBYTE(state), HIBYTE(state)<<8);

	switch(LOBYTE(state))
	{
	case 0:
		{
			ButtonHit(NOTHING,0);
			break;
		}
	case 1:
		{
			ButtonHit( app.saarm.Data.ButtonOneMode, HIBYTE(state)<<8 );
			break;
		}
	case 2:
		{
			ButtonHit( app.saarm.Data.ButtonTwoMode, HIBYTE(state)<<8 );
			break;
		}
	case 4:
		{
			ButtonHit( app.saarm.Data.ButtonThreeMode, HIBYTE(state)<<8 );
			break;
		}

	default:
		{
			//just update the graphics
			app.pA->UpdateToSpan();
		}
	}
}


void DGenMeas::ButtonHit(int Mode, int duration)
{
//	if((app.pA->MouseButtonBlock)&&!((Mode==BACKUP_MOUSE)&&(BDuration==BUTTON_LONG)))
//		return;
	if(!app.pA->ConnectedToArm)
		app.pA->ClearButtonState();
	
	switch(Mode)
	{
	case NOTHING:			//do nothing but update graphics
		{
			if(streamstarted)
			{
				ProcessNewData(app.saarm.Data.ptnameinc);
				return;
			}
			if(sendupdates)
				ProcessNewData(0);
			if(guidedmeas)
				ProcessNewData(0);
			if(!framemode)
				app.pA->UpdateToSpan();
			break;
		}
	case RECORD_ACCEPT:			//single point
		{
			if(duration == BUTTON_SHORT)
			{
				app.pA->ArmBeep(REC_OK);
				if( !sendfromdlg )
					ctr = app.pA->AddPoint();
				app.pA->UpdateToSpan();
				if( streaming )
				{
					streamstarted = TRUE;
					SetStreamIndicator(TRUE);
				}
				else if(sendfromdlg)
					ptCount++;
				if( ProcessNewData(app.saarm.Data.ptnameinc) )
					break;
			}
			//else if(duration == BUTTON_LONG && app.pA->IsRomer())	// 2004.08.26 - not clean, so commented out
			//	ProcessAccept();
			else if(duration == BUTTON_LONG && !ProcessingAccept)
			{
				//app.pA->UpdateToSpan();
				ProcessingAccept = TRUE;
				ProcessAccept();
			}
			else if(duration == BUTTON_LONG && ProcessingAccept)
			{
				//app.pA->UpdateToSpan();
			}
			break;
		}
	case BACKUP_MOUSE:
		{
			app.pA->ClearButtonState();
			if( streaming )
			{
				streamstarted = FALSE;
				SetStreamIndicator(FALSE);
				SendRemainingData();
			}
			if(duration == BUTTON_SHORT && !sendfromdlg)
			{
				if(app.pA->DataArray[app.pA->StepIndex]->P.GetSize()>0)
				{
					ctr = app.pA->RemovePoint();
					app.pA->UpdateToSpan();
					app.pA->ArmBeep(UNDO_OK);
					if( ProcessNewData(-app.saarm.Data.ptnameinc) )
						break;
				}
				else
				{
					app.pA->UpdateToSpan();
					app.pA->ArmBeep(UNDO_FAIL);
					break;
				}	

			}
			else if( duration == BUTTON_SHORT && (guidedmeas || avgptsmeas) )
				ProcessNewData(-app.saarm.Data.ptnameinc);
			else if( duration == BUTTON_SHORT && sendfromdlg && ptCount > 0 )
			{
				app.pA->IncrementName(app.saarm.Data.Target, -app.saarm.Data.ptnameinc);
				app.saarm.RemoveLastMeasurementInSA(true);
				ptCount--;
			}
			else if(duration == BUTTON_LONG)
			{
				app.pA->UpdateToSpan();
				OnCancel();	// that's right, just close the meas.  we toggle the mouse mode when we are NOT measuring!
			}
			break;
		}
	case BACKUP_CANCEL:
		{
			app.pA->ClearButtonState();
			if( streaming )
			{
				streamstarted = FALSE;
				SetStreamIndicator(FALSE);
				SendRemainingData();
			}
			if(duration == BUTTON_SHORT && !sendfromdlg)
			{
				if(app.pA->DataArray[app.pA->StepIndex]->P.GetSize()>0)
				{
					ctr = app.pA->RemovePoint();
					app.pA->UpdateToSpan();
					app.pA->ArmBeep(UNDO_OK);
					if( ProcessNewData(-app.saarm.Data.ptnameinc) )
						break;
				}
				else
				{
					app.pA->UpdateToSpan();
					app.pA->ArmBeep(UNDO_FAIL);
					break;
				}	

			}
			else if( duration == BUTTON_SHORT && (guidedmeas || avgptsmeas) )
				ProcessNewData(-app.saarm.Data.ptnameinc);
			else if( duration == BUTTON_SHORT && sendfromdlg && ptCount > 0 )
			{
				app.pA->IncrementName(app.saarm.Data.Target, -app.saarm.Data.ptnameinc);
				app.saarm.RemoveLastMeasurementInSA(true);
				ptCount--;
			}
			else if(duration == BUTTON_LONG)
			{
				app.pA->UpdateToSpan();
				OnCancel();
			}
			break;
		}
	case RECORD_BACKUP:
		{
			if(duration == BUTTON_SHORT)
			{
				app.pA->ArmBeep(REC_OK);
				if( !sendfromdlg )
					ctr = app.pA->AddPoint();
				app.pA->UpdateToSpan();
				if( streaming && !streamstarted )
				{
					streamstarted = TRUE;
					SetStreamIndicator(TRUE);
				}
				else if( streaming && streamstarted )
				{
					streamstarted = FALSE;
					SetStreamIndicator(FALSE);
					SendRemainingData();
				}
				else if(sendfromdlg)
					ptCount++;
				if( ProcessNewData(app.saarm.Data.ptnameinc) )
					break;
			}
			//else if(duration == BUTTON_LONG && app.pA->IsRomer())	// 2004.08.26 - not clean, so commented out
			//	ProcessAccept();
			else if(duration == BUTTON_LONG && !sendfromdlg)
			{
				if(app.pA->DataArray[app.pA->StepIndex]->P.GetSize()>0)
				{
					ctr = app.pA->RemovePoint();
					app.pA->UpdateToSpan();
					app.pA->ArmBeep(UNDO_OK);
					if( ProcessNewData(-app.saarm.Data.ptnameinc) )
						break;
				}
				else
				{
					app.pA->UpdateToSpan();
					app.pA->ArmBeep(UNDO_FAIL);
					break;
				}	

			}
			else if( duration == BUTTON_LONG && (guidedmeas || avgptsmeas) )
				ProcessNewData(-app.saarm.Data.ptnameinc);
			else if( duration == BUTTON_LONG && sendfromdlg && ptCount > 0 )
			{
				if( streaming )
				{
					streamstarted = FALSE;
					SetStreamIndicator(FALSE);
					SendRemainingData();
				}
				else
				{
					app.pA->IncrementName(app.saarm.Data.Target, -app.saarm.Data.ptnameinc);
					app.saarm.RemoveLastMeasurementInSA(true);
					ptCount--;
				}
			}
			else if( duration == BUTTON_LONG && streaming)
			{
				app.pA->IncrementName(app.saarm.Data.Target, -app.saarm.Data.ptnameinc);
				app.saarm.RemoveLastMeasurementInSA(true);
			}
			break;
		}
	case ACCEPT_CANCEL:
		{
			app.pA->ClearButtonState();
			if( streaming )
			{
				streamstarted = FALSE;
				SetStreamIndicator(FALSE);
				SendRemainingData();
			}

			if(duration == BUTTON_SHORT && !ProcessingAccept)
			{
				//app.pA->UpdateToSpan();
				ProcessingAccept = TRUE;
				ProcessAccept();
			}
			else if(duration == BUTTON_SHORT && ProcessingAccept)
			{
				//app.pA->UpdateToSpan();
			}


			else if(duration == BUTTON_LONG)
			{
				app.pA->UpdateToSpan();
				OnCancel();
			}
			break;
		}
	case NAV_NEXT_PREV:
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT)
			{
				SAIPInspectionNavigation in;
				in.navMode = SAIPInspectionNavigation::NAV_NEXT;
				app.saarm.SendInspectionNavigationToSA(in);
			}
			else if(duration == BUTTON_LONG)
			{
				SAIPInspectionNavigation in;
				in.navMode = SAIPInspectionNavigation::NAV_PREV;
				app.saarm.SendInspectionNavigationToSA(in);
			}
			break;
		}
	case NAV_NEXT_ITERATE_MEAS_MODE:	// for SA Toolbar ONLY
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT)
			{
				SAIPInspectionNavigation in;
				in.navMode = SAIPInspectionNavigation::NAV_NEXT;
				app.saarm.SendInspectionNavigationToSA(in);
			}
			else if(duration == BUTTON_LONG)
			{
				if(app.measDlg && app.pA->Measuring)
					app.measDlg->EndCancel();	// end the current meas dialog, so a pad button always works
				
				if(!app.pA->IsKreonScannerArm()) // or !app.pA->IsFaroUSB() ?? shouldn't we let it start its scan mode this way too?
				{
					if(app.saarm.GetMeasMode() == 0) // single pt.
						app.pA->SetMeasMode(1);	// stream pts.
					else
						app.pA->SetMeasMode(0); // single pt.
				}
				else
				{
					if(app.saarm.GetMeasMode() == 0) // single pt.
						app.pA->SetMeasMode(1);	// stream pts.
					else if(app.saarm.GetMeasMode() == 1)
						app.pA->SetMeasMode(13); // line scan
					else if(app.saarm.GetMeasMode() == 13)
						app.pA->SetMeasMode(0); // single pt.
				}
				app.saarm.SendSAIRCAttributesToSA();
				app.saarm.RestartMeasurement();
			}
			break;
		}
	case TOUCH_PROBE:			
		{
			if(duration == BUTTON_SHORT)
			{
				if( streaming )
				{
					streamstarted = TRUE;
					SetStreamIndicator(TRUE);
				}
				if(streamstarted)
				{
					ProcessNewData(app.saarm.Data.ptnameinc);
					return;
				}
				if(sendupdates)
					ProcessNewData(0);
				if(guidedmeas)
					ProcessNewData(0);
				if(!framemode)
					app.pA->UpdateToSpan();
				if( !streaming )
				{
					Beep(900,100);
					app.pA->ArmBeep(REC_OK);
					if( !sendfromdlg )
						ctr = app.pA->AddPoint();
					app.pA->UpdateToSpan();
					if(sendfromdlg)
						ptCount++;
					if( ProcessNewData(app.saarm.Data.ptnameinc) )
						break;
				}
			}
			else if(duration == BUTTON_LONG)
			{
				if( streaming )
				{
					streamstarted = FALSE;
					SetStreamIndicator(FALSE);
					SendRemainingData();
				}
			}
			break;
		}
	default:
		{
			app.pA->UpdateToSpan();
//			ProcessUpdate();
		}
	}
	if( app.pA->IsSNL() && !streaming )	// 2001.06.21
		app.pA->ClearButtonState();
	app.pA->overrideArmButtons = false;
}


//////////////////////////////////////////////////////////////////////
// Simulation mode
void DGenMeas::SetB1Short()
{
	app.pA->buttonstate = 1;
	app.pA->buttonstate += BUTTON_SHORT;
}
void DGenMeas::SetB1Long()
{
	app.pA->buttonstate = 1;
	app.pA->buttonstate += BUTTON_LONG;
}
void DGenMeas::SetB2Short()
{
	app.pA->buttonstate = 2;
	app.pA->buttonstate += BUTTON_SHORT;
}
void DGenMeas::SetB2Long()
{
	app.pA->buttonstate = 2;
	app.pA->buttonstate += BUTTON_LONG;
}
/////////////////////////////////////////////////////////////////////////

void DGenMeas::BaseOnOK()
{
	OnOK();
}

void DGenMeas::EndCancel()
{
	try
	{
		OnCancel();
	}
	catch (CMemoryException* e)
	{
		
	}
	catch (CFileException* e)
	{
	}
	catch (CException* e)
	{
	}
}

void DGenMeas::OnOK()
{
	KillTimer(MEASTIMER);
	if(!app.pA->IsRemoteMouseEnabled() && mousewason)
		app.pA->RemoteMouse(TRUE);
	app.pA->Measuring = FALSE;
	ProcessingAccept = FALSE;

	app.measDlg = NULL;

	CDialog::OnOK();
}

void DGenMeas::OnCancel()
{
	KillTimer(MEASTIMER);
	if(!app.pA->IsRemoteMouseEnabled() && mousewason)
		app.pA->RemoteMouse(TRUE);
	app.pA->Measuring = FALSE;
	TRACE("DGenMeas::OnCancel()\n");
//	app.pA->ClearVectorArray();
	ProcessingAccept = FALSE;
	app.saarm.TTS.TextToSpeech(_T("Measurement cancelled."));

	app.measDlg = NULL;

	CDialog::OnCancel();
}

void DGenMeas::OnClose()
{
	KillTimer(MEASTIMER);
	if(!app.pA->IsRemoteMouseEnabled() && mousewason)
		app.pA->RemoteMouse(TRUE);
	app.pA->Measuring = FALSE;
	TRACE("DGenMeas::OnClose()\n");
//	app.pA->ClearVectorArray();
	ProcessingAccept = FALSE;

	app.measDlg = NULL;

	CDialog::OnClose();
}