#if !defined(AFX_DGENMEAS_H__5B767E15_204E_4A88_B05E_F3C73A180729__INCLUDED_)
#define AFX_DGENMEAS_H__5B767E15_204E_4A88_B05E_F3C73A180729__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DGenMeas.h : header file
//

#define MEASTIMER 60

#include "Resource.h"
#include "fit\\fitball.h"

/////////////////////////////////////////////////////////////////////////////
// DGenMeas dialog

class DGenMeas : public CDialog
{
// Construction
public:
	DGenMeas(UINT a,CWnd* pParent);

	virtual BOOL Init();
	BOOL GetArmData();
	virtual BOOL ProcessNewData(int inc);
	virtual void SendRemainingData();
	virtual void ProcessUpdate();
	virtual void SetGTNames();

	void BaseOnOK();
	void EndCancel();


	void ButtonHit(int Mode, int duration); 
	void ProcessButtonHit(WORD state);
	virtual void ProcessAccept();
	BOOL ProcessingAccept;

	void PauseMeasTimer();
	void ResumeMeasTimer();

	// graphic model update
	double timeBetweenModelUpdates; // seconds
	DWORD timerPeriodsBetweenModelUpdates; // calculated at construction
	DWORD timerPeroidsPassed;

	CString title;
	BOOL ShowGpTarg;
	BOOL streaming;
	BOOL sendfromdlg;
	BOOL framemode;
	BOOL streamstarted;
	BOOL enoughdata;
	BOOL mousewason;
	BOOL sendupdates;
	BOOL guidedmeas;
	BOOL avgptsmeas;
	BOOL autoproxmeas;
	
	// geometry parameters
	Vector center;
	double rad;
	Transform t;
	double maxerr;
	double rmserr;
	double pctcov;
	CString name;
	CStringArray notes;
	CString	maxerrinfo;
	CString	rmserrinfo;
	
	// simulation mode 
	virtual BOOL MakeFakeData(int step);
	void HoseData(const Vector& xyzDataIn, Vector& xyzDataOut);
	int ctr;
	void SetB1Short();
	void SetB1Long();
	void SetB2Short();
	void SetB2Long();

	// 2001.11.19
	virtual void SetStreamIndicator(BOOL strm) {TRACE0("GenMeas SetStreamIndicator called\n");}

// Dialog Data
	//{{AFX_DATA(DGenMeas)
	enum { IDD = IDD_DIALOG_GENMEAS };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DGenMeas)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(DGenMeas)
	afx_msg void OnClose();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	DWORD_PTR ptCount;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DGENMEAS_H__5B767E15_204E_4A88_B05E_F3C73A180729__INCLUDED_)
