#pragma once

#include "Resource.h"
#include "DGenMeas.h"
#include "afxwin.h"
#include "PictureButtons\\GroupInc.h"
#include "PictureButtons\\TargInc.h"

// DGeomTriggerPts dialog

class DGeomTriggerPts : public DGenMeas
{
public:
	DGeomTriggerPts(CWnd* pParent = NULL);   // standard constructor
	
	virtual BOOL Init();
	virtual void SetGTNames();
	virtual BOOL ProcessNewData(int inc);
	void UpdateFields();
	virtual void ProcessAccept();

	CString	Group;
	CString	Target;

	// simulation mode
	virtual BOOL MakeFakeData(int step);
	virtual void SetStreamIndicator(BOOL strm);

// Dialog Data
	enum { IDD = IDD_DIALOG_GEOMTRIG_MEAS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	NewColorStatic StreamIndicator;
	CString tip;
	CString sampleinfo;
	CButton B1short_button;
	CButton B1long_button;
	CButton B2short_button;
	CButton B2long_button;
	afx_msg void OnBnClickedButtonOneshortGt();
	afx_msg void OnBnClickedButtonOnelongGt();
	afx_msg void OnBnClickedButtonTwoshortGt();
	afx_msg void OnBnClickedButtonTwolongGt();
	afx_msg void OnBnClickedIncgGt();
	afx_msg void OnBnClickedInctGt();
	GroupInc groupInc;
	TargInc targInc;
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedDefault();

private:
	bool refPosSet;
	Vector refPos;
};
