// DGuideMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DGuideMeas.h"
#include ".\dguidemeas.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DGuideMeas dialog


DGuideMeas::DGuideMeas(CWnd* pParent /*=NULL*/)
: DGenMeas(DGuideMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DGuideMeas)
	//}}AFX_DATA_INIT
	DeltaText = "";
	DelMagText = "";
	DelayCount = 0;
}


void DGuideMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DGuideMeas)
	DDX_Control(pDX, IDOK, m_AcceptCtrl);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_GPTG, grouptarg);
}


BEGIN_MESSAGE_MAP(DGuideMeas, DGenMeas)
	//{{AFX_MSG_MAP(DGuideMeas)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DGuideMeas message handlers

BOOL DGuideMeas::Init() 
{
	sendfromdlg = TRUE;
	guidedmeas = TRUE;
	updateXYZ = TRUE;

	//TipText.Format(_T("Tip Dia: %f %s"),
	//	app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
	//	app.saarm.units.DistUnitNames[app.saarm.units.distunits]);

	MeasGroup.TargetSuffix = app.pA->GuidedMeasGroup.TargetSuffix;
	MeasGroup.GroupSuffix = app.pA->GuidedMeasGroup.GroupSuffix;
	for( int i=0; i < app.pA->GuidedMeasGroup.Points.GetSize(); i++ )
	{
		SAIPMeasGroupPt* pGP = new SAIPMeasGroupPt;
		pGP->Nominal = app.pA->GuidedMeasGroup.Points[i]->Nominal;
		pGP->Group = app.pA->GuidedMeasGroup.Points[i]->Group + app.pA->GuidedMeasGroup.GroupSuffix;
		pGP->Target = app.pA->GuidedMeasGroup.Points[i]->Target + app.pA->GuidedMeasGroup.TargetSuffix;
		MeasGroup.Points.Add( pGP );
		TRACE3("Added guide pt. to DGuideMeas's array: pt.x = %f, gp = %s, t = %s\n", 
			MeasGroup.Points[i]->Nominal.x,
			MeasGroup.Points[i]->Group,
			MeasGroup.Points[i]->Target);
	}
	index = 0;
	UpdateFields();	
	CString s;
	s.Format(_T("Measure Nominal Point, group, %s, target, %s"),
		app.pA->GuidedMeasGroup.Points[index]->Group + app.pA->GuidedMeasGroup.GroupSuffix,
		app.pA->GuidedMeasGroup.Points[index]->Target + app.pA->GuidedMeasGroup.TargetSuffix);
	app.saarm.TTS.TextToSpeech(s);

	DGenMeas::Init();	// call Base class Init for translation, etc.
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void DGuideMeas::SetGTNames()
{
	CString gt;
	gt.Format(_T("%s::%s"),
		app.pA->GuidedMeasGroup.Points[index]->Group + app.pA->GuidedMeasGroup.GroupSuffix,
		app.pA->GuidedMeasGroup.Points[index]->Target + app.pA->GuidedMeasGroup.TargetSuffix);
	grouptarg.SetWindowText(gt);
}

void DGuideMeas::ProcessAccept()
{
	return;
}

void DGuideMeas::ProcessUpdate()
{
	UpdateFields();
}

BOOL DGuideMeas::ProcessNewData(int inc)
{
	// Mantis #5110 -- during initial 'lag' time when batch mode is starting, user could hit arm button before the meas has received any updates
	// currXYZ was being set only by updates, but there's no reason for that
	currXYZ.x = app.pA->X;
	currXYZ.y = app.pA->Y;
	currXYZ.z = app.pA->Z;

	if(inc == app.saarm.Data.ptnameinc)	// 2008.04.03 - this code was under ProcessAccept, now we're allowing a short butotn hit to accept in order to save time - (requested by Mike Obrien @ Boeing via Scott)
	{
		TRACE("DGuideMeas processing a short record button hit - sending pt.\n");

		Vector Nominal(MeasGroup.Points[index]->Nominal);
		Nominal.Scale(app.saarm.InchesToLocal);

		if(currXYZ.Distance(Nominal) > app.saarm.Data.GoodProximity)	// 2012.04.16 - by request from Mike Obrien @ Boeing -- don't allow meas if outside the good zone
			return FALSE;

		//Fire the point to SA
		app.pA->MeasToSpan(currXYZ, MeasGroup.Points[index]->Group, MeasGroup.Points[index]->Target);
		index++;
		updateXYZ = TRUE;

		//Check if its the last
		if(index > MeasGroup.Points.GetUpperBound())
		{
			app.saarm.TTS.TextToSpeech(_T("Guided Measurement Done"));
			ProcessingAccept = FALSE;
			DGenMeas::OnOK();
			return TRUE;
		}
	}
	if( inc == -app.saarm.Data.ptnameinc )
	{
		if( index <= 0 )
		{
			return TRUE;
		}
		
		app.saarm.RemoveLastMeasurementInSA(true);
		//app.pA->RemovePoint();	// not necessary, this meas does not add data to the DataArray array, or the NormArray
		index--;
		app.pA->ArmBeep(UNDO_OK);
	}

	//CString s;
	//s.Format(_T("Measure Nominal Point, group, %s, target, %s"),
	//	app.pA->GuidedMeasGroup.Points[index]->Group + app.pA->GuidedMeasGroup.GroupSuffix,
	//	app.pA->GuidedMeasGroup.Points[index]->Target + app.pA->GuidedMeasGroup.TargetSuffix);
	//app.saarm.TTS.TextToSpeech(s);
	
	UpdateFields();
	return TRUE;
}
void DGuideMeas::UpdateFields()
{
	// 2004.08.24 - SA servos the view per guided target!
	SAIPServoView pkt;
	pkt.tolerance = app.saarm.Data.GoodProximity*app.saarm.LocalToInches;
	pkt.toneRampZone = app.saarm.Data.proxWorkingField*app.saarm.LocalToInches;
	pkt.goalPoint = MeasGroup.Points[index]->Nominal;
	pkt.name.Format(_T("%s::%s"), MeasGroup.Points[index]->Group, MeasGroup.Points[index]->Target);
	app.saarm.QS.SendPacket(pkt);

	SetGTNames();
	Vector NominalInWork,ActualInWork,DeltaInWork;
	Vector Nominal(MeasGroup.Points[index]->Nominal);
	Nominal.Scale(app.saarm.units.UnitToMeters[DISTUNITS_IN]);	// convert to meters (SA now sends everything in inches!!)
	app.saarm.InstToWorking.Multiply(Nominal,&NominalInWork);	// apply transform
	NominalInWork.Scale(1.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);	// now back to current units
	//NominalText.Format(_T("Nominal %8.*f %8.*f %8.*f"),
	//	app.saarm.Data.Precision,NominalInWork.x,
	//	app.saarm.Data.Precision,NominalInWork.y,
	//	app.saarm.Data.Precision,NominalInWork.z);
	Vector Actual;
//	if(last accepted point has not been sent)
//	{
		// don't update the actual

//	}
//	else
//	{
		Actual = currXYZ;
		
//		if(app.pA->GuideSound)
//		{
			//if(DelayCount>5)
			//{
			//	Vector tmp(Nominal);
			//	tmp.Sub(Actual);
			//	TRACE1("scream this error %f\n", tmp.Length());
			//	app.saarm.ScreamThis(tmp.Length());
			//}
			//else
			//	DelayCount++;
//		}
//	}
	app.saarm.InstToWorking.Multiply(Actual,&ActualInWork);
	ActualInWork.Scale(1.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);
	
	DeltaInWork = ActualInWork;
	DeltaInWork.Sub(NominalInWork); // in meters
	//ActualText.Format(_T("Actual %8.*f %8.*f %8.*f"),
	//	app.saarm.Data.Precision,ActualInWork.x,
	//	app.saarm.Data.Precision,ActualInWork.y,
	//	app.saarm.Data.Precision,ActualInWork.z);
	DeltaText.Format(_T("%8.*f %8.*f %8.*f"),
		app.saarm.Data.Precision,DeltaInWork.x,
		app.saarm.Data.Precision,DeltaInWork.y,
		app.saarm.Data.Precision,DeltaInWork.z);
	DelMagText.Format(_T("Mag.= %8.*f"),app.saarm.Data.Precision,DeltaInWork.Length());

	CString cs1;
	cs1.Format(_T("Guided Point Measurement"));
	app.saarm.Data.measCommentArray.RemoveAll();
	app.saarm.Data.measCommentArray.Add(cs1);
	//app.saarm.Data.measCommentArray.Add(NominalText);
	app.saarm.Data.measCommentArray.Add(DeltaText);
	
	SetDlgItemText(IDC_DELTA,DeltaText);
	SetDlgItemText(IDC_DELTAMAG,DelMagText);
	UpdateData(FALSE);
}

BOOL DGuideMeas::MakeFakeData(int step)
{
	return TRUE;
}

void DGuideMeas::OnDefault() 
{
	UpdateData(TRUE);
}

void DGuideMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DGuideMeas"),this);	
}

void DGuideMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DGuideMeas"),this);

	DGenMeas::OnDestroy();
}
void DGuideMeas::OnBnClickedOk()
{
	ProcessAccept();
}
