// DHoleMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DHoleMeas.h"
#include "DCompareResults.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DHoleMeas dialog


DHoleMeas::DHoleMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DHoleMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DHoleMeas)
	Group = _T("");
	Target = _T("");
	Inspect = FALSE;
	ShiftText = _T("");
	//}}AFX_DATA_INIT
}


void DHoleMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DHoleMeas)
	DDX_Control(pDX, IDC_SHIFT, Shift);
	DDX_Control(pDX, IDC_CIRCBOX, circbox);
	DDX_Control(pDX, IDC_RADIUS, radius);
	DDX_Control(pDX, IDC_PSAMPLES, Psamples);
	DDX_Control(pDX, IDC_PRMSERR, Prmserr);
	DDX_Control(pDX, IDC_PMAXERR, Pmaxerr);
	DDX_Control(pDX, IDC_CSAMPLES, Csamples);
	DDX_Control(pDX, IDC_CRMSERR, Crmserr);
	DDX_Control(pDX, IDC_CMAXERR, Cmaxerr);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT2, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG2, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT2, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Text(pDX, IDC_SHIFT, ShiftText);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_EVAL, eval_message);
	DDX_Control(pDX, IDC_STATIC_PLANE_LABEL, planeLabel);
}


BEGIN_MESSAGE_MAP(DHoleMeas, DGenMeas)
	//{{AFX_MSG_MAP(DHoleMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT2, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG2, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT2, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_HOLE_SELECT_PLANE, &DHoleMeas::OnBnClickedButtonHoleSelectPlane)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DHoleMeas message handlers

BOOL DHoleMeas::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	OKButton.EnableWindow(FALSE);
	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);
	if(app.saarm.Data.AddExtraPatchShift)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	insideoutside = 0;
	if(Pin)
	{
		insideoutside = 1;
		circbox.SetWindowText(Tr("Pin"));
	}

	SetWindowText(title);
	SetDlgItemText(IDOK,Tr("Accept Plane"));

	CheckForDS_Plane();

	SetGTNames();
	if(app.saarm.Data.ds_planeSet)
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane, or accept Plane."));
	else
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane."));

//	MessageBeep(-1);
	
	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;
}

bool DHoleMeas::CheckForDS_Plane()
{
	if( !app.saarm.Data.ds_planeSet )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		OKButton.EnableWindow(FALSE);
		return false;
	}
	Plane = app.saarm.Data.ds_plane;
	PSampleText.Format(_T("%d Samples"), Plane.samples);

	if(Plane.patchShift != 0.0)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		Plane.patchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	CString m;
	m.Format(Tr("Plane ") + Plane.timeStamp);
	planeLabel.SetWindowText(m);
	UpdateDialog();
	OKButton.EnableWindow();
	return true;
}

void DHoleMeas::SetGTNames()
{
	Group = app.saarm.Data.Group;
	GroupCtrl.SetWindowText(Group);
	Target = app.saarm.Data.Target;
	TargCtrl.SetWindowText(Target);
}

BOOL DHoleMeas::ProcessNewData(int inc) 
{
	TRACE("ProcessNewData!!\n");
	if(app.pA->StepIndex==0)
	{
		return UpdatePlane(inc);
	}
	else if(app.pA->StepIndex==1)
	{
		//add check for plane proximity if it's a hole
		return UpdateCircle(inc);
	}
	return FALSE;
}

BOOL DHoleMeas::UpdatePlane(int inc)
{	
	PSampleText.Format(_T("%d Samples"), ctr+1);
	Psamples.SetWindowText(PSampleText);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);

	if(ctr < 0)
	{
		CheckForDS_Plane();
		return FALSE;
	}

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3)// || inc <= 0 )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		SetDlgItemText(IDC_PLANE,Tr("ABCD"));
		SetDlgItemText(IDC_PRMSERR,Tr("Max Err"));
		SetDlgItemText(IDC_PMAXERR,Tr("RMS Err"));
		if(app.saarm.Data.AddExtraPatchShift)
			ShiftText.Format(_T("Patch Shift: %f %s"),
			app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		else
			ShiftText.Format(_T("No Patch Shift"));
		Shift.SetWindowText(ShiftText);
		OKButton.EnableWindow(FALSE);
		return FALSE;
	}

	PauseMeasTimer();
	eval_message.SetWindowText(Tr("Fitting Plane, Please Wait"));
//	if(app.saarm.Data.AddExtraPatchShift)
//		m.Format("%d Samples    %5.2f %s Extra Shift",
//		app.pA->DataArray[0]->GetSize(),
//		app.saarm.Data.ExtraPatchShift/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
//		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
//	else
//		PSampleText.Format("%d Samples",ctr+1);
//	Psamples.SetWindowText(m);
		
//	double OldTip = app.pA->TipDia;
//	if(app.pA->AddExtraPatchShift)
//		app.pA->TipDia = app.pA->TipDia + (2.0 * app.pA->ExtraPatchShift);

	if(Plane.ComputePlane(app.pA->DataArray[0]))
		OKButton.EnableWindow(TRUE);
	else
		OKButton.EnableWindow(FALSE);
		
	UpdateDialog();
	ResumeMeasTimer();
	eval_message.SetWindowText(_T(""));
	return TRUE;
}

BOOL DHoleMeas::UpdateCircle(int inc)
{
	CString m;
	m.Format(_T("%d Samples"), ctr+1);
	Csamples.SetWindowText(m);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3 )//|| inc <= 0 )
	{
		SetDlgItemText(IDC_CENTER,_T(""));
		SetDlgItemText(IDC_RADIUS,_T(""));
		SetDlgItemText(IDC_CRMSERR,_T(""));
		SetDlgItemText(IDC_CMAXERR,_T(""));
		OKButton.EnableWindow(FALSE);
		return FALSE;	
	}

	PauseMeasTimer();
	eval_message.SetWindowText(Tr("Projecting Pt. and Fitting Circle, Please Wait"));
	
	CSampleText.Format(_T("%d Samples"),ctr+1);
	VectorArray pts;
	if(app.pA->DataArray[1]->GetVectorArrayofPoints(pts) <= 0)
		return FALSE;
	Plane.ProjectPointsToPlane(pts,&CircPointsOnPlane); //i/o all in inches

	for( int i=0; i<app.pA->DataArray[1]->P.GetSize(); i++)
	{
		TRACE0("Results of ProjectPointsToPlane:\n");
		TRACE3("Pt. In: X=%f, Y=%f, Z=%f\n",
			app.pA->DataArray[1]->P[i]->x,
			app.pA->DataArray[1]->P[i]->y,
			app.pA->DataArray[1]->P[i]->z);
		TRACE3("Pt. Out: X=%f, Y=%f, Z=%f\n\n",
			CircPointsOnPlane.P[i]->x,
			CircPointsOnPlane.P[i]->y,
			CircPointsOnPlane.P[i]->z);
	}
	
	if(Circle.ComputeCircle(&CircPointsOnPlane,insideoutside)) 
	{
		enoughdata = TRUE;
		OKButton.EnableWindow(TRUE);
		ActualRadius = Circle.radius;
		center = Circle.center;
		rad = Circle.radius;
		t = Circle.t;
		rmserr = Circle.rmserr;
		maxerr = Circle.maxerr;
		
		app.pA->X = Circle.center.x;
		app.pA->Y = Circle.center.y;
		app.pA->Z = Circle.center.z;
	}
	else
		OKButton.EnableWindow(FALSE);

	ResumeMeasTimer();
	eval_message.SetWindowText(_T(""));

	UpdateDialog();
	return TRUE;
}

void DHoleMeas::UpdateDialog()
{
	SetDlgItemText(IDC_PSAMPLES,PSampleText);
	SetDlgItemText(IDC_CSAMPLES,CSampleText);
	SetDlgItemText(IDC_PLANE,Plane.PlaneText);
	SetDlgItemText(IDC_PRMSERR,Plane.rmserrinfo);
	SetDlgItemText(IDC_PMAXERR,Plane.maxerrinfo);
	SetDlgItemText(IDC_CENTER,Circle.centerinfo);
	SetDlgItemText(IDC_RADIUS,Circle.radiusinfo);
	SetDlgItemText(IDC_CRMSERR,Circle.rmserrinfo);
	SetDlgItemText(IDC_CMAXERR,Circle.maxerrinfo);
	TRACE1("circle max err info: %s\n", Circle.maxerrinfo);
}

void DHoleMeas::MakeFrame(Transform* T)
{
	Vector ZAxis(Circle.normal);
	Vector Origin(Circle.center);
	Vector Temp;
	Temp = *app.pA->DataArray[app.pA->StepIndex]->P[0];
	Temp.Scale(app.saarm.LocalToInches);
	Temp.Sub(Circle.center);  
	Temp.Normalize();
	Vector YAxis;
	YAxis.Cross(ZAxis,Temp);
	YAxis.Normalize();
	Vector XAxis;
	XAxis.Cross(YAxis,ZAxis);
	XAxis.Normalize();
	T->SetRotation(XAxis,YAxis,ZAxis);
	T->SetTranslation(Origin);
}

void DHoleMeas::ProcessAccept()
{
	TRACE("DHoleMeas::ProcessAccept, stepindex = %d\n", app.pA->StepIndex);
	if(app.pA->StepIndex==0)
	{
		if(app.saarm.Data.ds_planeSet && app.pA->DataArray[0]->GetSize()==0)
		{
			*app.pA->DataArray[0] = app.saarm.Data.ds_plane.PPts;
		}
		else if(app.pA->DataArray[0]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough app.saarm.Data."));
			ProcessingAccept = FALSE;
			return;
		}
		else	// reset the persisted plane
		{
			CString m;
			m.Format(Tr("Plane ") + Plane.timeStamp);
			planeLabel.SetWindowText(m);
			app.saarm.Data.ds_plane = Plane;
			app.saarm.Data.ds_plane.samples = app.pA->DataArray[0]->GetSize();
			app.saarm.Data.ds_plane.PPts = *app.pA->DataArray[0];
		}

//		OKButton.EnableWindow(FALSE);
//		app.pA->RemoteMouse(FALSE);
		if(Pin)
		{
			SetDlgItemText(IDOK,Tr("Accept Pin"));
			OKButton.EnableWindow(FALSE);
			app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Pin"));
		}
		else
		{
			SetDlgItemText(IDOK,Tr("Accept Hole"));
			OKButton.EnableWindow(FALSE);
			app.saarm.TTS.TextToSpeech(_T("Measure at least three Points in hole"));
		}
		DGenMeas::ProcessAccept();
	}
	else if(app.pA->StepIndex==1)
	{
		if(app.pA->DataArray[1]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough points for circle."));
			ProcessingAccept = FALSE;
			return;
		}
		if(!enoughdata)
		{
			ProcessingAccept = FALSE;
			return;
		}

		notes.RemoveAll();
		
		if(Pin)
			notes.Add(Tr("Pin/Circle created by ") + app.saarm.CMMString);
		else
			notes.Add(Tr("Hole/Circle created by ") + app.saarm.CMMString);


		notes.Add(Tr("Plane ") + Plane.timeStamp);
		
		notes.Add(PSampleText + Tr(" for Plane   ") + CSampleText + Tr(" for Circle"));
		notes.Add(Tr("Plane: ") + Plane.maxerrinfo + _T("   ") + Plane.rmserrinfo + _T(" ") + app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		notes.Add(Tr("Circle: ") + Circle.maxerrinfo + _T("   ") + Circle.rmserrinfo + _T(" ") + app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		notes.Add(Circle.radiusinfo);

		app.saarm.Data.ds_planeSet = true;
		
		if(Pin)
			app.saarm.TTS.TextToSpeech(Tr("Pin accepted"));
		else
			app.saarm.TTS.TextToSpeech(Tr("Hole accepted"));
		
		if(Inspect)
			PresentComparisonResults();
		else
		{
			CString tName;
			tName.Format(_T("%s"), app.saarm.Data.Target);
			if(app.saarm.Data.geomName.IsEmpty())
			{
				name.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
			}
			else
			{
				name = app.saarm.Data.geomName;
				app.pA->IncrementName(app.saarm.Data.geomName);
			}
			//if(Pin)
			//{
			//	targName.Format(Tr("Pin Center ") + app.saarm.Data.Target);
			//	name += _T("_Pin");
			//}
			//else
			//{
			//	targName.Format(Tr("Hole Center ") + app.saarm.Data.Target);
			//	name += _T("_Hole");
			//}

			app.saarm.Data.measCommentArray.RemoveAll();
			app.saarm.Data.measCommentArray.Append(notes);
			center.Scale(1.0/app.saarm.GetInstrumentScaleFactor());
			app.pA->MeasToSpan(center, app.saarm.Data.Group, app.saarm.Data.Target, true, false);

			if( app.saarm.Data.SendGeom )
				app.saarm.SockGeom.SendCircle(t, rad, name, notes);

			if(app.saarm.Data.FirePointsToo)
			{
				CString tempGName = app.saarm.Data.Group;
				app.saarm.Data.Group.Format(_T("%s_%s-Meas"), tempGName, tName);
				app.pA->ScaleDataArrays(1.0/app.saarm.GetInstrumentScaleFactor());
				app.pA->MeasToSpan(app.pA->DataArray[0], Tr("PlanePoint"));
				app.pA->MeasToSpan(app.pA->DataArray[1], Tr("CirclePoint"));
				app.saarm.Data.Group = tempGName;
			}

			if(app.saarm.Data.incrementgroup)
			{
				app.saarm.Data.Target.Format(_T("P1"));
				app.pA->IncrementName(app.saarm.Data.Group, 1);
			}
			else
				app.pA->IncrementName(app.saarm.Data.Target, 1);

			app.pA->DataArray[1]->Clear();

			CheckForDS_Plane();
			ctr = -1;
			UpdateCircle(0);
			app.pA->SetDisplayData();
		}
	}
	ProcessingAccept = FALSE;
}

void DHoleMeas::PresentComparisonResults()
{
	// 2004.08.29 - stop the meas timer so button hits stop getting or deleting app.saarm.Data...
	PauseMeasTimer();

	app.saarm.TTS.TextToSpeech(_T("Comparison Results"));
	//do all the mapping to working
	Vector ActualCenter,ActualCenterInWork;
	ActualCenter = center;
	ActualTrans = t;
	ActualRadius = rad;
	ActualTrans.GetTranslation(&ActualCenter);
	app.saarm.InstToWorking.Multiply(ActualCenter,&ActualCenterInWork);
	Vector NominalCenter,NominalCenterInWork;
	NominalTrans.GetTranslation(&NominalCenter);
	NominalTrans.Debug();
	NominalCenter.Debug();
	
	app.saarm.InstToWorking.Multiply(NominalCenter,&NominalCenterInWork);
	NominalCenterInWork.Debug();
	Vector DeltaInWork(ActualCenterInWork);
	DeltaInWork.Sub(NominalCenterInWork);

	//get diff in z axes
	Vector xa,ya,zact,znom;

	ActualTrans.GetAxes(&xa,&ya,&zact);
	NominalTrans.GetAxes(&xa,&ya,&znom);
	double AngleError = 0;
	Vector axis;
	if(zact.Dot(znom)<0) //in diff directions
		zact.Scale(-1.0); //reverse one of them
	AngleError = zact.AngleBetween(znom,&axis);

	double DiaError = (ActualRadius - NominalRadius)*2.0;
		
	//NominalCenterInWork.Debug();
	//ActualCenterInWork.Debug();
	//DeltaInWork.Debug();


	DCompareResults diag;
	CString res,next;

	SAIPFitQueryBlock qb;

	if(Pin)
		res.Format(_T("Pin Inspection   -  %s"), ObName);
	else
		res.Format(_T("Hole Inspection   -  %s"), ObName);
	qb.Text.Add(res);
	res.Format(_T("Nominal Center   = %8.*f %8.*f %8.*f %s"),
		app.saarm.Data.Precision,NominalCenterInWork.x/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.Data.Precision,NominalCenterInWork.y/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.Data.Precision,NominalCenterInWork.z/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(res);
	res += _T("\n");
	next.Format(_T("Actual Center   = %8.*f %8.*f %8.*f %s"),
		app.saarm.Data.Precision,ActualCenterInWork.x/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.Data.Precision,ActualCenterInWork.y/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.Data.Precision,ActualCenterInWork.z/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res += next + _T("\n");
	next.Format(_T("Delta Center    = %8.*f %8.*f %8.*f %s"),
		app.saarm.Data.Precision,DeltaInWork.x/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.Data.Precision,DeltaInWork.y/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.Data.Precision,DeltaInWork.z/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res +=next + _T("\n\n");

	next.Format(_T("Nominal Diameter  = %8.*f %s"),
		app.saarm.Data.Precision,NominalRadius*2.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res +=next + _T("\n");
	next.Format(_T("Actual Diameter   = %8.*f %s"),
		app.saarm.Data.Precision,ActualRadius*2.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res +=next + _T("\n");
	next.Format(_T("Delta Diameter    = %8.*f %s"),
		app.saarm.Data.Precision,DiaError/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res +=next + _T("\n\n");

	next.Format(_T("Normal Direction Deviation   = %6.4f  degrees"),
		fabs(AngleError) );
	qb.Text.Add(next);
	res +=next;

	diag.m_Results = res;

//	if(Pin)
//		app.pA->SendReportItem("Pin Inspection Results", " ", Rep);
//	else
//		app.pA->SendReportItem("Hole Inspection Results", " ", Rep);

//	while(RDS_IsButtonNDown(1)||RDS_IsButtonNDown(2)||RDS_IsButtonNDown(3))
//		RDS_GetSystemUpdate(TRUE);
//	app.pA->RemoteMouse(TRUE);
	if( diag.DoModal() == IDOK )
		app.saarm.QS.SendPacket(qb);
	DGenMeas::OnOK();
}

BOOL DHoleMeas::MakeFakeData(int step)
{
	TRACE("MakeFakeData!!\n");
	if(app.StopNow)
		return FALSE;			

	switch(step)
	{
	case 0:
		{
			app.pA->X = 0.7 + ((double)rand())/((double)RAND_MAX)*0.1;
			app.pA->Y = ((double)rand())/((double)RAND_MAX)*0.1;
			app.pA->Z = -0.3;
			break;
		}
	case 1:
		{
			Vector XYZ(0.7, 0.1, -0.3), newXYZ;
			double rho, theta, phi;

			ProcessWaitingMessages();
			Delay(0.0005);

			if(app.StopNow)
				return FALSE;			

			rho = 0.02;
			phi = 180.0*((double)rand())/((double)RAND_MAX);
			theta = 90.0;

			Vector dhv(rho, phi, theta);
			Vector xyz;
			dhv.RTPtoXYZ(&xyz);

			newXYZ = XYZ;
			newXYZ.Add(xyz);
			app.pA->X = newXYZ.x;
			app.pA->Y = newXYZ.y;
			app.pA->Z = newXYZ.z;

			break;
		}
	default:
		break;
	}
	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DHoleMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DHoleMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DHoleMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DHoleMeas::OnButtonOneshort() 
{
	SetB1Short();
}

void DHoleMeas::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DHoleMeas::OnOK() 
{
	ProcessAccept();
}

void DHoleMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DHoleMeas"),this);	
}

void DHoleMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DHoleMeas"),this);

	DGenMeas::OnDestroy();
}

void DHoleMeas::OnBnClickedButtonHoleSelectPlane()
{
	SAIPGeomPlane gp;
	if(app.saarm.SelectPlaneFromSA(gp))
	{
		app.saarm.Data.ds_plane.SetFromSAIPGeomPlane(gp);
		app.saarm.Data.ds_planeSet = true;
		CheckForDS_Plane();
	}
}
