#if !defined(AFX_DHOLEMEAS_H__5D5456C6_6F93_402C_A596_6B8007CC5D6B__INCLUDED_)
#define AFX_DHOLEMEAS_H__5D5456C6_6F93_402C_A596_6B8007CC5D6B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DHoleMeas.h : header file
//

#include "DGenMeas.h"
#include "CircleObj.h"
#include "PlaneObj.h"
#include "afxwin.h"

/////////////////////////////////////////////////////////////////////////////
// DHoleMeas dialog

class DHoleMeas : public DGenMeas
{
// Construction
public:
	CString ObName;
	DHoleMeas(CWnd* pParent = NULL);   // standard constructor

	PlaneObj Plane;
	CircleObj Circle;

	virtual BOOL ProcessNewData(int inc);
	virtual BOOL Init();
	virtual void SetGTNames();
	virtual void ProcessAccept();
	
	BOOL UpdatePlane(int inc);
	bool CheckForDS_Plane();
	BOOL UpdateCircle(int inc);
	void UpdateDialog();
	void MakeFrame(Transform* T);
	void PresentComparisonResults();

	// simulation mode
	virtual BOOL MakeFakeData(int step);

	VectorArray CircPointsOnPlane;
	CString PSampleText;
	CString CSampleText;
	CString TipText;
	double NominalRadius;
	Transform NominalTrans;
	Transform ActualTrans;
	double ActualRadius;
	BOOL Inspect;
	BOOL Pin; //Flag to set Pin or Hole
	int insideoutside;

// Dialog Data
	//{{AFX_DATA(DHoleMeas)
	enum { IDD = IDD_HOLEMEAS };
	CStatic	Shift;
	CButton	circbox;
	CStatic	radius;
	CStatic	Psamples;
	CStatic	Prmserr;
	CStatic	Pmaxerr;
	CStatic	Csamples;
	CStatic	Crmserr;
	CStatic	Cmaxerr;
	CStatic	Tip;
	CButton	B2short_button;
	CButton	B2long_button;
	CButton	B1short_button;
	CButton	B1long_button;
	CButton	OKButton;
	CEdit	GroupCtrl;
	CEdit	TargCtrl;
	CString	Group;
	CString	Target;
	CString	ShiftText;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DHoleMeas)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(DHoleMeas)
	afx_msg void OnButtonOnelong();
	afx_msg void OnButtonOneshort();
	afx_msg void OnButtonTwolong();
	afx_msg void OnButtonTwoshort();
	afx_msg void OnDefault();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	CStatic eval_message;
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDestroy();
	CStatic planeLabel;
	afx_msg void OnBnClickedButtonHoleSelectPlane();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DHOLEMEAS_H__5D5456C6_6F93_402C_A596_6B8007CC5D6B__INCLUDED_)
