// DLineMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DLineMeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DLineMeas dialog


DLineMeas::DLineMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DLineMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DLineMeas)
	Group = _T("");
	Target = _T("");
	//}}AFX_DATA_INIT
	SampleText = "";
	TipText = "";
	P1Text = "";
	P2Text = "";
	DeltaText = "";
	MagText = "";

}


void DLineMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DLineMeas)
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT2, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG2, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT2, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_TEDIT, Target);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SAMPLES, samples_ctrl);
	DDX_Control(pDX, IDC_MAXERR, maxerr_ctrl);
	DDX_Control(pDX, IDC_RMSERR, rmserr_ctrl);
}


BEGIN_MESSAGE_MAP(DLineMeas, DGenMeas)
	//{{AFX_MSG_MAP(DLineMeas)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT2, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG2, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT2, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLineMeas message handlers

BOOL DLineMeas::Init() 
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	OKButton.EnableWindow(FALSE);

	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);

	SetGTNames();
	UpdateLine();	
	app.saarm.TTS.TextToSpeech(_T("Measure Two Line Points"));

	DGenMeas::Init();	// call Base class Init for translation, etc.
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void DLineMeas::SetGTNames()
{
	Group = app.saarm.Data.Group;
	GroupCtrl.SetWindowText(Group);
	Target = app.saarm.Data.Target;
	TargCtrl.SetWindowText(Target);
}

BOOL DLineMeas::ProcessNewData(int inc) 
{
	UpdateData(TRUE);
	app.pA->ClearButtonState();
	return UpdateLine();
}

void DLineMeas::ProcessAccept()
{
	if(!UpdateLine())
	{
		ProcessingAccept = FALSE;
		return;
	}

	if(app.saarm.Data.geomName.IsEmpty())
	{
		name.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
	}
	else
	{
		name = app.saarm.Data.geomName;
		app.pA->IncrementName(app.saarm.Data.geomName);
	}
	notes.RemoveAll();
	notes.Add(Tr("Line created by ") + app.saarm.CMMString);
	
	app.saarm.SockGeom.SendLine(P1,P2,FALSE,name,notes);

	app.saarm.TTS.TextToSpeech(_T("Line accepted"));

	//////////////////////////////////////////////
	// TESTING ONLY!!!!
	//		SAIPGeomCylinder cyl;
	//		cyl.Name.Format(_T("Test!"));
	//		cyl.PtA = *DataArray[0]->P[0];
	//		cyl.PtB = *DataArray[0]->P[1];
	//		cyl.PtA.Scale(app.saarm.LocalToInches);
	//		cyl.PtB.Scale(app.saarm.LocalToInches);
	//		cyl.Diameter = 3.0;
	//		app.saarm.QS.SendPacket(cyl);
	// END TEST
	/////////////////////////////////////////////

	app.saarm.Data.measCommentArray.RemoveAll();
	app.saarm.Data.measCommentArray.Append(notes);

	if( app.saarm.Data.FirePointsToo )
	{
		CString tempGName = app.saarm.Data.Group;
		app.saarm.Data.Group.Format(_T("%s_%s-Meas"), tempGName, app.saarm.Data.Target);
		app.pA->ScaleDataArrays(1.0/app.saarm.GetInstrumentScaleFactor());
		app.pA->MeasToSpan(app.pA->DataArray[0], app.saarm.Data.Target);
		app.saarm.Data.Group = tempGName;
		app.pA->IncrementName(app.saarm.Data.Target, app.saarm.Data.ptnameinc);
	}
	if(app.saarm.Data.incrementgroup)
	{
		app.saarm.Data.Target.Format(_T("P1"));
		app.pA->IncrementName(app.saarm.Data.Group, 1);
	}
	
	app.pA->DataArray[0]->Clear();
	ctr = -1;
	ProcessNewData(0);

	app.pA->SetDisplayData();

	ProcessingAccept = FALSE;
}

BOOL DLineMeas::UpdateLine()
{
	P1Text = _T("");
	P2Text = _T("");
	DeltaText = _T("");
	MagText = _T("");
	CString s;
	s.Format(_T("%d "), ctr+1);
	samples_ctrl.SetWindowText(s + Tr("Samples"));
	maxerr_ctrl.SetWindowText(Tr("Max Err"));
	rmserr_ctrl.SetWindowText(Tr("RMS Err"));
	Vector P1Work;
	
	if(app.pA->DataArray[0]->GetSize() <= 0)
	{
		samples_ctrl.SetWindowText(Tr("Samples"));
	}
	if(app.pA->DataArray[0]->GetSize()>0)
	{
		// post first now
		P1 = *app.pA->DataArray[0]->P[0];
		app.saarm.InstToWorking.Multiply(P1,&P1Work);
		P1Work.Scale(1.0/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
		P1Text.Format(_T("P1 = %8.*f %8.*f %8.*f"),
			app.saarm.Data.Precision,P1Work.x,
			app.saarm.Data.Precision,P1Work.y,
			app.saarm.Data.Precision,P1Work.z);
	}
	if(app.pA->DataArray[0]->GetSize() == 2)	// 2 pt. line...
	{
		// post first now
		P1 = *app.pA->DataArray[0]->P[0];
		app.saarm.InstToWorking.Multiply(P1,&P1Work);
		P1Work.Scale(1.0/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
		P1Text.Format(_T("P1 = %8.*f %8.*f %8.*f"),
			app.saarm.Data.Precision,P1Work.x,
			app.saarm.Data.Precision,P1Work.y,
			app.saarm.Data.Precision,P1Work.z);
		// post second now
		Vector P2Work;
		P2 = *app.pA->DataArray[0]->P[1];
		app.saarm.InstToWorking.Multiply(P2,&P2Work);
		P2Work.Scale(1.0/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
		P2Text.Format(_T("P2 = %8.*f %8.*f %8.*f"),
			app.saarm.Data.Precision,P2Work.x,
			app.saarm.Data.Precision,P2Work.y,
			app.saarm.Data.Precision,P2Work.z);
		Vector Del(P2Work);
		Del.Sub(P1Work);
		DeltaText.Format(_T("delta = %8.*f %8.*f %8.*f"),
			app.saarm.Data.Precision,Del.x,
			app.saarm.Data.Precision,Del.y,
			app.saarm.Data.Precision,Del.z);
		MagText.Format(_T("Length = %8.*f"),app.saarm.Data.Precision,Del.Length());
		maxerr_ctrl.SetWindowText(Tr("Max Err 0.0"));
		rmserr_ctrl.SetWindowText(Tr("RMS Err 0.0"));
		OKButton.EnableWindow(TRUE);
		UpdateDialog();
		return TRUE;
	}
	if(app.pA->DataArray[0]->GetSize() > 2)	// fit a line...
	{
		// do a fit...
		LineFit lf;
		CString name(_T("whoCares"));
		TRACE0("data pt 0...\n");
		app.pA->DataArray[0]->P.GetAt(0)->Debug();
		for(int i=0; i<app.pA->DataArray[0]->GetSize(); i++)
			lf.AddData(name, *app.pA->DataArray[0]->P.GetAt(i), app.saarm.Data.TipDia/2.0, app.saarm.Data.TipDia/2.0);
		lf.ShowProgress(TRUE);
		//lf.SetInputParams()
		if(!lf.Fit())
			return FALSE;
		PhLine& l = *((PhLine*)lf.GetGeometry());
		TRACE1("GetGeometry - name=%s, ", l.name);
		TRACE3("A:x=%f,y=%f,z=%f\n",
			l.A.x,l.A.y,l.A.z);
		TRACE3("B:x=%f,y=%f,z=%f\n",
			l.B.x,l.B.y,l.B.z);

		FitSummary fs;
		if(lf.Stats(&fs))
		{
			double absmax = fs.absmax/app.saarm.units.UnitToMeters[DISTUNITS_IN];
			double absmin = fs.absmin/app.saarm.units.UnitToMeters[DISTUNITS_IN];
			double mean = fs.mean/app.saarm.units.UnitToMeters[DISTUNITS_IN];
			double RMS = fs.rms/app.saarm.units.UnitToMeters[DISTUNITS_IN];
			TRACE3("LineFit Errs: max=%f, mean=%f, rms=%f\n", absmax, mean, RMS);
			CString m, r;
			m.Format(_T("%f"), absmax);
			r.Format(_T("%f"), RMS);
			maxerr_ctrl.SetWindowText(Tr("Max Err ") + m);
			rmserr_ctrl.SetWindowText(Tr("RMS Err ") + r);
		}

		P1 = l.A;
		Vector P1Work;
		app.saarm.InstToWorking.Multiply(P1,&P1Work);
		P1Work.Scale(1.0/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
		P1Text.Format(_T("P1 = %8.*f %8.*f %8.*f"),
			app.saarm.Data.Precision,P1Work.x,
			app.saarm.Data.Precision,P1Work.y,
			app.saarm.Data.Precision,P1Work.z);

		P2 = l.B;
		Vector P2Work;
		app.saarm.InstToWorking.Multiply(P2,&P2Work);
		P2Work.Scale(1.0/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
		P2Text.Format(_T("P2 = %8.*f %8.*f %8.*f"),
			app.saarm.Data.Precision,P2Work.x,
			app.saarm.Data.Precision,P2Work.y,
			app.saarm.Data.Precision,P2Work.z);
		Vector Del(P2Work);
		Del.Sub(P1Work);
		DeltaText.Format(_T("Delta = %8.*f %8.*f %8.*f"),
			app.saarm.Data.Precision,Del.x,
			app.saarm.Data.Precision,Del.y,
			app.saarm.Data.Precision,Del.z);
		MagText.Format(_T("Length = %8.*f"),app.saarm.Data.Precision,Del.Length());
		OKButton.EnableWindow(TRUE);
		UpdateDialog();
		return TRUE;
	}
	else
	{
		OKButton.EnableWindow(FALSE);
		UpdateDialog();
		return FALSE;
	}
}

void DLineMeas::UpdateDialog()
{
	SetDlgItemText(IDC_P1,P1Text);
	SetDlgItemText(IDC_P2,P2Text);
	SetDlgItemText(IDC_DELTA,DeltaText);
	SetDlgItemText(IDC_MAG,MagText);
	SetDlgItemText(IDC_TIP,TipText);
}

void DLineMeas::OnOK() 
{
	ProcessAccept();
}

BOOL DLineMeas::MakeFakeData(int step)
{
	if(app.StopNow)
		return FALSE;			
	
	app.pA->X = ((double)rand())/((double)RAND_MAX);
	app.pA->Y = ((double)rand())/((double)RAND_MAX);
	app.pA->Z = -0.3;

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DLineMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DLineMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DLineMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DLineMeas::OnButtonOneshort() 
{
	SetB1Short();
}

void DLineMeas::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DLineMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DLineMeas"),this);	
}

void DLineMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DLineMeas"),this);

	DGenMeas::OnDestroy();
}