// DLogon2.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DLogon2.h"
#include ".\dlogon2.h"
#include "HelpUI/HTMLHelpDlg.h"
#include "resource.h"
//#include "IPC.h"
//#include "DIPInfo.h"
//#include "simple_ping.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DLogon2 dialog


DLogon2::DLogon2(CWnd* pParent /*=NULL*/)
	: CDialog(DLogon2::IDD, pParent)
{
	//{{AFX_DATA_INIT(DLogon2)
	m_User = _T("");
	m_showall = FALSE;
	doconnection = TRUE;
	//}}AFX_DATA_INIT
	SAPort = 0;
}


void DLogon2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DLogon2)
	DDX_Control(pDX, IDC_TREE1, m_browsetree);
	DDX_Text(pDX, IDC_USEREDIT, m_User);
	DDX_Check(pDX, IDC_CHECK1, m_showall);
	DDX_Check(pDX, IDC_CHECKCONNECT, doconnection);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_BUTTON_HELP_STARTUP, helpButton);
}


BEGIN_MESSAGE_MAP(DLogon2, CDialog)
	//{{AFX_MSG_MAP(DLogon2)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE1, OnDblclkTree)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_HELP_STARTUP, OnBnClickedButtonHelpStartup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLogon2 message handlers



void DLogon2::OnOK() 
{
	if (!m_browsetree.GetResult(&SAComputer,&SAPort,&SAName))		// jmcbrowse - Computer and Name should be stored for auto pick next time.
		AfxMessageBox(_T("Please Select a valid SA to connect to.\nYou will need to have SA running and the proper instrument added to the model."));
	else
	{
		CDialog::OnOK();
	}
}

void DLogon2::OnCheck1() 
{
	UpdateData(TRUE);
	if (m_showall)
		m_browsetree.RefreshAll();
	else
		m_browsetree.RefreshFiltered();
	
}

BOOL DLogon2::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_browsetree.SetPickInfo(SAComputer,SAName);
	m_browsetree.InitializeNoRefresh();
	m_browsetree.ClearReturnFilterSet();
	// Romers
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,12);
	// Faro Serial's
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,6);
	// Faro USB's
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,47+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,48+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,49+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,50+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,51+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,52+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,53+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,54+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,55+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,56+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,124+1);	// Edge
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,162+1);	// QuantumS or QuantumM 2.5m 7dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,163+1);	// QuantumS or QuantumM 1.5m 6dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,164+1);	// QuantumS or QuantumM 3.5m 7dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,165+1);	// QuantumS or QuantumM 4m 7dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,166+1);	// QuantumS or QuantumM 2.5m 6dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,167+1);	// QuantumS or QuantumM 3.5m 6dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,168+1);	// QuantumS or QuantumM 4m 6dof
	// API Axxis's
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,104+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,105+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,106+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,146+1);
	// SNL
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,39);
	// French Romer
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,76+1);
	// Metris MCA
	//m_browsetree.AddItemToReturnFilterSet(DEVID_SA,86+1);		// 2009.10.09 - Metris now supports the MCA via their HHAPI interface (our Metris K-Series interface)
	// Hexagon
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,117+1);
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,125+1);	// Absolute 7x25SI (7325 and 7525)
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,118+1);	// Absolute 7x20SI (7320 and 7520)
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,119+1);	// Hexagon Absolute 7x20 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,126+1);	// Hexagon Absolute 7x30SI 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,127+1);	// Hexagon Absolute 7x35SI 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,128+1);	// Hexagon Absolute 7x40SI 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,129+1);	// Hexagon Absolute 7x45SI 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,130+1);	// Hexagon Absolute 7315 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,131+1);	// Hexagon Absolute 7x25 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,132+1);	// Hexagon Absolute 7x30 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,133+1);	// Hexagon Absolute 7x35 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,134+1);	// Hexagon Absolute 7x40 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,135+1);	// Hexagon Absolute 7x45 6 dof

	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,169+1);	// Hexagon Absolute 8 2.0m 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,170+1);	// Hexagon Absolute 8 2.5m 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,171+1);	// Hexagon Absolute 8 3.0m 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,172+1);	// Hexagon Absolute 8 3.5m 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,173+1);	// Hexagon Absolute 8 4.0m 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,174+1);	// Hexagon Absolute 8 4.5m 7 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,175+1);	// Hexagon Absolute 8 1.2m 6 dof Compact
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,176+1);	// Hexagon Absolute 8 2.0m 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,177+1);	// Hexagon Absolute 8 2.5m 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,178+1);	// Hexagon Absolute 8 3.0m 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,179+1);	// Hexagon Absolute 8 3.5m 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,180+1);	// Hexagon Absolute 8 4.0m 6 dof
	m_browsetree.AddItemToReturnFilterSet(DEVID_SA,181+1);	// Hexagon Absolute 8 4.5m 6 dof

	m_browsetree.SetBroadcastFilters(DEVID_SA, 0);
	m_browsetree.RefreshFiltered();

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	helpButton.SetIcon16x16(IDI_ICONQUEST);

	TRANSLATE_DIALOG;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DLogon2::OnDblclkTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnOK();
	*pResult = 0;
}

void DLogon2::OnCancel() 
{
	app.StopNow = TRUE;
	CDialog::OnCancel();
}

void DLogon2::OnClose() 
{
	app.StopNow = TRUE;	
	CDialog::OnClose();
}

void DLogon2::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DLogon2"),this);	
}

void DLogon2::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DLogon2"),this);

	CDialog::OnDestroy();
}
void DLogon2::OnBnClickedButtonHelpStartup()
{
	HTMLHelpDlg dlg(_T("Connection/Startup Info"), _T("Arms\\StartUp\\index.htm"));
	//DOMODAL(dlg);
	dlg.DoModal();
}
