// DOffsetLine.cpp : implementation file
//

#include "stdafx.h"
#include "DPCMM.h"
#include "DOffsetLine.h"
#include ".\doffsetline.h"


// DOffsetLine dialog

IMPLEMENT_DYNAMIC(DOffsetLine, CDialog)
DOffsetLine::DOffsetLine(CWnd* pParent /*=NULL*/)
	: DGenMeas(DOffsetLine::IDD, pParent)
	, Target(_T(""))
	, Group(_T(""))
{
	p1Set= false;
	p2Set = false;
	dist1=dist2 = 0.0;
}

DOffsetLine::~DOffsetLine()
{
}

void DOffsetLine::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_STATIC_PLANE_LABEL, planeLabel);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDC_STATIC_EVAL, eval_message);
	DDX_Control(pDX, IDC_PSAMPLES, Psamples);
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Control(pDX, IDC_STRMINDICATOR, StreamIndicator);
	DDX_Control(pDX, IDC_P1, P1_ctrl);
	DDX_Control(pDX, IDC_P2, P2_ctrl);
	DDX_Control(pDX, IDC_DELTA, length_ctrl);
}


BEGIN_MESSAGE_MAP(DOffsetLine, DGenMeas)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_OFFSET_LINE_SELECT_PLANE, &DOffsetLine::OnBnClickedButtonOffsetLineSelectPlane)
END_MESSAGE_MAP()


// DOffsetLine message handlers
BOOL DOffsetLine::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		return FALSE;
	}
	OKButton.EnableWindow(FALSE);
	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);

	P1_ctrl.SetWindowText(_T("P1"));
	P2_ctrl.SetWindowText(_T("P2"));
	length_ctrl.SetWindowText(_T("Delta"));

	SetWindowText(title);
	SetDlgItemText(IDOK,Tr("Accept Plane"));

	CheckForOffsetPlane();

	SetGTNames();
	SetStreamIndicator(FALSE);
	if(app.saarm.Data.sm_planeSet)
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane, or accept Plane."));
	else
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane."));

	//	MessageBeep(-1);

	DGenMeas::Init();	// call Base class Init for translation, etc.

	streaming = FALSE;
	sendfromdlg = FALSE;

	return TRUE;
}
void DOffsetLine::SetGTNames()
{
	Group = app.saarm.Data.Group;
	GroupCtrl.SetWindowText(Group);
	Target = app.saarm.Data.Target;
	TargCtrl.SetWindowText(Target);
}
void DOffsetLine::SetStreamIndicator(BOOL strm)
{
	if(strm)
	{
		TRACE0("Setting stream indicator ON\n");
		StreamIndicator.SetBkColor(RGB(0,255,0));
		StreamIndicator.SetTextColor(RGB(0,0,0));
		StreamIndicator.SetWindowText(_T("ON"));
	}
	else
	{
		TRACE0("Setting stream indicator OFF\n");
		StreamIndicator.SetBkColor(RGB(255,0,0));
		StreamIndicator.SetTextColor(RGB(0,0,0));
		StreamIndicator.SetWindowText(_T("OFF"));
	}
}

BOOL DOffsetLine::ProcessNewData(int inc) 
{
	if(app.pA->StepIndex==0)
	{
		return UpdatePlane(inc);
	}
	else if(app.pA->StepIndex==1)
	{
		return UpdateLine(inc);
	}
	return FALSE;
}

void DOffsetLine::UpdateDialog()
{
	SetDlgItemText(IDC_PSAMPLES,PSampleText);
	SetDlgItemText(IDC_PLANE,Plane.PlaneText);
	SetDlgItemText(IDC_PRMSERR,Plane.rmserrinfo);
	SetDlgItemText(IDC_PMAXERR,Plane.maxerrinfo);
}

bool DOffsetLine::CheckForOffsetPlane()
{
	if( !app.saarm.Data.sm_planeSet )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		OKButton.EnableWindow(FALSE);
		return false;
	}
	Plane = app.saarm.Data.sheetMetalPlane;
	PSampleText.Format(_T("%d Samples"), Plane.samples);
	CString m;
	m.Format(Tr("Plane ") + Plane.timeStamp);
	planeLabel.SetWindowText(m);
	UpdateDialog();
	OKButton.EnableWindow();
	return true;
}
void DOffsetLine::ProcessAccept()
{
	TRACE("DOffsetLine::ProcessAccept, stepindex = %d\n", app.pA->StepIndex);
	if(app.pA->StepIndex==0)
	{
		if(app.saarm.Data.sm_planeSet && app.pA->DataArray[0]->GetSize()==0)
		{
			*app.pA->DataArray[0] = app.saarm.Data.sheetMetalPlane.PPts;
		}
		else if(app.pA->DataArray[0]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough data."));
			ProcessingAccept = FALSE;
			return;
		}
		else	// reset the persisted plane
		{
			CString m;
			m.Format(Tr("Plane ") + Plane.timeStamp);
			planeLabel.SetWindowText(m);
			app.saarm.Data.sheetMetalPlane = Plane;
			app.saarm.Data.sheetMetalPlane.samples = app.pA->DataArray[0]->GetSize();
			app.saarm.Data.sheetMetalPlane.PPts = *app.pA->DataArray[0];
			app.saarm.Data.sm_planeSet = true;
		}

		//		OKButton.EnableWindow(FALSE);
		//		app.pA->RemoteMouse(FALSE);
	

		SetDlgItemText(IDOK,Tr("Accept Line"));
		app.pA->StepIndex = 1;
		OKButton.EnableWindow(FALSE);
		app.saarm.TTS.TextToSpeech(_T("Hit measure button, and drag over edge for line points."));

		ProcessingAccept = FALSE;
		// now, we go into streaming mode for the edge sampling...
		streaming = TRUE;
		sendfromdlg = TRUE;
	}
	else if(app.pA->StepIndex==1)
	{
		if(!p1Set || !p2Set)
		{
			app.saarm.TTS.TextToSpeech(_T("Need two points for the line."));
			ProcessingAccept = FALSE;
			return;
		}

		OKButton.EnableWindow(FALSE);
		p1Set = false;
		p2Set = false;

		P1_ctrl.SetWindowText(_T("P1"));
		P2_ctrl.SetWindowText(_T("P2"));
		length_ctrl.SetWindowText(_T("Delta"));

		notes.RemoveAll();
		notes.Add(Tr("Edge Line created by ") + app.saarm.CMMString);
		notes.Add(Tr("Plane ") + Plane.timeStamp);
		notes.Add(PSampleText + Tr(" for Plane   "));
		notes.Add(Tr("Plane: ") + Plane.maxerrinfo + _T("   ") + Plane.rmserrinfo + _T(" ") + app.saarm.units.DistUnitNames[app.saarm.units.distunits]);

		if(app.saarm.Data.geomName.IsEmpty())
		{
			name.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
		}
		else
		{
			name = app.saarm.Data.geomName;
			app.pA->IncrementName(app.saarm.Data.geomName);
		}

		eval_message.SetWindowText(Tr("Projecting Pts. and Evaluating, Please Wait"));
		VectorArray Ps;
		Ps.Add(P1);
		Ps.Add(P2);

		VectorArray LinePointsOnPlane;
		Plane.ProjectPointsToPlane(Ps,&LinePointsOnPlane); //i/o all in inches

		// Get the radial offsets...
		double offset1 = 0.0;
		double offset2 = 0.0;
		bool offsetsOK = true;
		if(!GetRadialOffset(dist1, offset1))
			offsetsOK = false;
		if(!GetRadialOffset(dist2, offset2))
			offsetsOK = false;
		if(!offsetsOK)
		{
			eval_message.SetWindowText(_T("Could not calculate offsets, re-scan."));
			p1Set = false;
			p2Set = false;
			P1_ctrl.SetWindowText(_T("P1"));
			P2_ctrl.SetWindowText(_T("P2"));
			length_ctrl.SetWindowText(_T("Delta"));
			ProcessingAccept = FALSE;
			return;
		}
		// offset the projected points radially...
		Vector radialOffsetDir;
		GetRadialOffsetDirection(LinePointsOnPlane, radialOffsetDir);
		// apply the radial offset
		Vector offsetP1, offsetP2;
		offsetP1 = radialOffsetDir;
		offsetP1.Scale(offset1);
		offsetP2 = radialOffsetDir;
		offsetP2.Scale(offset2);

		Vector P1Offset, P2Offset;
		P1Offset = LinePointsOnPlane.Get(0);
		P2Offset = LinePointsOnPlane.Get(1);
		P1Offset.Add(offsetP1);
		P2Offset.Add(offsetP2);

		if(app.saarm.Data.FirePointsToo)
		{
			Vector off1, off2;
			off1 = P1Offset;
			off2 = P2Offset;
			CString tempGName = app.saarm.Data.Group;
			app.saarm.Data.Group.Format(_T("%s_%s-Meas"), tempGName, app.saarm.Data.Target);
			off1.Scale(1.0/app.saarm.GetInstrumentScaleFactor());
			off2.Scale(1.0/app.saarm.GetInstrumentScaleFactor());
			app.pA->MeasToSpan(off1, true, false, false);
			app.pA->MeasToSpan(off2, true, false, false);
			app.saarm.Data.Group = tempGName;
			app.pA->IncrementName(app.saarm.Data.Target, app.saarm.Data.ptnameinc);
		}
		app.pA->SetDisplayData();
		//////////////////////////////////////////////////////////////
		// testing ONLY!
		//CString tempName = app.saarm.Data.Group;
		//app.saarm.Data.Group.Format(_T("%s::ProbeCenter"), tempName);
		//app.pA->MeasToSpan(P1);
		//app.pA->MeasToSpan(P2);
		//app.saarm.Data.Group.Format(_T("%s::OnPlane"), tempName);
		//app.pA->MeasToSpan(LinePointsOnPlane.Get(0));
		//app.pA->MeasToSpan(LinePointsOnPlane.Get(1));
		//app.saarm.Data.Group = tempName;
		//app.pA->SetDisplayData();
		//////////////////////////////////////////////////////////////////
		app.saarm.SockGeom.SendLine(P1Offset,P2Offset,FALSE,name,notes);
		app.saarm.TTS.TextToSpeech(_T("Line accepted"));
	}
	eval_message.SetWindowText(_T(""));
	ProcessingAccept = FALSE;
}
BOOL DOffsetLine::UpdatePlane(int inc)
{
	PSampleText.Format(_T("%d Samples"), ctr+1);
	Psamples.SetWindowText(PSampleText);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);

	if(ctr < 0)
	{
		CheckForOffsetPlane();
		return FALSE;
	}

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3)// || inc <= 0 )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		SetDlgItemText(IDC_PLANE,Tr("ABCD"));
		SetDlgItemText(IDC_PRMSERR,Tr("Max Err"));
		SetDlgItemText(IDC_PMAXERR,Tr("RMS Err"));
		OKButton.EnableWindow(FALSE);
		return FALSE;
	}

	PauseMeasTimer();
	eval_message.SetWindowText(Tr("Fitting Plane, Please Wait"));
	//	if(app.saarm.Data.AddExtraPatchShift)
	//		m.Format("%d Samples    %5.2f %s Extra Shift",
	//		app.pA->DataArray[0]->GetSize(),
	//		app.saarm.Data.ExtraPatchShift/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
	//		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	//	else
	//		PSampleText.Format("%d Samples",ctr+1);
	//	Psamples.SetWindowText(m);

	//	double OldTip = app.pA->TipDia;
	//	if(app.pA->AddExtraPatchShift)
	//		app.pA->TipDia = app.pA->TipDia + (2.0 * app.pA->ExtraPatchShift);

	if(Plane.ComputePlane(app.pA->DataArray[0]))
		OKButton.EnableWindow(TRUE);
	else
		OKButton.EnableWindow(FALSE);

	UpdateDialog();
	ResumeMeasTimer();
	eval_message.SetWindowText(_T(""));
	return TRUE;
}
bool DOffsetLine::EvaluateLinePoint(Vector& pos, Vector& dir)
{
	// see if the point is at least 1/8 the probe diam.
	// below the plane (use normal from ijk to ensure BELOW)
	if(!app.saarm.Data.sm_planeSet)
		return false;
	double dist = Plane.QueryPointToPlane(pos);
	double eval = 0.0125*app.saarm.units.UnitToMeters[DISTUNITS_IN];
	// set eval sign according to dot product of ijk and plane normal...
	if(dir.Dot(Plane.normal)>0)
	{
		TRACE0("negating distance...\n");
		dist *= -1.0;
	}
	pos.Debug();
	double r = app.saarm.Data.TipDia/2.0;
	double distEval = r-dist;
	TRACE2("distance below plane = %f, eval distance = %f, the point:\n", distEval/app.saarm.units.UnitToMeters[DISTUNITS_IN], eval/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
	if(-distEval >= 0)
		return false;
	if(distEval >= eval)
	{
		if(!p1Set && !p2Set)
			dist1 = r - fabs(dist);
		else if(p1Set && !p2Set)
			dist2 = r - fabs(dist);
		Beep(800, 100);
		return true;
	}
	return false;
}
bool DOffsetLine::GetRadialOffset(const double& distBelowPlane, double& offset)
{
	// see 'sheet metal probe offset.jpg' in Documentation folder
	double d = distBelowPlane;
	double r = app.saarm.Data.TipDia/2.0;
	TRACE2("dist below plane = %f, r = %f\n", d/app.saarm.units.UnitToMeters[DISTUNITS_IN], r/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
	offset = r;
	double det = d/r;
	det *= 2.0;
	double DsqOverRsq = d*d;
	DsqOverRsq /= r*r;
	det -= DsqOverRsq;
	if(det < 0)
		return false;
	offset = SafeSqrt(det);
	offset *= r;
	if(offset > r)
		offset = r/2.0;
	TRACE1("radial offset = %f\n", offset/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
	return true;
}
bool DOffsetLine::GetRadialOffsetDirection(const VectorArray& PointsOnPlane, Vector& dir)
{
	// see 'sheet metal probe offset direction.jpg' in Documentation folder
	Vector AP1, AP2, P1P2;
	Vector A;
	Plane.t.GetTranslation(&A);
	AP1 = PointsOnPlane.Get(0);
	AP1.Sub(A);

	AP2 = PointsOnPlane.Get(1);
	AP2.Sub(A);

	P1P2 = PointsOnPlane.Get(1);
	P1P2.Sub(PointsOnPlane.Get(0));

	Vector det;
	det.Cross(AP1, AP2);
	dir.Cross(det, P1P2);
	dir.Normalize();

	return true;
}
BOOL DOffsetLine::UpdateLine(int inc)
{
	PauseMeasTimer();
	Vector CurrentPos(app.pA->X,app.pA->Y,app.pA->Z);
	Vector CurrentNorm(app.pA->II,app.pA->JJ,app.pA->KK);
	eval_message.SetWindowText(Tr("Evaluating, Please Wait"));

	CurrentPos.Scale(app.saarm.GetInstrumentScaleFactor());	// scale to the scaled plane to evaluate

	if(!p1Set && !p2Set)
	{
		if(EvaluateLinePoint(CurrentPos, CurrentNorm))
		{
			streamstarted = FALSE;
			SetStreamIndicator(FALSE);
			P1 = CurrentPos;
			p1Set = true;
			app.saarm.InstToWorking.Multiply(P1,&P1Work);
			P1Work.Scale(1.0/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
			P1Text.Format(_T("P1 = %8.*f %8.*f %8.*f"),
				app.saarm.Data.Precision,P1Work.x,
				app.saarm.Data.Precision,P1Work.y,
				app.saarm.Data.Precision,P1Work.z);
			P1_ctrl.SetWindowText(P1Text);
			UpdateData();
			TRACE1("%s\n", P1Text);
		}
	}
	else if(p1Set && !p2Set)	// 2 pt. line...
	{
		if(inc < 0)
		{
			streamstarted = FALSE;
			SetStreamIndicator(FALSE);
			p1Set = false;
			P1_ctrl.SetWindowText(_T(""));
			eval_message.SetWindowText(_T(""));
			ResumeMeasTimer();
			return TRUE;
		}
		if(EvaluateLinePoint(CurrentPos, CurrentNorm))
		{
			streamstarted = FALSE;
			SetStreamIndicator(FALSE);
			P2 = CurrentPos;
			p2Set = true;
			// post second now
			Vector P2Work;
			app.saarm.InstToWorking.Multiply(P2,&P2Work);
			P2Work.Scale(1.0/app.saarm.units.UnitToMeters[DISTUNITS_IN]);
			P2Text.Format(_T("P2 = %8.*f %8.*f %8.*f"),
				app.saarm.Data.Precision,P2Work.x,
				app.saarm.Data.Precision,P2Work.y,
				app.saarm.Data.Precision,P2Work.z);
			P2_ctrl.SetWindowText(P2Text);
			Vector Del(P2Work);
			Del.Sub(P1Work);
			DeltaText.Format(_T("Delta = %8.*f %8.*f %8.*f"),
				app.saarm.Data.Precision,Del.x,
				app.saarm.Data.Precision,Del.y,
				app.saarm.Data.Precision,Del.z);
			length_ctrl.SetWindowText(DeltaText);
			OKButton.EnableWindow(TRUE);
			UpdateDialog();

			ResumeMeasTimer();
			eval_message.SetWindowText(_T(""));
			OKButton.EnableWindow();

			return TRUE;
		}
	}
	else if(inc < 0)
	{
		streamstarted = FALSE;
		SetStreamIndicator(FALSE);
		p2Set = false;
		P2_ctrl.SetWindowText(_T(""));
	}
	eval_message.SetWindowText(_T(""));
	ResumeMeasTimer();
	//UpdateDialog();
	return TRUE;
}
void DOffsetLine::OnBnClickedOk()
{
	ProcessAccept();
}

void DOffsetLine::OnBnClickedButtonOffsetLineSelectPlane()
{
	SAIPGeomPlane gp;
	if(app.saarm.SelectPlaneFromSA(gp))
	{
		app.saarm.Data.sheetMetalPlane.SetFromSAIPGeomPlane(gp);
		app.saarm.Data.sm_planeSet = true;
		CheckForOffsetPlane();
	}
}
