#pragma once

#include "DGenMeas.h"
#include "PlaneObj.h"
#include "afxwin.h"

// DOffsetLine dialog

class DOffsetLine : public DGenMeas
{
	DECLARE_DYNAMIC(DOffsetLine)

public:
	DOffsetLine(CWnd* pParent = NULL);   // standard constructor
	virtual ~DOffsetLine();

	afx_msg void OnBnClickedOk();

	PlaneObj Plane;
	CString PSampleText;

	virtual BOOL ProcessNewData(int inc);
	virtual BOOL Init();
	virtual void SetGTNames();
	virtual void SetStreamIndicator(BOOL strm);
	virtual void ProcessAccept();

	BOOL UpdatePlane(int inc);
	BOOL UpdateLine(int inc);
	bool EvaluateLinePoint(Vector& pos, Vector& dir);
	bool GetRadialOffset(const double& distBelowPlane, double& offset);
	bool GetRadialOffsetDirection(const VectorArray& PointsOnPlane, Vector& dir);
	CString SampleText;
	CString TipText;
	CString P1Text;
	CString P2Text;
	CString DeltaText;
	CString MagText;

	bool CheckForOffsetPlane();
	void UpdateDialog();

// Dialog Data
	enum { IDD = IDD_OFFSETLINEMEAS };
	CButton OKButton;
	CStatic planeLabel;
	CStatic Tip;
	CStatic eval_message;
	CStatic Psamples;
	CEdit TargCtrl;
	CString Target;
	CEdit GroupCtrl;
	CString Group;
	NewColorStatic StreamIndicator;
	CStatic P1_ctrl;
	CStatic P2_ctrl;
	CStatic length_ctrl;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

private:
	bool p1Set;
	bool p2Set;
	Vector P1,P2, P1Work;
	Vector P1Projected, P2Projected;
	double dist1, dist2;
public:
	afx_msg void OnBnClickedButtonOffsetLineSelectPlane();
};
