// DOptions.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DOptions.h"
#include "DSpeech.h"
#include "DFitOptions.h"
#include "DJtJog.h"
#include "DTextViewer.h"
#include ".\doptions.h"
#include "Articulated/ArticulatedArmWrapper.h"
#include "ModelCorrection/ModelInfo.h"
#include "DVoxelSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DOptions dialog


DOptions::DOptions(CWnd* pParent /*=NULL*/)
	: CDialog(DOptions::IDD, pParent)
	, ptnameinc(0)
	, incrementgroup(FALSE)
	, autoCorrectModel(TRUE)
	, updatethreshold(0)
	, sendAllPtsAsCloudPts(FALSE)
	, UseScanStripeClouds(TRUE)
	, shankDia(0)
	, useShankForAutoProx(FALSE)
	, shankDiaUnitsVal(_T(""))
{
	//{{AFX_DATA_INIT(DOptions)
	m_Interval = 0.0;
	m_ExtraPatchShift = 0.0;
	m_ButOne = app.saarm.Data.ButtonOneMode;
	m_ButTwo = app.saarm.Data.ButtonTwoMode;
	m_ButThree = app.saarm.Data.ButtonThreeMode;
	m_TNSN = 0;
	m_IntervalUnits = _T("");
	m_PatchShiftUnits = _T("");
	m_ProbeNum = app.pA->GetProbeNumber();
	m_AutoDetectProbe = TRUE;
	m_AddExtraPatchShift = FALSE;
	m_FirePointsToo = FALSE;
	distunits = -1;
	updateSA = FALSE;
	probeDia = 0.0;
	probeDiaUnitsVal = _T("");
	shankDia = 0.0;
	measfreq = 0.0;
	updatefreq = 0.0;
	updatethreshold = 0.5;
	SendGeom = FALSE;
	FaroAuxOn = FALSE;
	//}}AFX_DATA_INIT
	pDlg = NULL;
}


void DOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DOptions)
	DDX_Control(pDX, IDC_CHECK_FARO_AUX, FaroAux_Check);
	DDX_Control(pDX, IDC_JOGJTS, jtjog_button);
	DDX_Control(pDX, IDC_PROBE_DIA_LABEL, probeDiaLabel);
	DDX_Control(pDX, IDC_PROBE_DIA_UNITS, probeDiaUnits);
	DDX_Control(pDX, IDC_BUTTON_THREE_FCN_LABEL, ButThreeCtrlLabel);
	DDX_Control(pDX, IDC_PROBE_DIA_EDIT, probeDiaEdit);
	DDX_Control(pDX, IDC_PROBE_EDIT_LABEL, probeNumLabel);
	DDX_Control(pDX, IDC_AUTODETECT, AutoDetectCheck);
	DDX_Control(pDX, IDC_STATICPATCHSHIFTUNITS, patchshiftunitCtrl);
	DDX_Control(pDX, IDC_STATICINTERVALUNITS, intervalunitCtrl);
	DDX_Control(pDX, IDC_APPLY, m_Apply);
	DDX_Control(pDX, IDC_PROBENUM, m_ProbeNumCtl);
	DDX_Text(pDX, IDC_INTERVAL, m_Interval);
	DDX_Text(pDX, IDC_OFFSETEDIT, m_ExtraPatchShift);
	DDX_CBIndex(pDX, IDC_FBCOMBO, m_ButOne);
	DDX_CBIndex(pDX, IDC_RBUTCOMBO, m_ButTwo);
	DDX_CBIndex(pDX, IDC_RBUTCOMBO2, m_ButThree);
	DDX_Text(pDX, IDC_TNSN, m_TNSN);
	DDX_Text(pDX, IDC_STATICINTERVALUNITS, m_IntervalUnits);
	DDX_Text(pDX, IDC_STATICPATCHSHIFTUNITS, m_PatchShiftUnits);
	DDX_Text(pDX, IDC_PROBENUM, m_ProbeNum);
	DDX_Check(pDX, IDC_AUTODETECT, m_AutoDetectProbe);
	DDX_Check(pDX, IDC_EXTRASHIFTCHECK, m_AddExtraPatchShift);
	DDX_Check(pDX, IDC_FIRECHECK, m_FirePointsToo);
	DDX_Control(pDX, IDC_RBUTCOMBO2, m_ButThreeCtrl);
	DDX_CBIndex(pDX, IDC_UNITSCOMBO, distunits);
	DDX_Check(pDX, IDC_UPDATESACHECK, updateSA);
	DDX_Text(pDX, IDC_PROBE_DIA_EDIT, probeDia);
	DDX_Text(pDX, IDC_PROBE_DIA_UNITS, probeDiaUnitsVal);
	DDX_Text(pDX, IDC_MEASFREQ, measfreq);
	DDX_Text(pDX, IDC_UPDATEFREQ, updatefreq);
	DDX_Check(pDX, IDC_SENDGEOM, SendGeom);
	DDX_Check(pDX, IDC_CHECK_FARO_AUX, FaroAuxOn);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_EDIT_PTNAMEINC, ptnameinc);
	DDX_Check(pDX, IDC_CHECK_INCGROUP, incrementgroup);
	DDX_Control(pDX, IDC_ARM_SETTINGS_BUTTON, arm_settings_btn);
	DDX_Control(pDX, IDC_ARTICULATOR_DRIVE, artic_drive_buton);
	DDX_Control(pDX, IDC_ARM_JT_DRIVE, artic_jt_drive_buton);
	DDX_Check(pDX, IDC_CHECK_AUTO_CORRECT_GRAPHICS, autoCorrectModel);
	DDX_Text(pDX, IDC_EDIT_JT_UPDATE_THRESHOLD, updatethreshold);
	DDX_Check(pDX, IDC_SEND_AS_CLOUDPTS_CHECK, sendAllPtsAsCloudPts);
	DDX_Control(pDX, IDC_BUTTON_ONE_FCN_LABEL, ButOneCtrlLabel);
	DDX_Control(pDX, IDC_BUTTON_TWO_FCN_LABEL, ButTwoCtrlLabel);
	DDX_Control(pDX, IDC_FBCOMBO, m_ButOneCtrl);
	DDX_Control(pDX, IDC_PROBE_CAL_SET, probeCalSetButton);
	DDX_Control(pDX, IDC_STATIC_EASY_PAD_USAGE_LABEL, EasyPadInstructions);
	DDX_Control(pDX, IDC_BUTTON_KREON_DONGLE_LICENSE, KreonDongleLicenseButton);
	DDX_Check(pDX, IDC_SEND_SCAN_STRIPE_CLOUDS_CHECK, UseScanStripeClouds);
	DDX_Check(pDX, IDC_CHECK_USE_SHANK_FOR_AUTOPROX, useShankForAutoProx);
	DDX_Control(pDX, IDC_EDIT_SHANK_DIA, shankDiaEdit);
	DDX_Control(pDX, IDC_STATIC_SHANK_RAD, shankDiaUnits);
	DDX_Text(pDX, IDC_STATIC_SHANK_RAD, shankDiaUnitsVal);
	DDX_Text(pDX, IDC_EDIT_SHANK_DIA, shankDia);
	DDX_Control(pDX, IDC_BUTTON_VOXEL_SETTINGS, voxelButton);
}


BEGIN_MESSAGE_MAP(DOptions, CDialog)
	//{{AFX_MSG_MAP(DOptions)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_BN_CLICKED(IDC_SPEECH, OnSpeech)
	ON_BN_CLICKED(IDC_FITOPTIONS, OnFitOpts)
	ON_CBN_SELCHANGE(IDC_UNITSCOMBO, OnSelchangeUnitsCombo)
	ON_BN_CLICKED(IDC_AUTODETECT, OnCheckAutoDetect)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_JOGJTS, OnJogJts)
	ON_BN_CLICKED(IDC_USERNOTES, OnUserNotes)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_ARM_SETTINGS_BUTTON, OnBnClickedArmSettingsButton)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHANGE_LANGUAGE, OnBnClickedChangeLanguage)
	ON_BN_CLICKED(IDC_ARTICULATOR_DRIVE, OnBnClickedArticulatorDrive)
	ON_BN_CLICKED(IDC_ARM_JT_DRIVE, OnBnClickedArmJtDrive)
	ON_BN_CLICKED(IDC_RESET_MODELINFO_BUTTON, &DOptions::OnBnClickedResetModelinfoButton)
	ON_BN_CLICKED(IDC_PROBE_CAL_SET, &DOptions::OnBnClickedProbeCalSet)
	ON_BN_CLICKED(IDC_BUTTON_UDP_DATA_STREAM, &DOptions::OnBnClickedButtonUdpDataStream)
	ON_BN_CLICKED(IDC_BUTTON_KREON_DONGLE_LICENSE, &DOptions::OnBnClickedButtonKreonDongleLicense)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SEND_SCAN_STRIPE_CLOUDS_CHECK, &DOptions::OnBnClickedSendScanStripeCloudsCheck)
	ON_BN_CLICKED(IDC_BUTTON_VOXEL_SETTINGS, &DOptions::OnBnClickedButtonVoxelSettings)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DOptions message handlers


BOOL DOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();

//	m_IntervalUnits = app.saarm.units.DistUnitNames[distunits];
//	m_PatchShiftUnits = app.saarm.units.DistUnitNames[distunits];
	CString sUsageLabel;
	sUsageLabel.Format(Tr("Hold down delete last/cancel button when not measuring to calibrate ArmPad"));

	patchshiftunitCtrl.SetWindowText(app.saarm.units.DistUnitNames[distunits]);
	intervalunitCtrl.SetWindowText(app.saarm.units.DistUnitNames[distunits]);
	if(app.pA->GetButtonCount()<3 && !app.pA->IsAPIBacesAxxis())
	{
		ButThreeCtrlLabel.ShowWindow(SW_HIDE);
		m_ButThreeCtrl.ShowWindow(SW_HIDE);
		m_ButThree = app.saarm.Data.ButtonThreeMode;
	}
	if(!app.pA->IsFaro() && !app.pA->IsFaroUSB())
		FaroAux_Check.ShowWindow(SW_HIDE);
	if(!app.pA->IsRomer() && !app.pA->IsFrenchRomer())
	{
		AutoDetectCheck.ShowWindow(SW_HIDE);
		m_ProbeNumCtl.ShowWindow(SW_HIDE);
		probeNumLabel.ShowWindow(SW_HIDE);
		probeDiaUnits.SetWindowText(app.saarm.units.DistUnitNames[distunits]);
	}
	if(app.pA->IsRomer() || app.pA->IsFrenchRomer())
	{
		probeDiaEdit.ShowWindow(SW_HIDE);
		probeDiaLabel.ShowWindow(SW_HIDE);
		probeDiaUnits.ShowWindow(SW_HIDE);
	}
	if(app.pA->IsFaroUSB())
	{
		ButThreeCtrlLabel.SetWindowText(_T("Sensor"));
		probeDiaEdit.SetReadOnly(TRUE);		// user has to run the probe cal to create/select current probe - 2008.11.10 with iProbes, diameter is auto-updated anyway
	
		sUsageLabel += Tr("\nScanning: Press Green button to Pause/Resume. Press Red button to stop.");
	}
	if(app.pA->IsAPIBacesAxxis())
	{
		probeCalSetButton.ShowWindow(SW_SHOW);
		probeCalSetButton.EnableWindow(TRUE);

		probeDiaEdit.SetReadOnly(TRUE);
		m_Apply.EnableWindow(FALSE);
		m_Apply.ShowWindow(SW_HIDE);
		ButOneCtrlLabel.SetWindowText(_T("Blue"));
		ButTwoCtrlLabel.SetWindowText(_T("Yellow"));
		ButThreeCtrlLabel.SetWindowText(_T("Green"));

		if(app.pA->GetButtonCount() < 3)
		{
			ButOneCtrlLabel.ShowWindow(SW_HIDE);
			m_ButOneCtrl.ShowWindow(SW_HIDE);
		}
	}
	if(app.pA->IsKreonScannerArm())
	{
		probeCalSetButton.ShowWindow(SW_SHOW);
		probeCalSetButton.EnableWindow(TRUE);

		KreonDongleLicenseButton.ShowWindow(SW_SHOW);
		KreonDongleLicenseButton.EnableWindow(TRUE);

		probeDiaEdit.SetReadOnly(TRUE);
		m_Apply.EnableWindow(FALSE);
		m_Apply.ShowWindow(SW_HIDE);
		ButOneCtrlLabel.SetWindowText(_T("0")); // button[0], trigger push, side, yellow
		ButTwoCtrlLabel.SetWindowText(_T("1"));// button[1],  trigger pull, middle, green

		sUsageLabel += Tr("\nScanning: Pull and hold Trigger or Green button to Pause. Push Trigger or press Yellow button to stop.");
	}
	if(app.RunningArticulator() && app.pA->ConnectedToArm)
	{
		artic_jt_drive_buton.ShowWindow(SW_SHOW);
		artic_drive_buton.ShowWindow(SW_SHOW);
	}
	
	if(app.pA->ConnectedToArm || app.pA->IsFaroUSB())
	{
		TRACE0("app.pA->ConnectedToArm = TRUE\n");
		jtjog_button.ShowWindow(SW_HIDE);
	}
	if( (!app.pA->IsFaroUSB() && !app.pA->IsFaro() && !app.pA->IsFrenchRomer() && !app.pA->IsHexagonRDS()) || (!app.pA->ConnectedToArm && !app.pA->trackArmActive) )
		arm_settings_btn.ShowWindow(SW_HIDE);

	ptnameinc = app.saarm.Data.ptnameinc;
	TRACE2("dlg ptinc=%d, data ptinc=%d\n",ptnameinc, app.saarm.Data.ptnameinc);
	incrementgroup = app.saarm.Data.incrementgroup;
	autoCorrectModel = app.saarm.Data.autoCorrectModel;
	UseScanStripeClouds = app.saarm.Data.useScanStripeClouds ? TRUE : FALSE;
	if (UseScanStripeClouds)
		voxelButton.EnableWindow(FALSE);
	else
		voxelButton.EnableWindow(TRUE);

	shankDiaUnitsVal = app.saarm.units.DistUnitNames[distunits];
	probeDiaUnitsVal = app.saarm.units.DistUnitNames[distunits];

	GetDlgItem(IDC_STATIC_EASY_PAD_USAGE_LABEL)->SetWindowText(sUsageLabel);
	UpdateData(FALSE);

	OnCheckAutoDetect();

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	TRANSLATE_DIALOG;

	haveC = false;
	haveo = false;
	haven = false;
	havet = false;
	haver = false;
	haveo2 = false;
	havel = false;
	haveP = false;
	havea = false;
	haved = false;

	if(app.saarm.Data.controlPadEnabled)
	{
		EasyPadInstructions.ShowWindow(SW_SHOW);
	}

	if(app.pA->IsKreonScannerArm()) // or any others that pop their own ui for selecting and/or calibrating probe. This gives us a way to update our display based on whether they changed our Data.TipDia
		SetTimer(PROBEUPDATETIMER, 2000, NULL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void DOptions::OnApply() 
{
	UpdateData(TRUE);

	if(app.pA->IsFaroUSB())
	{
		CString pm;
		pm.Format(_T("Close Options and run Arm Cal. to Create/Select Probe definition."));
		AfxMessageBox(pm);
		return;
	}

	if(!app.pA->IsRomer() && !app.pA->IsFrenchRomer())
	{
		app.saarm.Data.TipDia = probeDia*app.saarm.units.UnitToMeters[distunits];
		app.pA->SetAuxPort(FaroAuxOn);
		return;
	}

	app.pA->SetProbeNumber(m_ProbeNum);
	if(!app.pA->ValidateCurrentProbe())
	{
		app.pA->SetProbeAutoDetect(TRUE);
		app.pA->ValidateCurrentProbe();
		int sensed = app.pA->GetProbeNumber();
		app.pA->SetProbeAutoDetect(FALSE);
		app.pA->SetProbeNumber(m_ProbeNum);
		CString temp;
		temp.Format(_T(" Probe %d unrecognized\n\t Sensed Probe ID = %d\nUse Anyway?"),m_ProbeNum,sensed);
		int ret = AfxMessageBox(temp,MB_YESNO);
		if(ret==IDYES)
		{
			app.pA->SetProbeNumber(m_ProbeNum);
		}
		else
		{
			app.pA->SetProbeNumber(sensed);
			app.pA->ValidateCurrentProbe();
		}
	}

	app.saarm.Data.useScanStripeClouds = UseScanStripeClouds ? true : false;
}

void DOptions::OnSpeech() 
{
	DSpeech diag;
	diag.m_Enabled = app.saarm.TTS.IsEnabled;

	diag.m_Computer = app.saarm.TTS.m_computer;
	diag.m_Port = app.saarm.TTS.m_port;
	diag.m_Vol = app.saarm.Data.SpkrVolume;
	diag.m_SectionSound = app.saarm.Data.SectionSound;
	
	if(diag.DoModal()!=IDOK)
		return;
	app.saarm.TTS.IsEnabled = diag.m_Enabled;
	app.saarm.TTS.m_computer = diag.m_Computer;
	app.saarm.TTS.m_port = diag.m_Port;
	app.saarm.TTS.WriteRegistry();
	app.saarm.Data.SpkrVolume = diag.m_Vol;
	app.saarm.Data.SectionSound = diag.m_SectionSound;
	app.saarm.Data.SpkrVolume = diag.m_Vol;

}
void DOptions::OnFitOpts() 
{
	DFitOptions diag;
	diag.m_LockCircles = app.saarm.Data.LockCircles;
	diag.m_LockSpheres = app.saarm.Data.LockSpheres;
	diag.m_CircleLockVal = app.saarm.Data.CircleLockVal/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.m_SphereLockVal = app.saarm.Data.SphereLockVal/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.m_Units1 = app.saarm.units.DistUnitNames[distunits];
	diag.m_Units2 = app.saarm.units.DistUnitNames[distunits];
	diag.scan_spatial = app.saarm.Data.scan_spatial;
	diag.scan_spatial_inc = app.saarm.Data.scan_spatial_inc/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.m_Units3 = app.saarm.units.DistUnitNames[distunits];
	diag.cloudDataInterval = app.saarm.Data.scannerTimerPeriodSec;
	diag.autoIncCloudName = app.saarm.Data.autoIncCloudName;
	diag.m_Units4 = app.saarm.units.DistUnitNames[distunits];
	diag.m_proxThresh = app.saarm.Data.GoodProximity/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.avgPointSamples = app.saarm.Data.avgPointSamples;
	diag.lineMeasType = app.saarm.Data.lineMeasType;
	diag.thinningFactor = app.saarm.Data.thinningFactor;
	diag.units5 = app.saarm.units.DistUnitNames[distunits];
	diag.proxWorkingField = app.saarm.Data.proxWorkingField/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.startUpInMeasMode = app.saarm.Data.startupInMeasMode;
	diag.startUpMeasMode = app.saarm.Data.startupMeasMode;
	diag.UseScannerForAutoProxMeas = app.saarm.Data.useScannerForAutoProxMeas ? TRUE : FALSE;
	UpdateData(TRUE);
	if (useShankForAutoProx)
		diag.UseScannerForAutoProxMeas = FALSE;
	if(diag.DoModal()!=IDOK)
		return;
	app.saarm.Data.LockCircles = diag.m_LockCircles;
	app.saarm.Data.LockSpheres = diag.m_LockSpheres;
	app.saarm.Data.CircleLockVal = diag.m_CircleLockVal*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	app.saarm.Data.SphereLockVal = diag.m_SphereLockVal*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	app.saarm.Data.scan_spatial = diag.scan_spatial;
	app.saarm.Data.scan_spatial_inc = diag.scan_spatial_inc*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	if(diag.cloudDataInterval >= 0)
		app.saarm.Data.scannerTimerPeriodSec = diag.cloudDataInterval;
	app.saarm.Data.autoIncCloudName = diag.autoIncCloudName;
	app.saarm.Data.GoodProximity = diag.m_proxThresh*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	app.saarm.Data.proxWorkingField = diag.proxWorkingField*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	app.saarm.SetScreamerParams();//screamer.SetParams(app.saarm.Data.GoodProximity, app.saarm.Data.proxWorkingField);
	app.saarm.Data.avgPointSamples = diag.avgPointSamples;
	app.saarm.Data.lineMeasType = diag.lineMeasType;
	app.saarm.Data.thinningFactor = diag.thinningFactor;
	app.saarm.Data.startupInMeasMode = diag.startUpInMeasMode;
	app.saarm.Data.startupMeasMode = diag.startUpMeasMode;
	app.saarm.Data.useScannerForAutoProxMeas = diag.UseScannerForAutoProxMeas ? true : false;
	if (app.saarm.Data.useScannerForAutoProxMeas)
	{
		app.saarm.Data.useShankForAutoProxMeas = false;
		useShankForAutoProx = FALSE;
		UpdateData(FALSE);
	}
}

void DOptions::OnSelchangeUnitsCombo() 
{
	UpdateData(TRUE);
	app.saarm.units.distunits = distunits;

	m_IntervalUnits = app.saarm.units.DistUnitNames[distunits];
	m_PatchShiftUnits = app.saarm.units.DistUnitNames[distunits];
	m_Interval = app.saarm.Data.Interval/app.saarm.units.UnitToMeters[distunits];
	m_ExtraPatchShift = app.saarm.Data.ExtraPatchShift/app.saarm.units.UnitToMeters[distunits];
	if(!app.pA->IsRomer() && !app.pA->IsFrenchRomer())
	{
		probeDia = app.saarm.Data.TipDia/app.saarm.units.UnitToMeters[distunits];
		probeDiaUnitsVal = app.saarm.units.DistUnitNames[distunits];
	}
	shankDia = app.saarm.Data.shankRadius*2.0/app.saarm.units.UnitToMeters[distunits];
	shankDiaUnitsVal = app.saarm.units.DistUnitNames[distunits];

	UpdateData(FALSE);
}

void DOptions::OnCheckAutoDetect() 
{
	UpdateData(TRUE);
	if(!app.pA->IsRomer() && !app.pA->IsFrenchRomer())
		return;

	if(m_AutoDetectProbe)
	{
		app.pA->SetProbeAutoDetect(TRUE);
		app.pA->ValidateCurrentProbe();
		m_ProbeNum  = app.pA->GetProbeNumber();
		TRACE2("Probenum = %d TipDia = %f mm\n", m_ProbeNum, app.saarm.Data.TipDia*1000.0);
		m_ProbeNumCtl.EnableWindow(FALSE);
		m_Apply.EnableWindow(FALSE);
	}
	else
	{
		app.pA->SetProbeAutoDetect(FALSE);
		m_ProbeNumCtl.EnableWindow(TRUE);
		m_Apply.EnableWindow(TRUE);
	}
	UpdateData(FALSE);
}

void DOptions::OnDefault() 
{
	UpdateData(TRUE);

	app.saarm.units.distunits = distunits;
	app.saarm.Data.FirePointsToo = m_FirePointsToo;
	app.saarm.Data.alwaysupdateSA = updateSA;
	app.saarm.Data.Interval = m_Interval*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	app.saarm.Data.TargetNameStartNumber = m_TNSN;

	app.saarm.Data.ButtonOneMode = m_ButOne;
	app.saarm.Data.ButtonTwoMode = m_ButTwo;
	app.saarm.Data.ButtonThreeMode = m_ButThree; 
	app.saarm.Data.AutoDetectProbe	= m_AutoDetectProbe;
	app.saarm.Data.AddExtraPatchShift = m_AddExtraPatchShift;
	app.saarm.Data.ExtraPatchShift = m_ExtraPatchShift*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	if(!app.pA->IsRomer() && !app.pA->IsFrenchRomer())
		app.saarm.Data.TipDia = probeDia*app.saarm.units.UnitToMeters[distunits];
	app.saarm.Data.useShankForAutoProxMeas = useShankForAutoProx ? true : false;
	app.saarm.Data.shankRadius = (shankDia/2.0)*app.saarm.units.UnitToMeters[distunits];
	app.saarm.Data.autoCorrectModel = autoCorrectModel;
	app.saarm.Data.useScanStripeClouds = UseScanStripeClouds ? true : false;
}

void DOptions::OnJogJts() 
{
	DJtJog dlg;
	dlg.DoModal();
}

void DOptions::OnUserNotes() 
{
	DTextViewer dlg;
	CString fname;
	if( app.pA->IsFaro() )
		fname.Format(_T("Faro_UserNotes.txt"));
	else if( app.pA->IsRomer())
		fname.Format(_T("Romer_UserNotes.txt"));
	else if( app.pA->IsSNL() )
		fname.Format(_T("SNL_UserNotes.txt"));
	dlg.filename = app.saarm.ProgramDirectory + fname;
	AfxMessageBox(dlg.filename);
	dlg.m_header.Format(_T("For a print-out, go to this interface's installation directory and print '%s'"), fname);
	dlg.DoModal();
}

void DOptions::OnBnClickedOk()
{
	UpdateData(TRUE);
	TRACE2("dlg ptinc=%d, data ptinc=%d\n",ptnameinc, app.saarm.Data.ptnameinc);
	TRACE1("dlg use shank = %d\n", useShankForAutoProx);
	app.saarm.Data.ptnameinc = ptnameinc;
	app.saarm.Data.incrementgroup = incrementgroup;
	app.saarm.Data.autoCorrectModel = autoCorrectModel;
	app.saarm.Data.useScanStripeClouds = UseScanStripeClouds ? true : false;
	OnOK();
}

void DOptions::OnBnClickedArmSettingsButton()
{
	app.pA->DoArmSettings();
}

void DOptions::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DOptions"),this);	
}

void DOptions::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DOptions"),this);

	CDialog::OnDestroy();
}
void DOptions::OnBnClickedChangeLanguage()
{
	NRKLang.ChangeLanguage();
}

void DOptions::OnBnClickedArticulatorDrive()
{
	app.pArtic->PopFrameDrive();
}

void DOptions::OnBnClickedArmJtDrive()
{
	app.pArtic->PopJtDrive();
}


void DOptions::OnBnClickedResetModelinfoButton()
{
	app.pA->ClearModelInfo();
}

void DOptions::OnBnClickedProbeCalSet()
{
	app.pA->ProbeCalSet();
}

void DOptions::OnBnClickedButtonUdpDataStream()
{
	app.saarm.BlastUDPProperties();
}

BOOL DOptions::PreTranslateMessage(MSG* pMsg)
{
	int nVirtKey = 0;
	bool SkipStandardHandling = false;

	if (pMsg->message == WM_KEYDOWN)
	{
		nVirtKey = (int) pMsg->wParam;
		if( nVirtKey == VK_ESCAPE )	// don't close when escape is hit!!
		{
			SkipStandardHandling = true;
		}
	}
	if (SkipStandardHandling)
		return TRUE;

	// 2010.09.03 - patent is pending, so ArmPad is enabled by default
	//if( pMsg->message == WM_KEYUP )
	//{
	//	nVirtKey = (int) pMsg->wParam;
	//	TRACE("%d, %c\n", nVirtKey, nVirtKey);

	//	if( nVirtKey == 'C' || nVirtKey == 'c'
	//		&& !haveC
	//		&& !haveo
	//		&& !haven
	//		&& !havet
	//		&& !haver
	//		&& !haveo2
	//		&& !havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		haveC = true;
	//	}
	//	if( nVirtKey == 'o' || nVirtKey == 'O'
	//		&& haveC
	//		&& !haveo
	//		&& !haven
	//		&& !havet
	//		&& !haver
	//		&& !haveo2
	//		&& !havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		haveo = true;
	//	}
	//	if( nVirtKey == 'n' || nVirtKey == 'N'
	//		&& haveC
	//		&& haveo
	//		&& !haven
	//		&& !havet
	//		&& !haver
	//		&& !haveo2
	//		&& !havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		haven = true;
	//	}
	//	if( nVirtKey == 't' || nVirtKey == 'T'
	//		&& haveC
	//		&& haveo
	//		&& haven
	//		&& !havet
	//		&& !haver
	//		&& !haveo2
	//		&& !havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		havet = true;
	//	}
	//	if( nVirtKey == 'r' || nVirtKey == 'R'
	//		&& haveC
	//		&& haveo
	//		&& haven
	//		&& havet
	//		&& !haver
	//		&& !haveo2
	//		&& !havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		haver = true;
	//	}
	//	if( nVirtKey == 'o' || nVirtKey == 'O'
	//		&& haveC
	//		&& haveo
	//		&& haven
	//		&& havet
	//		&& haver
	//		&& !haveo2
	//		&& !havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		haveo2 = true;
	//	}
	//	if( nVirtKey == 'l' || nVirtKey == 'L'
	//		&& haveC
	//		&& haveo
	//		&& haven
	//		&& havet
	//		&& haver
	//		&& haveo2
	//		&& !havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		havel = true;
	//	}
	//	if( nVirtKey == 'P' || nVirtKey == 'p'
	//		&& haveC
	//		&& haveo
	//		&& haven
	//		&& havet
	//		&& haver
	//		&& haveo2
	//		&& havel
	//		&& !haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		haveP = true;
	//	}
	//	if( nVirtKey == 'a' || nVirtKey == 'A'
	//		&& haveC
	//		&& haveo
	//		&& haven
	//		&& havet
	//		&& haver
	//		&& haveo2
	//		&& havel
	//		&& haveP
	//		&& !havea
	//		&& !haved )
	//	{
	//		havea = true;
	//	}
	//	if( nVirtKey == 'd' || nVirtKey == 'D'
	//		&& haveC
	//		&& haveo
	//		&& haven
	//		&& havet
	//		&& haver
	//		&& haveo2
	//		&& havel
	//		&& haveP
	//		&& havea
	//		&& !haved )
	//	{
	//		haved = true;

	//		app.saarm.Data.controlPadEnabled = true;
	//		EasyPadInstructions.ShowWindow(SW_SHOW);
	//	}
	//}

	return CDialog::PreTranslateMessage(pMsg);
}

void DOptions::OnBnClickedButtonKreonDongleLicense()
{
	app.pA->OpenKreonDongleLicenseDlg();
}

void DOptions::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == PROBEUPDATETIMER && probeDia != app.saarm.Data.TipDia/app.saarm.units.UnitToMeters[distunits])
	{
		probeDia = app.saarm.Data.TipDia/app.saarm.units.UnitToMeters[distunits];

		if (shankDia != (app.saarm.Data.shankRadius*2.0)/app.saarm.units.UnitToMeters[distunits])
			shankDia = (app.saarm.Data.shankRadius*2.0)/app.saarm.units.UnitToMeters[distunits];

		UpdateData(FALSE);
	}

	CDialog::OnTimer(nIDEvent);
}

void DOptions::OnBnClickedSendScanStripeCloudsCheck()
{
	UpdateData(TRUE);

	if (UseScanStripeClouds)
		voxelButton.EnableWindow(FALSE);
	else
		voxelButton.EnableWindow(TRUE);
}

void DOptions::OnBnClickedButtonVoxelSettings()
{
	DVoxelSettings dlg;
	double inchesToCurrentUnit = app.saarm.InchesToLocal/app.saarm.units.UnitToMeters[app.saarm.units.distunits];

	dlg.voxEnabled = 	(BOOL)app.saarm.Data.voxelizationEnabled;
	dlg.voxelSize = app.saarm.Data.voxelSize * inchesToCurrentUnit;  // stored in inches since that's native to our voxelization code
	dlg.minPtsPerVoxel = app.saarm.Data.minPtsPerVoxel;
	dlg.numPtsPerVoxelization = app.saarm.Data.minCloudPtsToVoxelize;

	if(dlg.DoModal()!=IDOK)
		return;

	app.pA->ClearScanClouds(); // 2020.04.07 - the scannertimer might still be running, and if e.g. user just turned off voxelization, 
										// CheckAndSendScannerCloud is likely waiting for more points to fill the numPtsPerVoxelization. 
										// If we didn't clear the cloud data, we'd get a bunch of un-voxelized data at the end of the last scan pass, 
										// due to voxelization being turned off, and the minPtsPerVoxelization would no longer be required

	app.saarm.Data.voxelizationEnabled = (bool)dlg.voxEnabled;
	app.saarm.Data.voxelSize = dlg.voxelSize / inchesToCurrentUnit;
	app.saarm.Data.minPtsPerVoxel = dlg.minPtsPerVoxel;
	app.saarm.Data.minCloudPtsToVoxelize = dlg.numPtsPerVoxelization;
}
