// DPCMM.h : main header file for the DPCMM application
//

#if !defined(AFX_DPCMM_H__9BBA07DA_F82F_49F1_AFA1_338BD0D19BF7__INCLUDED_)
#define AFX_DPCMM_H__9BBA07DA_F82F_49F1_AFA1_338BD0D19BF7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#define QUERY 5
#define QUERY2 6
//#define UPDATE 7
#define INITIAL 8
#define FRAMEUPDATE 9
#define QUERYRATEFAST 250
#define QUERYRATESLOW 1200
#define UPDATESARATE  800
#define FRAMEUPDATESARATE  1000

//sounds
#define REC_OK 100    //arbitrary numbers
#define UNDO_OK 101
#define UNDO_FAIL 102
#define CALC_OK  103
#define JT_LIMIT 104

#define MAXFREQ 5600
#define HIFREQ	5000   //Upper end of freq range
#define LOFREQ	200   //Lower end of freq range

//Button hit durations
#define LONG_DURATION	1500  //threshold in ms of what defines a long hit
#define BUTTON_LONG		512
#define BUTTON_SHORT		256

//Button hit codes
#define NOTHING							0
#define RECORD_ACCEPT					1
#define BACKUP_MOUSE						2
#define BACKUP_CANCEL					3
#define RECORD_BACKUP					4
#define ACCEPT_CANCEL					5
#define NAV_NEXT_PREV					6
#define NAV_NEXT_ITERATE_MEAS_MODE	7
// add new ones above here, and bump TOUCH_PROBE
#define TOUCH_PROBE						8

#define PININSPECT		0
#define HOLEINSPECT		1
#define PLANEINSPECT		2

#define LEFTBUTTON	1
#define MIDBUTTON		2
#define RIGHTBUTTON	4

/////////////////////////////////////////////////////////////////////////////
// CDPCMMApp:
// See DPCMM.cpp for the implementation of this class
//

#include "resource.h"		// main symbols

#define MAINQUERY 5
#define DATAQUERY 6

#include "ArmBase.h"	// yes, we should forward declare this, and include in the cpp, but MANY other classes include only this header, and need to access the ArmBase member...
#include "SAArm.h"	// yes, we should forward declare this, and include in the cpp, but MANY other classes include only this header, and need to access the saarm member...

class ArticulatedArmWrapper;
class EasyPadArmInterface;

class DGenMeas;

class CDPCMMApp : public SAIBWinApp
{
public:
	CDPCMMApp();
	void CleanUp();

	virtual SAInstBase* GetSAIB()		// saib - need this so sainstbase::Getsaib can get member.
	{  
		return (SAInstBase*)&saarm;
	}

	void EstablishArm_FaroUSB();
	void EstablishArm_Romer();
	void EstablishArm_FaroSerial();
	void EstablishArm_SNL();
	void EstablishArm_RomerArticulator();
	void EstablishArm_RomerEurope();
	void EstablishArm_MetrisMCA();
	void EstablishArm_API_Baces();
	void EstablishArm_API_Baces_Kreon_Scanner();
	void EstablishArm_Hexagon_RDS();
	
	ArmBase* pA;
	SAArm& saarm;
	DGenMeas* measDlg;

	EasyPadArmInterface& controlPad;

	ArticulatedArmWrapper* pArtic;
	bool RunningArticulator() {return pArtic!=NULL;}
	
	BOOL StopNow;
	
	BOOL FindSADir( LPCTSTR Key, CString* pDir);

	CString VString;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDPCMMApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CDPCMMApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	bool keyCtrl;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

extern CDPCMMApp app;

#endif // !defined(AFX_DPCMM_H__9BBA07DA_F82F_49F1_AFA1_338BD0D19BF7__INCLUDED_)
