// DPCMMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DPCMMDlg.h"
#include "JtPak.h"
#include "SerialComm.cpp"

#include "PDARemote\RemoteUIManager.h"  // jmc PDA
#include "PDARemote\RemoteButton.h"  // jmc PDA
#include "PDARemote\RemoteUIDefs.h"  // jmc PDA
#include "PDARemote\UIMessage.h"  // jmc PDA
#include ".\dpcmmdlg.h"

#include "FaroUSB/TrackArm/DTrackArm.h"

#include "SA Easy Pad/EasyPadArmInterface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/*
#define WM_CALL_PROCEDURE WM_APP
RDS_RECORD_DATA g_RDSRecordData;
bool m_bRun;
static WORD CALLBACK Callback( RDS_CALLBACK_DATA* aData );
*/
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	version;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	version = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_STATIC_VERSION, version);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString m;
	m.Format(_T("About %s_Arm"), app.saarm.CMMString);
	SetWindowText(m);

	version.Format(_T("%s_Arm v. %s"), app.saarm.CMMString, app.VString);
	UpdateData(FALSE);	

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	TRANSLATE_DIALOG;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CDPCMMDlg dialog

CDPCMMDlg::CDPCMMDlg(CWnd* pParent /*=NULL*/)
: CDialog(CDPCMMDlg::IDD, pParent)
, groupCombo(app.saarm)
, collectionCombo(app.saarm)
, geomName(_T(""))
{
	TrashRemoteMessages = FALSE;		// jmc PDA
	
	scanbutton.Icon = IDI_SCANICON;
	avgptsbutton.Icon = IDI_AVGPOINTSICON;
	spherebutton.Icon = IDI_SPHERE_ICON;
	circlebutton.Icon = IDI_CIRCLE_ICON;
	framebutton.Icon = IDI_FRAMEICON;
	guidebutton.Icon = IDI_GUIDEICON;
	holebutton.Icon = IDI_HOLEICON;
	linebutton.Icon = IDI_LINEICON;
	patchbutton.Icon = IDI_PATCHICON;
	pinbutton.Icon = IDI_PINICON;
	planebutton.Icon = IDI_PLANEICON;
	pointbutton.Icon = IDI_POINTSICON;
	sectionbutton.Icon = IDI_SECTIONICON;
	slotbutton.Icon = IDI_SLOTICON;
	streambutton.Icon = IDI_STREAMICON;
	geomtrigbutton.Icon = IDI_GEOM_TRIGGER_ICON;
	coneButton.Icon = IDI_CONEICON;
	singlePtHoleButton.Icon = IDI_HOLEICON;
	armPadButton.Icon = IDI_ARMPAD;
	//theobutton.Icon = IDI_THEOICON;
	targinc.Icon = IDI_TARGETINCICON;
	groupinc.Icon = IDI_GROUPINCICON;
	toggleArmButtonsButton.Icon = IDI_ARM_BUTTONS_ENABLED_ICON;
	//{{AFX_DATA_INIT(CDPCMMDlg)
	Target = _T("P1");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	saInstBarButton.Icon = IDI_ICON_PROBING_INTERFACE;

	m_bWasDockedBeforeTB = false;

	leftWasDown=false;
	rightWasDown=false;

	onDestroyCalledAlready = false;

	collectionComboHasFocus = false;
	groupComboHasFocus = false;
	targetEditHasFocus = false;
	geomNameEditHasFocus = false;
}

CDPCMMDlg::~CDPCMMDlg() 
{
}

void CDPCMMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDPCMMDlg)
	DDX_Control(pDX, IDC_BUTTON4, B2Long);
	DDX_Control(pDX, IDC_BUTTON3, B2Short);
	DDX_Control(pDX, IDC_BUTTON2, B1Long);
	DDX_Control(pDX, IDC_BUTTON1, B1Short);
	DDX_Control(pDX, IDC_BUTTON_CAL, calbutton);
	DDX_Control(pDX, IDC_STATIC_JTLIMIT, jtlimit);
	DDX_Control(pDX, IDC_BUTTON_START, startbutton);
	DDX_Control(pDX, IDC_STATIC_INSTINDEX, SAInstIndex);
	DDX_Control(pDX, IDC_BUTTON_OPTIONS, optionsbutton);
	DDX_Control(pDX, IDC_INCT, targinc);
	DDX_Control(pDX, IDC_INCG, groupinc);
	DDX_Control(pDX, IDC_BUTTON_STREAM, streambutton);
	DDX_Control(pDX, IDC_BUTTON_SLOT, slotbutton);
	DDX_Control(pDX, IDC_BUTTON_SECTION, sectionbutton);
	DDX_Control(pDX, IDC_BUTTON_POINTS, pointbutton);
	DDX_Control(pDX, IDC_BUTTON_PLANE, planebutton);
	DDX_Control(pDX, IDC_BUTTON_PIN, pinbutton);
	DDX_Control(pDX, IDC_BUTTON_PATCH, patchbutton);
	DDX_Control(pDX, IDC_BUTTON_LINE, linebutton);
	DDX_Control(pDX, IDC_BUTTON_HOLE, holebutton);
	DDX_Control(pDX, IDC_BUTTON_GUIDE, guidebutton);
	DDX_Control(pDX, IDC_BUTTON_FRAME, framebutton);
	DDX_Control(pDX, IDC_BUTTON_CIRCLE, circlebutton);
	DDX_Control(pDX, IDC_BUTTON_SPHERE, spherebutton);
	DDX_Control(pDX, IDC_BUTTON_SCAN, scanbutton);
	DDX_Text(pDX, IDC_TARGET, Target);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_GROUP_COMBO, groupCombo);
	DDX_Control(pDX, IDC_BUTTON_AVG_POINTS, avgptsbutton);
	DDX_Control(pDX, IDC_DOCKING_BUTTON, m_dockingBtnCtrl);
	DDX_Control(pDX, IDC_BUTTON_HELP_GENERAL, helpButton);
	DDX_Control(pDX, IDC_BUTTON_PIPE_PROBE, pipeProbeButton);
	DDX_Control(pDX, IDC_BUTTON_TOGGLE_ARM_BUTTONS, toggleArmButtonsButton);
	DDX_Text(pDX, IDC_GEOM_NAME, geomName);
	DDX_Control(pDX, IDC_BUTTON_GEOM_TRIGGER, geomtrigbutton);
	DDX_Control(pDX, IDC_BUTTON_TRACK_ARM, trackArmButton);
	DDX_Control(pDX, IDC_BUTTON_CONE, coneButton);
	DDX_Control(pDX, IDC_BUTTON_ARMPAD_LOC, armPadButton);
	DDX_Control(pDX, IDC_COLLECTION_COMBO, collectionCombo);
	DDX_Control(pDX, IDC_BUTTON_SINGLE_PT_HOLE, singlePtHoleButton);
	DDX_Control(pDX, IDC_SA_INST_TOOLBAR_BUTTON, saInstBarButton);
}

BEGIN_MESSAGE_MAP(CDPCMMDlg, CDialog)
	//{{AFX_MSG_MAP(CDPCMMDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_DEFAULTBUTTON, OnDefaultButton)
	ON_BN_CLICKED(IDC_TEST, OnButtonTest)
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_DESTROY()
	ON_MESSAGE(S_DATA_IN_Q, OnSerialDataInQ)			// SERIALCOMM
	ON_BN_CLICKED(IDC_INCG, OnIncg)
	ON_BN_CLICKED(IDC_INCT, OnInct)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_REMOTECOMMAND, OnRemoteCommand)   // jmc PDA
	ON_MESSAGE(WM_REMOTECONNECT, OnRemoteConnect)   // jmc PDA
	ON_MESSAGE(WM_UIREPLYMESSAGE, OnUIReply)   // jmc PDA
	ON_MESSAGE(DONE_TRASHING_REMOTE_MSG, OnDoneTrashingRemoteMessages)   // jmc PDA
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnTTNeedText )  // jmc pb
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_BUTTON_PIPE_PROBE, OnBnClickedButtonPipeProbe)
	ON_CBN_SETFOCUS(IDC_GROUP_COMBO, &CDPCMMDlg::OnCbnSetfocusGroupCombo)
	ON_CBN_KILLFOCUS(IDC_GROUP_COMBO, &CDPCMMDlg::OnCbnKillfocusGroupCombo)
	ON_EN_SETFOCUS(IDC_TARGET, &CDPCMMDlg::OnEnSetfocusTarget)
	ON_EN_KILLFOCUS(IDC_TARGET, &CDPCMMDlg::OnEnKillfocusTarget)
	ON_EN_SETFOCUS(IDC_GEOM_NAME, &CDPCMMDlg::OnEnSetfocusGeomName)
	ON_EN_KILLFOCUS(IDC_GEOM_NAME, &CDPCMMDlg::OnEnKillfocusGeomName)
	ON_BN_CLICKED(IDC_BUTTON_TRACK_ARM, &CDPCMMDlg::OnBnClickedButtonTrackArm)
	ON_WM_SETFOCUS()
	ON_CBN_SETFOCUS(IDC_COLLECTION_COMBO, &CDPCMMDlg::OnCbnSetfocusCollectionCombo)
	ON_CBN_KILLFOCUS(IDC_COLLECTION_COMBO, &CDPCMMDlg::OnCbnKillfocusCollectionCombo)
	ON_BN_CLICKED(IDC_SA_INST_TOOLBAR_BUTTON, &CDPCMMDlg::OnBnClickedSaInstToolbarButton)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDPCMMDlg message handlers

BOOL CDPCMMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	DockWrapper& dockWrapper = app.GetSAIB()->GetDockWrapper();
	dockWrapper.SetDockingBtnCtrl(m_dockingBtnCtrl);
	dockWrapper.CheckDockability(*app.GetSAIB());

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	EnableToolTips(TRUE);	// for the picture buttons
	
	GetDataParams();

	// User must call this, it makes a CWnd member of ArmBase to house the main timer
	// give it a pointer to this to use as its parent window
//	app.pA->timerWnd.Init(this);

	// set inst index indicator
	DisplayInstColNameIdx(app.saarm.GetInstrumentFullName());

	helpButton.SetIcon16x16(IDI_ICONQUEST);

	trackArmButton.ShowWindow(SW_HIDE);

	if( app.pA->IsFaro() )
	{
//		calbutton.ShowWindow(SW_HIDE);
//		framebutton.ShowWindow(SW_HIDE);
		if(app.saarm.Data.doconnection)
		{
			if(!InitComm(TRUE))
			{
				app.pA->ConnectedToArm = FALSE;
				CString Msg;
				Msg.Format(Tr("Faro Serial Connection failed."));
				int ans = AfxMessageBox(Msg + Tr("\n\nRun in Simulation mode?"),MB_YESNO);
				if(ans==IDNO)
				{
					PostQuitMessage(0);
					return false;
				}
				else
					return true;	// simulation mode
				return false;
			}
			else
				app.pA->SetAuxPort(app.saarm.Data.FaroAuxOn);
		}
	}

	if(app.pA->ConnectedToArm && !app.pA->CMMSerialNum.IsEmpty())
	{
		jtlimit.SetWindowText(app.pA->CMMSerialNum);
		//trackArmButton.ShowWindow(SW_SHOW);	// no longer shown - Faro now has a new TrackArm which no longer uses a sync cable at all, they just match trajectories. Also, no sdk for the new one, Faro implimented it in CAM2 and one other 3rd party software, says Ken Steffey
	}

	measmode = app.saarm.Data.measmode;
	HighlightButton();

	if(!app.saarm.Data.doconnection || !app.pA->ConnectedToArm)
		if(!app.pA->IsKreonScannerArm())
			ShowFakeArmButtons();
	
	// Init the remote UI manager here
	// 2003.10.28 - don't do this - seems to be causing trouble
	//if ( !m_RemUIMgr.InitToListen( this, 997 ) )			// jmc PDA
	//	AfxMessageBox( Tr("Could not initialize the remote PDA manager.") );			// jmc PDA

	if( app.pA->IsSNL() )
	{
//		calbutton.ShowWindow(SW_HIDE);
		calbutton.EnableWindow(FALSE);
		framebutton.EnableWindow(FALSE);
		SetAllButtonStatesFalse();
	}
	scanbutton.EnableWindow();
	if( !app.pA->IsFaroUSB() && !app.pA->IsRomer() && !app.pA->IsKreonScannerArm() && app.saarm.arm_type != SAArm::arm_Hexagon_Absolute_SI )
		scanbutton.EnableWindow(FALSE);

	if(app.pA->IsKreonScannerArm())
		calbutton.SetWindowText(Tr("Scanner Calibration"));

	if( app.pA->IsFrenchRomer() )
	{
		//		calbutton.ShowWindow(SW_HIDE);
		calbutton.EnableWindow(FALSE);
	}

	//if( !app.pA->IsRomer() && !app.pA->IsFrenchRomer() )
	//{
		pipeProbeButton.EnableWindow(FALSE);
		pipeProbeButton.ShowWindow(SW_HIDE);
	//}

	if(app.saarm.toolBarDevFlagSet)
		saInstBarButton.ShowWindow(SW_SHOW);

	TRANSLATE_DIALOG;

	SetTimer(INITTIMER, 500, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}
void CDPCMMDlg::SetTopMost()
{
	SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
}
void CDPCMMDlg::SetTop()
{
	SetWindowPos(&wndTop, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
}
void CDPCMMDlg::SetNoTopMost()
{
	SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
}
void CDPCMMDlg::StartQueryTimer(double periodsec)
{
	KillTimer(BUTTONTIMER);
	KillTimer(QUERYTIMER);

	SetTimer(BUTTONTIMER, (int)(1000/BUTTONTIMERFREQ), NULL);
	SetTimer(QUERYTIMER,(int)(periodsec*1000),NULL);
	//TRACE1("QueryTimer set for %f sec period\n", periodsec);
}
void CDPCMMDlg::StopQueryTimer()
{
	if (!app.pA->IsHexagonRDS()) // 2019.08.07 - BUG!  Faro arms will continue to process button hits (e.g. to change meas mode) unless the button timer is killed here!
		KillTimer(BUTTONTIMER);
	else if(app.pA->IsHexagonRDS() && !app.pA->armScannerSwitchOn) // 2019.03.15 - rds arms - allowing side buttons to e.g. operate Next Feature during line scanning, don't need BUTTONTIMER for e.g. Faro's
		KillTimer(BUTTONTIMER);
	KillTimer(QUERYTIMER);
}
//////////////////////////////////////////////////////////////
// scanner timer stuff
void CDPCMMDlg::StartScannerTimer(double periodsec)
{
	KillTimer(SCANNERTIMER);
	SetTimer(SCANNERTIMER,(int)(periodsec*1000),NULL);
}
void CDPCMMDlg::StopScannerTimer()
{
	KillTimer(SCANNERTIMER);
}
//////////////////////////////////////////////////////////////
void CDPCMMDlg::ShowPos(double x, double y, double z)
{
	Target.Format(_T("%f"), x);
	UpdateData(FALSE);
	TRACE3("X=%f,Y=%f,Z=%f", x,y,z);
}

void CDPCMMDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDPCMMDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDPCMMDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDPCMMDlg::OnDefaultButton() 
{
	SetDataParams();
}

BOOL CDPCMMDlg::OnTTNeedText( UINT id, NMHDR * pTTTStruct, LRESULT * pResult )  // jmc pb
{
	// NOTE: Tab order matters!  If you're missing tool tips for some buttons, there may simply be a non-contiguous tab order, and that may be where the tool tips don't work
	TRACE0("ONTTNeedText...\n");
	TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pTTTStruct;
	UINT nID = pTTT->hdr.idFrom;
	if (pTTT->uFlags & TTF_IDISHWND)
		nID = ::GetDlgCtrlID((HWND)nID);

	CWnd* pw = GetDlgItem(nID);
	if (pw->IsKindOf(RUNTIME_CLASS(PictureButton)) || pw->IsKindOf(RUNTIME_CLASS(CButton)))  // extract text from picture button.
	{
		CString tip;
		pw->GetWindowText(tip);
		lstrcpy(pTTT->szText,tip);
	}

	return TRUE;
}

void CDPCMMDlg::SetDataParams()
{
	UpdateData(TRUE);
	
	collectionCombo.GetWindowText(app.saarm.Data.Collection);
	groupCombo.GetWindowText(app.saarm.Data.Group);
	app.saarm.Data.Target = Target;
	app.saarm.Data.geomName = geomName;

	app.pA->FixBlankNames();
}
void CDPCMMDlg::GetDataParams()
{
	app.pA->FixBlankNames();
	
	collectionCombo.SetWindowText(app.saarm.Data.Collection);
	groupCombo.SetWindowText(app.saarm.Data.Group);
	Target = app.saarm.Data.Target;
	geomName = app.saarm.Data.geomName;
	
	UpdateData(FALSE);

	app.saarm.OnCGTargetNameChanged();
}

bool CDPCMMDlg::FocusOnKeyboardInput()
{
	if(collectionComboHasFocus || groupComboHasFocus || targetEditHasFocus || geomNameEditHasFocus)
		return true;
	else
		return false;
}

///////////////////////////////////////////////////////////////////////
// Faro Specific Functions - serial communications
BOOL CDPCMMDlg::InitComm(BOOL QueryCaliper)      //create and open comm
{
	// init - call global functions included by SerialComm.cpp
	if (!CreateTTYInfo( m_hWnd ))
	{
		AfxMessageBox(_T("could not create serial port info"));
		return FALSE;
	}
	
	int br = 0;
	int db = 0;
	CString par;
	if(app.saarm.Data.CommBaud==0) br = 19200;
	else if(app.saarm.Data.CommBaud==1) br = 38400;
	else if(app.saarm.Data.CommBaud==2) br = 57600;
	else if(app.saarm.Data.CommBaud==3) br = 115200;
	pSerialInfo->dwBaudRate = br;

	CommParams = app.saarm.Data.commParams;

	if(CommParams==0)
	{
		par = "even";
		db = 7;
		pSerialInfo->bByteSize = 7;
		pSerialInfo->bParity = EVENPARITY;
	}
	else
	{
		par = "no";
		db = 8;
		pSerialInfo->bByteSize = 8;
		pSerialInfo->bParity = NOPARITY;
	}

	if( QueryCaliper )
	{
		CString m;
		m.Format(_T("Have you run CALIPER 3D and set\nCOMM port parameters to\n%d baud, %d data bits, 1 stop bit and %s parity?\n"),br,db,par);
		int temp = AfxMessageBox( m, MB_YESNO | MB_ICONQUESTION );
		if(temp == IDNO)	
			return FALSE;
	}

//	m.Format("CommPort = %d", app.saarm.Data.CommPort);
//	AfxMessageBox(m);

	pSerialInfo->bPort = app.saarm.Data.CommPort;
	if (!OpenConnection( m_hWnd ))
	{
		if( QueryCaliper )
			AfxMessageBox(_T("Could not open connection - Check serial port!"),MB_ICONSTOP);
		return FALSE;
	}
	// we are initialized, lets set the Terminator characters and buffer pointer.
	hTTYWnd = m_hWnd;	  // set global for watch thread.
	pSerialInfo->Terminator[0] = 0x0D;
	pSerialInfo->nTerminator = 1;
	//pSerialInfo->Terminator[0] = 'U';
	//pSerialInfo->Terminator[1] = 'H';
	//pSerialInfo->nTerminator = 2;
	pSerialInfo->iBuf = 0;
	CommConnected = TRUE;
	CommStatus = "CONNECTED";
	pSerialInfo->NoTerminatorRequired = FALSE;  //not normal serialcomm set in sc now
	pSerialInfo->NoTermLength = 129;	//no. of chars in unterminated response "O_ packet"

	app.pA->firstshot = TRUE;
	if( !WriteHead("_D1") )	// set Calip units to mm
		return FALSE;
	Delay(0.2, TRUE);

	// 2001.05.29 - clear any user defined coordinate system from arm!!
	// user can define an "object coordinate system" in Faro software, and
	// that transform is saved in the arm, and applied to all xyz data in the
	// 'PPacket'.  We used to use the undocumented 'OPacket' for xyz app.saarm.Data.  In
	// that diagnostic packet, the transform is not applied to the xyz app.saarm.Data.
	if( !WriteHead("_C2 0.0 0.0 0.0 0.0 0.0 0.0") )
		return FALSE;
	Delay(0.2, TRUE);

	Holding = TRUE;

	WriteHead("_O");
//	while( Holding )
//		ProcessWaitingMessages();
	HoldForResponse(1.0);
//	WriteHead("_P");
//	WriteHead("_H0");	// testing only!!!  this sets the default probe type, 0 -> point probe, 1 -> 1.4" ball

	// 2001.11.15 begin, turn arm button beep off, but leave limit beep on
	WriteHead("_S0 1 0030 0030");
	Delay(0.2,TRUE);
	// 2001.11.15 end



	return TRUE;
}


void CDPCMMDlg::CloseComm()     // port close
{
   if(CommConnected && app.pA->ConnectedToArm)						//if open
   {
		TRACE0("Closing comm connection...\n");
		if (DestroyTTYInfo( app.m_pMainWnd->m_hWnd ))				//try to close
		{
			TRACE0("... port closed.\n");
			CommConnected = FALSE;
			CommStatus = "DISCONNECTED";
		}
		else
			AfxMessageBox(_T("could not CLOSE"));
	}
}

BOOL CDPCMMDlg::WriteHead(char b[])	//data out
{
//	for(int i=0;i<(int)strlen(b);i++)
//		TRACE("%2x %c\n",b[i],b[i]);
//	strcpy(LastCommand,b);
	if(app.StopNow)
		return FALSE;

	if (!WriteCommBlock( app.m_pMainWnd->m_hWnd, b, strlen(b)))
	{
		AfxMessageBox(_T("problem writing to head."));
		return FALSE;
	}
//	TRACE1("Wrote command %s\n", b);
	return TRUE;
}

BOOL CDPCMMDlg::HoldForResponse(float timeout)
{
   timeout *=1000;
//	HoldResponse = FALSE;   //initialize to a T.O. error
								//if a packet is read it becomes TRUE
	Holding = TRUE;
//	TRACE("beginning hold\n");
	MSG msg;
	DWORD Start = ::GetCurrentTime();	//set time ref
	while (Holding)
	{
		if(app.StopNow)
		{
			Holding = FALSE;
			return FALSE;
		}

 		// clear out message queue (process any waiting messages)
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) && Holding)	// 2001.04.13 - OnSerialDataInQ sets holding FALSE too!
		{
			if(app.StopNow)
			{
				Holding = FALSE;
				return FALSE;
			}
	 		TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		//check elapsed time against timeout
		if((::GetCurrentTime() - Start)>(DWORD)timeout)
		{
			if(app.StopNow)
			{
				Holding = FALSE;
				return FALSE;
			}

			Holding = FALSE;
			//AfxMessageBox("No Response from Instrument");
//			TRACE0("No Response from Instrument\n");
			//StopNow = TRUE;
			return FALSE;
		}
	}
//	TRACE("done holding\n");
	return TRUE;
}



BOOL CDPCMMDlg::HandShakeHead(char command[],char expected,float timeout)
{
	int temp = IDRETRY;
	while(temp!=IDCANCEL)
	{
		WriteHead( command );				//send command
		while(HoldForResponse(timeout))	// wait for the heads response	
		{
			if(RespString[0]== expected)	//if the head responds as expected
				return TRUE;
		}
		temp = AfxMessageBox(_T("Instrument Communication Timeout Error!"),MB_RETRYCANCEL|MB_ICONSTOP|MB_DEFBUTTON1);
	}	
//	StopNow = TRUE;
	return FALSE;
}

/*BOOL CDPCMMDlg::WriteAndHold(CString data,int Blocks,float timeout,BOOL Notify)	//data out
{
	if(!sm_CommConnected)
		return FALSE;
	sm_RespCount = 0;
	sm_DesiredRespCount = Blocks;
	char b[200];
	//copy cstring to char buffer
	for(int i=0;i<app.saarm.Data.GetLength();i++)
		b[i] = data[i];
	if (!WriteCommBlock( b, app.saarm.Data.GetLength()))
	{
		CString msg;
		if(Notify)
		{
			msg.Format("problem writing comm port %d",sm_CommPort);
//			((HW*)(sm_pOwner))->PostError(msg);
		}
		return FALSE;
	}
	//we wrote it, now lets wait for resp blocks

   timeout *=1000;
	DWORD Start = ::GetCurrentTime();	//set time ref
	TRACE("in W&H DRC = %d\n",sm_DesiredRespCount);
	while(sm_RespCount<sm_DesiredRespCount)
	{
		// PROCESS WAITING MESSAGES
		MSG msg;
 		// clear out message queue (process any waiting messages)
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
	 		TranslateMessage(&msg);
			DispatchMessage(&msg);
		}       
		if((::GetCurrentTime() - Start)>(DWORD)timeout)
		{
//			if(Notify)
//				((HW*)(sm_pOwner))->PostError("No response to write");
			FlushResp();
			sm_DesiredRespCount = 0;
			sm_RespCount = 0;
			TRACE("leaving W&H, unsuccessful, respct = %d\n\n", sm_RespCount);
			return FALSE;
		}
	}
	sm_RespCount = 0;

	TRACE("leaving W&H, successful, respct = %d\n\n", sm_RespCount);
	return TRUE;
}*/
#define FAROJTPAKSIZE 129
#define FAROIJKPAKSIZE 73
LONG CDPCMMDlg::OnSerialDataInQ(UINT a, LONG d)
{        
	if(app.StopNow)
		return 0;
	// we have a buffer with new app.saarm.Data. 
	// first, we must null terminate it or pay for the consequences.
	pSerialInfo->Buf[ pSerialInfo->iBuf ] = 0;
	int Size = pSerialInfo->iBuf;
	//TRACE("packet length = %d, %s\n",pSerialInfo->iBuf,pSerialInfo->Buf);
	strcpy(RespString,pSerialInfo->Buf);
	if(RespString[0] == 'U')  //an _O response
	{
//		TRACE("\nJTPACKET recieved! SIZE %d\n",Size);
		JointPacket Data;
		strcpy(Data.Raw,RespString);
//		TRACE1("Got a U or H Response, button %c\n", app.saarm.Data.Opacket.Error[6]);
	//	pSerialInfo->iBuf = 0;		// start at beginning of packet.
	//	pSerialInfo->Go = TRUE;		// allow the watch thread to continue;
		if(!app.pA->ProcessButtonsandUpdatePacket(&Data))
		{
			TRACE("ProcessMeas Incomplete!\n");
		}
	}
	if (Size == FAROIJKPAKSIZE || Size == FAROIJKPAKSIZE + 1 )
	{
		//TRACE1("\nIJKPACKET recieved! SIZE %d\n",Size);
		IJKPacket Data;
		strcpy(Data.Raw, RespString);
		if(!app.pA->ProcessXYZIJKPacket(&Data))
		{
			TRACE("ProcessIJK Inclomplete!\n");
		}
	}
/*	else if (Size != FAROJTPAKSIZE && Size != FAROIJKPAKSIZE)
	{
		TRACE("BAD BAD BAD PACKET SIZE %d\n",Size);
		// ignore!
	}
	else
	{
		TRACE("unknown packet\n");
		//ignore and keep going
	}
*/	//ignore all others


	pSerialInfo->iBuf = 0;		// start at beginning of packet.
	Holding = FALSE;			//Stop the holding loop!
	pSerialInfo->Flush = TRUE;		// allow the watch thread to continue;
	pSerialInfo->Go = TRUE;		// allow the watch thread to continue;
	return d;
}
///////////////////////////////////////////////////////////////////////

void CDPCMMDlg::OnButtonTest() 
{
	if(app.saarm.SelectTrackArmTrackerFromSA())
	{
		Transform tx;
		Vector t(30,0,0), r(5,0,0);
		tx.SetTranslation(t);
		tx.SetRotation(r);
		app.saarm.OnTrackArmTransformChanged(tx, true);
	}
//	RDS_VerifyProbeRecording( this->m_hWnd );

//	app.pA->Test();
//	app.pA->Logon();
/*
	int a, b, c, d, e, f, g;

	a = 0;
	b = 1;
	c = 2;
	d = 3;
	e = 4;
	f = 5;
	g = 5;

	c |= b;
	e ^= g;
	d &= f;

	CString m;
	m.Format("2 |= 1, %d    4 ^= 5, %d   3 &= 5, %d", c, e, d);
	AfxMessageBox(m);
*/
}

void CDPCMMDlg::OnButtonStart() 
{
	// testing new romer power probe & callback stuff
	return;
/*
	if ( !m_bRun )
	{
		UpdateData( TRUE );

		m_bRun = true;

		g_RDSRecordapp.saarm.Data.pfnCallbackProbePosition = Callback;
		g_RDSRecordapp.saarm.Data.dwWnd = DWORD( this );
		g_RDSRecordapp.saarm.Data.lSoundFrequency = 0;
		g_RDSRecordapp.saarm.Data.lSoundDuration = 0;
		g_RDSRecordapp.saarm.Data.dwRecordFunction = 0;

		// Joe, this is where the sample posts a message to do the following
		startbutton.SetWindowText( "Stop" );

		RDS_WaitAndRecordOnProbeFunction( &g_RDSRecordData );

//		m_bRun = false;
//		startbutton.SetWindowText( "Start" );
		RDS_OutputSpeakerSound( 2000, 500 );	}	
	else
		m_bRun = false;
*/
}
/*
WORD CALLBACK Callback( RDS_CALLBACK_DATA* aData )
{
	CDPCMMDlg* pDlg = static_cast< CDPCMMDlg* >( ( void* )aData->dwWnd );

	// Joe, I've tried commenting these two if's out - nothin'
//	if (  !m_bRun ) 
		// A user aborted recording (possibly hitting <Stop> button)
//		return RDS_ABORT_RECORDING;

//	if ( !pDlg->IsWindowVisible() )
		// A way of knowing that the dialog is closed
//		return RDS_ABORT_RECORDING;

	//pDlg->ShowPos(aData->stProbePosition.dX, aData->stProbePosition.dY, aData->stProbePosition.dZ);

	pDlg->Target.Format( "%.3lf", aData->stProbePosition.dX );
	TRACE1("CALLBACK: X=%f", aData->stProbePosition.dX);
	// Get data from the RDS_CALLBACK_DATA structure
//	pDlg->m_strI.Format( "%.3lf", aData->stProbePosition.dZI );
//	pDlg->m_strJ.Format( "%.3lf", aData->stProbePosition.dZJ );
//	pDlg->m_strK.Format( "%.3lf", aData->stProbePosition.dZK );
//	pDlg->m_strX.Format( "%.3lf", aData->stProbePosition.dX );
//	pDlg->m_strY.Format( "%.3lf", aData->stProbePosition.dY );
//	pDlg->m_strZ.Format( "%.3lf", aData->stProbePosition.dZ );

	// Update controls to show the new app.saarm.Data.
	// The refresh rate will be set to 100 msec.

	static DWORD dwTime1 = GetTickCount();
	DWORD dwTime2 = GetTickCount();

	if ( dwTime2 - dwTime1 > 100 )
	{
		dwTime1 = dwTime2;
		pDlg->UpdateData( FALSE );
	}

	// To keep the application alive, process the messages posted to 
	// the thread message queue.

	MSG msg;

   	while ( ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) 
	{
	    ::TranslateMessage( &msg );
 	  	::DispatchMessage( &msg );
  	}

	// Continue calling this function
	return RDS_CONTINUE_RECORDING;
}
*/
void CDPCMMDlg::OnTimer(UINT nIDEvent) 
{
	if(app.StopNow)
	{
		CDialog::OnTimer(nIDEvent);
		return;
	}
	if( nIDEvent == INITTIMER )
	{
		KillTimer(INITTIMER);

		// set main dlg title bar text
		CString m;
		if(!app.pA->ConnectedToArm)
			app.saarm.CMMString.Format(_T("Simulation"));
		m.Format(_T("%s %s"), app.saarm.CMMString, app.VString);
		SetWindowText(m);

		// send arm info to SA log file...
		CString logTitle, versionInfo;
		logTitle.Format(_T("%s %s"), app.saarm.CMMString, app.pA->CMMSerialNum);
		versionInfo.Format(Tr("SA PCMM Driver v. ") + app.VString);
		app.saarm.SendReportItem(logTitle, CString(_T("")), versionInfo);

		helpButton.SetFocus();	// 2007.09.19 - in case user starts out using keyboard ctrl buttons for arm buttons, don't want that to edit coll, grp, targ

		//scanbutton.SetBitmap(IDB_LINE_SCANNER);
		//avgptsbutton.SetBitmap(IDB_AVG_PTS);
		//spherebutton.SetBitmap(IDB_SPHERE);
		//circlebutton.SetBitmap(IDB_CIRCLE);
		//framebutton.SetBitmap(IDB_FRAME);
		//guidebutton.SetBitmap(IDB_BATCH);
		//holebutton.SetBitmap(IDB_HOLE);
		//linebutton.SetBitmap(IDB_LINE);
		//patchbutton.SetBitmap(IDB_PATCH);
		//pinbutton.SetBitmap(IDB_PIN);
		//planebutton.SetBitmap(IDB_PLANE);
		//pointbutton.SetBitmap(IDB_PTS);
		//sectionbutton.SetBitmap(IDB_SECTION);
		//slotbutton.SetBitmap(IDB_SLOT);
		//streambutton.SetBitmap(IDB_STREAM);
		//geomtrigbutton.SetBitmap(IDB_GEOMTRIG);
		//coneButton.SetBitmap(IDB_CONE);
		//armPadButton.SetBitmap(IDB_ARMPAD);

		if(app.controlPad.IsPadCalibrated())
		{
			app.controlPad.SwitchOn();
		}

		app.pA->DoPostInitOperations();

		StartQueryTimer(app.saarm.Data.updatetimerperiodsec);
		app.saarm.SignalInterfaceReady();	// 2004.10.20 - since we now connect to SA BEFORE starting the inst (have to see what to instantiate!), we needed a way for MP's to wait
	
		if(app.saarm.Data.startupInMeasMode)
		{
			app.pA->SetMeasMode(app.saarm.Data.startupMeasMode);
			DoMeasurement();
		}

		/////////////////////////////////////////////////////
		// JIRA XIT-29 - 2016.05.17
		if(app.pA->armScannerSwitchOn)
		{
			app.saarm.EndMeasurement();
			CString err;
			app.pA->SetMeasModeByName(_T("Scanner"), err);
			app.pA->StartScannerMeas();
		}
		app.pA->mainDlgIsInitialized = true;
		/////////////////////////////////////////////////////

		//////////////////////////////////////////////////////////////////////////
		// jmc - the SA toolbar state is stored in the interface settings file.  So here, we check the state
		// that came from the loaded settings and apply it if true by "pressing the TB button".
		app.OnInstrumentInterfaceInitDialogEnding();
		//////////////////////////////////////////////////////////////////////////
	}
	else if(nIDEvent == RESTARTMEASTIMER)
	{
		StopQueryTimer();
		KillTimer(RESTARTMEASTIMER);
		StartQueryTimer(app.saarm.Data.updatetimerperiodsec);
		DoMeasurement();
	}
	else if( nIDEvent == BUTTONTIMER )
	{
		if( GetArmData() )
		{
			app.pA->CheckAndUpdateModelInfo();
			ProcessButtonHit(app.pA->buttonstate);

			if(app.pA->IsMetrisGarda())
			{
				if(app.saarm.Data.alwaysupdateSA)
					app.pA->UpdateToSpan();
			}
		}
	}
	else if( nIDEvent == QUERYTIMER )
	{
		app.pA->CheckPad();
		if(app.saarm.Data.alwaysupdateSA)
			app.pA->UpdateToSpan();
	}
	else if( nIDEvent == PDATIMER )
	{
		PDAUpdateXYZ(Vector(app.pA->X, app.pA->Y, app.pA->Z));
	}
	else if( nIDEvent == SCANNERTIMER )
	{
		KillTimer(SCANNERTIMER);
		app.pA->CheckAndSendScannerCloud();
		StartScannerTimer(app.saarm.Data.scannerTimerPeriodSec);
	}
	CDialog::OnTimer(nIDEvent);
}
void CDPCMMDlg::DisplayInstColNameIdx(CString instFullName)
{
	CString sidx;
	sidx.Format(_T("%s"), instFullName.Left(20));
	SAInstIndex.SetWindowText(sidx);	
}
BOOL CDPCMMDlg::GetArmData()
{
	KillTimer(BUTTONTIMER);
	if( app.pA->IsSNL() )
		app.pA->ClearButtonState();
	if( !app.pA->GetAllData() )
	{
		if(app.StopNow)
			return FALSE;
		// 2001.03.23 begin
		if( app.pA->IsRomer() || app.pA->IsFaroUSB() || app.pA->IsFrenchRomer() || app.pA->IsMetrisGarda())	// Romer needs to keep checking for joint limit condition!!
			SetTimer(BUTTONTIMER, (int)(1000/BUTTONTIMERFREQ), NULL);
		// 2001.03.23 end
		return FALSE;
	}
	SetTimer(BUTTONTIMER, (int)(1000/BUTTONTIMERFREQ), NULL);
	return TRUE;
}
/////////////////////////////////
// SA Arm Toolbar
void CDPCMMDlg::RestartMeasurement()
{
	SetTimer(RESTARTMEASTIMER, 250, NULL);
}
/////////////////////////////////
void CDPCMMDlg::ProcessButtonHit(WORD state) 
{
//	TRACE("button state = %d, lobyte = %d, shifted hibyte = %d\n", state, LOBYTE(state), HIBYTE(state)<<8);

	if(app.StopNow)
		return;

	if( app.pA->IsSNL() )	// SNL edit this - can't do the meas mode selection currently.
		return;					// We're processing keyboard hits in leu of arm buttons!

	switch(LOBYTE(state))
	{
	case 0:
		{
			ButtonHit(NOTHING,0);
			break;
		}
	case 1:
		{
			ButtonHit( app.saarm.Data.ButtonOneMode, HIBYTE(state)<<8 );
			break;
		}
	case 2:
		{
			ButtonHit( app.saarm.Data.ButtonTwoMode, HIBYTE(state)<<8 );
			break;
		}
	case 4:
		{
			ButtonHit( app.saarm.Data.ButtonThreeMode, HIBYTE(state)<<8 );
			break;
		}

	default:
		{
			break;
		}
	}
}

// 2001.06.01 - adding all but BACKUP_MOUSE case.
// adding toggle and set measure modes
void CDPCMMDlg::ButtonHit(int Mode, int duration)
{
	switch(Mode)
	{
	case RECORD_ACCEPT:
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT && !app.pA->IsRemoteMouseEnabled())
			{
				if(measmode >= UPPERMODE)
					measmode = 0;
				else
					measmode++;
				HighlightButton();
				SpeakMeasMode();	// 2001.06.07
			}
			else if(duration == BUTTON_LONG && !app.pA->IsRemoteMouseEnabled())
			{
				DoMeasurement();
			}
			else if(duration == BUTTON_SHORT && app.pA->IsFaro() && app.pA->IsRemoteMouseEnabled())
			{
				mouse_event(
					MOUSEEVENTF_LEFTDOWN,	// flags specifying various motion/click variants    	
					0x0,
					0x0,
					0x0,	// unused, reserved for future use, set to zero
					0x0 	// 32 bits of application-defined information	
					);
				leftWasDown = true;
			}
			break;
		}
	case BACKUP_CANCEL:
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT && !app.pA->IsRemoteMouseEnabled())
			{
				if(measmode <= 0)
					measmode = UPPERMODE;
				else
					measmode--;
				HighlightButton();
				SpeakMeasMode();	// 2001.06.07
			}
			else if(duration == BUTTON_LONG && !app.pA->IsRemoteMouseEnabled())	// 'hidden' way to start easy pad cal.
			{
				if(app.saarm.Data.controlPadEnabled)
				{
					TRACE0("LONG ARM BUTTON HIT STARTING SA PAD LOC\n");
					app.pA->DoEasyPadLocMeas();
				}
			}
			// 2001.11.19 - inspection mode with arm button?
/*			else if(duration == BUTTON_LONG && !app.pA->IsRemoteMouseEnabled())
			{
				if( measmode == 8 )
				{
					app.pA->inspectreq = PLANEINSPECT;
					SAIPInspectObject io;
					io.Type = SAIPInspectObjectPlane;
					app.saarm.QS.SendPacket(io);
					app.saarm.TTS.TextToSpeech("Pick Plane in S A");
				}
				else if( measmode == 4 )
				{
					app.pA->inspectreq = HOLEINSPECT;
					SAIPInspectObject io;
					io.Type = SAIPInspectObjectCircle;
					app.saarm.QS.SendPacket(io);
					app.saarm.TTS.TextToSpeech("Pick Circle in S A");
				}
				else if( measmode == 3 )
				{
					app.pA->inspectreq = PININSPECT;
					SAIPInspectObject io;
					io.Type = SAIPInspectObjectCircle;
					app.saarm.QS.SendPacket(io);
					app.saarm.TTS.TextToSpeech("Pick Circle in S A");
				}
			}
*/
			break;
		}
	case BACKUP_MOUSE:
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT && !app.pA->IsRemoteMouseEnabled())
			{
				if(measmode <= 0)
					measmode = UPPERMODE;
				else
					measmode--;
				HighlightButton();
			}
			if(duration == BUTTON_LONG)
			{
				MessageBeep(-1);
				app.pA->ToggleRemoteMouse();
				if(app.pA->IsRemoteMouseEnabled())
					app.saarm.TTS.TextToSpeech(_T("Mouse Enabled"));
				else
					app.saarm.TTS.TextToSpeech(_T("Mouse Disabled"));
			}
			break;
		}
	case RECORD_BACKUP:
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT && !app.pA->IsRemoteMouseEnabled())
			{
				if(measmode >= UPPERMODE)
					measmode = 0;
				else
					measmode++;
				HighlightButton();
				SpeakMeasMode();	// 2001.06.07
			}
			else if(duration == BUTTON_LONG && !app.pA->IsRemoteMouseEnabled())
			{
				if(measmode <= 0)
					measmode = UPPERMODE;
				else
					measmode--;
				HighlightButton();
				SpeakMeasMode();	// 2001.06.07
			}

			break;
		}
	case ACCEPT_CANCEL:
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT && !app.pA->IsRemoteMouseEnabled())
			{
				DoMeasurement();
			}
			else if(duration == BUTTON_SHORT && app.pA->IsFaro() && app.pA->IsRemoteMouseEnabled())
			{
				mouse_event(
					MOUSEEVENTF_LEFTDOWN,	// flags specifying various motion/click variants    	
					0x0,
					0x0,
					0x0,	// unused, reserved for future use, set to zero
					0x0 	// 32 bits of application-defined information	
					);
				leftWasDown = true;
			}
			else if(duration == BUTTON_LONG && !app.pA->IsRemoteMouseEnabled())	// 'hidden' way to start easy pad cal.
			{
				if(app.saarm.Data.controlPadEnabled)
				{
					TRACE0("LONG ARM BUTTON HIT STARTING SA PAD LOC\n");
					app.pA->DoEasyPadLocMeas();
				}
			}
			break;
		}
	case NAV_NEXT_PREV:
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT)
			{
				SAIPInspectionNavigation in;
				in.navMode = SAIPInspectionNavigation::NAV_NEXT;
				app.saarm.SendInspectionNavigationToSA(in);
			}
			else if(duration == BUTTON_LONG)
			{
				SAIPInspectionNavigation in;
				in.navMode = SAIPInspectionNavigation::NAV_PREV;
				app.saarm.SendInspectionNavigationToSA(in);
			}
			break;
		}
	case NAV_NEXT_ITERATE_MEAS_MODE:	// for SA Toolbar ONLY
		{
			app.pA->ClearButtonState();
			if(duration == BUTTON_SHORT)
			{
				SAIPInspectionNavigation in;
				in.navMode = SAIPInspectionNavigation::NAV_NEXT;
				app.saarm.SendInspectionNavigationToSA(in);
			}
			else if(duration == BUTTON_LONG)
			{
				app.saarm.EndMeasurement();

				if(measmode == 0) // single pt.
					app.pA->SetMeasMode(1);	// stream pts.
				else
					app.pA->SetMeasMode(0); // single pt.
				app.saarm.SendSAIRCAttributesToSA();
				app.saarm.RestartMeasurement();
			}
			break;
		}
	default:
		{
			if(app.pA->IsRemoteMouseEnabled() && app.pA->IsFaro() && leftWasDown)
			{
				leftWasDown = false;
				mouse_event(
					MOUSEEVENTF_LEFTUP,	// flags specifying various motion/click variants    	
					0x0,
					0x0,
					0x0,	// unused, reserved for future use, set to zero
					0x0 	// 32 bits of application-defined information	
					);
			}
			break;
		}
	}
	app.pA->overrideArmButtons = false;
}

void CDPCMMDlg::IncrementMeasMode()
{
	if(measmode >= UPPERMODE)
		measmode = 0;
	else
		measmode++;
	HighlightButton();
	SpeakMeasMode();
}
void CDPCMMDlg::DecrementMeasMode()
{
	if(measmode <= 0)
		measmode = UPPERMODE;
	else
		measmode--;
	HighlightButton();
	SpeakMeasMode();
}
void CDPCMMDlg::SetMeasMode(int mode)
{
	if(mode <= 0 || mode > UPPERMODE)
		return;
	measmode = mode;

	HighlightButton();
	SpeakMeasMode();
}
void CDPCMMDlg::IncGorT(CString& str, int incr)
{
	UpdateData(TRUE);
	app.pA->FixBlankNames();
	app.pA->IncrementName( str, incr );
	UpdateData(FALSE);
	PDASendGT();
}

///////////////////////////// REMOTE PDA Handlers -- jmc /////////////////////////////////
// ////////////////////////////////////////////////////////

LRESULT CDPCMMDlg::OnDoneTrashingRemoteMessages( WPARAM wParam, LPARAM lParam )				// jmc PDA
{
	TrashRemoteMessages = FALSE;
	return 1;
}

LRESULT CDPCMMDlg::OnRemoteCommand( WPARAM wParam, LPARAM lParam )  // jmc PDA
{
	if (TrashRemoteMessages)
	{
		TRACE0("Trashed Message!\n");
		return 0;
	}
	TrashRemoteMessages = TRUE;		// discard any new remote messages

	ArmBase& ab = *app.pA;

	CString strEntry;
	strEntry.Format( _T("REMOTE Code=%d, ID=%d"), HIWORD(wParam), LOWORD(wParam) );
	TRACE1("%s\n",strEntry);

	int id = LOWORD(wParam);

	if (id==IDC_GT_APPLY)
		PDARequestGT();
	else if (id==IDC_G_U)
		app.pA->IncrementName(app.saarm.Data.Group,1);
	else if (id==IDC_T_U)
		app.pA->IncrementName(app.saarm.Data.Target,1);
	else if (id==IDC_G_D)
		app.pA->IncrementName(app.saarm.Data.Group,-1);
	else if (id==IDC_T_D)
		app.pA->IncrementName(app.saarm.Data.Target,-1);
	else if (id==IDC_T_ZERO)
	{
		UpdateData(TRUE);
		Target = _T("P1");
		UpdateData(FALSE);
		PDASendGT();
	}
	else if (id==IDC_SINGLEPTS)
		app.pA->DoPointMeas();
	else if (id==IDC_STREAMPTS)
		app.pA->DoStreamPtsMeas();
	else if (id==IDC_PATCH)
		app.pA->DoPatchMeas();
	else if (id==IDC_PIN)
		app.pA->DoPinMeas();
	else if (id==IDC_HOLE)
		app.pA->DoHoleMeas();
	else if (id==IDC_SLOT)
		app.pA->DoSlotMeas();
	else if (id==IDC_LINE)
		app.pA->DoLineMeas();
	else if (id==IDC_CIRCLE)
		app.pA->DoCircleMeas();
	else if (id==IDC_PLANE)
		app.pA->DoPlaneMeas();
	else if (id==IDC_SPHERE)
		app.pA->DoSphereMeas();
	else if (id==IDC_SECTION)
		app.pA->DoSectionMeas();
	else if (id==IDC_FRAME)
		app.pA->DoFrameMeas();

	PostMessage(DONE_TRASHING_REMOTE_MSG,0,0);  // jmc PDA
	return 1;
}		

LRESULT CDPCMMDlg::OnRemoteConnect( WPARAM wParam, LPARAM lParam ) // jmc PDA
{
	// send over the initial dialog
	m_RemUIMgr.StartGrouping();
	m_RemUIMgr.CreateRemoteDialog(IDD_PDA_REMOTE);
	PDAUpdateXYZ(Vector(app.pA->X, app.pA->Y, app.pA->Z), TRUE,FALSE);
	CString group;
	groupCombo.GetWindowText(group);
	m_RemUIMgr.SetRemoteWindowText(IDC_GROUP, group);
	m_RemUIMgr.SetRemoteWindowText(IDC_TARGET, Target);

	m_RemUIMgr.EndGrouping();

	app.saarm.TTS.TextToSpeech(Tr("Remote Control Activated!"));

	SetTimer(PDATIMER, (int)(1000.0*app.saarm.Data.PDAtimerperiodsec), NULL);	// PDAtimerperiodsec is already in datastore and is being
																		// persisted.  Just need to add an edit box to DOptions for user
	return 1;
}
LRESULT CDPCMMDlg::OnUIReply( WPARAM wParam, LPARAM lParam ) // jmc PDA
{
	TRACE0("OnUIReply\n");
	CString* pStr;
	int nID;
	int nUpdateType;

	nUpdateType = LOWORD( wParam );
	nID = HIWORD( wParam );

	CString m_strCaption;
	ArmBase& gt = *app.pA;

	CString m;
	switch ( nUpdateType ) {
	case CUIMessage::UMT_GETCURTEXT:
	case CUIMessage::UMT_GETTEXT:
		pStr = (CString *) lParam;
		m_strCaption.Format( _T("%s"), *pStr );
		delete pStr;
		m.Format(_T("Get Status: %d  value %s"),nID,m_strCaption);
		TRACE("%s\n",m);
		if (nID==IDC_GROUP)
		{
			app.saarm.Data.Group = m_strCaption;
			GetDataParams();
			UpdateData(FALSE);
		}
		else if (nID==IDC_TARGET)
		{
			app.saarm.Data.Target = m_strCaption;
			GetDataParams();
			UpdateData(FALSE);
		}
//		else if (nID==IDC_MEAS_LIST)
//		{
//			PDAMeasure(m_strCaption);
//		}
		break;
//	case CUIMessage::UMT_GETCHECK:
//		CString m;
//		m.Format(_T("GetStatus CHECK: %d value %d"),nID,lParam);
//		gt.StatusMsg(m);
//		break;
	}
	return 1;
}

void CDPCMMDlg::PDAUpdateXYZ(Vector& DHV,BOOL bing,BOOL GroupCmds)
{
	if (m_RemUIMgr.m_pSockMgr==NULL)
	{
		KillTimer(PDATIMER);
		return;
	}
	
	Vector xyzarm(app.pA->X, app.pA->Y, app.pA->Z), xyzworking;
	app.saarm.InstToWorking.Multiply(xyzarm, &xyzworking);
	xyzworking.Scale(1.0/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]));

	Vector ijkarm(app.pA->II, app.pA->JJ, app.pA->KK), ijkworking;
	app.saarm.InstToWorking.MultiplyRot(ijkarm, &ijkworking);

	if (GroupCmds)
		m_RemUIMgr.StartGrouping();
	
	m_RemUIMgr.SetRemoteWindowText(IDC_WORKING_FRAME,app.saarm.WorkingFrameName);
	CString m;
	m.Format(_T("%10.4f"),xyzworking.x);
	m_RemUIMgr.SetRemoteWindowText(IDC_WORKING_VEC1, m);
	m.Format(_T("%10.4f"),xyzworking.y);
	m_RemUIMgr.SetRemoteWindowText(IDC_WORKING_VEC2, m);
	m.Format(_T("%10.4f"),xyzworking.z);
	m_RemUIMgr.SetRemoteWindowText(IDC_WORKING_VEC3, m);
	m.Format(_T("%10.4f"),ijkworking.x);
	m_RemUIMgr.SetRemoteWindowText(IDC_WORKING_VEC4, m);
	m.Format(_T("%10.4f"),ijkworking.y);
	m_RemUIMgr.SetRemoteWindowText(IDC_WORKING_VEC5, m);
	m.Format(_T("%10.4f"),ijkworking.z);
	m_RemUIMgr.SetRemoteWindowText(IDC_WORKING_VEC6, m);
	m_RemUIMgr.SetRemoteWindowText(IDC_UNITS, app.saarm.units.DistUnitNames[app.saarm.units.distunits]);

	if (bing)
		m_RemUIMgr.CreateRemoteBing();

	if (GroupCmds)
		m_RemUIMgr.EndGrouping();
}

void CDPCMMDlg::PDARequestGT()
{
	m_RemUIMgr.StartGrouping();
	m_RemUIMgr.GetRemoteWindowText(IDC_GROUP);
	m_RemUIMgr.GetRemoteWindowText(IDC_TARGET);
	m_RemUIMgr.EndGrouping();
}

void CDPCMMDlg::PDASendGT()
{
	if (m_RemUIMgr.m_pSockMgr==NULL)
		return;

	m_RemUIMgr.StartGrouping();
	CString group;
	groupCombo.GetWindowText(group);
	m_RemUIMgr.SetRemoteWindowText(IDC_GROUP, group);
	m_RemUIMgr.SetRemoteWindowText(IDC_TARGET, Target);
	m_RemUIMgr.EndGrouping();
}

///////////////////////////////////////////////////////////////////////////////////
// 2001.06.01 - simulation stuff, for measure mode selection with arm buttons
void CDPCMMDlg::OnButton1() 
{
	app.pA->buttonstate = 1;
	app.pA->buttonstate += BUTTON_SHORT;
}

void CDPCMMDlg::OnButton2() 
{
	app.pA->buttonstate = 1;
	app.pA->buttonstate += BUTTON_LONG;
}

void CDPCMMDlg::OnButton3() 
{
	app.pA->buttonstate = 2;
	app.pA->buttonstate += BUTTON_SHORT;
}

void CDPCMMDlg::OnButton4() 
{
	app.pA->buttonstate = 2;
	app.pA->buttonstate += BUTTON_LONG;
}

void CDPCMMDlg::ShowFakeArmButtons()
{
	B1Short.ShowWindow(SW_SHOW);
	B1Long.ShowWindow(SW_SHOW);
	B2Short.ShowWindow(SW_SHOW);
	B2Long.ShowWindow(SW_SHOW);
}
///////////////////////////////////////////////////////////////////////////////////////
// 2001.06.01 - added following functions, for measure mode selection with arm buttons
BOOL CDPCMMDlg::SetAllButtonStatesFalse()
{
	streambutton.SetState(FALSE);
	slotbutton.SetState(FALSE);
	sectionbutton.SetState(FALSE);
	pointbutton.SetState(FALSE);
	planebutton.SetState(FALSE);
	pinbutton.SetState(FALSE);
	patchbutton.SetState(FALSE);
	linebutton.SetState(FALSE);
	holebutton.SetState(FALSE);
	guidebutton.SetState(FALSE);
	framebutton.SetState(FALSE);
	circlebutton.SetState(FALSE);
	spherebutton.SetState(FALSE);
	scanbutton.SetState(FALSE);
	avgptsbutton.SetState(FALSE);
	geomtrigbutton.SetState(FALSE);
	coneButton.SetState(FALSE);
	singlePtHoleButton.SetState(FALSE);
	return TRUE;
}
void CDPCMMDlg::HighlightButton()
{
	SetAllButtonStatesFalse();
	app.saarm.Data.measmode = measmode;

	switch (measmode)
	{
	case 0:
		pointbutton.SetState(TRUE);
		break;
	case 1:
		streambutton.SetState(TRUE);
		break;
	case 2:
		patchbutton.SetState(TRUE);
		break;
	case 3:
		pinbutton.SetState(TRUE);
		break;
	case 4:
		holebutton.SetState(TRUE);
		break;
	case 5:
		slotbutton.SetState(TRUE);
		break;
	case 6:
		linebutton.SetState(TRUE);
		break;
	case 7:
		circlebutton.SetState(TRUE);
		break;
	case 8:
		planebutton.SetState(TRUE);
		break;
	case 9:
		spherebutton.SetState(TRUE);
		break;
	case 10:
		sectionbutton.SetState(TRUE);
		break;
	case 11:
		framebutton.SetState(TRUE);
		break;
	case 12:
		guidebutton.SetState(TRUE);
		break;
	case 13:
		scanbutton.SetState(TRUE);
		break;
	case 14:
		avgptsbutton.SetState(TRUE);
		break;
	case 15:
		geomtrigbutton.SetState(TRUE);
		break;
	case 16:
		coneButton.SetState(TRUE);
		break;
	case 17:
		singlePtHoleButton.SetState(TRUE);
		break;
	default:
		break;
	}
}
void CDPCMMDlg::HighlightPadButton()
{
	TRACE0("Highlight pad button...\n");
	armPadButton.SetState(TRUE);
}
void CDPCMMDlg::UnHighlightPadButton()
{
	armPadButton.SetState(FALSE);
}
BOOL CDPCMMDlg::DoMeasurement()
{
	app.saarm.EndMeasurement();

	SetDataParams();	// 2003.02.18 - be sure g and t are updated... 2004.09.09 - and collection
	BOOL ret = FALSE;

	StopQueryTimer();
	Sleep(500);

	if(!app.saarm.TTS.IsEnabled)
		Beep(1200,100);

	switch (measmode)
	{
	case 0:
		ret = app.pA->DoPointMeas();
		break;
	case 1:
		ret = app.pA->DoStreamPtsMeas();
		break;
	case 2:
		ret = app.pA->DoPatchMeas();
		break;
	case 3:
		ret = app.pA->DoPinMeas();
		break;
	case 4:
		ret = app.pA->DoHoleMeas();
		break;
	case 5:
		ret = app.pA->DoSlotMeas();
		break;
	case 6:
		ret = app.pA->DoLineMeas();
		break;
	case 7:
		ret = app.pA->DoCircleMeas();
		break;
	case 8:
		ret = app.pA->DoPlaneMeas();
		break;
	case 9:
		ret = app.pA->DoSphereMeas();
		break;
	case 10:
		ret = app.pA->DoSectionMeas();
		break;
	case 11:
		ret = app.pA->DoFrameMeas();
		break;
	case 12:
		ret = app.pA->DoGuidedMeas();
		break;
	case 13:
		app.pA->performingStdScannerMeas = true;
		ret = app.pA->StartScannerMeas();
		break;
	case 14:
		ret = app.pA->DoAvgPtsMeas();
		break;
	case 15:
		ret = app.pA->DoGeomTriggerMeas();
		break;
	case 16:
		ret = app.pA->DoConeMeas();
		break;
	case 17:
		ret = app.pA->DoSinglePtHoleMeas();
		break;
	default:
		break;
	}
	if(ret)	// 2005.04.12 - always send the meas done packet back
		app.saarm.OnMeasurementDone(MPResult::DoneSuccess);
	else
		app.saarm.OnMeasurementDone(MPResult::DoneFatalError);

	if(!app.pA->IsKreonScannerArm())
		StartQueryTimer(app.saarm.Data.updatetimerperiodsec);
	return ret;
}
// 2001.06.07, one more for meas mode selection with arm buttons, Jim H. @ Brunson
// has tested the selection with an arm
void CDPCMMDlg::SpeakMeasMode()
{
	switch (measmode)
	{
	case 0:
		app.saarm.TTS.TextToSpeech(_T("Discrete Points"));
		break;
	case 1:
		app.saarm.TTS.TextToSpeech(_T("Stream Points"));
		break;
	case 2:
		app.saarm.TTS.TextToSpeech(_T("Project Point"));
		break;
	case 3:
		app.saarm.TTS.TextToSpeech(_T("Pin"));
		break;
	case 4:
		app.saarm.TTS.TextToSpeech(_T("Hole"));
		break;
	case 5:
		app.saarm.TTS.TextToSpeech(_T("Slot"));
		break;
	case 6:
		app.saarm.TTS.TextToSpeech(_T("Line"));
		break;
	case 7:
		app.saarm.TTS.TextToSpeech(_T("Circle"));
		break;
	case 8:
		app.saarm.TTS.TextToSpeech(_T("Plane"));
		break;
	case 9:
		app.saarm.TTS.TextToSpeech(_T("Sphere"));
		break;
	case 10:
		app.saarm.TTS.TextToSpeech(_T("Cross Section"));
		break;
	case 11:
		app.saarm.TTS.TextToSpeech(_T("Frame"));
		break;
	case 12:
		app.saarm.TTS.TextToSpeech(_T("Batch"));
		break;
	case 13:
		app.saarm.TTS.TextToSpeech(_T("Line Scan"));
		break;
	case 14:
		app.saarm.TTS.TextToSpeech(_T("Averaged Points"));
		break;
	case 15:
		app.saarm.TTS.TextToSpeech(_T("Geometry Trigger"));
		break;
	default:
		break;
	}
}
//////////////////////////////////////////////////////////////////////////////////////
// 2004.10.08 - added the following for calls from SAArm::OnSAIP... calls
void CDPCMMDlg::SetCollectionName(const CString& name)
{
	app.saarm.Data.Collection = name;
	collectionCombo.SetWindowText(app.saarm.Data.Collection);
}
void CDPCMMDlg::SetGroupName(const CString& name)
{
	app.saarm.Data.Group = name;
	groupCombo.SetWindowText(app.saarm.Data.Group);
}
void CDPCMMDlg::SetTargetName(const CString& name)
{
	app.saarm.Data.Target = name;
	Target = app.saarm.Data.Target;
	UpdateData(FALSE);
	app.saarm.OnCGTargetNameChanged();
}
void CDPCMMDlg::SetGeomName(const CString& name)
{
	app.saarm.Data.geomName = name;
	geomName = app.saarm.Data.Target;
	UpdateData(FALSE);
}
//////////////////////////////////////////////////////////////////////////////////////

void CDPCMMDlg::OnClose() // 2016.03.30 - added this for the Faro USB arm scanners
{
	app.pA->StopScannerMeas(); // 2016.03.30 - if we try this during DisconnectFromHardware, or in OnDestroy, or in FaroUSB's destructor, the confounded Faro rangefinder window will not close, and will stay up after this app is gone!
	CDialog::OnClose();
}

void CDPCMMDlg::OnDestroy() 
{
	if(onDestroyCalledAlready)
	{
		TRACE0("CDPCMMDlg::OnDestroy() HAS ALREADY BEEN CALLED!!!\n");
		return;
	}
	onDestroyCalledAlready = true;

	TRACE0("CDPCMMDlg::OnDestroy() BEGIN\n");

	app.saarm.EndMeasurement();

	app.saarm.RestoreArmButtonsForMainInterface();

	app.StopNow = TRUE;
	KillTimer(BUTTONTIMER);
	KillTimer(QUERYTIMER);
	KillTimer(PDATIMER);
	NRKProgress nrkprog(_T("CMM Arm Shutting Down..."), FALSE);
	nrkprog.Update(0,10);
	nrkprog.SetMsg(_T("Saving Settings..."));
	if(app.pA->IsFaro() && app.pA->ConnectedToArm)
	{
		WriteHead("_S0 1 0100 0700");
		Delay(0.5);
	}
	SetDataParams();	// set data store parameters to current dialog values
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_mainDlg"),this);
	nrkprog.Update(1,10);
	Delay(0.5);
	app.saarm.SaveSettings();
	nrkprog.Update(5,10);
	nrkprog.SetMsg(_T("Closing Communications..."));
	Delay(0.5);
	nrkprog.Update(7,10);
	app.saarm.DisconnectFromHardware();	// this calls CloseComm
	if(app.pA->IsFaroUSB())
		app.pA->DisconnectFromHardware(); // 2016.05.05 - need to shut down the rangefinder if scanner is active - otherwise, it is hidden but active upon next startup
	Delay(0.5);
	delete app.pA;
	nrkprog.Update(10,10);
	Delay(0.1);
	nrkprog.Kill();

	CDialog::OnDestroy();
	TRACE0("CDPCMMDlg::OnDestroy() END\n");
}

void CDPCMMDlg::OnIncg() 
{
	app.pA->IncrementName(app.saarm.Data.Group, 1);
	app.pA->SetDisplayData();
}

void CDPCMMDlg::OnInct() 
{
	app.pA->IncrementName(app.saarm.Data.Target, app.saarm.Data.ptnameinc);
	app.pA->SetDisplayData();
}

void CDPCMMDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_mainDlg"),this);	
}

BOOL CDPCMMDlg::OnCommand( WPARAM wParam, LPARAM lParam )
{
	if (!app.GetSAIB()->GetDockWrapper().OnCommand(*this, wParam, lParam))
	{
		CDialog::OnCommand(wParam, lParam);
	}

	return TRUE;
}
void CDPCMMDlg::OnBnClickedButtonPipeProbe()
{
	app.pA->DoPipeProbeMeas();
}

void CDPCMMDlg::OnCbnSetfocusGroupCombo()
{
	groupComboHasFocus = true;
}
void CDPCMMDlg::OnCbnKillfocusGroupCombo()
{
	groupComboHasFocus = false;
}
void CDPCMMDlg::OnEnSetfocusTarget()
{
	targetEditHasFocus = true;
}
void CDPCMMDlg::OnEnKillfocusTarget()
{
	targetEditHasFocus = false;
}

void CDPCMMDlg::OnEnSetfocusGeomName()
{
	geomNameEditHasFocus = true;
}

void CDPCMMDlg::OnEnKillfocusGeomName()
{
	geomNameEditHasFocus = false;
}

void CDPCMMDlg::OnBnClickedButtonTrackArm()
{
	StopQueryTimer();

	DTrackArm dlg;
	dlg.DoModal();

	Sleep(250);

	StartQueryTimer(app.saarm.Data.updatetimerperiodsec);
}

void CDPCMMDlg::OnCbnSetfocusCollectionCombo()
{
	collectionComboHasFocus = true;
}

void CDPCMMDlg::OnCbnKillfocusCollectionCombo()
{
	collectionComboHasFocus = false;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//>> SA Toolbar
bool CDPCMMDlg::MakeInvisible()
{
	return ShowWindow(SW_HIDE) ? true : false;
}
bool CDPCMMDlg::MakeVisible()
{
	if (m_bWasDockedBeforeTB)
	{
		m_dockingBtnCtrl.ForceDockBtnClick();
		Delay(0.25); // 2017.03.15 - XIT-570 - Jeremy says he can click fast enough to show both interfaces!  tone down the trigger happy
	}
	bool ret =  ShowWindow(SW_SHOW) ? true : false;
	::SetWindowPos(m_hWnd,HWND_TOP,300,300,50,50,SWP_NOSIZE + SWP_NOMOVE);
	return ret;
}
void CDPCMMDlg::OnBnClickedSaInstToolbarButton()
{
	m_bWasDockedBeforeTB = false;
	if (m_dockingBtnCtrl.IsDocked())
	{
		// Make sure to undock first!
		//SendMessage(WM_COMMAND, MAKELONG(m_dockingBtnCtrl.GetDlgCtrlID(), BN_CLICKED), (LPARAM) m_dockingBtnCtrl.GetSafeHwnd());
		m_dockingBtnCtrl.ForceDockBtnClick(); // 2017.03.14 - XIT-570 - do this instead of the windows msg - for some reason, that stopped working (was reported by Leica guys using new AT403) - windows update maybe... who knows
		m_bWasDockedBeforeTB = true; // Remember that we were docked prior to request to become toolbar centric
		Delay(0.25); // 2017.03.15 - XIT-570 - Jeremy says he can click fast enough to show both interfaces!  tone down the trigger happy
	}

	app.GetSAIB()->OnToolbarActivationButtonPressed();
}
//<< SA Toolbar
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////