#pragma once

#include "Resource.h"
#include "PictureButtons\\SphereButton.h"
#include "PictureButtons\\CircleButton.h"
#include "PictureButtons\\FrameButton.h"
#include "PictureButtons\\GuideButton.h"
#include "PictureButtons\\HoleButton.h"
#include "PictureButtons\\LineButton.h"
#include "PictureButtons\\PatchButton.h"
#include "PictureButtons\\PinButton.h"
#include "PictureButtons\\PlaneButton.h"
#include "PictureButtons\\PointButton.h"
#include "PictureButtons\\SectionButton.h"
#include "PictureButtons\\SlotButton.h"
#include "PictureButtons\\StreamButton.h"
#include "PictureButtons\\TheoButton.h"
#include "PictureButtons\\GroupInc.h"
#include "PictureButtons\\TargInc.h"
#include "PictureButtons\\OptionButton.h"
#include "PictureButtons\\CalButton.h"
#include "PictureButtons\\ScanButton.h"
#include "PictureButtons\\AvgPointsButton.h"
#include "PictureButtons/GeomTriggerButton.h"
#include "PictureButtons/ConeButton.h"
#include "PictureButtons/SinglePtHoleButton.h"
#include "PictureButtons/ToggleArmButtonsButton.h"
#include "PictureButtons/MPCOmmandHelpButton.h"
#include "PictureButtons/ArmPadButton.h"

#include "PDARemote\SocketManager.h"	// jmc PDA
#include "PDARemote\RemoteUIManager.h"	// jmc PDA
#include "afxwin.h"
#include "picturebuttons\singleptholebutton.h"

#define QUERYTIMER	WM_USER + 10
#define PDATIMER		WM_USER + 11
#define BUTTONTIMER	WM_USER + 12	// 2001.08.30
#define INITTIMER		WM_USER + 13	// 2003.10.29 - see comment in OnTimer
#define SCANNERTIMER WM_USER + 14
#define RESTARTMEASTIMER WM_USER + 15
#define BUTTONTIMERFREQ	4	// per sec

/////////////////////////////////////////////////////////////////////////////
// CDPCMMDlg dialog

class CDPCMMDlg : public CDialog
{
// Construction
public:
	CDPCMMDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CDPCMMDlg();

	void SetTop();
	void SetTopMost();
	void SetNoTopMost();
	void IncGorT(CString& str, int incr=1);
	void PDASendGT();			// jmc
	void PDARequestGT();		// jmc
	void PDAUpdateXYZ(Vector& XYZ, BOOL bing = FALSE,BOOL GroupCmds = TRUE);   // jmc

	void ShowPos(double x, double y, double z);

	BOOL OnTTNeedText( UINT id, NMHDR * pTTTStruct, LRESULT * pResult );  // jmc pb

	void StartQueryTimer(double periodsec);
	void StopQueryTimer();
	void ButtonHit(int Mode, int duration); 
	void ProcessButtonHit(WORD state);
	BOOL GetArmData();

	/////////////////////////////////
	// SA Arm Toolbar
	void RestartMeasurement();
	/////////////////////////////////

	void DisplayInstColNameIdx(CString instFullName);

	bool FocusOnKeyboardInput();

	// scanner timer stuff
	void StartScannerTimer(double periodsec);
	void StopScannerTimer();

	// Faro Specific Serial comm stuff////////////////////////////
//	UINT CommBaud;	2001.06.27 moved to data store
	UINT CommParams;
	BOOL NoSound;
	BOOL CommConnected;
	CString CommStatus;
	char RespString[300];
	BOOL Holding;
	LONG OnSerialDataInQ(UINT a, LONG d);
	BOOL InitComm(BOOL QueryCaliper);      //create and open comm
	void CloseComm();     // port close
	BOOL WriteHead(char b[]);	//data out
	BOOL HandShakeHead(char command[],char expected,float timeout);
	BOOL HoldForResponse(float timeout);
	BOOL WriteAndHold(CString data,int Blocks,float timeout,BOOL Notify);
	///////////////////////////////////////////////////////////////

	CString title;

	void SetDataParams();
	void GetDataParams();

	void SetCollectionName(const CString& name);
	void SetGroupName(const CString& name);
	void SetTargetName(const CString& name);
	void SetGeomName(const CString& name);

	///////////////////////////////////////////////////////////////////////////////////////
	// 2001.06.01 - added the following, for measure mode selection with arm buttons
	int measmode;
#define UPPERMODE	17
	BOOL SetAllButtonStatesFalse();
	void HighlightButton();
	void HighlightPadButton();
	void UnHighlightPadButton();
	BOOL DoMeasurement();
	void SpeakMeasMode();
	void ShowFakeArmButtons();
	//////////////////////////////////////////////////////////////////////////////////////
	void IncrementMeasMode();
	void DecrementMeasMode();
	void SetMeasMode(int mode);

// Dialog Data
	//{{AFX_DATA(CDPCMMDlg)
	enum { IDD = IDD_DPCMM_DIALOG };
	CButton	B2Long;
	CButton	B2Short;
	CButton	B1Long;
	CButton	B1Short;
	CalButton	calbutton;
	CStatic	jtlimit;
	CButton	startbutton;
	CStatic	SAInstIndex;
	OptionButton	optionsbutton;
	TargInc			targinc;
	GroupInc			groupinc;
	StreamButton	streambutton;
	SlotButton		slotbutton;
	SectionButton	sectionbutton;
	PointButton		pointbutton;
	PlaneButton		planebutton;
	PinButton		pinbutton;
	PatchButton		patchbutton;
	LineButton		linebutton;
	HoleButton		holebutton;
	GuideButton		guidebutton;
	FrameButton		framebutton;
	CircleButton	circlebutton;
	SphereButton	spherebutton;
	ScanButton		scanbutton;
	GeomTriggerButton geomtrigbutton;
	ConeButton coneButton;
	SinglePtHoleButton singlePtHoleButton;
	ToggleArmButtonsButton toggleArmButtonsButton;
	ArmPadButton armPadButton;
	CString	Target;
	CString geomName;
	//}}AFX_DATA
	AvgPointsButton avgptsbutton;
	GroupNamePicker groupCombo;
	MPCommandHelpButton helpButton;
	CButton pipeProbeButton;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDPCMMDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CDockingBtnCtrl     m_dockingBtnCtrl;
	bool	m_bWasDockedBeforeTB;
	BOOL OnCommand( WPARAM wParam, LPARAM lParam );
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDPCMMDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDefaultButton();
	afx_msg void OnButtonTest();
	afx_msg void OnButtonStart();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnDestroy();
	afx_msg void OnIncg();
	afx_msg void OnInct();
	//}}AFX_MSG
	afx_msg LRESULT OnRemoteCommand( WPARAM wParam, LPARAM lParam );			// jmc PDA
	afx_msg LRESULT OnRemoteConnect( WPARAM wParam, LPARAM lParam );			// jmc PDA
	afx_msg LRESULT OnUIReply( WPARAM wParam, LPARAM lParam );					// jmc PDA
	afx_msg LRESULT OnDoneTrashingRemoteMessages( WPARAM wParam, LPARAM lParam );	
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);// jmc PDA
	DECLARE_MESSAGE_MAP()
private:
	BOOL TrashRemoteMessages;			// jmc PDA
	CRemoteUIManager m_RemUIMgr;			// jmc PDA	
	bool leftWasDown, rightWasDown;
	bool onDestroyCalledAlready;
	bool collectionComboHasFocus;
	bool groupComboHasFocus;
	bool targetEditHasFocus;
	bool geomNameEditHasFocus;
public:
	afx_msg void OnBnClickedButtonPipeProbe();

	afx_msg void OnCbnSetfocusGroupCombo();
	afx_msg void OnCbnKillfocusGroupCombo();
	afx_msg void OnEnSetfocusTarget();
	afx_msg void OnEnKillfocusTarget();
	afx_msg void OnEnSetfocusGeomName();
	afx_msg void OnEnKillfocusGeomName();
	CButton trackArmButton;
	afx_msg void OnBnClickedButtonTrackArm();
	CollectionNamePicker collectionCombo;
	afx_msg void OnCbnSetfocusCollectionCombo();
	afx_msg void OnCbnKillfocusCollectionCombo();

	//>> SA Toolbar
	bool MakeInvisible();
	bool MakeVisible();
	PictureButton saInstBarButton;
	afx_msg void OnBnClickedSaInstToolbarButton();
	//<< SA Toolbar
};
#define DONE_TRASHING_REMOTE_MSG (WM_USER+37)    // jmc PDA
