// DPatchMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DPatchMeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DPatchMeas dialog


DPatchMeas::DPatchMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DPatchMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DPatchMeas)
	Group = _T("");
	Target = _T("");
	ShiftText = _T("");
	//}}AFX_DATA_INIT
	PPointText = "";
	TipText = "";
	PSampleText = "";
	//Step = 0;
	//LastPatchPoint = 0;
}


void DPatchMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DPatchMeas)
	DDX_Control(pDX, IDC_SHIFT, Shift);
	DDX_Control(pDX, IDC_SAMPLES, Psamples);
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT2, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG2, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT2, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Text(pDX, IDC_SHIFT, ShiftText);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_EVAL, eval_message);
	DDX_Control(pDX, IDC_STATIC_PLANE_LABEL, planeLabel);
}


BEGIN_MESSAGE_MAP(DPatchMeas, DGenMeas)
	//{{AFX_MSG_MAP(DPatchMeas)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT2, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG2, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT2, OnButtonTwoshort)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_PATCH_SELECT_PLANE, &DPatchMeas::OnBnClickedButtonPatchSelectPlane)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DPatchMeas message handlers


BOOL DPatchMeas::Init() 
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	OKButton.EnableWindow(FALSE);

//	if(app.saarm.Data.AddExtraPatchShift)
//		PSampleText.Format("%d Samples    %5.2f %s Extra Shift",
//		app.pA->DataArray[0]->GetSize(),
//		app.saarm.Data.ExtraPatchShift/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
//		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
//	else
		PSampleText.Format(_T("%d Samples"),app.pA->DataArray[0]->GetSize());

	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);
	if(app.saarm.Data.AddExtraPatchShift)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	CheckForDS_Plane();

	SetGTNames();
	if(app.saarm.Data.ds_planeSet)
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane, or accept Plane."));
	else
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane."));

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

bool DPatchMeas::CheckForDS_Plane()
{
	if( !app.saarm.Data.ds_planeSet )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		OKButton.EnableWindow(FALSE);
		return false;
	}
	Plane = app.saarm.Data.ds_plane;
	PSampleText.Format(_T("%d Samples"), Plane.samples);

	if(Plane.patchShift != 0.0)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		Plane.patchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	t = Plane.t;
	CString m;
	m.Format(Tr("Plane ") + Plane.timeStamp);
	planeLabel.SetWindowText(m);
	UpdateFields();
	OKButton.EnableWindow();
	return true;
}

void DPatchMeas::SetGTNames()
{
	Group = app.saarm.Data.Group;
	GroupCtrl.SetWindowText(Group);
	Target = app.saarm.Data.Target;
	TargCtrl.SetWindowText(Target);
}

BOOL DPatchMeas::ProcessNewData(int inc) 
{
	UpdateData(TRUE);
	if(app.pA->StepIndex==0)
	{
		PSampleText.Format(_T("%d Samples"), ctr+1);
		Psamples.SetWindowText(PSampleText);
		app.pA->IncrementName(Target, inc);
		TargCtrl.SetWindowText(Target);

		if(ctr < 0)
		{
			CheckForDS_Plane();
			return FALSE;
		}
		if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3)// || inc <= 0 )
		{
			planeLabel.SetWindowText(Tr("Plane"));

			if(app.saarm.Data.AddExtraPatchShift)
				ShiftText.Format(_T("Patch Shift: %f %s"),
				app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
				app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
			else
				ShiftText.Format(_T("No Patch Shift"));
			Shift.SetWindowText(ShiftText);

			SetDlgItemText(IDC_PLANE,Tr("ABCD"));
			SetDlgItemText(IDC_RMSERR,Tr("Max Err"));
			SetDlgItemText(IDC_MAXERR,Tr("RMS Err"));
			OKButton.EnableWindow(FALSE);
			return FALSE;
		}

		PauseMeasTimer();
		eval_message.SetWindowText(_T("Fitting Plane, Please Wait"));
		if( !Plane.ComputePlane(app.pA->DataArray[app.pA->StepIndex]) )
		{
			OKButton.EnableWindow(FALSE);
			return FALSE;
		}
		OKButton.EnableWindow(TRUE);

//		if(pRomerDlg->AddExtraPatchShift)
//			m.Format("%d Samples    %5.2fmm Extra Shift",DataArray[0]->GetSize(),pRomerDlg->ExtraPatchShift*1000);
//		else
//			m.Format("%d Samples",ctr+1);
//		Psamples.SetWindowText(m);

		maxerr = Plane.maxerr;
		rmserr = Plane.rmserr;
		t = Plane.t;
		maxerrinfo = Plane.maxerrinfo;
		rmserrinfo = Plane.rmserrinfo;

		UpdateFields();
		eval_message.SetWindowText(_T(""));
		ResumeMeasTimer();
	}
	else
	{
		if(inc < 0)
		{
			app.pA->IncrementName(app.saarm.Data.Target, -app.saarm.Data.ptnameinc);
			app.saarm.RemoveLastMeasurementInSA(true);
			return FALSE;
		}

		app.pA->ClearButtonState();
		PPointText = _T("");

		CString s;
		notes.RemoveAll();

		s.Format(_T("User: %s"), app.saarm.Data.UserName);//, app.saarm.Data.SpanPort);
		notes.Add(s);

		s.Format(_T("Patch Plane fit %s  %d samples"), name,
			app.pA->DataArray[0]->P.GetSize());
		notes.Add(s);

		notes.Add(Tr("Plane ") + Plane.timeStamp);

		s.Format(_T("%s, %s"),
			Plane.maxerrinfo,
			Plane.rmserrinfo);
		notes.Add(s);

		if(app.saarm.Data.AddExtraPatchShift)
		{
			s.Format(_T("Patch Shift: %f %s"),
			app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		
			notes.Add(s);
		}

		if( app.saarm.Data.SendGeom && !app.saarm.Data.ds_planeSet )
		{
			app.pA->GetBoundaryPoints(t);
			if(app.saarm.Data.geomName.IsEmpty())
			{
				name.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
			}
			else
			{
				name = app.saarm.Data.geomName;
				app.pA->IncrementName(app.saarm.Data.geomName);
			}
			app.saarm.SockGeom.SendPlane(t, app.pA->BPoints, name, notes);
		}
		app.saarm.Data.ds_planeSet = true;

		CheckForDS_Plane();
		ctr = -1;
		app.pA->SetDisplayData();

		PPointText = _T("");
		ProcessPoint();
			
		UpdateFields();
	}
	return TRUE;
}

BOOL DPatchMeas::ProcessPoint()
{
	PauseMeasTimer();
	eval_message.SetWindowText(_T("Evaluating Point, Please Wait"));

	// compute the new point
	BOOL ret = FALSE;

	Vector PPOnPlaneInWork;
	INT_PTR idx = app.pA->DataArray[app.pA->StepIndex]->GetUpperBound();
	//project point onto plane, have update show live data
	Vector PP(app.pA->DataArray[app.pA->StepIndex]->P[idx]->GetPoint());
	Plane.ProjectPointToPlane(PP,&PPOnPlane); //result in meters
	app.saarm.InstToWorking.Multiply(PPOnPlane,&PPOnPlaneInWork);
	PPointText.Format(_T("%8.*f  %8.*f  %8.*f"),
		app.saarm.Data.Precision,PPOnPlaneInWork.x/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.Data.Precision,PPOnPlaneInWork.y/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.Data.Precision,PPOnPlaneInWork.z/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]));
	ret = TRUE;

	app.pA->X = PPOnPlane.x;
	app.pA->Y = PPOnPlane.y;
	app.pA->Z = PPOnPlane.z;

	app.saarm.Data.measCommentArray.RemoveAll();
	app.saarm.Data.measCommentArray.Append(notes);
	CString targName(app.saarm.Data.Target);
	PPOnPlane.Scale(1.0/app.saarm.GetInstrumentScaleFactor());
	app.pA->MeasToSpan(PPOnPlane, app.saarm.Data.Group, targName, true);

	if(app.saarm.Data.incrementgroup)
	{
		app.saarm.Data.Target.Format(_T("P1"));
		app.pA->IncrementName(app.saarm.Data.Group, 1);
	}
	else
		app.pA->IncrementName(app.saarm.Data.Target, 1);

	app.saarm.TTS.TextToSpeech(_T("Patch Point Sent"));
	
	eval_message.SetWindowText(_T(""));
	ResumeMeasTimer();
	return ret;
}

void DPatchMeas::UpdateFields()
{
	UpdateData(FALSE);
	SetDlgItemText(IDC_SAMPLES,PSampleText);
	SetDlgItemText(IDC_PPOINT,PPointText);
	SetDlgItemText(IDC_PLANE,Plane.PlaneText);
	SetDlgItemText(IDC_RMSERR,Plane.rmserrinfo);
	SetDlgItemText(IDC_MAXERR,Plane.maxerrinfo);
}


void DPatchMeas::ProcessAccept()
{
	if(app.pA->StepIndex==0)
	{
		if(app.saarm.Data.ds_planeSet && app.pA->DataArray[0]->GetSize()==0)
		{
			*app.pA->DataArray[0] = app.saarm.Data.ds_plane.PPts;
		}
		else if(app.pA->DataArray[0]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough app.saarm.Data."));
			ProcessingAccept = FALSE;
			return;
		}
		else	// reset the persisted plane
		{
			CString m;
			m.Format(Tr("Plane ") + Plane.timeStamp);
			planeLabel.SetWindowText(m);
			app.saarm.Data.ds_plane = Plane;
			app.saarm.Data.ds_plane.samples = app.pA->DataArray[0]->GetSize();
			app.saarm.Data.ds_plane.PPts = *app.pA->DataArray[0];
		}

		app.saarm.TTS.TextToSpeech(_T("Measure point to project onto surface"));
		SetDlgItemText(IDOK,_T("Done"));
		DGenMeas::ProcessAccept();
//		pRomerDlg->RemoteMouse(FALSE);
		return;
	}
	else
	{
		app.pA->DataArray[app.pA->StepIndex]->Clear();	// clear the array
		DGenMeas::OnOK();
		ProcessingAccept = FALSE;
	}
}

BOOL DPatchMeas::MakeFakeData(int step)
{
	TRACE("MakeFakeData!!\n");
	if(app.StopNow)
		return FALSE;			

	switch(step)
	{
	case 0:	// plane
		{
			app.pA->X = 0.7 + ((double)rand())/((double)RAND_MAX)*0.1;
			app.pA->Y = ((double)rand())/((double)RAND_MAX)*0.1;
			app.pA->Z = -0.3;
			break;
		}
	case 1:	// point
		{
			app.pA->X = ((double)rand())/((double)RAND_MAX);
			app.pA->Y = ((double)rand())/((double)RAND_MAX);
			app.pA->Z = (-(double)rand())/((double)RAND_MAX);
			break;
		}
	default:
		break;
	}
	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DPatchMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DPatchMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DPatchMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DPatchMeas::OnButtonOneshort() 
{
	SetB1Short();
}

void DPatchMeas::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DPatchMeas::OnOK() 
{
	ProcessAccept();
}

void DPatchMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DPatchMeas"),this);	
}

void DPatchMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DPatchMeas"),this);

	DGenMeas::OnDestroy();
}
void DPatchMeas::OnBnClickedButtonPatchSelectPlane()
{
	SAIPGeomPlane gp;
	if(app.saarm.SelectPlaneFromSA(gp))
	{
		app.saarm.Data.ds_plane.SetFromSAIPGeomPlane(gp);
		app.saarm.Data.ds_planeSet = true;
		CheckForDS_Plane();
	}
}
