// DPlaneMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DPlaneMeas.h"
#include "DCompareResults.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DPlaneMeas dialog


DPlaneMeas::DPlaneMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DPlaneMeas::IDD, pParent)
{
	title.Format(_T("Plane Measurement"));
	//{{AFX_DATA_INIT(DPlaneMeas)
	sampleinfo = _T("");
	Target = _T("");
	Group = _T("");
	TipText = _T("");
	maxerrinfo = _T("");
	rmserrinfo = _T("");
	Inspect = FALSE;
	ShiftText = _T("");
	//}}AFX_DATA_INIT
}


void DPlaneMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DPlaneMeas)
	DDX_Control(pDX, IDC_PATCH_SHIFT, Shift);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Text(pDX, IDC_SAMPLES, sampleinfo);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_TIP, TipText);
	DDX_Text(pDX, IDC_MAXERR, maxerrinfo);
	DDX_Text(pDX, IDC_RMSERR, rmserrinfo);
	DDX_Text(pDX, IDC_PATCH_SHIFT, ShiftText);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_EVAL, eval_message);
	DDX_Control(pDX, IDC_STATIC_PLANE_LABEL, planeLabel);
}


BEGIN_MESSAGE_MAP(DPlaneMeas, DGenMeas)
	//{{AFX_MSG_MAP(DPlaneMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_PLANE_SELECT_PLANE, &DPlaneMeas::OnBnClickedButtonPlaneSelectPlane)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DPlaneMeas message handlers

BOOL DPlaneMeas::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);
	if(app.saarm.Data.AddExtraPatchShift)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	OKButton.EnableWindow(FALSE);
	SetWindowText(title);

	CheckForDS_Plane();
	usingDS_Plane = false;

	SetGTNames();
	if(app.saarm.Data.ds_planeSet)
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane, or accept Plane."));
	else
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane."));

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;
}
bool DPlaneMeas::CheckForDS_Plane()
{
	if( !app.saarm.Data.ds_planeSet )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		OKButton.EnableWindow(FALSE);
		return false;
	}
	Plane = app.saarm.Data.ds_plane;
	t = Plane.t;
	sampleinfo.Format(_T("%d Samples"), Plane.samples);

	if(Plane.patchShift != 0.0)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		Plane.patchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	CString m;
	m.Format(Tr("Plane ") + Plane.timeStamp);
	planeLabel.SetWindowText(m);
	maxerrinfo.Format(_T("%s"), Plane.maxerrinfo);
	rmserrinfo.Format(_T("%s"), Plane.rmserrinfo);
	SetDlgItemText(IDC_PLANE,Plane.PlaneText);
	UpdateData(FALSE);
	OKButton.EnableWindow();
	return true;
}
void DPlaneMeas::SetGTNames()
{
	if(ShowGpTarg)
	{
		Group = app.saarm.Data.Group;
		GroupCtrl.SetWindowText(Group);
		Target = app.saarm.Data.Target;
		TargCtrl.SetWindowText(Target);
	}
	else
	{
		GroupCtrl.EnableWindow(FALSE);
		TargCtrl.EnableWindow(FALSE);
	}
}

void DPlaneMeas::ProcessAccept()
{
	if(app.saarm.Data.ds_planeSet && app.pA->DataArray[0]->GetSize()==0)
	{
		*app.pA->DataArray[0] = app.saarm.Data.ds_plane.PPts;
		usingDS_Plane = true;
	}
	else if(app.pA->DataArray[0]->GetSize()<3)
	{
		app.saarm.TTS.TextToSpeech(_T("Not enough app.saarm.Data."));
		ProcessingAccept = FALSE;
		return;
	}
	else	// reset the persisted plane
	{
		CString m;
		m.Format(Tr("Plane ") + Plane.timeStamp);
		planeLabel.SetWindowText(m);
		app.saarm.Data.ds_plane = Plane;
		app.saarm.Data.ds_plane.samples = app.pA->DataArray[0]->GetSize();
		app.saarm.Data.ds_plane.PPts = *app.pA->DataArray[0];
	}

	if(app.saarm.Data.geomName.IsEmpty())
	{
		name.Format(_T("%s_%s"), Group, Target);
	}
	else
	{
		name = app.saarm.Data.geomName;
		app.pA->IncrementName(app.saarm.Data.geomName);
	}

	CString s;
	notes.RemoveAll();

	s.Format(_T("User: %s"), app.saarm.Data.UserName);//, app.saarm.Data.SpanPort);
	notes.Add(s);

	s.Format(_T("Plane fit %s  %d samples"), name,
		app.pA->DataArray[app.pA->StepIndex]->P.GetSize());
	notes.Add(s);

	notes.Add(Plane.timeStamp);

	s.Format(_T("Max Error = %f, RMS Error = %f %s"),
		maxerr/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		rmserr/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	notes.Add(s);

	if(app.saarm.Data.AddExtraPatchShift)
	{
		s.Format(_T("Patch Shift: %f %s"),
		app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);

		notes.Add(s);
	}

	app.saarm.Data.ds_planeSet = true;

	if(Inspect)
	{
		PresentComparisonResults();
	}
	else
	{
		app.pA->GetBoundaryPoints(t);
		app.saarm.SockGeom.SendPlane(t, app.pA->BPoints, name, notes);

		app.saarm.Data.measCommentArray.RemoveAll();
		app.saarm.Data.measCommentArray.Append(notes);
		if( app.saarm.Data.FirePointsToo )
		{
			CString tempGName = app.saarm.Data.Group;
			app.saarm.Data.Group.Format(_T("%s_%s-Meas"), tempGName, app.saarm.Data.Target);
			app.pA->ScaleDataArrays(1.0/app.saarm.GetInstrumentScaleFactor());
			app.pA->MeasToSpan(app.pA->DataArray[0], app.saarm.Data.Target);
			app.saarm.Data.Group = tempGName;
			app.pA->IncrementName(app.saarm.Data.Target, app.saarm.Data.ptnameinc);
		}
		if(app.saarm.Data.incrementgroup)
		{
			app.saarm.Data.Target.Format(_T("P1"));
			app.pA->IncrementName(app.saarm.Data.Group, 1);
		}

		app.pA->DataArray[0]->Clear();
		ctr = -1;
		ProcessNewData(0);

		app.pA->SetDisplayData();
	}

	ProcessingAccept = FALSE;
}
BOOL DPlaneMeas::ProcessNewData(int inc)
{
	sampleinfo.Format(_T("%d Samples"), ctr+1);
	app.pA->IncrementName(Target, inc);

	if(app.pA->DataArray[app.pA->StepIndex]->P.GetSize() <= 0)
	{
		CheckForDS_Plane();
		return FALSE;
	}
	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3 )// || inc <= 0 )
	{
		planeLabel.SetWindowText(Tr("Plane"));

		if(app.saarm.Data.AddExtraPatchShift)
			ShiftText.Format(_T("Patch Shift: %f %s"),
			app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		else
			ShiftText.Format(_T("No Patch Shift"));
		Shift.SetWindowText(ShiftText);

		maxerrinfo.Format(Tr("Max Err"));
		rmserrinfo.Format(Tr("RMS Err"));
		SetDlgItemText(IDC_PLANE,Tr("ABCD"));
		OKButton.EnableWindow(FALSE);
		UpdateData(FALSE);
		return FALSE;
	}

	PauseMeasTimer();
	eval_message.SetWindowText(_T("Fitting Plane, Please Wait"));
	if( !Plane.ComputePlane(app.pA->DataArray[app.pA->StepIndex]) )
		return FALSE;

	enoughdata = TRUE;
	OKButton.EnableWindow();

	maxerr = Plane.maxerr;
	rmserr = Plane.rmserr;
	t = Plane.t;
	maxerrinfo = Plane.maxerrinfo;
	rmserrinfo = Plane.rmserrinfo;
	SetDlgItemText(IDC_PLANE,Plane.PlaneText);
	UpdateData(FALSE);
	eval_message.SetWindowText(_T(""));
	ResumeMeasTimer();
	return TRUE;
}

void DPlaneMeas::PresentComparisonResults()
{
	// 2004.08.29 - stop the meas timer so button hits stop getting or deleting app.saarm.Data...
	PauseMeasTimer();

	app.saarm.TTS.TextToSpeech(_T("Comparison Results"));
		
	//get an arbitrary point to act as a pos reference for the report
	Vector NominalCenter,NominalCenterInWork;
	NominalTrans.GetTranslation(&NominalCenter);
	app.saarm.InstToWorking.Multiply(NominalCenter,&NominalCenterInWork);

	//get diff in z axes
	Vector xa,ya,zact,znom;
	ActualTrans = t;

	TRACE0("Actual Trans...\n");
	ActualTrans.Debug();
	TRACE0("Nominal Trans..\n");
	NominalTrans.Debug();

	ActualTrans.GetAxes(&xa,&ya,&zact);
	NominalTrans.GetAxes(&xa,&ya,&znom);
	double AngleError = 0.0;
	Vector axis;
	if(zact.Dot(znom)<0) //in diff directions
		zact.Scale(-1.0); //reverse one of them
	AngleError = zact.AngleBetween(znom,&axis);
		
	//find max,mean and rms errors to nominal plane
	Vector Shift(znom);
	Shift.Normalize();

	TRACE0("planeshift from znom...\n");
	Shift.Debug();

	double Mag = 0.0;
	if(Plane.patchShift != 0.0)
		Mag = Plane.patchShift;
	if(!usingDS_Plane)
		Mag += (app.saarm.Data.TipDia/2.0);
	Shift.Scale(Mag);

	TRACE0("planeshift AFTER tip dia and extrapatchshift...\n");
	Shift.Debug();

	Vector g;
	g = app.pA->ComputeAvgDirection();
	if(g.Dot(Shift)<0.0 && Mag>0.0)
		Shift.Scale(-1.0);
	else if(g.Dot(Shift)>0.0 && Mag<0.0)
		Shift.Scale(-1.0);

	double MaxError = 0.0;
	double MeanError = 0.0;
	double RMSError = 0.0;
	double DistSum = 0.0;
	double DistSqrdSum = 0.0;
	double NomPlaneD = 0.0;
	NomPlaneD = -(znom.Dot(NominalCenter));

	TRACE1("planeshift NomPlaneD = %f, nominalcenter...\n", NomPlaneD);
	NominalCenter.Debug();

	for(int i=0;i<app.pA->DataArray[0]->GetSize();i++)
	{
		//app.pA->TargetName.Format(_T("PlanePoit%d"),i);
		Vector Raw(app.pA->DataArray[0]->P[i]->x,
				app.pA->DataArray[0]->P[i]->y,
				app.pA->DataArray[0]->P[i]->z);

		TRACE1("planept %d BEFORE adding shift...\n", i);
		Raw.Debug();

		Raw.Add(Shift);

		TRACE1("planept %d AFTER adding shift...\n", i);
		Raw.Debug();

		double DistToNomPlane = Raw.Dot(znom)+NomPlaneD;

		TRACE2("Raw.Dot(znom) = %f, DistToNomPlane = %f\n", Raw.Dot(znom), DistToNomPlane);

		DistSum += DistToNomPlane;
		DistSqrdSum += DistToNomPlane*DistToNomPlane;
		MaxError = max(fabs(DistToNomPlane),MaxError);
	}
	MeanError = DistSum/app.pA->DataArray[0]->GetSize();
	RMSError = sqrt(DistSqrdSum/(app.pA->DataArray[0]->GetSize()-1));

	if(usingDS_Plane)
	{
		MaxError = 0.0;
		MeanError = 0.0;
		RMSError = 0.0;
	}
	//NominalCenterInWork.Debug();
	//ActualCenterInWork.Debug();
	//DeltaInWork.Debug();

	
	DCompareResults diag;
	CString res,next;
	SAIPFitQueryBlock qb;

	res.Format(_T("Plane Inspection   -  %s"), ObName);
	qb.Text.Add(res);
	res += "\n";
		next.Format(_T("Reference Location   = %8.*f %8.*f %8.*f"),
		app.saarm.Data.Precision,NominalCenterInWork.x/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.Data.Precision,NominalCenterInWork.y/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.Data.Precision,NominalCenterInWork.z/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]));
	qb.Text.Add(next);

	next.Format(_T("Max Deviation   = %8.*f %s"),
		app.saarm.Data.Precision,MaxError/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res +=next + _T("\n");

	next.Format(_T("Mean Deviation  = %8.*f %s"),
		app.saarm.Data.Precision,MeanError/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res +=next + _T("\n");

	next.Format(_T("RMS Deviation   = %8.*f %s"),
		app.saarm.Data.Precision,RMSError/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	qb.Text.Add(next);
	res +=next + _T("\n\n");

	next.Format(_T("Nominal ijk = %8.*f %8.*f %8.*f"),
		app.saarm.Data.Precision+1,znom.x,
		app.saarm.Data.Precision+1,znom.y,
		app.saarm.Data.Precision+1,znom.z);
	qb.Text.Add(next);
	res+=next + _T("\n");
	next.Format(_T("Actual  ijk = %8.*f %8.*f %8.*f"),
		app.saarm.Data.Precision+1,zact.x,
		app.saarm.Data.Precision+1,zact.y,
		app.saarm.Data.Precision+1,zact.z);
	qb.Text.Add(next);
	res+=next + _T("\n");
	
	next.Format(_T("Normal Direction Deviation = %6.4f  degrees"),
		fabs(AngleError) );
	qb.Text.Add(next);
	res +=next + _T("\n");

	diag.m_Results = res;

//	app.pA->SendReportItem("Plane Inspection Results"), " "), Rep);

//	app.pA->RemoteMouse(TRUE);

	if( diag.DoModal() == IDOK )
		app.saarm.QS.SendPacket(qb);
	DGenMeas::OnOK();
}


///////////////////////////////////////////////////////////////////////////
// simulation mode

BOOL DPlaneMeas::MakeFakeData(int step)
{
	if(app.StopNow)
		return FALSE;
	
	app.pA->X = ((double)rand())/((double)RAND_MAX);
	app.pA->Y = ((double)rand())/((double)RAND_MAX);
	app.pA->Z = -0.3;

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DPlaneMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DPlaneMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DPlaneMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DPlaneMeas::OnButtonOneshort() 
{
	SetB1Short();
}

void DPlaneMeas::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}


void DPlaneMeas::OnOK() 
{
	ProcessAccept();
}

void DPlaneMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DPlaneMeas"),this);	
}

void DPlaneMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DPlaneMeas"),this);

	DGenMeas::OnDestroy();
}
void DPlaneMeas::OnBnClickedButtonPlaneSelectPlane()
{
	SAIPGeomPlane gp;
	if(app.saarm.SelectPlaneFromSA(gp))
	{
		app.saarm.Data.ds_plane.SetFromSAIPGeomPlane(gp);
		app.saarm.Data.ds_planeSet = true;
		CheckForDS_Plane();
	}
}
