// DPointMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DPointMeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DPointMeas dialog


DPointMeas::DPointMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DPointMeas::IDD, pParent)
{
	groupInc.Icon = IDI_GROUPINCICON;
	targInc.Icon = IDI_TARGETINCICON;
	//{{AFX_DATA_INIT(DPointMeas)
	Group = _T("");
	Target = _T("");
	tip = _T("");
	sampleinfo = _T("");
	//}}AFX_DATA_INIT
}


void DPointMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DPointMeas)
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG2, B1long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT, B1short_button);
	//DDX_Text(pDX, IDC_GEDIT, Group);
	//DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Text(pDX, IDC_TIP, tip);
	DDX_Text(pDX, IDC_SAMPLES, sampleinfo);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_INCG, groupInc);
	DDX_Control(pDX, IDC_INCT, targInc);
}


BEGIN_MESSAGE_MAP(DPointMeas, DGenMeas)
	//{{AFX_MSG_MAP(DPointMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG2, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_INCG, &DPointMeas::OnBnClickedIncg)
	ON_BN_CLICKED(IDC_INCT, &DPointMeas::OnBnClickedInct)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DPointMeas message handlers

BOOL DPointMeas::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	tip.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	sendfromdlg = TRUE;
	SetGTNames();

	DGenMeas::Init();	// call Base class Init for translation, etc.

	if(app.saarm.units.toolBarModeOn && !app.pA->ConnectedToArm)// Mantis #6602 - 2013.11.08 - pop meas dlg's when simulating in toolbar mode
		::SetWindowPos(m_hWnd,HWND_TOPMOST,300,300,50,50,SWP_NOSIZE + SWP_NOMOVE);

	return TRUE;
}
void DPointMeas::SetGTNames()
{
	Group = app.saarm.Data.Group;
	Target = app.saarm.Data.Target;
	UpdateData(FALSE);
}

void DPointMeas::ProcessAccept()
{
	name.Format(_T("%s_%s"), Group,Target);

	notes.RemoveAll();
	CString s;
	s.Format(_T("User: %s"), app.saarm.Data.UserName);//, app.saarm.Data.SpanPort);
	notes.Add(s);
	
	DGenMeas::OnOK();
}
BOOL DPointMeas::ProcessNewData(int inc)
{
	app.pA->ClearButtonState();
	app.pA->IncrementName(Target, inc);
	int index = app.pA->AddPoint();
	sampleinfo.Format(_T("%d Pts Measured"), index+1);
	UpdateData(FALSE);

	LXText = CXText;
	LYText = CYText;
	LZText = CZText;

	Vector Current(app.pA->DataArray[app.pA->StepIndex]->P[index]->x,
		app.pA->DataArray[app.pA->StepIndex]->P[index]->y,
		app.pA->DataArray[app.pA->StepIndex]->P[index]->z);
	Vector CurrWork;
	app.saarm.InstToWorking.Multiply(Current,&CurrWork);
	CurrWork.Scale(1.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);

	if( index >= 0 )
	{
		CXText.Format(_T("%6.2f"), CurrWork.x);
		CYText.Format(_T("%6.2f"), CurrWork.y);
		CZText.Format(_T("%6.2f"), CurrWork.z);
		if( inc > 0 )
		{
			CString cs1;
			cs1.Format(_T("Discrete Point Measurement"));
			app.saarm.Data.measCommentArray.RemoveAll();
			app.saarm.Data.measCommentArray.Add(cs1);
			app.pA->ScaleDataArrays(1.0/app.saarm.GetInstrumentScaleFactor());
			app.pA->MeasToSpan(*app.pA->DataArray[app.pA->StepIndex]->P[index], false, true);
		}
//		app.pA->MeasToSpan(*app.pA->NormArray[index]);	// TESTING!!
		UpdateFields();
	}

	return TRUE;
}

void DPointMeas::UpdateFields()
{
	UpdateData(FALSE);
	//SetDlgItemText(IDC_CURRX,CXText);
	//SetDlgItemText(IDC_CURRY,CYText);
	//SetDlgItemText(IDC_CURRZ,CZText);
	//SetDlgItemText(IDC_LASTX,LXText);
	//SetDlgItemText(IDC_LASTY,LYText);
	//SetDlgItemText(IDC_LASTZ,LZText);
}

//void DPointMeas::OnBnClickedButtonIncGroup()
//{
//	app.saarm.Data.Target.Format(_T("P1"));
//	
//}
void DPointMeas::OnBnClickedIncg()
{
	app.pA->IncrementName(app.saarm.Data.Group, 1);
}

void DPointMeas::OnBnClickedInct()
{
	app.pA->IncrementName(app.saarm.Data.Target, app.saarm.Data.ptnameinc);
}

void DPointMeas::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

///////////////////////////////////////////////////////////////////////////
// simulation mode

BOOL DPointMeas::MakeFakeData(int step)
{
	if(app.StopNow)
		return FALSE;			
	
	app.pA->X = ((double)rand())/((double)RAND_MAX);
	app.pA->Y = ((double)rand())/((double)RAND_MAX);
	app.pA->Z = (-(double)rand())/((double)RAND_MAX);

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DPointMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DPointMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DPointMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DPointMeas::OnButtonOneshort() 
{
	SetB1Short();
}
///////////////////////////////////////////////////////////////////////////

void DPointMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if(app.saarm.units.toolBarModeOn && app.pA->ConnectedToArm)
		ShowWindow(SW_MINIMIZE); //SW_HIDE
	else if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DPointMeas"),this);
}

void DPointMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DPointMeas"),this);

	DGenMeas::OnDestroy();
}
