// DPreSection.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DPreSection.h"
#include "DSectionMeas.h"
#include "DTheoMeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DPreSection dialog


DPreSection::DPreSection(CWnd* pParent /*=NULL*/)
	: CDialog(DPreSection::IDD, pParent)
{
	//{{AFX_DATA_INIT(DPreSection)
	m_Target = _T("");
	m_Group = _T("");
	m_Units = _T("");
	m_Tip = _T("");
	m_Radioxyz = 0;
	m_Val = 0.0;
	//}}AFX_DATA_INIT
	TheoPt = FALSE;
}


void DPreSection::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DPreSection)
	DDX_Text(pDX, IDC_TARGETEDIT, m_Target);
	DDX_Text(pDX, IDC_GROUPEDIT, m_Group);
	DDX_Text(pDX, IDC_UNITSSTATIC, m_Units);
	DDX_Text(pDX, IDC_TIP, m_Tip);
	DDX_Radio(pDX, IDC_RADIOXYZ, m_Radioxyz);
	DDX_Text(pDX, IDC_VALEDIT, m_Val);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DPreSection, CDialog)
	//{{AFX_MSG_MAP(DPreSection)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DPreSection message handlers

BOOL DPreSection::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_Tip.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	m_Group = app.saarm.Data.Group;
	m_Target = app.saarm.Data.Target;
	m_Units = app.saarm.units.DistUnitNames[app.saarm.units.distunits];
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void DPreSection::OnOK() 
{
	UpdateData(TRUE);
	if(TheoPt)
	{
		DTheoMeas diag;
		app.measDlg = &diag;
		diag.Val = m_Val*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
		diag.RadioXYZ = m_Radioxyz;
		diag.DoModal();
	}
	else
	{
		DSectionMeas diag;
		app.measDlg = &diag;
		diag.Val = m_Val*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
		diag.RadioXYZ = m_Radioxyz;
		diag.DoModal();
	}
	CDialog::OnOK();
}

void DPreSection::OnDefault() 
{
	UpdateData(TRUE);
	
}

void DPreSection::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DPreSection"),this);	
}

void DPreSection::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DPreSection"),this);

	CDialog::OnDestroy();
}