// DSAReq_SinglePtMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DSAReq_SinglePtMeas.h"
#include ".\dsareq_singleptmeas.h"


// DSAReq_SinglePtMeas dialog

DSAReq_SinglePtMeas::DSAReq_SinglePtMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DSAReq_SinglePtMeas::IDD, pParent)
	, tip(_T(""))
{
}

void DSAReq_SinglePtMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG2, B1long_button);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG, B2long_button);
	DDX_Text(pDX, IDC_TIP, tip);
}


BEGIN_MESSAGE_MAP(DSAReq_SinglePtMeas, DGenMeas)
	ON_BN_CLICKED(IDC_DEFAULT, OnBnClickedDefault)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT, OnBnClickedButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG2, OnBnClickedButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT, OnBnClickedButtonTwoshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG, OnBnClickedButtonTwolong)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// DSAReq_SinglePtMeas message handlers
BOOL DSAReq_SinglePtMeas::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	tip.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	sendfromdlg = FALSE;
	streaming = FALSE;
	ShowGpTarg = FALSE;

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;
}

void DSAReq_SinglePtMeas::ProcessAccept()
{
	CString s;
	notes.RemoveAll();
	s.Format(_T("User: %s"), app.saarm.Data.UserName);
	notes.Add(s);
	s.Format(_T("SA Single Point Request"));
	notes.Add(s);

	if(app.pA->DataArray[0]->GetSize()>0)
	{
		Vector currPt(app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->x,
			app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->y,
			app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->z);

		Vector currNorm(app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->Normal.x,
			app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->Normal.y,
			app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->Normal.z);

		GenVec currJts = app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->Joints;

		app.pA->DataArray[0]->Clear();
		
		app.pA->AddPoint(currPt, currNorm, currJts);
	}

	DGenMeas::OnOK();
}
BOOL DSAReq_SinglePtMeas::ProcessNewData(int inc)
{
	app.pA->ClearButtonState();
	//app.pA->ClearVectorArray();
	//int index = app.pA->AddPoint();
	if(app.pA->DataArray[0]->GetSize() <= 0)
	{
		CXText.Format(_T(""));
		CYText.Format(_T(""));
		CZText.Format(_T(""));
		UpdateFields();
	}
	if(app.pA->DataArray[0]->GetSize()>0)
	{
		Vector Current(app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->x,
			app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->y,
			app.pA->DataArray[0]->P[app.pA->DataArray[0]->GetUpperBound()]->z);
		Vector CurrWork;
		app.saarm.InstToWorking.Multiply(Current,&CurrWork);
		CurrWork.Scale(1.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);

		CXText.Format(_T("%6.2f"), CurrWork.x);
		CYText.Format(_T("%6.2f"), CurrWork.y);
		CZText.Format(_T("%6.2f"), CurrWork.z);

		UpdateFields();
	}
	return TRUE;
}

void DSAReq_SinglePtMeas::UpdateFields()
{
	UpdateData(FALSE);
	SetDlgItemText(IDC_CURRX,CXText);
	SetDlgItemText(IDC_CURRY,CYText);
	SetDlgItemText(IDC_CURRZ,CZText);
}

void DSAReq_SinglePtMeas::OnBnClickedDefault()
{

}

///////////////////////////////////////////////////////////////////////////
// simulation mode

BOOL DSAReq_SinglePtMeas::MakeFakeData(int step)
{
	if(app.StopNow)
		return FALSE;			

	app.pA->X = ((double)rand())/((double)RAND_MAX);
	app.pA->Y = ((double)rand())/((double)RAND_MAX);
	app.pA->Z = (-(double)rand())/((double)RAND_MAX);

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DSAReq_SinglePtMeas::OnBnClickedButtonOneshort()
{
	SetB1Short();
}

void DSAReq_SinglePtMeas::OnBnClickedButtonOnelong()
{
	SetB1Long();
}

void DSAReq_SinglePtMeas::OnBnClickedButtonTwoshort()
{
	SetB2Short();
}

void DSAReq_SinglePtMeas::OnBnClickedButtonTwolong()
{
	SetB2Long();
}
////////////////////////////////////////////////////////////
void DSAReq_SinglePtMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DSAPointMeas"),this);	
}

void DSAReq_SinglePtMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DSAPointMeas"),this);

	DGenMeas::OnDestroy();
}
