// DSectionMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DSectionMeas.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DSectionMeas dialog


DSectionMeas::DSectionMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DSectionMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DSectionMeas)
	m_SampleText = _T("");
	tip = _T("");
	//}}AFX_DATA_INIT
	RadioXYZ = 0;
	Val = 0.0;
	First = TRUE;
	LastButtonHit = 0;
}


void DSectionMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DSectionMeas)
	DDX_Control(pDX, IDC_STRMINDICATOR, StreamIndicator);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG2, B1long_button);
	DDX_Text(pDX, IDC_SAMPLES, m_SampleText);
	DDX_Text(pDX, IDC_TIP, tip);
	//}}AFX_DATA_MAP

}


BEGIN_MESSAGE_MAP(DSectionMeas, DGenMeas)
	//{{AFX_MSG_MAP(DSectionMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG2, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT, OnButtonTwoshort)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DSectionMeas message handlers

BOOL DSectionMeas::Init() 
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	tip.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	streaming = TRUE;
	sendfromdlg = TRUE;
	UpdateData(FALSE);
	app.saarm.TTS.TextToSpeech(_T("Cross Section Plane"));
	SetStreamIndicator(FALSE);

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



BOOL DSectionMeas::ProcessNewData(int inc)
{
//	TRACE("First = %d\n"),First);
//	app.pA->IncrementName(Target, inc);
	Vector Current(app.pA->X,app.pA->Y,app.pA->Z); //in meters
	Vector CurrWork;
	app.saarm.InstToWorking.Multiply(Current,&CurrWork);
	if(First)
	{
		First = FALSE;
		LastPointWork = CurrWork;
		return TRUE;
	}

	//PauseMeasTimer();
	//eval_message.SetWindowText(_T("Evaluating Point, Please Wait"));

	LXText = CXText;
	LYText = CYText;
	LZText = CZText;

	//do the test in working in meters
	Vector ResultWork;
	CString groupSuffix;
	if(PlaneCross(LastPointWork,CurrWork,Val,RadioXYZ,&ResultWork,groupSuffix))
	{
		//they did cross!
		//so map back to romer
		Vector ResultArm;
		Transform WorkingToArm;
		app.saarm.InstToWorking.Invert(&WorkingToArm);
		WorkingToArm.Multiply(ResultWork,&ResultArm);
		ctr = app.pA->DataArray[app.pA->StepIndex]->P.Add(new ArmPoint(ResultArm, Vector(app.pA->II,app.pA->JJ,app.pA->KK), app.pA->J));
		app.pA->X = ResultArm.x;
		app.pA->Y = ResultArm.y;
		app.pA->Z = ResultArm.z;
		m_SampleText.Format(_T("%d Points Sent"),ctr+1);
		CXText.Format(_T("%6.2f"),
			app.pA->DataArray[app.pA->StepIndex]->P[ctr]->x/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);
		CYText.Format(_T("%6.2f"),
			app.pA->DataArray[app.pA->StepIndex]->P[ctr]->y/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);
		CZText.Format(_T("%6.2f"),
			app.pA->DataArray[app.pA->StepIndex]->P[ctr]->z/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);
		if( inc > 0 )
		{
			CString axis;
			if(RadioXYZ == 0)
				axis = _T("X-Axis");
			else if(RadioXYZ == 1)
				axis = _T("Y-Axis");
			else if(RadioXYZ == 2)
				axis = _T("Z-Axiz");

			CString cs1, cs2;
			cs1.Format(_T("Cross Section Measurement"));
			cs2.Format(_T("%s = %f"),axis,Val);
			app.saarm.Data.measCommentArray.RemoveAll();
			app.saarm.Data.measCommentArray.Add(cs1);
			app.saarm.Data.measCommentArray.Add(cs2);

			app.pA->MeasToSpan(*app.pA->DataArray[app.pA->StepIndex]->P[ctr],groupSuffix);
		}
		if( ctr > 0 )
			UpdateFields();
//		m_Group = app.saarm.Data.Group;
//		m_Target = app.saarm.Data.Target;

//		pRomerDlg->Beep(REC_OK);
	}
	LastPointWork = CurrWork;
	//eval_message.SetWindowText(_T(""));
	//ResumeMeasTimer();
	return TRUE;
}

void DSectionMeas::UpdateFields()
{
	UpdateData(FALSE);
	SetDlgItemText(IDC_CURRX,CXText);
	SetDlgItemText(IDC_CURRY,CYText);
	SetDlgItemText(IDC_CURRZ,CZText);
	SetDlgItemText(IDC_LASTX,LXText);
	SetDlgItemText(IDC_LASTY,LYText);
	SetDlgItemText(IDC_LASTZ,LZText);
}

void DSectionMeas::OnOK() 
{
	ProcessAccept();
}

void DSectionMeas::ProcessAccept()
{
//	CString NameBase;
//	NameBase.Format(_T("%s-%s"),app.saarm.Data.Group,app.saarm.Data.Target);
//	for(int i=1;i<app.pA->DataArray[app.pA->StepIndex]->GetSize();i++)
//	{
//		notes.RemoveAll();
//		name.Format(_T("%s - Line%d"),NameBase,i);
//		notes.Add("Line From Romer Section Cut"));
//		app.saarm.SockGeom.SendLine(*app.pA->DataArray[app.pA->StepIndex]->P[i-1],*app.pA->DataArray[app.pA->StepIndex]->P[i],FALSE,name,notes);	
//	}	
	app.saarm.TTS.TextToSpeech(_T("Section Measurement ended"));
	DGenMeas::OnOK();
}

BOOL DSectionMeas::PlaneCross(Vector& P1,Vector& P2,double& Val,int XYorZ, Vector* Result, CString& groupSuffix)
{
	// P1 in ? in working
	// P2 in ? in working
	// val in ?  in working, obviuosly
	// XYorZ = 0 for X
	// XYorZ = 1 for Y
	// XYorZ = 2 for Z
	// Result in ? in working
	
	
	//mask out all but one axis
	Vector DirMask,Origin;
	if(XYorZ==0)
		DirMask = Vector(1.0,0.0,0.0);
	else if(XYorZ==1)
		DirMask = Vector(0.0,1.0,0.0);
	else if(XYorZ==2)
		DirMask = Vector(0.0,0.0,1.0);
	else
		return FALSE;
	
	double d1 = 0.0;
	double d2 = 0.0;
	d1 = P1.Dot(DirMask)-Val;
	d2 = P2.Dot(DirMask)-Val;
	
	if(Val==0)	// if the user sets the cross value to 0, evaluate only the '0' plane...
	{
		if((d1*d2)>0.0) // the measurements are on the same side of the zero plane
			return false;
	}
	else	// when the user sets a non-zero cross value, we evaluate integer multiples of the cross value.
	{
		// this will not get the pt. if it lies between the zero plane and the val plane
		// be sure we don't have a 'zero' plane crossing instead of a 'val' plane crossing...
		if( (P1.Dot(DirMask))*(P2.Dot(DirMask)) < 0.0)
		{
			groupSuffix.Format(_T(" (%5.3f %s)"), 0.0, app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
			d1 = P1.Dot(DirMask);
			d2 = P2.Dot(DirMask);
		}
		else if((d1*d2)>0.0) //they're on the same side of the 'val' plane, so look for the next crossing, n*val, n = ...,-1, 0, 1,...
		{
			int m1 = (int) (P1.Dot(DirMask) / Val);
			int m2 = (int) (P2.Dot(DirMask) / Val);
			//TRACE2("m1=%d, m2=%d\n", m1, m2);
			if(m1==m2)	// they're in between some pair of planes
				return false;
			else if(abs(m1-m2) != 1)	// we've skipped across planes, user needs to reduce sampling increment
				return false;
			else
			{
				double planeVal = abs(m1) > abs(m2) ? m1 : m2;
				planeVal *= Val;
				groupSuffix.Format(_T(" (%5.3f %s)"), planeVal/app.saarm.units.UnitToMeters[app.saarm.units.distunits], app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
				d1 = P1.Dot(DirMask)-planeVal;
				d2 = P2.Dot(DirMask)-planeVal;
				//TRACE2("d1=%f, d2=%f\n", d1,d2);
			}
		}
		else
			groupSuffix.Format(_T(" (%5.3f %s)"), Val/app.saarm.units.UnitToMeters[app.saarm.units.distunits], app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	}
	// now we know we have a crossing interpolate
	double delta = 0.0;
	if((fabs(d1)+fabs(d2))>0.00001)
		delta = fabs(d1)/(fabs(d1)+fabs(d2));
	Vector Del(P2);
	Del.Sub(P1);
	Del.Scale(delta);
	Vector Ans(P1);
	Ans.Add(Del);
//	TRACE("P1 = %f %f %f\n"),P1.x,P1.y,P1.z);
//	TRACE("P2 = %f %f %f\n"),P2.x,P2.y,P2.z);
//	TRACE("Ans = %f %f %f\n"),Ans.x,Ans.y,Ans.z);
	if(app.saarm.Data.SectionSound)
		app.pA->ArmBeep(REC_OK);
	*Result = Ans;
	return TRUE;
	
}

void DSectionMeas::SetStreamIndicator(BOOL strm)
{
	if(strm)
	{
		TRACE0("Setting stream indicator ON\n");
		StreamIndicator.SetBkColor(RGB(0,255,0));
		StreamIndicator.SetTextColor(RGB(0,0,0));
		StreamIndicator.SetWindowText(_T("ON"));
	}
	else
	{
		TRACE0("Setting stream indicator OFF\n");
		StreamIndicator.SetBkColor(RGB(255,0,0));
		StreamIndicator.SetTextColor(RGB(0,0,0));
		StreamIndicator.SetWindowText(_T("OFF"));
	}
}

//////////////////////////////////////////////////////////////
// sim. mode
BOOL DSectionMeas::MakeFakeData(int step)
{
	if(app.StopNow)
		return FALSE;

	if(RadioXYZ==0)
	{
		app.pA->X = Val;
		app.pA->Y = ((double)rand())/((double)RAND_MAX);
		app.pA->Z = ((double)rand())/((double)RAND_MAX);
	}
	else if(RadioXYZ==1)
	{
		app.pA->X = ((double)rand())/((double)RAND_MAX);
		app.pA->Y = Val;
		app.pA->Z = ((double)rand())/((double)RAND_MAX);
	}
	else if(RadioXYZ==2)
	{
		app.pA->X = ((double)rand())/((double)RAND_MAX);
		app.pA->Y = ((double)rand())/((double)RAND_MAX);
		app.pA->Z = Val;
	}
	else
		return FALSE;

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DSectionMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DSectionMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DSectionMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DSectionMeas::OnButtonOneshort() 
{
	SetB1Short();
}

//////////////////////////////////////////////////////////////
/*
BOOL DSectionMeas::CheckButton(int but)
{
	if(app.pA->GetButtonStates(but))
	{
		//any hit will immediately process
		ProcessButtonHit(but,BUTTON_SHORT);
	}
	else
		return FALSE;
	return TRUE;
}

void DSectionMeas::ProcessButtonHit(int Button, int Duration) 
{
	UpdateData(TRUE);
	pRomerDlg->GroupName = m_Group;
	pRomerDlg->TargetName = m_Target;
	TRACE("Button = %d     Last = %d\n"),Button,LastButtonHit);
	if(Button==0)
		First = TRUE;
	if(Button==LastButtonHit)
		Duration = BUTTON_LONG; //it's a repeat
	switch(Button)
	{
	case 1:
		{
			ButtonHit(pRomerDlg->ButtonOneMode,Duration);
			break;
		}
	case 2:
		{
			ButtonHit(pRomerDlg->ButtonTwoMode,Duration);
			break;
		}
	case 3:
		{
			ButtonHit(pRomerDlg->ButtonThreeMode,Duration);
			break;
		}
	default:
		{
			//just update the graphics
			pRomerDlg->UpdateSpan();
			//ProcessUpdate();	
		}
	}
	LastButtonHit = Button;
}


void DSectionMeas::ButtonHit(int Mode,int BDuration) 
{
	if((pRomerDlg->MouseButtonBlock)&&!((Mode==BACKUP_MOUSE)&&(BDuration==BUTTON_LONG)))
		return;
	switch(Mode)
	{
	case NOTHING:			//do nothing but update graphics
		{
			pRomerDlg->UpdateSpan();
			//ProcessUpdate();
			break;
		}
	case RECORD_ACCEPT:			//single point
		{
			pRomerDlg->UpdateSpan();
			ProcessUpdate();
			break;
		}
	case BACKUP_MOUSE:
		{
			ProcessAccept();
			break;
		}
	case BACKUP_CANCEL:
		{
			ProcessAccept();
			break;
		}
		
	default:
		{
			pRomerDlg->UpdateSpan();
			//ProcessUpdate();
		}
	}
}
*/

void DSectionMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DSectionMeas"),this);	
}

void DSectionMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DSectionMeas"),this);

	DGenMeas::OnDestroy();
}