// DSelectCalibration.cpp : implementation file
//

#include "stdafx.h"
#include "DPCMM.h"
#include "DSelectCalibration.h"


// DSelectCalibration dialog

IMPLEMENT_DYNAMIC(DSelectCalibration, CDialog)

DSelectCalibration::DSelectCalibration(CWnd* pParent /*=NULL*/)
	: CDialog(DSelectCalibration::IDD, pParent)
{
	selectedCal = -1;
}

DSelectCalibration::~DSelectCalibration()
{
}

void DSelectCalibration::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST2, list);
}


BEGIN_MESSAGE_MAP(DSelectCalibration, CDialog)
	ON_WM_CLOSE()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// DSelectCalibration message handlers

BOOL DSelectCalibration::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);

	list.SetExtendedStyle
		(list.GetExtendedStyle() | LVS_EX_FULLROWSELECT | LVS_EX_HEADERDRAGDROP | LVS_EX_GRIDLINES | LVS_EX_FLATSB);

	list.SetRedraw(FALSE);
	list.DeleteAllItems();
	//LPRECT r = NULL;
	//list.GetWindowRect(r);
	//int w = r->right - r->left;
	list.InsertColumn(0,_T(""),LVCFMT_LEFT,-1,0);
	for(int i=0; i<cals.GetSize(); i++)
	{
		list.InsertItem(i, cals.GetAt(i));
		list.SetItemData(i,i);
		list.SetItemText(i,0,cals.GetAt(i));
	}
	list.SetRedraw(TRUE);

	UpdateData(TRUE);

	TRANSLATE_DIALOG;

	SetTimer(INIT_TIMER,200,NULL);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void DSelectCalibration::SetCals(const CStringArray& inputCals)
{
	cals.RemoveAll();
	cals.Append(inputCals);
}
void DSelectCalibration::SetSelection(DWORD_PTR sel)
{
	if(sel > 0 && sel <= (DWORD_PTR)cals.GetUpperBound())
		list.SetSingleSelection(sel);
}
void DSelectCalibration::OnOK()
{
	if(!list.GetSingleSelection(selectedCal))
	{
		AfxMessageBox(Tr("You must select a calibration."), MB_ICONSTOP);
		return;
	}

	CDialog::OnOK();
}

void DSelectCalibration::OnClose()
{
	if(selectedCal < 0)
	{
		AfxMessageBox(Tr("You must select a calibration."), MB_ICONSTOP);
		return;
	}

	CDialog::OnClose();
}

void DSelectCalibration::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == INIT_TIMER)
	{
		KillTimer(INIT_TIMER);
		SetSelection(selectedCal);
	}
	CDialog::OnTimer(nIDEvent);
}
