// DSerialPortSettings.cpp : implementation file
//

#include "stdafx.h"
#include "DPCMM.h"
#include "DSerialPortSettings.h"
#include ".\dserialportsettings.h"


// DSerialPortSettings dialog

IMPLEMENT_DYNAMIC(DSerialPortSettings, CDialog)
DSerialPortSettings::DSerialPortSettings(const int& carm_type)
: arm_type(carm_type)
, m_CommPort(0)
, CommBaud(0)
, faro_com_param_comboval(0)
{
}

DSerialPortSettings::~DSerialPortSettings()
{
}

void DSerialPortSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, comctrl);
	DDX_Control(pDX, IDC_COMBO2, baudctrl);
	DDX_Control(pDX, IDC_STATIC_BAUDLABEL, baudLabel);
	DDX_CBIndex(pDX, IDC_COMBO1, m_CommPort);
	DDX_CBIndex(pDX, IDC_COMBO2, CommBaud);
	DDX_Control(pDX, IDC_STATIC_FARO_COM_PARAMS, faro_comparam_label);
	DDX_Control(pDX, IDC_COMBO_FARO_COM_PARAMS, faro_com_param_combo);
	DDX_CBIndex(pDX, IDC_COMBO_FARO_COM_PARAMS, faro_com_param_comboval);
}


BEGIN_MESSAGE_MAP(DSerialPortSettings, CDialog)
	ON_WM_DESTROY()
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()


// DSerialPortSettings message handlers
void DSerialPortSettings::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DSerialPortSettings"),this);	
}
void DSerialPortSettings::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DSerialPortSettings"),this);
	CDialog::OnDestroy();
}

BOOL DSerialPortSettings::OnInitDialog()
{
	CDialog::OnInitDialog();

	switch(arm_type)
	{
		case app.saarm.arm_Romer:
		{
			comctrl.AddString(_T("Com1:"));
			comctrl.AddString(_T("Com2:"));
			comctrl.AddString(_T("Com3:"));
			comctrl.AddString(_T("Com4:"));
			comctrl.AddString(_T("Com5:"));
			comctrl.AddString(_T("Com6:"));
			comctrl.AddString(_T("Com7:"));
			comctrl.AddString(_T("Com8:"));
			comctrl.AddString(_T("USB"));
			comctrl.AddString(_T("Wi-Fi"));

			comctrl.SetCurSel(m_CommPort);
			break;
		}
		case app.saarm.arm_FaroSerial:
		{
			comctrl.AddString(_T("Com1:"));
			comctrl.AddString(_T("Com2:"));
			comctrl.AddString(_T("Com3:"));
			comctrl.AddString(_T("Com4:"));
			comctrl.AddString(_T("Com5:"));
			comctrl.AddString(_T("Com6:"));
			comctrl.AddString(_T("Com7:"));
			comctrl.AddString(_T("Com8:"));
			comctrl.AddString(_T("Com9:"));

			baudLabel.ShowWindow(SW_SHOW);
			baudctrl.ShowWindow(SW_SHOW);
			baudctrl.AddString(_T("19200"));
			baudctrl.AddString(_T("38400"));
			baudctrl.AddString(_T("57600"));
			baudctrl.AddString(_T("115200"));

			faro_comparam_label.ShowWindow(SW_SHOW);
			faro_com_param_combo.ShowWindow(SW_SHOW);
			faro_com_param_combo.AddString(_T("even,7,1"));
			faro_com_param_combo.AddString(_T("none,8,1"));

			comctrl.SetCurSel(m_CommPort);
			baudctrl.SetCurSel(CommBaud);
			faro_com_param_combo.SetCurSel(faro_com_param_comboval);
			break;
		}
		case app.saarm.arm_SNL:
		{
			comctrl.AddString(_T("Com1:"));
			comctrl.AddString(_T("Com2:"));
			comctrl.AddString(_T("Com3:"));
			comctrl.AddString(_T("Com4:"));
			comctrl.AddString(_T("Com5:"));
			comctrl.AddString(_T("Com6:"));
			comctrl.AddString(_T("Com7:"));
			comctrl.AddString(_T("Com8:"));
			comctrl.AddString(_T("Com9:"));

			comctrl.SetCurSel(m_CommPort);
			break;
		}
	}

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	TRANSLATE_DIALOG;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
