// DSinglePtHole.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DPCMM.h"
#include "DSinglePtHole.h"


// DSinglePtHole dialog

DSinglePtHole::DSinglePtHole(CWnd* pParent /*=NULL*/)
	: DGenMeas(DSinglePtHole::IDD, pParent)
	, Group(_T(""))
	, Target(_T(""))
	, lockSPCircRadius(FALSE)
	, spHoleLockedRadius(0)
{
	circIdx = 0;
}

DSinglePtHole::~DSinglePtHole()
{
}

void DSinglePtHole::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDC_PSAMPLES, Psamples);
	DDX_Control(pDX, IDC_PRMSERR, Prmserr);
	DDX_Control(pDX, IDC_PMAXERR, Pmaxerr);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT2, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT2, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG2, B2long_button);
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_STATIC_PLANE_LABEL, planeLabel);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Control(pDX, IDC_STATIC_EVAL, eval_message);
	DDX_Check(pDX, IDC_CHECK_LOCK_SP_CIRC_RAD, lockSPCircRadius);
	DDX_Control(pDX, IDC_EDIT_SP_CIRC_LOCKED_RADIUS, lockSPHoleRadiusEdit);
	DDX_Text(pDX, IDC_EDIT_SP_CIRC_LOCKED_RADIUS, spHoleLockedRadius);
}


BEGIN_MESSAGE_MAP(DSinglePtHole, DGenMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT2, &DSinglePtHole::OnBnClickedButtonOneshort2)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, &DSinglePtHole::OnBnClickedButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT2, &DSinglePtHole::OnBnClickedButtonTwoshort2)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG2, &DSinglePtHole::OnBnClickedButtonTwolong2)
	ON_BN_CLICKED(IDC_DEFAULT, &DSinglePtHole::OnBnClickedDefault)
	ON_BN_CLICKED(IDOK, &DSinglePtHole::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_SPT_HOLE_SELECT_PLANE, &DSinglePtHole::OnBnClickedButtonSptHoleSelectPlane)
	ON_BN_CLICKED(IDC_CHECK_LOCK_SP_CIRC_RAD, &DSinglePtHole::OnBnClickedCheckLockSpCircRad)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// DSinglePtHole message handlers

BOOL DSinglePtHole::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	OKButton.EnableWindow(FALSE);
	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);
	//if(app.saarm.Data.AddExtraPatchShift)
	//	ShiftText.Format(_T("Patch Shift: %f %s"),
	//	app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
	//	app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	//else
	//	ShiftText.Format(_T("No Patch Shift"));
	//Shift.SetWindowText(ShiftText);

	SetWindowText(title);
	SetDlgItemText(IDOK,Tr("Accept Plane"));

	CheckForSPC_Plane();

	SetGTNames();
	if(app.saarm.Data.singlePtPlaneSet)
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane, or accept Plane."));
	else
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane."));

	SetDlgItemText(IDC_STATIC_UNITS, app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	OnBnClickedCheckLockSpCircRad();

	//	MessageBeep(-1);

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;
}

bool DSinglePtHole::CheckForSPC_Plane()
{
	if( !app.saarm.Data.singlePtPlaneSet )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		OKButton.EnableWindow(FALSE);
		return false;
	}
	Plane = app.saarm.Data.singlePtPlane;
	PSampleText.Format(_T("%d Samples"), Plane.samples);

	//if(Plane.patchShift != 0.0)
	//	ShiftText.Format(_T("Patch Shift: %f %s"),
	//	Plane.patchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
	//	app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	//else
	//	ShiftText.Format(_T("No Patch Shift"));
	//Shift.SetWindowText(ShiftText);

	CString m;
	m.Format(Tr("Plane ") + Plane.timeStamp);
	planeLabel.SetWindowText(m);
	UpdateDialog();
	OKButton.EnableWindow();
	return true;
}

void DSinglePtHole::SetGTNames()
{
	Group = app.saarm.Data.Group;
	GroupCtrl.SetWindowText(Group);
	Target = app.saarm.Data.Target;
	TargCtrl.SetWindowText(Target);
}

BOOL DSinglePtHole::ProcessNewData(int inc) 
{
	TRACE("ProcessNewData!!\n");
	if(app.pA->StepIndex==0)
	{
		return UpdatePlane(inc);
	}
	else if(app.pA->StepIndex==1)
	{
		//add check for plane proximity if it's a hole
		AddCircle(inc);
	}
	return FALSE;
}

BOOL DSinglePtHole::UpdatePlane(int inc)
{	
	PSampleText.Format(_T("%d Samples"), ctr+1);
	Psamples.SetWindowText(PSampleText);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);

	if(ctr < 0)
	{
		CheckForSPC_Plane();
		return FALSE;
	}

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3)// || inc <= 0 )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		SetDlgItemText(IDC_PLANE,Tr("ABCD"));
		SetDlgItemText(IDC_PRMSERR,Tr("Max Err"));
		SetDlgItemText(IDC_PMAXERR,Tr("RMS Err"));
		//if(app.saarm.Data.AddExtraPatchShift)
		//	ShiftText.Format(_T("Patch Shift: %f %s"),
		//	app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		//	app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		//else
		//	ShiftText.Format(_T("No Patch Shift"));
		//Shift.SetWindowText(ShiftText);
		OKButton.EnableWindow(FALSE);
		return FALSE;
	}

	PauseMeasTimer();
	eval_message.SetWindowText(Tr("Fitting Plane, Please Wait"));
	//	if(app.saarm.Data.AddExtraPatchShift)
	//		m.Format("%d Samples    %5.2f %s Extra Shift",
	//		app.pA->DataArray[0]->GetSize(),
	//		app.saarm.Data.ExtraPatchShift/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
	//		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	//	else
	//		PSampleText.Format("%d Samples",ctr+1);
	//	Psamples.SetWindowText(m);

	//	double OldTip = app.pA->TipDia;
	//	if(app.pA->AddExtraPatchShift)
	//		app.pA->TipDia = app.pA->TipDia + (2.0 * app.pA->ExtraPatchShift);

	if(Plane.ComputePlane(app.pA->DataArray[0]))
		OKButton.EnableWindow(TRUE);
	else
		OKButton.EnableWindow(FALSE);

	UpdateDialog();
	ResumeMeasTimer();
	eval_message.SetWindowText(_T(""));
	return TRUE;
}

void DSinglePtHole::ProcessAccept()
{
	TRACE("DHoleMeas::ProcessAccept, stepindex = %d\n", app.pA->StepIndex);
	if(app.pA->StepIndex==0)
	{
		if(app.saarm.Data.singlePtPlaneSet && app.pA->DataArray[0]->GetSize()==0)
		{
			*app.pA->DataArray[0] = app.saarm.Data.singlePtPlane.PPts;

			SAIPGeomPlane gp;
			app.saarm.Data.singlePtPlane.GetSAIPGeomPlane(gp);
			singlePointCircle.SetPlane(gp);
		}
		else if(app.pA->DataArray[0]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough Data."));
			ProcessingAccept = FALSE;
			return;
		}
		else	// reset the persisted plane
		{
			CString m;
			m.Format(Tr("Plane ") + Plane.timeStamp);
			planeLabel.SetWindowText(m);
			app.saarm.Data.singlePtPlane.name = m;
			app.saarm.Data.singlePtPlane = Plane;
			app.saarm.Data.singlePtPlane.samples = app.pA->DataArray[0]->GetSize();
			app.saarm.Data.singlePtPlane.PPts = *app.pA->DataArray[0];

			SAIPGeomPlane gp;
			app.saarm.Data.singlePtPlane.GetSAIPGeomPlane(gp);
			singlePointCircle.SetPlane(gp);
		}

		OKButton.EnableWindow(FALSE);
	
		DGenMeas::ProcessAccept();
	}
}

void DSinglePtHole::AddCircle(int inc)
{		
	Transform circ;
	double radius = 0.0;
	UpdateData(TRUE);	// get locked radius
	if(singlePointCircle.MakeCircleFromPoint( Vector(app.pA->X,app.pA->Y,app.pA->Z), app.saarm.Data.TipDia/2.0, spHoleLockedRadius*app.saarm.units.UnitToMeters[app.saarm.units.distunits], lockSPCircRadius ? true : false, circ, radius) )
	{
		notes.RemoveAll();

		notes.Add(Tr("Single Pt. Hole created by ") + app.saarm.CMMString);
		notes.Add(Tr("Plane ") + Plane.timeStamp);

		CString tName;
		tName.Format(_T("%s"), app.saarm.Data.Target);
		if(app.saarm.Data.geomName.IsEmpty())
		{
			name.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
		}
		else
		{
			name = app.saarm.Data.geomName;
			app.pA->IncrementName(app.saarm.Data.geomName);
		}

		app.saarm.Data.measCommentArray.RemoveAll();
		app.saarm.Data.measCommentArray.Append(notes);

		Vector center;
		circ.GetTranslation(&center);
		app.pA->MeasToSpan(center, app.saarm.Data.Group, app.saarm.Data.Target, true, false);

		if( app.saarm.Data.SendGeom )
			app.saarm.SockGeom.SendCircle(circ, radius, name, notes);

		SetDlgItemText(IDC_CSAMPLES, name);
		CString rad;
		rad.Format(Tr("Radius") + _T("%f"), radius/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]));
		//SetDlgItemText(IDC_CENTER,Circle.centerinfo);
		SetDlgItemText(IDC_RADIUS, rad);

		if(app.saarm.Data.incrementgroup)
		{
			app.saarm.Data.Target.Format(_T("P1"));
			app.pA->IncrementName(app.saarm.Data.Group, 1);
		}
		else
			app.pA->IncrementName(app.saarm.Data.Target, 1);

		app.pA->DataArray[1]->Clear();
		app.pA->SetDisplayData();
	}
}

void DSinglePtHole::UpdateDialog()
{
	SetDlgItemText(IDC_PSAMPLES,PSampleText);
	SetDlgItemText(IDC_CSAMPLES,CSampleText);
	SetDlgItemText(IDC_PLANE,Plane.PlaneText);
	SetDlgItemText(IDC_PRMSERR,Plane.rmserrinfo);
	SetDlgItemText(IDC_PMAXERR,Plane.maxerrinfo);
	//SetDlgItemText(IDC_CENTER,Circle.centerinfo);
	//SetDlgItemText(IDC_RADIUS,Circle.radiusinfo);
	//SetDlgItemText(IDC_CRMSERR,Circle.rmserrinfo);
	//SetDlgItemText(IDC_CMAXERR,Circle.maxerrinfo);
	TRACE1("circle max err info: %s\n", Circle.maxerrinfo);
}

void DSinglePtHole::OnBnClickedButtonOneshort2()
{
	SetB1Short();
}


void DSinglePtHole::OnBnClickedButtonOnelong()
{
	SetB1Long();
}

void DSinglePtHole::OnBnClickedButtonTwoshort2()
{
	SetB2Short();
}

void DSinglePtHole::OnBnClickedButtonTwolong2()
{
	SetB2Long();
}

void DSinglePtHole::OnBnClickedDefault()
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DSinglePtHole::OnBnClickedOk()
{
	ProcessAccept();
}

void DSinglePtHole::OnBnClickedButtonSptHoleSelectPlane()
{
	SAIPGeomPlane gp;
	if(app.saarm.SelectPlaneFromSA(gp))
	{
		app.saarm.Data.singlePtPlane.SetFromSAIPGeomPlane(gp);
		app.saarm.Data.singlePtPlaneSet = true;
		if(CheckForSPC_Plane())
		{
			singlePointCircle.SetPlane(gp);
			OKButton.EnableWindow(FALSE);
			DGenMeas::ProcessAccept();
			app.pA->StepIndex = 1;
		}
	}
}

void DSinglePtHole::OnBnClickedCheckLockSpCircRad()
{
	UpdateData();
	if(lockSPCircRadius)
	{
		lockSPHoleRadiusEdit.EnableWindow(TRUE);
	}
	else
	{
		lockSPHoleRadiusEdit.EnableWindow(FALSE);
	}
}

void DSinglePtHole::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DSinglePtHole"),this);	
}

void DSinglePtHole::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DSinglePtHole"),this);

	DGenMeas::OnDestroy();
}
