#pragma once
#include "afxwin.h"
#include "DGenMeas.h"
#include "CircleObj.h"
#include "PlaneObj.h"

// DSinglePtHole dialog

class DSinglePtHole : public DGenMeas
{
public:
	DSinglePtHole(CWnd* pParent = NULL);   // standard constructor
	virtual ~DSinglePtHole();

	PlaneObj Plane;
	CircleObj Circle;

	SinglePointCircle singlePointCircle;

	virtual BOOL ProcessNewData(int inc);
	virtual BOOL Init();
	virtual void SetGTNames();
	virtual void ProcessAccept();

	BOOL UpdatePlane(int inc);
	bool CheckForSPC_Plane();
	void AddCircle(int inc);
	void UpdateDialog();

	CString PSampleText;
	CString CSampleText;
	CString TipText;

// Dialog Data
	enum { IDD = IDD_DIALOG_SINGLE_PT_HOLE };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	CStatic Tip;
	CStatic Psamples;
	CStatic Prmserr;
	CStatic Pmaxerr;
	afx_msg void OnBnClickedButtonOneshort2();
	afx_msg void OnBnClickedButtonOnelong();
	afx_msg void OnBnClickedButtonTwoshort2();
	afx_msg void OnBnClickedButtonTwolong2();
	afx_msg void OnBnClickedDefault();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedButtonSptHoleSelectPlane();
	CString Group;
	CString Target;
	CButton B1short_button;
	CButton B1long_button;
	CButton B2short_button;
	CButton B2long_button;
	CButton OKButton;
	CStatic planeLabel;
	CEdit GroupCtrl;
	CEdit TargCtrl;
	CStatic eval_message;
	BOOL lockSPCircRadius;
	afx_msg void OnBnClickedCheckLockSpCircRad();
	CEdit lockSPHoleRadiusEdit;
	double spHoleLockedRadius;
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDestroy();

private:
	int circIdx;
};
