// DSlotMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DSlotMeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DSlotMeas dialog


DSlotMeas::DSlotMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DSlotMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DSlotMeas)
	Group = _T("");
	Bradius = _T("");
	Target = _T("");
	ShiftText = _T("");
	//}}AFX_DATA_INIT
}


void DSlotMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DSlotMeas)
	DDX_Control(pDX, IDC_SHIFT, Shift);
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_TEDIT, TargCtrl);
	DDX_Control(pDX, IDC_GEDIT, GroupCtrl);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT3, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG3, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT2, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Control(pDX, IDC_TIP, Tip);
	DDX_Control(pDX, IDC_SLOTCENTER, Slotcenter);
	DDX_Control(pDX, IDC_RADIUSA, Aradius);
	DDX_Control(pDX, IDC_PSAMPLES, Psamples);
	DDX_Control(pDX, IDC_PRMSERR, Prmserr);
	DDX_Control(pDX, IDC_PMAXERR, Pmaxerr);
	DDX_Control(pDX, IDC_CRMSERRB, CBrmserr);
	DDX_Control(pDX, IDC_CRMSERRA, CArmserr);
	DDX_Control(pDX, IDC_CMAXERRB, CBmaxerr);
	DDX_Control(pDX, IDC_CMAXERRA, CAmaxerr);
	DDX_Control(pDX, IDC_CENTERB, Bcenter);
	DDX_Control(pDX, IDC_CENTERA, Acenter);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_RADIUSB, Bradius);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Text(pDX, IDC_SHIFT, ShiftText);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_PLANE_LABEL, planeLabel);
}


BEGIN_MESSAGE_MAP(DSlotMeas, DGenMeas)
	//{{AFX_MSG_MAP(DSlotMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT2, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG3, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT3, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_DEFAULT2, OnDefault)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_SLOT_SELECT_PLANE, &DSlotMeas::OnBnClickedButtonSlotSelectPlane)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DSlotMeas message handlers

BOOL DSlotMeas::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	OKButton.EnableWindow(FALSE);
	TipText.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	Tip.SetWindowText(TipText);
	if(app.saarm.Data.AddExtraPatchShift)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	SetDlgItemText(IDOK,_T("Accept Plane"));
	CheckForDS_Plane();

	SetGTNames();
	if(app.saarm.Data.ds_planeSet)
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane, or accept Plane."));
	else
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Plane."));
	UpdateDialog();
	
//	MessageBeep(-1);
	
	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;
}

bool DSlotMeas::CheckForDS_Plane()
{
	if( !app.saarm.Data.ds_planeSet )
	{
		planeLabel.SetWindowText(Tr("Plane"));
		OKButton.EnableWindow(FALSE);
		return false;
	}
	Plane = app.saarm.Data.ds_plane;
	PSampleText.Format(_T("%d Samples"), Plane.samples);

	if(Plane.patchShift != 0.0)
		ShiftText.Format(_T("Patch Shift: %f %s"),
		Plane.patchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		ShiftText.Format(_T("No Patch Shift"));
	Shift.SetWindowText(ShiftText);

	CString m;
	m.Format(Tr("Plane ") + Plane.timeStamp);
	planeLabel.SetWindowText(m);
	UpdateDialog();
	OKButton.EnableWindow();
	return true;
}

void DSlotMeas::SetGTNames()
{
	Group = app.saarm.Data.Group;
	GroupCtrl.SetWindowText(Group);
	Target = app.saarm.Data.Target;
	TargCtrl.SetWindowText(Target);
}

BOOL DSlotMeas::ProcessNewData(int inc) 
{
	TRACE("ProcessNewData!!\n");
	if(app.pA->StepIndex==0)
	{
		return UpdatePlane(inc);
	}
	else if(app.pA->StepIndex==1)
	{
		//add check for plane proximity if it's a hole
		return UpdateCircleA(inc);
	}
	else if(app.pA->StepIndex==2)
	{
		//add check for plane proximity if it's a hole
		return UpdateCircleB(inc);
	}

	return FALSE;
}

BOOL DSlotMeas::UpdatePlane(int inc)
{	
	PSampleText.Format(_T("%d Samples"), ctr+1);
	Psamples.SetWindowText(PSampleText);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);

	if(ctr < 0)
	{
		CheckForDS_Plane();
		return FALSE;
	}

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3)// || inc <= 0 )
	{
		planeLabel.SetWindowText(Tr("Plane"));

		if(app.saarm.Data.AddExtraPatchShift)
			ShiftText.Format(_T("Patch Shift: %f %s"),
			app.saarm.Data.ExtraPatchShift/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		else
			ShiftText.Format(_T("No Patch Shift"));
		Shift.SetWindowText(ShiftText);

		SetDlgItemText(IDC_PLANE,Tr("ABCD"));
		SetDlgItemText(IDC_PRMSERR,Tr("Max Err"));
		SetDlgItemText(IDC_PMAXERR,Tr("RMS Err"));
	
		OKButton.EnableWindow(FALSE);
		return FALSE;
	}

//	if(app.saarm.Data.AddExtraPatchShift)
//		m.Format(_T("%d Samples    %5.2f %s Extra Shift"),
//		app.pA->DataArray[0]->GetSize(),
//		app.saarm.Data.ExtraPatchShift/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
//		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
//	else
//		m.Format(_T("%d Samples"),ctr+1);
//	Psamples.SetWindowText(m);
		
//	double OldTip = pRomerDlg->TipDia;
//	if(pRomerDlg->AddExtraPatchShift)
//		pRomerDlg->TipDia = pRomerDlg->TipDia + (2.0 * pRomerDlg->ExtraPatchShift);

	PauseMeasTimer();
	SlotCenterText.Format(_T("***Fitting Plane, Please Wait***"));
	SetDlgItemText(IDC_SLOTCENTER,SlotCenterText);

	if(Plane.ComputePlane(app.pA->DataArray[0]))
		OKButton.EnableWindow(TRUE);
	else
		OKButton.EnableWindow(FALSE);
		
	SlotCenterText.Format(_T(""));
	ResumeMeasTimer();

	UpdateDialog();
	return TRUE;
}

BOOL DSlotMeas::UpdateCircleA(int inc)
{
	CASampleText.Format(_T("%d Samples"), ctr+1);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);
	OKButton.EnableWindow(FALSE);

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3 )//|| inc <= 0 )
	{
		CircleA.centerinfo.Format(_T(""));
		CircleA.radiusinfo.Format(_T(""));
		CircleA.rmserrinfo.Format(_T(""));
		CircleA.maxerrinfo.Format(_T(""));
		SlotCenterText.Format(_T(""));

		CBSampleText.Format(_T(""));
		CircleB.centerinfo.Format(_T(""));
		CircleB.radiusinfo.Format(_T(""));
		CircleB.rmserrinfo.Format(_T(""));
		CircleB.maxerrinfo.Format(_T(""));

		SlotCenterText.Format(_T(""));

		UpdateDialog();
		OKButton.EnableWindow(FALSE);
		return FALSE;	
	}

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() >= 3 )
	{
		PauseMeasTimer();
		SlotCenterText.Format(_T("***Fitting Circle A, Please Wait***"));
		SetDlgItemText(IDC_SLOTCENTER,SlotCenterText);

		VectorArray pts;
		if(app.pA->DataArray[1]->GetVectorArrayofPoints(pts) <= 0)
			return FALSE;
		Plane.ProjectPointsToPlane(pts,&CircAPointsOnPlane); //i/o all in inches
	
		if(CircleA.ComputeCircle(&CircAPointsOnPlane,0)) 
			OKButton.EnableWindow(TRUE);

		SlotCenterText.Format(_T(""));
		SetDlgItemText(IDC_SLOTCENTER,SlotCenterText);
		ResumeMeasTimer();
	}
	UpdateDialog();
	return TRUE;
}

BOOL DSlotMeas::UpdateCircleB(int inc)
{
	CBSampleText.Format(_T("%d Samples"), ctr+1);
	app.pA->IncrementName(Target, inc);
	TargCtrl.SetWindowText(Target);
	OKButton.EnableWindow(FALSE);

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 3 )//|| inc <= 0 )
	{
		CircleB.centerinfo.Format(_T(""));
		CircleB.radiusinfo.Format(_T(""));
		CircleB.rmserrinfo.Format(_T(""));
		CircleB.maxerrinfo.Format(_T(""));
		SlotCenterText.Format(_T(""));

		UpdateDialog();
		OKButton.EnableWindow(FALSE);
		return FALSE;	
	}

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() >= 3 )
	{	
		PauseMeasTimer();
		SlotCenterText.Format(_T("***Fitting Circle B, Please Wait***"));
		SetDlgItemText(IDC_SLOTCENTER,SlotCenterText);

		VectorArray pts;
		if(app.pA->DataArray[2]->GetVectorArrayofPoints(pts) <= 0)
			return FALSE;
		Plane.ProjectPointsToPlane(pts,&CircBPointsOnPlane); //i/o all in inches
		
		if(CircleB.ComputeCircle(&CircBPointsOnPlane,0))
		{
			UpdateSlot();
			enoughdata = TRUE;
			OKButton.EnableWindow(TRUE);
		}

		SlotCenterText.Format(_T(""));
		ResumeMeasTimer();
	}
	UpdateDialog();
	return TRUE;
}

void DSlotMeas::UpdateSlot()
{
	Width = CircleA.radius+CircleB.radius;  //in meters
	double dist;
	dist = CircleA.center.Distance(CircleB.center);
	Length = Width+dist;
	center = CircleA.center;
	center.Add(CircleB.center);
	center.Scale(0.5);  //in meters

	Vector CInWorking;
	app.saarm.InstToWorking.Multiply(center, &CInWorking);

	SlotCenterText.Format(_T("Width=%6.*f %s, Length=%6.*f %s\nCenter: X=%6.*f, Y=%6.*f, Z=%6.*f %s"),
		app.saarm.Data.Precision,Width/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits],
		app.saarm.Data.Precision,Length/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits],
		app.saarm.Data.Precision,CInWorking.x/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.Data.Precision,CInWorking.y/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.Data.Precision,CInWorking.z/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	UpdateDialog();
}

void DSlotMeas::UpdateDialog()
{
	SetDlgItemText(IDC_PSAMPLES,PSampleText);
	SetDlgItemText(IDC_CSAMPLESA,CASampleText);
	SetDlgItemText(IDC_CSAMPLESB,CBSampleText);
	SetDlgItemText(IDC_PLANE,Plane.PlaneText);
	SetDlgItemText(IDC_PRMSERR,Plane.rmserrinfo);
	SetDlgItemText(IDC_PMAXERR,Plane.maxerrinfo);
	SetDlgItemText(IDC_CENTERA,CircleA.centerinfo);
	SetDlgItemText(IDC_RADIUSA,CircleA.radiusinfo);
	SetDlgItemText(IDC_CRMSERRA,CircleA.rmserrinfo);
	SetDlgItemText(IDC_CMAXERRA,CircleA.maxerrinfo);
	SetDlgItemText(IDC_CENTERB,CircleB.centerinfo);
	SetDlgItemText(IDC_RADIUSB,CircleB.radiusinfo);
	SetDlgItemText(IDC_CRMSERRB,CircleB.rmserrinfo);
	SetDlgItemText(IDC_CMAXERRB,CircleB.maxerrinfo);
	SetDlgItemText(IDC_SLOTCENTER,SlotCenterText);
}

void DSlotMeas::ProcessAccept()
{
	TRACE("DSlotMeas::ProcessAccept, stepindex = %d\n", app.pA->StepIndex);
	if(app.pA->StepIndex==0)
	{
		if(app.saarm.Data.ds_planeSet && app.pA->DataArray[0]->GetSize()==0)
		{
			*app.pA->DataArray[0] = app.saarm.Data.ds_plane.PPts;
		}
		else if(app.pA->DataArray[0]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough app.saarm.Data."));
			ProcessingAccept = FALSE;
			return;
		}
		else	// reset the persisted plane
		{
			CString m;
			m.Format(Tr("Plane ") + Plane.timeStamp);
			planeLabel.SetWindowText(m);
			app.saarm.Data.ds_plane = Plane;
			app.saarm.Data.ds_plane.samples = app.pA->DataArray[0]->GetSize();
			app.saarm.Data.ds_plane.PPts = *app.pA->DataArray[0];
		}

		OKButton.EnableWindow(FALSE);
//		pRomerDlg->RemoteMouse(FALSE);
		SetDlgItemText(IDOK,_T("Accept Circle A"));
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Circle A"));

		DGenMeas::ProcessAccept();
	}
	else if(app.pA->StepIndex==1)
	{
		if(app.pA->DataArray[1]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough app.saarm.Data."));
			ProcessingAccept = FALSE;
			return;
		}
//		OKButton.EnableWindow(FALSE);
//		pRomerDlg->RemoteMouse(FALSE);

		rad = CircleA.radius;
		t = CircleA.t;

		SetDlgItemText(IDOK,_T("Accept Slot"));
		OKButton.EnableWindow(FALSE);
		app.saarm.TTS.TextToSpeech(_T("Measure at least three Points on Circle B"));
		DGenMeas::ProcessAccept();
	}
	else if(app.pA->StepIndex==2)
	{
		if(app.pA->DataArray[2]->GetSize()<3)
		{
			app.saarm.TTS.TextToSpeech(_T("Not enough app.saarm.Data."));
			ProcessingAccept = FALSE;
			return;
		}

		if(!enoughdata)
		{
			ProcessingAccept = FALSE;
			return;
		}

		if(app.saarm.Data.geomName.IsEmpty())
		{
			name.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
		}
		else
		{
			name = app.saarm.Data.geomName;
			app.pA->IncrementName(app.saarm.Data.geomName);
		}
		CString tName;
		tName.Format(_T("%s"), app.saarm.Data.Target);
		notes.RemoveAll();
		notes.Add(_T("Slot created by ") + app.saarm.CMMString);
		notes.Add(SlotCenterText);
		notes.Add(Tr("Plane ") + Plane.timeStamp);
		notes.Add(PSampleText + _T(" for Plane   -") + CASampleText + _T(" for CircleA")+ CBSampleText + _T(" for CircleB"));
		notes.Add(_T("Plane - ") + Plane.maxerrinfo + _T("   ") + Plane.rmserrinfo + _T(" ") + app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		notes.Add(_T("CircleA - ") + CircleA.maxerrinfo + _T("   ") + CircleA.rmserrinfo + _T(" ") + app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		notes.Add(CircleA.radiusinfo);
		notes.Add(_T("CircleB - ") + CircleB.maxerrinfo + _T("   ") + CircleB.rmserrinfo + _T(" ") + app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
		notes.Add(CircleB.radiusinfo);

		radB = CircleB.radius;
		tB = CircleB.t;

		app.saarm.Data.ds_planeSet = true;

//		MakeFrame(&ActualTrans); //in arm coords
//		app.saarm.SockGeom.SendCircle(Circle.t,ActualRadius,360.0,Name,Notes);
		
		app.saarm.TTS.TextToSpeech(_T("Slot accepted"));
		
		if(Inspect)
			PresentComparisonResults();
		else
		{
			CString targName(app.saarm.Data.Target);
			//targName.Format(Tr("Slot Center ") + app.saarm.Data.Target);
			app.saarm.Data.measCommentArray.RemoveAll();
			app.saarm.Data.measCommentArray.Append(notes);
			center.Scale(1.0/app.saarm.GetInstrumentScaleFactor());
			app.pA->MeasToSpan(center, app.saarm.Data.Group, targName, true, false);

			if( app.saarm.Data.SendGeom )
			{
				app.saarm.SockGeom.SendCircle(t, rad, name + Tr("_SlotA"), notes);
				app.saarm.SockGeom.SendCircle(tB, radB, name + Tr("_SlotB"), notes);
			}

			if(app.saarm.Data.FirePointsToo)
			{
				CString tempGName = app.saarm.Data.Group;
				app.saarm.Data.Group.Format(_T("%s_%s-Meas"), tempGName, tName);
				app.pA->ScaleDataArrays(1.0/app.saarm.GetInstrumentScaleFactor());
				app.pA->MeasToSpan(app.pA->DataArray[0], Tr("PlanePoint"));
				app.pA->MeasToSpan(app.pA->DataArray[1], Tr("CircleAPoint"));
				app.pA->MeasToSpan(app.pA->DataArray[2], Tr("CircleBPoint"));
				app.saarm.Data.Group = tempGName;
			}

			if(app.saarm.Data.incrementgroup)
			{
				app.saarm.Data.Target.Format(_T("P1"));
				app.pA->IncrementName(app.saarm.Data.Group, 1);
			}
			else
				app.pA->IncrementName(app.saarm.Data.Target, 1);

			app.pA->DataArray[1]->Clear();
			app.pA->DataArray[2]->Clear();
			app.pA->StepIndex = 1;

			CheckForDS_Plane();
			ctr = -1;
			UpdateCircleA(0);
			UpdateCircleB(0);
			CASampleText.Format(_T("0 Samples"));
			CBSampleText.Format(_T("0 Samples"));
			app.pA->SetDisplayData();
		}
	}
	ProcessingAccept = FALSE;
}

void DSlotMeas::PresentComparisonResults()
{
	// 2004.08.29 - stop the meas timer so button hits stop getting or deleting app.saarm.Data...
	PauseMeasTimer();

	app.saarm.TTS.TextToSpeech(_T("Comparison Results"));
	//do all the mapping to working
	Vector ActualCenter,ActualCenterInWork;
	ActualTrans.GetTranslation(&ActualCenter);
	app.saarm.InstToWorking.Multiply(ActualCenter,&ActualCenterInWork);
	Vector NominalCenter,NominalCenterInWork;
	NominalTrans.GetTranslation(&NominalCenter);
	NominalTrans.Debug();
	NominalCenter.Debug();
	
	app.saarm.InstToWorking.Multiply(NominalCenter,&NominalCenterInWork);
	NominalCenterInWork.Debug();
	Vector DeltaInWork(ActualCenterInWork);
	DeltaInWork.Sub(NominalCenterInWork);

	//get diff in z axes
	Vector xa,ya,zact,znom;

	ActualTrans.GetAxes(&xa,&ya,&zact);
	NominalTrans.GetAxes(&xa,&ya,&znom);
	double AngleError = 0;
	Vector axis;
	if(zact.Dot(znom)<0) //in diff directions
		zact.Scale(-1.0); //reverse one of them
	AngleError = zact.AngleBetween(znom,&axis);

	double DiaError = (ActualRadius - NominalRadius)*2.0;
		
	//NominalCenterInWork.Debug();
	//ActualCenterInWork.Debug();
	//DeltaInWork.Debug();

/*
	DCompareResults diag;
	CString res,next;
	CStringArray Rep;		

	if(Pin)
		res.Format(_T("Pin Inspection   -  %s"), ObName);
	else
		res.Format(_T("Hole Inspection   -  %s"), ObName);
	Rep.Add(res);
	res.Format(_T("Nominal Center   = %8.*f %8.*f %8.*f"),
		pRomerDlg->Precision,NominalCenterInWork.x/pRomerDlg->UnitConversionFactorToMeters,
		pRomerDlg->Precision,NominalCenterInWork.y/pRomerDlg->UnitConversionFactorToMeters,
		pRomerDlg->Precision,NominalCenterInWork.z/pRomerDlg->UnitConversionFactorToMeters);
	Rep.Add(res);
	res += "\n";
	next.Format(_T("Actual Center   = %8.*f %8.*f %8.*f"),
		pRomerDlg->Precision,ActualCenterInWork.x/pRomerDlg->UnitConversionFactorToMeters,
		pRomerDlg->Precision,ActualCenterInWork.y/pRomerDlg->UnitConversionFactorToMeters,
		pRomerDlg->Precision,ActualCenterInWork.z/pRomerDlg->UnitConversionFactorToMeters);
	Rep.Add(next);
	res += next + "\n";
	next.Format(_T("Delta Center    = %8.*f %8.*f %8.*f"),
		pRomerDlg->Precision,DeltaInWork.x/pRomerDlg->UnitConversionFactorToMeters,
		pRomerDlg->Precision,DeltaInWork.y/pRomerDlg->UnitConversionFactorToMeters,
		pRomerDlg->Precision,DeltaInWork.z/pRomerDlg->UnitConversionFactorToMeters);
	Rep.Add(next);
	res +=next + "\n\n";

	next.Format(_T("Nominal Diameter  = %8.*f"),
		pRomerDlg->Precision,NominalRadius*2.0/pRomerDlg->UnitConversionFactorToMeters );
	Rep.Add(next);
	res +=next + "\n";
	next.Format(_T("Actual Diameter   = %8.*f"),
		pRomerDlg->Precision,ActualRadius*2.0/pRomerDlg->UnitConversionFactorToMeters );
	Rep.Add(next);
	res +=next + "\n";
	next.Format(_T("Delta Diameter    = %8.*f"),
		pRomerDlg->Precision,DiaError/pRomerDlg->UnitConversionFactorToMeters );
	Rep.Add(next);
	res +=next + "\n\n";

	next.Format(_T("Normal Direction Deviation   = %6.4f  degrees"),
		fabs(AngleError) );
	Rep.Add(next);
	res +=next;

	diag.m_Results = res;

	pRomerDlg->Span.Packet.Command = PAK_STRING_ARRAY;
	pRomerDlg->Span.CStringArrayToPak(Rep);
	int sent = pRomerDlg->Span.SendPacket();
	//TRACE("send string packet.. %d bytes\n"),sent);

	while(RDS_IsButtonNDown(1)||RDS_IsButtonNDown(2)||RDS_IsButtonNDown(3))
		RDS_GetSystemUpdate(TRUE);
	pRomerDlg->RemoteMouse(TRUE);
	diag.DoModal();
*/
}

BOOL DSlotMeas::MakeFakeData(int step)
{
	TRACE("MakeFakeData!!\n");
	if(app.StopNow)
		return FALSE;			

	switch(step)
	{
	case 0:
		{
			app.pA->X = 0.7 + ((double)rand())/((double)RAND_MAX)*0.1;
			app.pA->Y = ((double)rand())/((double)RAND_MAX)*0.1;
			app.pA->Z = -0.3;
			break;
		}
	case 1:
		{
			Vector XYZ(0.7, 0.1, -0.3), newXYZ;
			double rho, theta, phi;

			ProcessWaitingMessages();
			Delay(0.0005);

			if(app.StopNow)
				return FALSE;			

			rho = 0.02;
			phi = 180.0*((double)rand())/((double)RAND_MAX);
			theta = 90.0;

			Vector dhv(rho, phi, theta);
			Vector xyz;
			dhv.RTPtoXYZ(&xyz);

			newXYZ = XYZ;
			newXYZ.Add(xyz);
			app.pA->X = newXYZ.x;
			app.pA->Y = newXYZ.y;
			app.pA->Z = newXYZ.z;

			break;
		}
	case 2:
		{
			Vector XYZ(0.7, -0.1, -0.3), newXYZ;
			double rho, theta, phi;

			ProcessWaitingMessages();
			Delay(0.0005);

			if(app.StopNow)
				return FALSE;			

			rho = 0.02;
			phi = -180.0*((double)rand())/((double)RAND_MAX);
			theta = 90.0;

			Vector dhv(rho, phi, theta);
			Vector xyz;
			dhv.RTPtoXYZ(&xyz);

			newXYZ = XYZ;
			newXYZ.Add(xyz);
			app.pA->X = newXYZ.x;
			app.pA->Y = newXYZ.y;
			app.pA->Z = newXYZ.z;

			break;
		}
	default:
		break;
	}
	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DSlotMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DSlotMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DSlotMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DSlotMeas::OnButtonOneshort() 
{
	SetB1Short();
}

void DSlotMeas::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DSlotMeas::OnOK() 
{
	ProcessAccept();
}

void DSlotMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DSlotMeas"),this);	
}

void DSlotMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DSlotMeas"),this);

	DGenMeas::OnDestroy();
}
void DSlotMeas::OnBnClickedButtonSlotSelectPlane()
{
	SAIPGeomPlane gp;
	if(app.saarm.SelectPlaneFromSA(gp))
	{
		app.saarm.Data.ds_plane.SetFromSAIPGeomPlane(gp);
		app.saarm.Data.ds_planeSet = true;
		CheckForDS_Plane();
	}
}
