#if !defined(AFX_DSLOTMEAS_H__E8BD30AA_C609_4E3B_BE7D_483B425C5349__INCLUDED_)
#define AFX_DSLOTMEAS_H__E8BD30AA_C609_4E3B_BE7D_483B425C5349__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DSlotMeas.h : header file
//

#include "DGenMeas.h"
#include "CircleObj.h"
#include "PlaneObj.h"
#include "afxwin.h"

/////////////////////////////////////////////////////////////////////////////
// DSlotMeas dialog

class DSlotMeas : public DGenMeas
{
// Construction
public:
	CString ObName;
	DSlotMeas(CWnd* pParent = NULL);   // standard constructor

	PlaneObj Plane;
	CircleObj CircleA;
	CircleObj CircleB;

	// geometry parameters
	Transform tB;
	double radB;

	virtual BOOL ProcessNewData(int inc);
	virtual BOOL Init();
	virtual void SetGTNames();
	virtual void ProcessAccept();
	
	BOOL UpdatePlane(int inc);
	bool CheckForDS_Plane();
	BOOL UpdateCircleA(int inc);
	BOOL UpdateCircleB(int inc);
	void UpdateSlot();
	void UpdateDialog();
	void MakeFrame(Transform* T);
	void PresentComparisonResults();

	// simulation mode
	virtual BOOL MakeFakeData(int step);

	VectorArray CircAPointsOnPlane;
	VectorArray CircBPointsOnPlane;
	CString PSampleText;
	CString CASampleText;
	CString CBSampleText;
	CString TipText;
	CString SlotCenterText;
	double NominalRadius;
	Transform NominalTrans;
	Transform ActualTrans;
	double ActualRadius;
	BOOL Inspect;
	double Width;
	double Length;
	
// Dialog Data
	//{{AFX_DATA(DSlotMeas)
	enum { IDD = IDD_SLOTMEAS };
	CStatic	Shift;
	CButton	OKButton;
	CEdit	TargCtrl;
	CEdit	GroupCtrl;
	CButton	B2short_button;
	CButton	B2long_button;
	CButton	B1short_button;
	CButton	B1long_button;
	CStatic	Tip;
	CStatic	Slotcenter;
	CStatic	Aradius;
	CStatic	Psamples;
	CStatic	Prmserr;
	CStatic	Pmaxerr;
	CStatic	CBrmserr;
	CStatic	CArmserr;
	CStatic	CBmaxerr;
	CStatic	CAmaxerr;
	CStatic	Bcenter;
	CStatic	Acenter;
	CString	Group;
	CString	Bradius;
	CString	Target;
	CString	ShiftText;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DSlotMeas)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(DSlotMeas)
	virtual void OnOK();
	afx_msg void OnButtonOnelong();
	afx_msg void OnButtonOneshort();
	afx_msg void OnButtonTwolong();
	afx_msg void OnButtonTwoshort();
	afx_msg void OnDefault();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDestroy();
	CStatic planeLabel;
	afx_msg void OnBnClickedButtonSlotSelectPlane();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DSLOTMEAS_H__E8BD30AA_C609_4E3B_BE7D_483B425C5349__INCLUDED_)
