// DSpeech.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DSpeech.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DSpeech dialog


DSpeech::DSpeech(CWnd* pParent /*=NULL*/)
	: CDialog(DSpeech::IDD, pParent)
{
	//{{AFX_DATA_INIT(DSpeech)
	m_Computer = _T("");
	m_Port = 0;
	m_Enabled = FALSE;
	m_Vol = 0;
	m_SectionSound = FALSE;
	//}}AFX_DATA_INIT
}


void DSpeech::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DSpeech)
	DDX_Control(pDX, IDC_ARMBUTTONTOGG, FaroArmBeepButton);
	DDX_Text(pDX, IDC_COMPUTER, m_Computer);
	DDX_Text(pDX, IDC_PORT, m_Port);
	DDX_Check(pDX, IDC_SPEECHCHECK, m_Enabled);
	DDX_Text(pDX, IDC_EDITVOL, m_Vol);
	DDV_MinMaxInt(pDX, m_Vol, 1, 40);
	DDX_Check(pDX, IDC_CHECKPLANESECT, m_SectionSound);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DSpeech, CDialog)
	//{{AFX_MSG_MAP(DSpeech)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	ON_BN_CLICKED(IDC_SPEECHCHECK, OnSpeechcheck)
	ON_BN_CLICKED(IDC_TESTARM, OnTestarm)
	ON_BN_CLICKED(IDC_ARMBUTTONTOGG, OnArmButtonBeepTogg)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DSpeech message handlers

void DSpeech::OnTest() 
{
	UpdateData(TRUE);
	app.saarm.TTS.IsEnabled = m_Enabled;
	app.saarm.TTS.m_computer = m_Computer;
	app.saarm.TTS.m_port = m_Port;
	app.saarm.TTS.WriteRegistry();
	app.saarm.Data.SectionSound = m_SectionSound;
	app.saarm.Data.SpkrVolume = m_Vol;
	if(m_Enabled)
		app.saarm.TTS.TextToSpeech(_T("Speech Option Enabled."));
	else
		app.saarm.TTS.TextToSpeech(_T("Speech Option Disabled."));
		
}

void DSpeech::OnSpeechcheck() 
{
	UpdateData(TRUE);
	if(m_Enabled)
		app.saarm.TTS.IsEnabled = TRUE;
	else
		app.saarm.TTS.IsEnabled = FALSE;
	
}

void DSpeech::OnTestarm() 
{
	UpdateData(TRUE);
	app.pA->SetVolumeLevel(m_Vol);
	for(int i = 200;i<=5600;i+=200)
	{
		app.pA->OutputSpeakerSound(i,200);
		Delay(0.05f);
	}
}

BOOL DSpeech::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
//	m_Vol = RDS_GetVolumeLevel();

	if(!app.pA->IsFaro())
	{
		FaroArmBeepButton.EnableWindow(FALSE);
		FaroArmBeepButton.ShowWindow(SW_HIDE);
	}

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	TRANSLATE_DIALOG;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DSpeech::OnArmButtonBeepTogg() 
{
	app.pA->ToggleArmButtonBeep();
}

void DSpeech::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DSpeech"),this);	
}

void DSpeech::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DSpeech"),this);

	CDialog::OnDestroy();
}
