// DSphereMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DSphereMeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DSphereMeas dialog


DSphereMeas::DSphereMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DSphereMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DSphereMeas)
	Group = _T("");
	Target = _T("");
	tip = _T("");
	centerinfo = _T("");
	radinfo = _T("");
	sampleinfo = _T("");
	maxerrinfo = _T("");
	rmserrinfo = _T("");
	//}}AFX_DATA_INIT
}


void DSphereMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DSphereMeas)
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT, B1short_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Text(pDX, IDC_TIP, tip);
	DDX_Text(pDX, IDC_CENTER, centerinfo);
	DDX_Text(pDX, IDC_RADIUS, radinfo);
	DDX_Text(pDX, IDC_SAMPLES, sampleinfo);
	DDX_Text(pDX, IDC_MAXERR, maxerrinfo);
	DDX_Text(pDX, IDC_RMSERR, rmserrinfo);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_EVAL, eval_message);
}


BEGIN_MESSAGE_MAP(DSphereMeas, DGenMeas)
	//{{AFX_MSG_MAP(DSphereMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DSphereMeas message handlers

BOOL DSphereMeas::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	OKButton.EnableWindow(FALSE);
	tip.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	SetGTNames();

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;
}
void DSphereMeas::SetGTNames()
{
	Group = app.saarm.Data.Group;
	Target = app.saarm.Data.Target;
	UpdateData(FALSE);
}

void DSphereMeas::ProcessAccept()
{
	if(!enoughdata)
	{
		app.saarm.TTS.TextToSpeech(_T("Not enough data to fit."));
		ProcessingAccept = FALSE;
		return;
	}

	name.Format(_T("%s_%s"), Group,Target);

	CString s;
	notes.RemoveAll();

	s.Format(_T("User: %s"), app.saarm.Data.UserName);//, app.saarm.Data.SpanPort);
	notes.Add(s);

	s.Format(_T("Sphere fit %s  %d samples"), name,
		app.pA->DataArray[app.pA->StepIndex]->P.GetSize());
	notes.Add(s);

	s.Format(_T("Radius = %f %s"),
		rad/app.saarm.units.UnitToMeters[app.saarm.units.distunits],
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	notes.Add(s);

	s.Format(_T("RMS Error = %f %s, %f pct. coverage"),
		rmserr,
		app.saarm.units.DistUnitNames[app.saarm.units.distunits],
		pctcov);
	notes.Add(s);

//	app.pA->DataArray[app.pA->StepIndex]->P.Add(new Vector(center));
	
	app.saarm.Data.measCommentArray.RemoveAll();
	app.saarm.Data.measCommentArray.Append(notes);

	CString name, tName;
	if(app.saarm.Data.geomName.IsEmpty())
	{
		name.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
	}
	else
	{
		name = app.saarm.Data.geomName;
		app.pA->IncrementName(app.saarm.Data.geomName);
	}
	tName.Format(_T("%s"), app.saarm.Data.Target);
	if( app.saarm.Data.SendGeom )
	{
		app.saarm.SockGeom.SendSphere(center, rad, name, notes);
	}

	//app.saarm.Data.Target.Format(_T("SphereCenter"));
	TRACE3("Sphere Center: X=%f,Y=%f,Z=%f\n", center.x, center.y, center.z);
	center.Scale(1.0/app.saarm.GetInstrumentScaleFactor());
	app.pA->MeasToSpan(center, true, false, false);

	if( app.saarm.Data.FirePointsToo )
	{
		CString tempGName = app.saarm.Data.Group;
		app.saarm.Data.Group.Format(_T("%s_%s-Meas"), tempGName, tName);
		app.pA->ScaleDataArrays(1.0/app.saarm.GetInstrumentScaleFactor());
		app.pA->MeasToSpan(app.pA->DataArray[0], tName);
		app.saarm.Data.Group = tempGName;
	}

	if(app.saarm.Data.incrementgroup)
	{
		app.saarm.Data.Target.Format(_T("P1"));
		app.pA->IncrementName(app.saarm.Data.Group, 1);
	}

	app.pA->DataArray[0]->Clear();
	ctr = -1;
	ProcessNewData(0);

	app.pA->SetDisplayData();

	ProcessingAccept = FALSE;
}
BOOL DSphereMeas::ProcessNewData(int inc)
{
	sampleinfo.Format(_T("%d Samples"), ctr+1);
	app.pA->IncrementName(Target, inc);

	if( app.pA->DataArray[app.pA->StepIndex]->P.GetSize() < 4 )//|| inc <= 0 )
	{
		centerinfo.Format(_T("Center"));
		radinfo.Format(_T("Radius"));
		maxerrinfo.Format(_T("Pct Coverage"));
		rmserrinfo.Format(_T("RMS Error"));
		OKButton.EnableWindow(FALSE);
		enoughdata = FALSE;
		UpdateData(FALSE);
		return FALSE;
	}
	enoughdata = TRUE;
	OKButton.EnableWindow(TRUE);

	PauseMeasTimer();
	eval_message.SetWindowText(_T("Fitting Sphere, Please Wait"));

	OptimizationParameters opt;		// could be global for app.
	int tolcount = 0;
	// SPHERE FIT
	FitBall fb;
	double Radius = 0.0;
	// 2001.02.14 this isn't working, so the radius is just hard-coded below
//	if(app.saarm.Data.LockSpheres)
//	{
//		fb.VaryRad = FALSE;
//		fb.Radius = (app.saarm.Data.TipDia/2.0) + app.saarm.Data.SphereLockVal*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
//		Radius = fb.Radius;
//	}
	fb.Tolerance = app.saarm.Data.SphereTol; // /app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	VectorArray pts;
	if(app.pA->DataArray[app.pA->StepIndex]->GetVectorArrayofPoints(pts) <= 0)
		return FALSE;
	fb.pPoints = &pts;
	fb.pOpt = &opt;

	TRACE("tip dia = %f in\n", app.saarm.Data.TipDia*app.saarm.LocalToInches);

	double freeradmeters = 0.0;
	double fbrad = app.saarm.Data.TipDia/2.0f;	// 2001.04.18
	fb.Calculate(&tolcount, &Radius, &fbrad);		// run optimization.
//	rad = fb.Radius*app.saarm.units.UnitToMeters[DISTUNITS_IN];
//	fb.Radius -= app.saarm.Data.TipDia/2.0;	// 2001.04.18
	if(app.saarm.Data.LockSpheres)	// the above wasn't working, just set the radius
	{
		fb.Radius = app.saarm.Data.SphereLockVal;
	}
	rad = fb.Radius;
	center = fb.Center;
	pctcov = fb.pct;
	rmserr = fb.rmserr;
//	center.Scale(app.saarm.units.UnitToMeters[DISTUNITS_IN]);
//	fb.VaryRad = FALSE;
//	Radius = d.app.saarm.Data.SphereLocRad/d.UnitToMeters[DISTUNITS_IN];

//	for( int j=0; j<fb.pPoints->P.GetSize(); j++)
//		TRACE("pPoints %d, x=%f\n"), j, fb.pPoints->P[j]->x);	

//	fb.Calculate(&tolcount, &Radius, &caserad);			// run optimization.
//	outsideRMStol = fb.outsideRMStol;
//	TRACE("TolCount = %d\n"),tolcount);

//	double radmeters = fb.Radius*d.UnitToMeters[DISTUNITS_IN];

	Vector CenterDisplay;
	app.saarm.InstToWorking.Multiply(center, &CenterDisplay);
	CenterDisplay.Scale(1.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);
	fb.Radius /= app.saarm.units.UnitToMeters[app.saarm.units.distunits];

	centerinfo.Format(_T("Center: %f, %f, %f %s"), CenterDisplay.x, CenterDisplay.y, CenterDisplay.z,
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	if(app.saarm.Data.LockSpheres)
		radinfo.Format(_T("Radius[locked]: %f %s"), fb.Radius,
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		radinfo.Format(_T("Radius: %f %s"), fb.Radius,
			app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	maxerrinfo.Format(_T("Pct Coverage: %0.3f"), fb.pct);
	rmserrinfo.Format(_T("RMS Error: %f %s"), fb.rmserr,
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);

//	TRACE3("Sphere Center: X=%f,Y=%f,Z=%f\n"), center.x, center.y, center.z);
	UpdateData(FALSE);
	eval_message.SetWindowText(_T(""));
	ResumeMeasTimer();
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////
// simulation mode

BOOL DSphereMeas::MakeFakeData(int step)
{
	Vector XYZ(1.0, 0.0, 0.0), newXYZ;
	double rho, theta, phi;

	if(app.StopNow)
		return FALSE;			
	
	rho = 0.1+((double)rand())/((double)RAND_MAX)*0.01;		// the radius of the sphere!!
	phi = 180.0*((double)rand())/((double)RAND_MAX);
	theta = 360.0*((double)rand())/((double)RAND_MAX);

	Vector dhv(rho, theta, phi);
	Vector xyz;
	dhv.RTPtoXYZ(&xyz);

	newXYZ = XYZ;
	newXYZ.Add(xyz);
	app.pA->X = newXYZ.x;
	app.pA->Y = newXYZ.y;
	app.pA->Z = newXYZ.z;

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DSphereMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DSphereMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DSphereMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DSphereMeas::OnButtonOneshort() 
{
	SetB1Short();
}

/////////////////////////////////////////////////////////////////////////////

void DSphereMeas::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DSphereMeas::OnOK() 
{
	ProcessAccept();
}

void DSphereMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DSphereMeas"),this);	
}

void DSphereMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DSphereMeas"),this);

	DGenMeas::OnDestroy();
}