// DStreamPts.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DStreamPts.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DStreamPts dialog


DStreamPts::DStreamPts(CWnd* pParent /*=NULL*/)
	: DGenMeas(DStreamPts::IDD, pParent)
{
	groupInc.Icon = IDI_GROUPINCICON;
	targInc.Icon = IDI_TARGETINCICON;
	//{{AFX_DATA_INIT(DStreamPts)
	Group = _T("");
	Target = _T("");
	tip = _T("");
	sampleinfo = _T("");
	//}}AFX_DATA_INIT
	fstpt = TRUE;
	maxBufferAge = 500; // 0.5 sec
}


void DStreamPts::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DStreamPts)
	DDX_Control(pDX, IDC_STRMINDICATOR, StreamIndicator);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG2, B1long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT, B1short_button);
	DDX_Text(pDX, IDC_GEDIT, Group);
	DDX_Text(pDX, IDC_TEDIT, Target);
	DDX_Text(pDX, IDC_TIP, tip);
	DDX_Text(pDX, IDC_SAMPLES, sampleinfo);
	//}}AFX_DATA_MAP
	//DDX_Control(pDX, IDC_BUTTON_INC_GROUP, groupInc);
	DDX_Control(pDX, IDC_INCT, targInc);
	DDX_Control(pDX, IDC_INCG, groupInc);
}

BEGIN_MESSAGE_MAP(DStreamPts, DGenMeas)
	//{{AFX_MSG_MAP(DStreamPts)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG2, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT, OnButtonTwoshort)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//ON_BN_CLICKED(IDC_BUTTON_INC_GROUP, OnBnClickedButtonIncGroup)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_INCT, &DStreamPts::OnBnClickedInct)
	ON_BN_CLICKED(IDC_INCG, &DStreamPts::OnBnClickedIncg)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DStreamPts message handlers

BOOL DStreamPts::Init()
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	tip.Format(_T("Tip Dia: %f %s"), 
		app.saarm.Data.TipDia/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	streaming = TRUE;
	sendfromdlg = TRUE;
	SetGTNames();
	SetStreamIndicator(FALSE);
	CString title;
	if(app.saarm.Data.scan_spatial)
		title.Format(_T("SPATIAL Stream Points Meas. - %f %s Spacing"),
		app.saarm.Data.scan_spatial_inc/(app.saarm.units.UnitToMeters[app.saarm.units.distunits]),
		app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	else
		title.Format(_T("TEMPORAL Stream Points Measurement"));
	app.saarm.Data.measCommentArray.RemoveAll();
	app.saarm.Data.measCommentArray.Add(title);
	SetWindowText(title);

	DGenMeas::Init();	// call Base class Init for translation, etc.

	if(app.saarm.units.toolBarModeOn && !app.pA->ConnectedToArm)	// Mantis #6602 - 2013.11.08 - pop meas dlg's when simulating in toolbar mode
		::SetWindowPos(m_hWnd,HWND_TOPMOST,300,300,50,50,SWP_NOSIZE + SWP_NOMOVE);

	measStart = ::GetCurrentTime();

	return TRUE;
}
void DStreamPts::SetGTNames()
{
	Group = app.saarm.Data.Group;
	Target = app.saarm.Data.Target;
	UpdateData(FALSE);
}

void DStreamPts::ProcessAccept()
{
	name.Format(_T("%s_%s"), Group,Target);

	CString s;
	s.Format(_T("User: %s"), app.saarm.Data.UserName);//, app.saarm.Data.SpanPort);
	notes.RemoveAll();
	notes.Add(s);
	
	DGenMeas::OnOK();
}
BOOL DStreamPts::ProcessNewData(int inc)
{
	PauseMeasTimer();
	Vector CurrentPos(app.pA->X,app.pA->Y,app.pA->Z);
	Vector CurrentNorm(app.pA->II,app.pA->JJ,app.pA->KK);

	if(app.saarm.Data.scan_spatial)
	{
		if(fstpt)
		{
			LastPos = CurrentPos;
			fstpt = FALSE;
		}
		else
		{
			Vector Delta = LastPos;
			Delta.Sub(CurrentPos);
			if(Delta.Length() >= app.saarm.Data.scan_spatial_inc)
				LastPos = CurrentPos;
			else
			{
				ResumeMeasTimer();
				return FALSE;
			}
		}
	}

	//app.pA->IncrementName(Target, inc);

	//LXText = CXText;
	//LYText = CYText;
	//LZText = CZText;

	app.pA->AddPoint(CurrentPos,CurrentNorm,app.pA->J);
	sampleinfo.Format(_T("%d Pts Measured"), ctr+1);
	ctr++;

	Vector CurrWork;
	app.saarm.InstToWorking.Multiply(CurrentPos,&CurrWork);
	CurrWork.Scale(1.0/app.saarm.units.UnitToMeters[app.saarm.units.distunits]);
	
	//TRACE2("ctr = %d, data array size = %d\n", ctr, app.pA->DataArray[app.pA->StepIndex]->GetSize());
	//TRACE1("time passed = %ld ms\n", ::GetCurrentTime() - measStart);
	if( app.pA->DataArray[app.pA->StepIndex]->GetSize() % 5 == 0 || (::GetCurrentTime() - measStart >= maxBufferAge && app.pA->DataArray[app.pA->StepIndex]->GetSize() > 0) )
	{
		//CXText.Format(_T("%6.2f"), CurrWork.x);
		//CYText.Format(_T("%6.2f"), CurrWork.y);
		//CZText.Format(_T("%6.2f"), CurrWork.z);
		if( inc > 0 )
		{
			app.pA->DataArray[app.pA->StepIndex]->Scale(1.0/app.saarm.GetInstrumentScaleFactor());
			app.pA->MeasToSpan(app.pA->DataArray[app.pA->StepIndex], Target, false);
			app.pA->IncrementName(app.saarm.Data.Target, inc*app.pA->DataArray[app.pA->StepIndex]->GetSize());
			Target = app.saarm.Data.Target;
			app.pA->DataArray[app.pA->StepIndex]->Clear();
		}
		measStart = ::GetCurrentTime();
		UpdateData(FALSE);
		//UpdateFields();
	}
	ResumeMeasTimer();
	return TRUE;
}
void DStreamPts::SendRemainingData()
{
	if( app.pA->DataArray[app.pA->StepIndex]->GetSize() > 0 )	// this is useless since we are clearing the array every time through, and setting counter to the return from AddPoint (should return an index of 0 every time)
	{
		app.pA->DataArray[app.pA->StepIndex]->Scale(1.0/app.saarm.GetInstrumentScaleFactor());
		app.pA->MeasToSpan(app.pA->DataArray[app.pA->StepIndex], Target, false);
		app.pA->IncrementName(app.saarm.Data.Target, app.saarm.Data.ptnameinc*app.pA->DataArray[app.pA->StepIndex]->GetSize());
		Target = app.saarm.Data.Target;
		UpdateData(FALSE);
		app.pA->DataArray[app.pA->StepIndex]->Clear();
	}
}

void DStreamPts::UpdateFields()
{
	UpdateData(FALSE);
	SetDlgItemText(IDC_CURRX,CXText);
	SetDlgItemText(IDC_CURRY,CYText);
	SetDlgItemText(IDC_CURRZ,CZText);
	SetDlgItemText(IDC_LASTX,LXText);
	SetDlgItemText(IDC_LASTY,LYText);
	SetDlgItemText(IDC_LASTZ,LZText);
}

void DStreamPts::SetStreamIndicator(BOOL strm)
{
	if(strm)
	{
		TRACE0("Setting stream indicator ON\n");
		StreamIndicator.SetBkColor(RGB(0,255,0));
		StreamIndicator.SetTextColor(RGB(0,0,0));
		StreamIndicator.SetWindowText(_T("ON"));
	}
	else
	{
		TRACE0("Setting stream indicator OFF\n");
		StreamIndicator.SetBkColor(RGB(255,0,0));
		StreamIndicator.SetTextColor(RGB(0,0,0));
		StreamIndicator.SetWindowText(_T("OFF"));
	}
}

///////////////////////////////////////////////////////////////////////////
// simulation mode

BOOL DStreamPts::MakeFakeData(int step)
{
	if(app.StopNow)
		return FALSE;			
	
	app.pA->X = ((double)rand())/((double)RAND_MAX);
	app.pA->Y = ((double)rand())/((double)RAND_MAX);
	app.pA->Z = (-(double)rand())/((double)RAND_MAX);

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DStreamPts::OnButtonOnelong() 
{
	SetB1Long();
}

void DStreamPts::OnButtonTwolong() 
{
	SetB2Long();
}

void DStreamPts::OnButtonTwoshort() 
{
	SetB2Short();
}

void DStreamPts::OnButtonOneshort() 
{
	SetB1Short();
}

void DStreamPts::OnDefault() 
{
	UpdateData(TRUE);
	app.saarm.Data.Group = Group;
	app.saarm.Data.Target = Target;
	app.pA->SetDisplayData();
}

void DStreamPts::OnBnClickedIncg()
{
	app.pA->IncrementName(app.saarm.Data.Group, 1);
}

void DStreamPts::OnBnClickedInct()
{
	app.pA->IncrementName(app.saarm.Data.Target, app.saarm.Data.ptnameinc);
	app.pA->SetDisplayData();
}


void DStreamPts::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if(app.saarm.units.toolBarModeOn && app.pA->ConnectedToArm)
		ShowWindow(SW_MINIMIZE); //SW_HIDE
	else if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DStreamPts"),this);
}

void DStreamPts::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DStreamPts"),this);

	DGenMeas::OnDestroy();
}