// DStreamPtsSettings.cpp : implementation file
//

#include "stdafx.h"
#include "DPCMM.h"
#include "DStreamPtsSettings.h"


// DStreamPtsSettings dialog

IMPLEMENT_DYNAMIC(DStreamPtsSettings, CDialog)

DStreamPtsSettings::DStreamPtsSettings(CWnd* pParent /*=NULL*/)
	: CDialog(DStreamPtsSettings::IDD, pParent)
	, scan_spatial(FALSE)
	, scan_spatial_inc(0)
	, unitsLabel(_T(""))
{

}

DStreamPtsSettings::~DStreamPtsSettings()
{
}

void DStreamPtsSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RADIO_STREAM_PTS_TEMPORAL, scan_spatial);
	DDX_Text(pDX, IDC_EDIT_SPAT_INC, scan_spatial_inc);
	DDX_Text(pDX, IDC_UNIT3STATIC, unitsLabel);
}


BEGIN_MESSAGE_MAP(DStreamPtsSettings, CDialog)
	ON_BN_CLICKED(IDC_RADIO_STREAM_PTS_TEMPORAL, &DStreamPtsSettings::OnBnClickedRadioStreamPtsTemporal)
	ON_BN_CLICKED(IDC__STREAM_PTS_SPATIAL, &DStreamPtsSettings::OnBnClickedRadioStreamPtsSpatial)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// DStreamPtsSettings message handlers

BOOL DStreamPtsSettings::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);
	TRANSLATE_DIALOG;

	UpdateData(FALSE);

	CheckSpatRadioStatus();

	::SetWindowPos(m_hWnd,HWND_TOPMOST,300,300,50,50,SWP_NOSIZE + SWP_NOMOVE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void DStreamPtsSettings::OnBnClickedRadioStreamPtsTemporal()
{
	GetDlgItem(IDC_EDIT_SPAT_INC)->EnableWindow(FALSE);
}

void DStreamPtsSettings::OnBnClickedRadioStreamPtsSpatial()
{
	GetDlgItem(IDC_EDIT_SPAT_INC)->EnableWindow();
}

void DStreamPtsSettings::CheckSpatRadioStatus()
{
	if(scan_spatial)
		GetDlgItem(IDC_EDIT_SPAT_INC)->EnableWindow();
	else
		GetDlgItem(IDC_EDIT_SPAT_INC)->EnableWindow(FALSE);
}

void DStreamPtsSettings::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DStreamPtsSettings"),this);	
}

void DStreamPtsSettings::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DStreamPtsSettings"),this);

	CDialog::OnDestroy();
}