// DTheoMeas.cpp : implementation file
//

#include "stdafx.h"
#include "nrkapp.h"
#include "DTheoMeas.h"
#include "fit\\FitLine.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DTheoMeas dialog


DTheoMeas::DTheoMeas(CWnd* pParent /*=NULL*/)
	: DGenMeas(DTheoMeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(DTheoMeas)
	m_SampleText = _T("");
	m_SampleText2 = _T("");
	//}}AFX_DATA_INIT
	RadioXYZ = 0;
	Val = 0.0;
	First = TRUE;
	LastButtonHit = 0;
	Line = 1;
	MaxErr = 0;
	RMSErr = 0;
}

void DTheoMeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DTheoMeas)
	DDX_Control(pDX, IDOK, OKButton);
	DDX_Control(pDX, IDC_BUTTON_TWOSHORT2, B2short_button);
	DDX_Control(pDX, IDC_BUTTON_TWOLONG2, B2long_button);
	DDX_Control(pDX, IDC_BUTTON_ONELONG, B1long_button);
	DDX_Control(pDX, IDC_BUTTON_ONESHORT2, B1short_button);
	DDX_Text(pDX, IDC_SAMPLES, m_SampleText);
	DDX_Text(pDX, IDC_SAMPLES2, m_SampleText2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DTheoMeas, DGenMeas)
	//{{AFX_MSG_MAP(DTheoMeas)
	ON_BN_CLICKED(IDC_BUTTON_ONELONG, OnButtonOnelong)
	ON_BN_CLICKED(IDC_BUTTON_ONESHORT2, OnButtonOneshort)
	ON_BN_CLICKED(IDC_BUTTON_TWOLONG2, OnButtonTwolong)
	ON_BN_CLICKED(IDC_BUTTON_TWOSHORT2, OnButtonTwoshort)
	//}}AFX_MSG_MAP
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DTheoMeas message handlers
BOOL DTheoMeas::Init() 
{
	if(!app.pA->ConnectedToArm)
	{
		B1long_button.ShowWindow(SW_SHOW);
		B1short_button.ShowWindow(SW_SHOW);
		B2long_button.ShowWindow(SW_SHOW);
		B2short_button.ShowWindow(SW_SHOW);
	}
	sendfromdlg = TRUE;
	OKButton.EnableWindow(FALSE);
	m_SampleText.Format(_T("%d Points Recorded"),0);
	m_SampleText2.Format(_T("%d Points Recorded"),0);
	app.saarm.TTS.TextToSpeech(_T("Scan First Line"));
//	RefGroup = m_Group;
//	RefTarget = m_Target;

	DGenMeas::Init();	// call Base class Init for translation, etc.

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL DTheoMeas::ProcessNewData(int inc)
{
//	TRACE("First = %d\n"),First);
	Vector Current(app.pA->X,app.pA->Y,app.pA->Z); //in meters
	Vector currNorm(app.pA->II, app.pA->JJ, app.pA->KK);
	GenVec currJts = app.pA->J;
	Vector CurrWork;
	app.saarm.InstToWorking.Multiply(Current,&CurrWork);
	if(First)
	{
		First = FALSE;
		LastPointWork = CurrWork;
		return TRUE;
	}

	//PauseMeasTimer();
	//eval_message.SetWindowText(_T("Evaluating Plane Cross, Please Wait."));

	//do the test in working in meters
	Vector ResultWork;
	if(PlaneCross(LastPointWork,CurrWork,Val,RadioXYZ,&ResultWork))
	{
		//they did cross!
		//so map back to romer
//		m_Group = RefGroup;
//		m_Target = RefTarget + "Pt1";
		Vector ResultArm;
		Transform WorkingToArm;
		app.saarm.InstToWorking.Invert(&WorkingToArm);
		WorkingToArm.Multiply(ResultWork,&ResultArm);
//		Vector ResultRomerInch(ResultArm);
//		ResultRomerInch.Scale(1.0/pRomerDlg->InchesToMeters);
//		if(Line==1)
//			Sect1.P.Add(new Vector(ResultRomerInch));
//		else
//			Sect2.P.Add(new Vector(ResultRomerInch));
		ArmPoint aPt(ResultArm, currNorm, currJts);
		app.pA->DataArray[app.pA->StepIndex]->Add(aPt);
		app.pA->X = ResultArm.x;
		app.pA->Y = ResultArm.y;
		app.pA->Z = ResultArm.z;
		app.pA->MeasToSpan(ResultArm);
//		m_Group = pRomerDlg->GroupName;
//		m_Target = pRomerDlg->TargetName;

//		pRomerDlg->Beep(REC_OK);
	}
	UpdateFields();
	LastPointWork = CurrWork;
	//eval_message.SetWindowText(_T(""));
	//ResumeMeasTimer();
	return TRUE;
}



void DTheoMeas::UpdateFields()
{
	m_SampleText.Format(_T("%d Points Recorded"),app.pA->DataArray[0]->P.GetSize());
	OKButton.EnableWindow(TRUE);
	if(app.pA->DataArray.GetSize() > 1)
	{
		OKButton.SetWindowText(_T("Done"));
		m_SampleText2.Format(_T("%d Points Recorded"),app.pA->DataArray[1]->P.GetSize());
	}
	UpdateData(FALSE);
}


void DTheoMeas::OnOK() 
{
	ProcessAccept();
}

BOOL DTheoMeas::LineFit(Vector* Begin,Vector* End, double* MaxError, double* RMSError)
{
	//Note DataPoints in Arm Coords in INCHES//
	//     Begin and End are in Arm Coords in INCHES//
	OptimizationParameters opt;		// could be global for app.

	FitLine fl;
	VectorArray pts;
	if(app.pA->DataArray[app.pA->StepIndex]->GetVectorArrayofPoints(pts) <= 0)
		return FALSE;
	fl.pPoints = &pts;
	fl.pOpt = &opt;

	if (!fl.Calculate())
		return FALSE;

	*Begin = fl.A;
	*End = fl.B;
	// BOB --- need to get the error values from the fitline class... just add whatever you need.

//	pDataPoints->Clear(); // jmc - seems dangerous
	return TRUE;
}


void DTheoMeas::ProcessAccept()
{
	CString NameBase;
	Vector Result;
	if(app.saarm.Data.geomName.IsEmpty())
	{
		NameBase.Format(_T("%s_%s"), app.saarm.Data.Group, app.saarm.Data.Target);
	}
	else
	{
		NameBase = app.saarm.Data.geomName;
		app.pA->IncrementName(app.saarm.Data.geomName);
	}
	if(Line==1)
	{
		if(app.pA->DataArray[0]->P.GetSize()<2)
			return;
		Line++;
		app.saarm.TTS.TextToSpeech(_T("Scan Second Line"));
		DGenMeas::ProcessAccept();
		return;
	}
	else
	{
		if(app.pA->DataArray[1]->P.GetSize()<2)
			return;
		//theapp.saarm.TTS.TextToSpeech("Computing Theoretical Point"));
		LineFit(&A1,&B1,&MaxErr,&RMSErr);
		LineFit(&A2,&B2,&MaxErr,&RMSErr);
		ComputeTheoPoint(&Result);
//		pRomerDlg->GroupName  = RefGroup;
//		pRomerDlg->TargetName = RefTarget;
		app.pA->X = Result.x;
		app.pA->Y = Result.y;
		app.pA->Z = Result.z;

		CString axis;
		if(RadioXYZ == 0)
			axis = _T("X-Axis");
		else if(RadioXYZ == 1)
			axis = _T("Y-Axis");
		else if(RadioXYZ == 2)
			axis = _T("Z-Axiz");
		
		CString cs1, cs2;
		cs1.Format(_T("Theoretical Point"));
		cs2.Format(_T("%s = %f"),axis,Val);
		app.saarm.Data.measCommentArray.RemoveAll();
		app.saarm.Data.measCommentArray.Add(cs1);
		app.saarm.Data.measCommentArray.Add(cs2);
		
		app.pA->MeasToSpan(Result, true, false, false);

//		PostResults();
		//send line to SA 
		notes.RemoveAll();
		name.Format(_T("%s_LineA"),NameBase);
		notes.Add(_T("Line From ") + app.saarm.CMMString + _T(" Theoretical Point"));
		app.saarm.SockGeom.SendLine(A1,B1,FALSE,name,notes);
//		PostResults();
		//send line to SA 
		notes.RemoveAll();
		name.Format(_T("%s_LineB"),NameBase);
		notes.Add(_T("Line From") + app.saarm.CMMString + _T(" Theoretical Point"));
		app.saarm.SockGeom.SendLine(A2,B2,FALSE,name,notes);
	}
	
	app.saarm.TTS.TextToSpeech(_T("Theoretical Point Measurement ended"));
	DGenMeas::OnOK();
}

BOOL DTheoMeas::ComputeTheoPoint(Vector* Result)
{

	//B2 = *Sect2.P[Sect2.GetUpperBound()];
	//A2 = Sect2[0];
	//B1 = Sect1[Sect1.GetUpperBound()];
	//A1 = Sect1[0];
	//Make Ref direction vectors
	Vector G1(B2);
	G1.Sub(A1);
	G1.Normalize();
	
	Vector G2(B1);
	G2.Sub(A2);
	G2.Normalize();

	Vector V1(B1);
	V1.Sub(A1);
	V1.Normalize();
	if(V1.Dot(G1)<0.0)
		V1.Scale(-1.0);
	
	Vector V2(B2);
	V2.Sub(A2);
	V2.Normalize();
	if(V2.Dot(G2)<0.0)
		V2.Scale(-1.0);

	//Now Both Vectors Point to the Edge

	
	Vector Edge;
	double ang;
	Edge.Cross(V1,V2,&ang);
	Edge.Normalize();
	Vector V1Shift;
	V1Shift.Cross(V1,Edge,&ang);
	V1Shift.Normalize();
	if(V1Shift.Dot(V2)>0.0)
		V1Shift.Scale(-1.0);
	V1Shift.Scale(app.saarm.Data.TipDia/2.0);
	
	Vector V2Shift;
	V2Shift.Cross(V2,Edge,&ang);
	V2Shift.Normalize();
	if(V2Shift.Dot(V1)>0.0)
		V2Shift.Scale(-1.0);
	V2Shift.Scale(app.saarm.Data.TipDia/2.0);

	A1.Add(V1Shift);
	B1.Add(V1Shift);
	A2.Add(V2Shift);
	B2.Add(V2Shift);
	
	Ray R1;
	R1.StartPoint = A1;
	R1.Normal = V1;

	Ray R2;
	R2.StartPoint = A2;
	R2.Normal = V2;

	double dist;
	dist = R1.RayCompare(R1,R2,Result);
	
	
	return TRUE;
}


BOOL DTheoMeas::PlaneCross(Vector& P1,Vector& P2,double& Val,int XYorZ, Vector* Result)
{
	// P1 in ? in working
	// P2 in ? in working
	// val in ?  in working, obviuosly
	// XYorZ = 0 for X
	// XYorZ = 1 for Y
	// XYorZ = 2 for Z
	// Result in ? in working
	
	
	//mask out all but one axis
	Vector DirMask,Origin;
	if(XYorZ==0)
		DirMask = Vector(1.0,0.0,0.0);
	else if(XYorZ==1)
		DirMask = Vector(0.0,1.0,0.0);
	else if(XYorZ==2)
		DirMask = Vector(0.0,0.0,1.0);
	else
		return FALSE;
	
	double d1 = 0.0;
	double d2 = 0.0;
	d1 = P1.Dot(DirMask)-Val;
	d2 = P2.Dot(DirMask)-Val;

//	if(pRomerDlg->SectionSound)
//		pRomerDlg->SquealError(fabs(d1));	
	
	if((d1*d2)>0.0) //their on the same side
		return FALSE;
	// now we know we have a crossing interpolate
	
	double delta = 0.0;
	if((fabs(d1)+fabs(d2))>0.00001)
		delta = fabs(d1)/(fabs(d1)+fabs(d2));
	Vector Del(P2);
	Del.Sub(P1);
	Del.Scale(delta);
	Vector Ans(P1);
	Ans.Add(Del);
//	TRACE("P1 = %f %f %f\n"),P1.x,P1.y,P1.z);
//	TRACE("P2 = %f %f %f\n"),P2.x,P2.y,P2.z);
//	TRACE("Ans = %f %f %f\n"),Ans.x,Ans.y,Ans.z);
	*Result = Ans;
	return TRUE;
}

//////////////////////////////////////////////////////////////
// sim. mode
BOOL DTheoMeas::MakeFakeData(int step)
{
	if(app.StopNow)
		return FALSE;

	if(RadioXYZ==0)
	{
		app.pA->X = Val;
		app.pA->Y = ((double)rand())/((double)RAND_MAX);
		app.pA->Z = ((double)rand())/((double)RAND_MAX);
	}
	else if(RadioXYZ==1)
	{
		app.pA->X = ((double)rand())/((double)RAND_MAX);
		app.pA->Y = Val;
		app.pA->Z = ((double)rand())/((double)RAND_MAX);
	}
	else if(RadioXYZ==2)
	{
		app.pA->X = ((double)rand())/((double)RAND_MAX);
		app.pA->Y = ((double)rand())/((double)RAND_MAX);
		app.pA->Z = Val;
	}
	else
		return FALSE;

	app.pA->CurrentTransform.SetTranslation(Vector(app.pA->X, app.pA->Y, app.pA->Z));

	return TRUE;
}

void DTheoMeas::OnButtonOnelong() 
{
	SetB1Long();
}

void DTheoMeas::OnButtonTwolong() 
{
	SetB2Long();
}

void DTheoMeas::OnButtonTwoshort() 
{
	SetB2Short();
}

void DTheoMeas::OnButtonOneshort() 
{
	SetB1Short();
}

/*
BOOL DTheoMeas::CheckButton(int but)
{
	if(RDS_IsButtonNDown(but))
	{
		//any hit will immediately process
		ProcessButtonHit(but,BUTTON_SHORT);
	}
	else
		return FALSE;
	return TRUE;
}

void DTheoMeas::ProcessButtonHit(int Button, int Duration) 
{
	UpdateData(TRUE);
	pRomerDlg->GroupName = m_Group;
	pRomerDlg->TargetName = m_Target;
	TRACE("Button = %d     Last = %d\n"),Button,LastButtonHit);
	if(Button==0)
	{
		if(!First)
			ProcessAccept();
		First = TRUE;
	}

	if(Button==LastButtonHit)
		Duration = BUTTON_LONG; //it's a repeat
	switch(Button)
	{
	case 1:
		{
			ButtonHit(pRomerDlg->ButtonOneMode,Duration);
			break;
		}
	case 2:
		{
			ButtonHit(pRomerDlg->ButtonTwoMode,Duration);
			break;
		}
	case 3:
		{
			ButtonHit(pRomerDlg->ButtonThreeMode,Duration);
			break;
		}
	default:
		{
			//just update the graphics
			pRomerDlg->UpdateSpan();
			//ProcessUpdate();	
		}
	}
	LastButtonHit = Button;
}


void DTheoMeas::ButtonHit(int Mode,int BDuration) 
{
	if((pRomerDlg->MouseButtonBlock)&&!((Mode==BACKUP_MOUSE)&&(BDuration==BUTTON_LONG)))
		return;
	switch(Mode)
	{
	case NOTHING:			//do nothing but update graphics
		{
			pRomerDlg->UpdateSpan();
			//ProcessUpdate();
			break;
		}
	case RECORD_ACCEPT:			//single point
		{
			pRomerDlg->UpdateSpan();
			ProcessUpdate();
			break;
		}
	case BACKUP_MOUSE:
		{
			ProcessCancel();
			break;
		}
	case BACKUP_CANCEL:
		{
			ProcessCancel();
			break;
		}
		
	default:
		{
			pRomerDlg->UpdateSpan();
			//ProcessUpdate();
		}
	}
}
*/

void DTheoMeas::OnShowWindow(BOOL bShow, UINT nStatus)
{
	DGenMeas::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"),_T("SA_Arms_DTheoMeas"),this);	
}

void DTheoMeas::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"),_T("SA_Arms_DTheoMeas"),this);

	DGenMeas::OnDestroy();
}