#ifndef _DATA_STORE_H
#define _DATA_STORE_H

// Data Storage class defintitions

class PlaneObj;
class KreonProbeCalibrations;
class ConeFit;

class Store : public CObject
{
public:
	Store();
	~Store();
	void Clear();

	BYTE LoadSchema;

	PlaneObj& sheetMetalPlane;
	bool sm_planeSet;

	CString SAComputer;
	CString SAName;
	CString UserName;
	int SAPort;
	int CommPort;
	CString	Target;
	CString	Group;
	CString Collection;
	CString geomName;
	CString MeasComments;
	CStringArray measCommentArray;
	int ButtonOneMode;
	int ButtonTwoMode;
	int ButtonThreeMode;
	//>>SA Toolbar
	//int buttonOneToolbar;
	//int buttonTwoToolbar;
	//int buttonThreeToolbar;
	int buttonOneMain;
	int buttonTwoMain;
	int buttonThreeMain;
	//<<SA Toolbar
	int TargetNameStartNumber;
	double TipDia;
	BOOL AutoDetectProbe;
	BOOL NoSound;
	BOOL ComputerSound;
	CString defaultsfile;
	CString PathToDataFiles;
	CString TName;
	CString TNumber;
	CString GName;
	CString GNumber;
	BOOL GuideToPatchPoints;
	int DisplayUnits;
	double Interval;
	int SpkrVolume;
	double MEProximity;
	double GoodProximity;
	double proxWorkingField;
	bool useScannerForAutoProxMeas;
	bool useShankForAutoProxMeas;
	double shankRadius;
	BOOL GuideSound;
	BOOL SectionSound;
	int Precision;
	BOOL alwaysupdateSA;

	UINT QueryRate;
	UINT FrameQueryRate;
	BOOL FrameRequest;
	BOOL DoRealTimeGraphics;
//	BOOL ContQueryMode;
	BOOL FirePointsToo;
	BOOL SendGeom;	// 2001.12.04
	BOOL sendAllPtsAsCloudPts;	// 2007.08.17
	int SlackCount;
	BOOL AddExtraPatchShift;
	double ExtraPatchShift;

	BOOL LockSpheres;
	double SphereLockVal;
	BOOL LockCircles;
	double CircleLockVal;

	double SphereTol;
	double CircleTol;
	double PlaneTol;

	int inoutface;	// circle meas

	double meastimerperiodsec;
	double updatetimerperiodsec;
	double PDAtimerperiodsec;

	BOOL doconnection;

	int ptnameinc;	// 2003.02.11
	BOOL incrementgroup;

	BOOL scan_spatial;	// 2003.11.17
	double scan_spatial_inc;

	int avgPointSamples;

	// Faro Specific Serial comm stuff////////////////////////////
	UINT CommBaud;
	int commParams; // parity, data bits, stop bits

	// Faro Only
	BOOL FaroAuxOn;
	// mouse mode
	int mouseGain;
	BOOL backButtonCentersMouse;

	// line scanner
	double scannerTimerPeriodSec;
	BOOL autoIncCloudName;
	int thinningFactor;	// 2006.03.02 - applied once data reaches us - i.e. mfcr setting is ALSO used

	// added offset line (sheet metal), but kept probe center line
	int lineMeasType;
	PlaneObj& ds_plane;
	bool ds_planeSet;

	PlaneObj& singlePtPlane;
	bool singlePtPlaneSet;

	int measmode;

	// 2006.12.05 - for SA graphic model auto-update
	BOOL autoCorrectModel;

	// 2007.04.12 - sa update joint threshold
	double jtUpdateThreshold;	// degrees

	// 2008.06.18 - start up meas mode option
	BOOL startupInMeasMode;
	int startupMeasMode;

	// 2009.04.07 - API_Baces (Axxis) specific settings
	int apiBacesComPort;
	CString apiBacesParamPath;
	
	// 2009.04.27 - Kreon Scanner Arm settings
	Transform kreonScannerCalMatrix;
	KreonProbeCalibrations& KreonProbeCals;

	double scaleFromInstBase;	// keep this around to keep track of when scale changes - so we can clear the intrinsic reference planes
	void InvalidateReferencePlanes();

	// 2010.02.26 - first intro of GeomFitDLL into arm interface
	ConeFit &cf;

	bool controlPadEnabled;

	bool useScanStripeClouds;	// 2016.06.30 - added option so user can go back to original pt. cloud format for when they don't need meshing but need max. performance

	// 2020.04.03 - voxelize before sending to SA
	bool voxelizationEnabled;
	double voxelSize; // inches
	int minPtsPerVoxel;
	UINT minCloudPtsToVoxelize;

	void Serialize(CArchive& ar);

protected:   
	DECLARE_SERIAL( Store );
};

#endif
