// FaroArm.h: interface for the Faro class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAROARM_H__BDF10A56_9154_4CE5_BC7D_B1EC094DA94E__INCLUDED_)
#define AFX_FAROARM_H__BDF10A56_9154_4CE5_BC7D_B1EC094DA94E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ArmBase.h"

class FaroArm : public ArmBase  
{
public:
	FaroArm();
	virtual ~FaroArm();

	DWORD buttontime;
	BOOL LongDown;

	virtual bool ConnectToArm(const int dof);
	virtual bool PopCommSettingsDlg();
	virtual BOOL DisconnectFromHardware();
	virtual BOOL GetAllData();
	virtual BOOL GetPos();
	virtual BOOL GetJoints(bool simulate=true);
	virtual int GetButtonStates();
	virtual BOOL CheckButton(int but, int* duration);
	virtual BOOL GetTemp();
	virtual int GetProbeNumber();
	virtual int GetButtonCount();

	virtual BOOL IsRomer();
	virtual BOOL IsFaro();
	virtual BOOL IsFaroUSB();
	virtual BOOL IsFrenchRomer();
	virtual BOOL IsSNL();
	virtual BOOL IsMetrisGarda();

	virtual BOOL ProcessButtonsandUpdatePacket(JointPacket* Data);	// serial data, see JtPak.h
	virtual BOOL ProcessXYZIJKPacket(IJKPacket* Data);	// other serial data, see JtPak.h
	virtual void ToggleArmButtonBeep();
	virtual void SetAuxPort(BOOL on);

	// 2004.08.30 - mouse mode!
	virtual BOOL IsRemoteMouseEnabled();
	virtual void ToggleRemoteMouse();
	virtual void RemoteMouse(BOOL flag);
	virtual void DoArmSettings();
private:
	BOOL mouseModeOn;
	Vector FaroCoord, oldFaroCoord;

	bool leftWasDown, rightWasDown;
};

#endif // !defined(AFX_FAROARM_H__BDF10A56_9154_4CE5_BC7D_B1EC094DA94E__INCLUDED_)
