#pragma once
#include "afxwin.h"
#include "FaroScannerAPI.h"
#include "../FaroUSBArm.h"

// this class added for FaroUSB scanner support in their SDK v. 5 BETA
// dual derived because I may make this a scan line control, where the user can see the current scan line in a dialog which owns this in the form of a picture control
// for now, just using the virtual OnPositionSampled from Faro's CDataCaptureCallBack class...
class FaroUSBCallBack : public CStatic, CDataCaptureCallBack
{
public:
	FaroUSBCallBack(FaroUSBArm& _parent);
	virtual ~FaroUSBCallBack(void);

	// Overrides
	virtual void OnPositionSampled(const CScanData& ScanData);
	virtual void OnPositionChanged(const CScanData& ScanData);
	virtual void OnStart();	// 2016.03.29 - added for meshing - need to know when to start/stop mesh based on scan passes
	virtual void OnEnd();	// 2016.03.29 - added for meshing - need to know when to start/stop mesh based on scan passes

	// Generated message map functions
protected:
	FaroUSBArm& parent;
	CriticalSectionWrapper& scannerCS;
	//{{AFX_MSG(CPreviewWnd)
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

// 2016.05.13 - added this class in order to create ScanStarted and ScanStopped events for ScanStripeClouds - HOWEVER, it does not work as hoped. We get arm button STATUS, not events from this. So it would get nasty to try and make this into a scan pass started/stopped event producer
class FaroUSBRawEvents : public CDeviceRawEventCallBack
{
public:
	FaroUSBRawEvents(FaroUSBArm& _parent);
	virtual ~FaroUSBRawEvents(void);

	// Overrides
	virtual void OnDeviceRawEvent(const CScanData& ScanData, const BUTTON_STATUS& eButtonStatus );

protected:
	FaroUSBArm& parent;
};
