// ScannerControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "../../DPCMM.h"
#include "../../FaroUSBArm.h"
#include "ScannerControlDlg.h"

// CScannerControlDlg dialog

IMPLEMENT_DYNAMIC(CScannerControlDlg, CDialog)

CScannerControlDlg::CScannerControlDlg(FaroUSBArm& _arm)
: arm(_arm)
{

}

CScannerControlDlg::~CScannerControlDlg()
{
}

void CScannerControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScannerControlDlg)
	//DDX_Control(pDX, IDC_STATIC_PREVIEW, m_PreviewWnd);
	DDX_Control(pDX, IDC_SLIDER_WIDTH_THRESOLD, m_SliderWidthThreshold);
	DDX_Control(pDX, IDC_SLIDER_NOISE_THRESHOLD, m_SliderNoiseThreshold);
	DDX_Control(pDX, IDC_SLIDER_HIGH_THRESOLD, m_SliderHighThresold);
	DDX_Control(pDX, IDC_SLIDER_EXPOSURE, m_SliderExposure);
	DDX_Control(pDX, IDC_COMBO_ALGORITHM, m_ComboAlgorithm);
	DDX_Control(pDX, IDC_COMBO_SCAN_DENSITY, m_ComboScanDenisty);
	DDX_Control(pDX, IDC_COMBO_SCAN_RATE, m_ComboScanRate);
	DDX_Text(pDX, IDC_EDIT_EXPOSURE, m_nExposure);
	DDV_MinMaxInt(pDX, m_nExposure, 1, 100);
	DDX_Text(pDX, IDC_EDIT_HIGH_THRESOLD, m_nHighThresold);
	DDV_MinMaxInt(pDX, m_nHighThresold, 0, 255);
	DDX_Text(pDX, IDC_EDIT_NOISE_THRESOLD, m_nNoiseThresold);
	DDV_MinMaxInt(pDX, m_nNoiseThresold, 0, 255);
	DDX_Text(pDX, IDC_EDIT_WIDTH_THRESHOLD, m_nWidthThresold);
	DDV_MinMaxInt(pDX, m_nWidthThresold, 0, 10);
	DDX_CBString(pDX, IDC_COMBO_ALGORITHM, m_strAlgorithm);
	DDX_CBString(pDX, IDC_COMBO_SCAN_DENSITY, m_strScanDensity);
	DDX_CBString(pDX, IDC_COMBO_SCAN_RATE, m_strScanRate);
	DDX_Check(pDX, IDC_CHECK_LASER_ON, m_bLaserOn);
	DDX_Check(pDX, IDC_CHECK_SHOW_COG, m_bShowCOG);
	DDX_Check(pDX, IDC_CHECK_SHOW_RAW_IMAGE, m_bShowRawImage);
	DDX_Check(pDX, IDC_CHECK_SHOW_RANGE_FINDER, m_bShowRangeFinder);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScannerControlDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_LASER_ON, &CScannerControlDlg::OnBnClickedCheckLaserOn)
	ON_BN_CLICKED(IDC_CHECK_SHOW_COG, &CScannerControlDlg::OnBnClickedCheckShowCog)
	ON_BN_CLICKED(IDC_CHECK_SHOW_RAW_IMAGE, &CScannerControlDlg::OnBnClickedCheckShowRawImage)
	ON_BN_CLICKED(IDC_CHECK_SHOW_RANGE_FINDER, &CScannerControlDlg::OnBnClickedCheckShowRangeFinder)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_EXPOSURE, &CScannerControlDlg::OnNMReleasedcaptureSliderExposure)
	ON_CBN_SELCHANGE(IDC_COMBO_ALGORITHM, &CScannerControlDlg::OnCbnSelchangeComboAlgorithm)
	ON_CBN_SELCHANGE(IDC_COMBO_SCAN_RATE, &CScannerControlDlg::OnCbnSelchangeComboScanRate)
	ON_CBN_SELCHANGE(IDC_COMBO_SCAN_DENSITY, &CScannerControlDlg::OnCbnSelchangeComboScanDensity)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_HIGH_THRESOLD, &CScannerControlDlg::OnNMReleasedcaptureSliderHighThresold)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_NOISE_THRESHOLD, &CScannerControlDlg::OnNMReleasedcaptureSliderNoiseThreshold)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_WIDTH_THRESOLD, &CScannerControlDlg::OnNMReleasedcaptureSliderWidthThresold)
	ON_EN_CHANGE(IDC_EDIT_EXPOSURE, &CScannerControlDlg::OnEnChangeEditExposure)
	ON_EN_CHANGE(IDC_EDIT_HIGH_THRESOLD, &CScannerControlDlg::OnEnChangeEditHighThresold)
	ON_EN_CHANGE(IDC_EDIT_NOISE_THRESOLD, &CScannerControlDlg::OnEnChangeEditNoiseThresold)
	ON_EN_CHANGE(IDC_EDIT_WIDTH_THRESHOLD, &CScannerControlDlg::OnEnChangeEditWidthThreshold)
END_MESSAGE_MAP()


// CScannerControlDlg message handlers

BOOL CScannerControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CStringArray arrAlgorithms;
	CStringArray arrScanDensities;
	CStringArray arrScanRates;
	arm.GetAvailableAlgorithms(arrAlgorithms);
	arm.GetAvailableScanDensities(arrScanDensities);
	arm.GetAvailableScanRates(arrScanRates);

	arm.SetLineScannerEnabled(TRUE);
	arm.GetLineScannerTransformation(m_ProbeData);
	arm.GetCameraInfo(m_ProbeData);

	m_bLaserOn = m_ProbeData.m_nScanLaserOn;
	m_bShowCOG = m_ProbeData.m_nScanFrameMode;// & COG_MODE;
	m_bShowRawImage = m_ProbeData.m_nScanFrameMode;// & IMAGE_MODE;
	m_strAlgorithm = m_ProbeData.m_strScanAlgorithm;
	m_strScanDensity = m_ProbeData.m_strScanDensity;
	m_strScanRate = m_ProbeData.m_strScanRate;
	m_nExposure = m_ProbeData.m_nScanExposure;
	m_nNoiseThresold = m_ProbeData.m_nScanNoiseThreshold;
	m_nHighThresold = m_ProbeData.m_nScanPeakThreshold;
	m_nWidthThresold = m_ProbeData.m_nScanWidthThreshold;

	for(INT_PTR i=0; i<arrAlgorithms.GetSize(); i++)
	{
		m_ComboAlgorithm.AddString(arrAlgorithms.GetAt(i));
	}

	for(INT_PTR i=0; i<arrScanDensities.GetSize(); i++)
	{
		m_ComboScanDenisty.AddString(arrScanDensities.GetAt(i));
	}
	m_ComboScanDenisty.SetCurSel(0);

	for(INT_PTR i=0; i<arrScanRates.GetSize(); i++)
	{
		m_ComboScanRate.AddString(arrScanRates.GetAt(i));
	}
	m_ComboScanRate.SetCurSel(0);

	m_SliderExposure.SetRange(1, 100);
	m_SliderExposure.SetPos(m_nExposure);
	m_SliderNoiseThreshold.SetRange(0, 255);
	m_SliderNoiseThreshold.SetPos(m_nNoiseThresold);
	m_SliderHighThresold.SetRange(0, 255);
	m_SliderHighThresold.SetPos(m_nHighThresold);
	m_SliderWidthThreshold.SetRange(0, 10);
	m_SliderWidthThreshold.SetPos(m_nWidthThresold);

	arm.GetRangeFinderEnabled(m_bShowRangeFinder);

	//if(app.saarm.units.toolBarModeOn)
		::SetWindowPos(m_hWnd,HWND_TOPMOST,300,300,50,50,SWP_NOSIZE + SWP_NOMOVE);

	UpdateData(FALSE);


	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CScannerControlDlg::OnBnClickedCheckLaserOn()
{
	UpdateData(TRUE);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanLaserOn = m_bLaserOn;
	arm.SetCameraInfo(m_ProbeData);
}

void CScannerControlDlg::OnBnClickedCheckShowCog()
{
	//UpdateData(TRUE);
	//arm.GetCameraInfo(m_ProbeData);
	//if(m_bShowCOG)
	//{
	//	m_ProbeData.m_nScanFrameMode = m_ProbeData.m_nScanFrameMode;// | COG_MODE;
	//}
	//else
	//{
	//	m_ProbeData.m_nScanFrameMode = m_ProbeData.m_nScanFrameMode;// & (~COG_MODE);
	//}
	//arm.SetCameraInfo(m_ProbeData);
	//m_PreviewWnd.m_bShowCOG = m_bShowCOG;
}

void CScannerControlDlg::OnBnClickedCheckShowRawImage()
{
	// TODO: Add your control notification handler code here
}

void CScannerControlDlg::OnBnClickedCheckShowRangeFinder()
{
	UpdateData(TRUE);
	arm.SetRangeFinderEnabled(m_bShowRangeFinder);
}

void CScannerControlDlg::OnCbnSelchangeComboAlgorithm()
{
	UpdateData(TRUE);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_strScanAlgorithm = m_strAlgorithm;
	arm.SetCameraInfo(m_ProbeData);	
}

void CScannerControlDlg::OnCbnSelchangeComboScanRate()
{
	UpdateData(TRUE);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_strScanRate = m_strScanRate;
	arm.SetCameraInfo(m_ProbeData);	
}

void CScannerControlDlg::OnCbnSelchangeComboScanDensity()
{
	UpdateData(TRUE);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_strScanDensity = m_strScanDensity;
	arm.SetCameraInfo(m_ProbeData);	
}

void CScannerControlDlg::OnNMReleasedcaptureSliderExposure(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_nExposure = m_SliderExposure.GetPos();
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanExposure = m_nExposure;
	arm.SetCameraInfo(m_ProbeData);
	UpdateData(FALSE);
	*pResult = 0;
}


void CScannerControlDlg::OnNMReleasedcaptureSliderHighThresold(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_nHighThresold = m_SliderHighThresold.GetPos();
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanPeakThreshold = m_nHighThresold;
	arm.SetCameraInfo(m_ProbeData);
	UpdateData(FALSE);
	*pResult = 0;
}

void CScannerControlDlg::OnNMReleasedcaptureSliderNoiseThreshold(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_nNoiseThresold = m_SliderNoiseThreshold.GetPos();
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanNoiseThreshold = m_nNoiseThresold;
	arm.SetCameraInfo(m_ProbeData);
	UpdateData(FALSE);
	*pResult = 0;
}

void CScannerControlDlg::OnNMReleasedcaptureSliderWidthThresold(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_nWidthThresold = m_SliderWidthThreshold.GetPos();
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanWidthThreshold = m_nWidthThresold;
	arm.SetCameraInfo(m_ProbeData);
	UpdateData(FALSE);
	*pResult = 0;
}

void CScannerControlDlg::OnEnChangeEditExposure()
{
	UpdateData(TRUE);
	m_SliderExposure.SetPos(m_nExposure);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanExposure = m_nExposure;
	arm.SetCameraInfo(m_ProbeData);
}

void CScannerControlDlg::OnEnChangeEditHighThresold()
{
	UpdateData(TRUE);
	m_SliderHighThresold.SetPos(m_nHighThresold);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanPeakThreshold = m_nHighThresold;
	arm.SetCameraInfo(m_ProbeData);
}

void CScannerControlDlg::OnEnChangeEditNoiseThresold()
{
	UpdateData(TRUE);
	m_SliderNoiseThreshold.SetPos(m_nNoiseThresold);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanNoiseThreshold = m_nNoiseThresold;
	arm.SetCameraInfo(m_ProbeData);
}

void CScannerControlDlg::OnEnChangeEditWidthThreshold()
{
	UpdateData(TRUE);
	m_SliderWidthThreshold.SetPos(m_nWidthThresold);
	arm.GetCameraInfo(m_ProbeData);
	m_ProbeData.m_nScanWidthThreshold = m_nWidthThresold;
	arm.SetCameraInfo(m_ProbeData);
}
