#pragma once

#include "../ProbeData.h"

class FaroUSBArm;

// CScannerControlDlg dialog

class CScannerControlDlg : public CDialog
{
	DECLARE_DYNAMIC(CScannerControlDlg)

public:
	CScannerControlDlg(FaroUSBArm& _arm);
	virtual ~CScannerControlDlg();

// Dialog Data
	enum { IDD = IDD_SCANNERCONTROL_DIALOG };
	//CPreviewWnd	m_PreviewWnd;
	CSliderCtrl	m_SliderWidthThreshold;
	CSliderCtrl	m_SliderNoiseThreshold;
	CSliderCtrl	m_SliderHighThresold;
	CSliderCtrl	m_SliderExposure;
	CComboBox	m_ComboAlgorithm;
	CComboBox	m_ComboScanDenisty;
	CComboBox	m_ComboScanRate;
	int		m_nExposure;
	int		m_nHighThresold;
	int		m_nNoiseThresold;
	int		m_nWidthThresold;
	CString	m_strAlgorithm;
	CString	m_strScanDensity;
	CString	m_strScanRate;
	BOOL	m_bLaserOn;
	BOOL	m_bShowCOG;
	BOOL	m_bShowRawImage;
	CProbeData m_ProbeData;
	BOOL	m_bShowRangeFinder;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

	FaroUSBArm& arm;
public:
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedCheckLaserOn();
	afx_msg void OnBnClickedCheckShowCog();
	afx_msg void OnBnClickedCheckShowRawImage();
	afx_msg void OnBnClickedCheckShowRangeFinder();
	afx_msg void OnNMReleasedcaptureSliderExposure(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnCbnSelchangeComboAlgorithm();
	afx_msg void OnCbnSelchangeComboScanRate();
	afx_msg void OnCbnSelchangeComboScanDensity();
	afx_msg void OnNMReleasedcaptureSliderHighThresold(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMReleasedcaptureSliderNoiseThreshold(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMReleasedcaptureSliderWidthThresold(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEditExposure();
	afx_msg void OnEnChangeEditHighThresold();
	afx_msg void OnEnChangeEditNoiseThresold();
	afx_msg void OnEnChangeEditWidthThreshold();
};
