#pragma once
#include "afx.h"

class ArmBase;

#include "CmmSpecific.h"

class TrackArmInterface :
	public CObject
{
public:
	TrackArmInterface(ArmBase& _parent);
	virtual ~TrackArmInterface(void);

	DWORD buttontime;
	BOOL LongDown;

	bool ConnectTrackArm();
	bool DisconnectTrackArm();

	BOOL GetAllData();
	BOOL GetJoints(bool simulate=true);

	bool LocateArm(Transform& trackArmTransform);	//PopTrackArmDlg
	bool GetTrackArmTransform(Transform& trackArmTransform);
	bool IsProbeValid();

	bool SetSampleSetup( int nWatchWindowUpdates, int nMeasurementUpdates, int nCompensationUpdates, int nScanUpdates );
	bool GetSampleSetup();

	BOOL DoTrackerSettings();

private:

	ArmBase& parent;
	HMODULE m_hArmLib;
	int ( *m_pCmmSpecific )( void * );
	vPositionUpdate m_UpdateStruct;
	BOOL			m_bOpened;
	BOOL			m_bTrackerActive;
	int				m_nPrev;
	BOOL			m_bUseBackSight;
	int				m_nDistanceMode;
	int				m_nInvalidUpdates;

	bool LoadDevice( LPCTSTR DllName );
	BOOL SetUnits( const bool bInches );
	BOOL IsTrackerActive();

	BOOL StartMeasurementCommand();
	BOOL StopMeasurementCommand();
	BOOL StartMeasurement( const int nCount, const PointType nType );
	BOOL StopMeasurement();
	UpdateType DecodePositionUpdate(vPositionUpdate& TmpPosUpdate);
	BOOL CheckForValidity( vPositionUpdate TmpPosUpdate );
};
