#if !defined(FITBALL_H__INCLUDED_)
#define FITBALL_H__INCLUDED_


#include "GeomCoverage.h"

class FitBall : public CObject
{	  // created to group fitting functions and variables.
public:
	Vector Center;
	double Radius;
	double Tolerance;
	double rmserr;

	BYTE outsideRMStol;

	GeomCoverage Coverage;
	double pct;

	BOOL VaryRad;	// added 9/14/99 blt

	OptimizationParameters *pOpt;	// SET THIS - points to the optimization control structure.
	VectorArray* pPoints;		// SET THIS - points to points that are to be fit.

	Vector OldCenter;
	double OldRadius;

	CStringArray Resid;
	virtual BOOL Calculate(int* retcount, double* lockrad, double* caserad);

	FitBall();
	Vector& PtA( int i)
		{  return *pPoints->P[i]; }
	void SetOld();		  // used to save before perturbing.
	void GetOld();
	void EvaluateVec( double* e );
	BOOL GetMidPlane(Vector& P1,Vector& P2,Vector* Norm,double* D);
	BOOL FourPtSphere(Vector& P1,Vector& P2,Vector& P3,Vector& P4, Vector* Cent, double* Rad);
	BOOL Guess();

}; 

extern double ITM;

#endif // !defined(FITBALL_H__INCLUDED_)