#if !defined(FITCIRCLE_H__INCLUDED_)
#define FITCIRCLE_H__INCLUDED_

class FitCircle : public CObject
{	  // created to group fitting functions and variables.
public:
	Vector Center;
	Vector Normal;
	double Theta, Phi, Radius;
	int rejctr;

	BOOL VaryRad;	// added 9/14/99 blt

	VectorArray* pPoints;		// SET THIS - points to points that are to be fit.
	OptimizationParameters *pOpt;	// SET THIS - points to the optimization control structure.

	CStringArray Resid;		// Will contain the listing of errors.

	double FitCircle::RayCompareForFit(Ray& RayA, Ray& RayB, Vector* pPA, Vector* pPB, bool* pAnyNeg=NULL);
	virtual BOOL Calculate(Vector* pres);		// call this after setting inputs to guess then fit!

	FitCircle();
	Vector& PtA( int i)
		{  return *pPoints->P[i]; }
	void EvaluateVec( double *e );
	BOOL Guess();
	BOOL ThreePtCircle(Vector& P1,Vector& P2,Vector& P3, Vector* Cent,Vector* Norm, double* Rad);

}; 

#endif // !defined(FITCIRCLE_H__INCLUDED_)