#if !defined(FITPLANE_H__INCLUDED_)
#define FITPLANE_H__INCLUDED_

///////////////////// Plane fitting class

class FitPlane : public CObject
{	  // created to group fitting functions and variables.
public:

	double Theta;
	double Phi;
	Vector FittedNormal;
	double D;
	double MaxError;
	double RMSError;
	int retcount;
	Transform Trans;		// for later use.

	BOOL ShowResults;

	CStringArray Resid;

	VectorArray* pPoints;		// SET THIS - points to points that are to be fit.
	OptimizationParameters *pOpt;	// SET THIS - points to the optimization control structure.

//	GenVec* pKnowns;			// optional - known values for the plane offsets.
//	Plane* pPlane;				// optional
	CDWordArray* pArray;		// optional

	FitPlane();
	BOOL Guess(Vector* FitNorm,Vector* FitPoint);
	BOOL ThreePtPlane(Vector& P0,Vector& P1,Vector& P2,Vector* Normal,Vector* Point);

	Vector& PtA( int i)
		{  return *LocPoints.P[i]; }
	virtual BOOL Calculate( );

	VectorArray LocPoints;
	Vector LocCenter;

	void Evaluate(double e[]);
}; 

#endif // !defined(FITPLANE_H__INCLUDED_)