#pragma once
#include "afx.h"

class GeomTriggerWrapper :
	public CObject
{
public:
	GeomTriggerWrapper(void);
	~GeomTriggerWrapper(void);

	void SetGeomTriggers();
	bool EnsureValidity_InstScaleFactorHasNotChanged();
	bool Check(const Vector& previous, const Vector& current, const double& offset, VectorNamedArray& out);
	bool HasTriggersDefined();

	void AddSelectedPlane(SAIPGeomPlane& p);
	bool WantSelectedPlanes();
	void TurnOffPlaneSelection();

	void AddSelectedCylinder(SAIPGeomCylinder& c);
	bool WantSelectedCylinders();
	void TurnOffCylinderSelection();

	void AddSelectedSphere(SAIPGeomSphere& s);
	bool WantSelectedSpheres();
	void TurnOffSphereSelection();

	void Serialize(CArchive& ar);	
protected:
	DECLARE_SERIAL( GeomTriggerWrapper );

private:
	GeometryTrigger& geomTrigger;
};
