// GeometryObj.cpp: implementation of the PlaneObj class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GeometryObj.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GeometryObj::GeometryObj()
{
	maxerr = -1e6;
	rmserr = 0.0;
	pctcov = 0.0;
	radius = 0.0;
	samples = 0;
}

GeometryObj::~GeometryObj()
{
}
///////////////////////////////////////////////////////////////////////
void GeometryObj::operator=(const GeometryObj& geOb)
{
	t = geOb.t;
	center = geOb.center;
	normal = geOb.normal;
	radius = geOb.radius;
	maxerr = geOb.maxerr;
	rmserr = geOb.rmserr;
	pctcov = geOb.pctcov;
	name = geOb.name;
	samples = geOb.samples;
	notes.RemoveAll();
	for(int i=0; i<notes.GetSize(); i++)
		notes.Add(geOb.notes.GetAt(i));
	maxerrinfo = geOb.maxerrinfo;
	rmserrinfo = geOb.rmserrinfo;
}
void GeometryObj::Serialize(CArchive& ar)
{
	BYTE Schema = 1;
	BYTE LoadSchema = 0;

	if (ar.IsStoring())
	{ 
		ar << Schema;

		t.Serialize(ar);
		center.Serialize(ar);
		normal.Serialize(ar);
		ar <<  radius;
		ar <<  maxerr;
		ar <<  rmserr;
		ar <<  pctcov;
		ar << name;
		notes.Serialize(ar);
		ar << maxerrinfo;
		ar << rmserrinfo;
		ar << samples;
	}
	else
	{
		ar >> LoadSchema;

		t.Serialize(ar);
		center.Serialize(ar);
		normal.Serialize(ar);
		ar >>  radius;
		ar >>  maxerr;
		ar >>  rmserr;
		ar >>  pctcov;
		ar >> name;
		notes.Serialize(ar);
		ar >> maxerrinfo;
		ar >> rmserrinfo;
		ar >> samples;
	}
} 
IMPLEMENT_SERIAL( GeometryObj, CObject, 0 );