// GeometryObj.h: interface for the GeometryObj base class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GEOMETRYOBJ_H__INCLUDED_)
#define AFX_GEOMETRYOBJ_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "nrkapp.h"
#include "fit\\fitball.h"
#include "fit\\fitcircle.h"
#include "fit\\fitplane.h"

class GeometryObj : public CObject  
{
public:
	GeometryObj();
	virtual ~GeometryObj();

	Transform t;
	Vector center;
	Vector normal;
	double radius;
	double maxerr;
	double rmserr;
	double pctcov;
	CString name;
	CStringArray notes;
	CString maxerrinfo;
	CString rmserrinfo;

	int samples;

	virtual void operator=(const GeometryObj& geOb);

	virtual void Serialize(CArchive& ar);
protected:
	DECLARE_SERIAL( GeometryObj );
};

#endif // !defined(AFX_GEOMETRYOBJ_H__INCLUDED_)
