// C:\_Bruce\@Projects\PCMM Arms\HelpUI\HTMLHelpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "../DPCMM.h"
#include "HTMLHelpDlg.h"


// HTMLHelpDlg dialog

IMPLEMENT_DYNAMIC(HTMLHelpDlg, CDialog)
HTMLHelpDlg::HTMLHelpDlg(CString _title/*=_T("")*/, CString _initialPage/*=_T("")*/, CWnd* pParent /*=NULL*/)
: CDialog(HTMLHelpDlg::IDD, pParent)
{
	title = _title;
	initialPage = _initialPage;
}

HTMLHelpDlg::~HTMLHelpDlg()
{
}

void HTMLHelpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EXPLORER1, ieBox);
	DDX_Control(pDX, IDC_BUTTON_BACK, backButton);
	DDX_Control(pDX, IDC_BUTTON_FORWARD, nextButton);
	DDX_Control(pDX, IDC_BUTTON_STOP, stopButton);
	DDX_Control(pDX, IDC_BUTTON_PRINT, printButton);
}


BEGIN_MESSAGE_MAP(HTMLHelpDlg, CDialog)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_BACK, OnBnClickedButtonBack)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnBnClickedButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_FORWARD, OnBnClickedButtonForward)
	ON_BN_CLICKED(IDC_BUTTON_PRINT, OnBnClickedButtonPrint)
END_MESSAGE_MAP()


// HTMLHelpDlg message handlers

BOOL HTMLHelpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// set dlg icon to match main dlg...
	SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);

	if(!title.IsEmpty())
		SetWindowText(title);

	//backButton.SetBitmaps(IDB_BITMAP_BACK_BUTTON, 18, 20, RGB(255, 0, 255));
	//backButton.SetHelpText(_T("Back"), _T("Go to Previous Page"));

	//nextButton.SetBitmaps(IDB_BITMAP_NEXT_BUTTON, 18, 20, RGB(255, 0, 255));
	//nextButton.SetHelpText(_T("Next"), _T("Go to Next Page"));

	//stopButton.SetBitmaps(IDB_BITMAP_STOP_BUTTON, 18, 20, RGB(255, 0, 255));
	//stopButton.SetHelpText(_T("Stop"), _T("Stop Download, etc."));

	if(!initialPage.IsEmpty())
		SetTimer(HD_INITTIMER, 50, NULL);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void HTMLHelpDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if(IsWindow(ieBox.m_hWnd))
	{
		CRect orig;
		ieBox.GetWindowRect(&orig);
		ScreenToClient(&orig);
		int rtBorder = 10;
		int btBorder = 15;
		CPoint size;
		size.x = cx - orig.TopLeft().x - rtBorder;
		size.y = cy - orig.TopLeft().y - btBorder;
		ieBox.MoveWindow(orig.TopLeft().x, orig.TopLeft().y, size.x, size.y);
	}
}

void HTMLHelpDlg::OnTimer(UINT nIDEvent)
{
	if( nIDEvent == HD_INITTIMER )
	{
		KillTimer(HD_INITTIMER);
		showPage(initialPage);
	}

	CDialog::OnTimer(nIDEvent);
}

void HTMLHelpDlg::showPage(const CString& fileName)
{
	CString path;
	path.Format(_T("%sButtonHelp\\%s"), app.saarm.ProgramDirectory, fileName);
	TRACE1("navigate to '%s'\n", path);
	ieBox.Navigate(path,NULL,NULL,NULL,NULL);
}

/////////////////////////////////////////////////////////////////////
// window persistence...
void HTMLHelpDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	if (bShow)
		PersistentWnd::RestoreWndRect(_T("windows"), _T("salt_htmlHelpDlg"), this, PersistentWnd::POS_SIZE_STATE);
}
void HTMLHelpDlg::OnDestroy()
{
	PersistentWnd::SaveWndRect(_T("windows"), _T("salt_htmlHelpDlg"), this, PersistentWnd::POS_SIZE_STATE);

	CDialog::OnDestroy();
}
//////////////////////////////////////////////////////////////////////
void HTMLHelpDlg::OnBnClickedButtonBack()
{
	ieBox.GoBack();
	nextButton.EnableWindow();
}

void HTMLHelpDlg::OnBnClickedButtonStop()
{
	ieBox.Stop();
}

void HTMLHelpDlg::OnBnClickedButtonForward()
{
	ieBox.GoForward();
}

void HTMLHelpDlg::OnBnClickedButtonPrint()
{
	ieBox.ExecWB(OLECMDID_PRINTPREVIEW, 0, NULL, NULL);
	//ieBox.ExecWB(OLECMDID_PRINT, 0, NULL, NULL);	// no preview, just print ui
}
