#pragma once
#include "ArmBase.h"

class HexagonRDS :
	public ArmBase
{
public:
	HexagonRDS();
	virtual ~HexagonRDS();

	friend class RDSWindowsMessenger;

	virtual bool ConnectToArm(const int dof);
	virtual BOOL DisconnectFromHardware();

	virtual void DoPostInitOperations();

	virtual BOOL GetAllData();
	virtual BOOL GetPos();
	virtual BOOL GetJoints(bool simulate=true);
	virtual int GetButtonStates();
	virtual BOOL CheckButton(int but, int* duration);

	void OnTouchTriggerPressed(); // 2015.01.28 - for Ute Burton @ Hexagon

	virtual void DoCal();
	virtual void DoArmSettings();

	//virtual BOOL GetTemp();
	//virtual int GetProbeNumber();
	virtual int GetButtonCount();

	//virtual void SetProbeNumber(int ProbeNum);
	virtual BOOL ValidateCurrentProbe() {return probeValid ? TRUE : FALSE;}
	//virtual void SetProbeAutoDetect(BOOL ad);

	virtual void OutputSpeakerSound( int frequency, int duration );
	virtual void ArmBeep(int sound);

	virtual BOOL IsRemoteMouseEnabled();
	virtual void RemoteMouse(BOOL flag);
	virtual void ToggleRemoteMouse();

	virtual BOOL ScannerSettings();	// 2014.04.11
	virtual BOOL StartScannerMeas();
	virtual BOOL StopScannerMeas();

	virtual BOOL IsHexagonRDS() {return TRUE;}

	bool lineScanning;

	//////////////////////////////////////////////////
	// Perceptron Scanner stuff
	//virtual BOOL ScannerSettings();
	virtual BOOL StartPerceptronScannerMeas();
	virtual BOOL StopPerceptronScannerMeas();
	// Perceptron specific
	Transform scannerXform;
	bool SetScannerRegKey(bool reportError=false);	// requested code changes from Perceptron - ScanWorks now 'shares' the WinRDS connection nicely!
	bool SetScanWorksUnitsToInches();	// added in ScanWorks v. 4.4
	bool ScanWorksCheckForProbe();		// They say, "We are moving away from using only probe number 8 and this is probably the safest way to detect if the scanner is active."
	bool StartModel();
	bool StopModel();
	void ResetSocket();
	bool ScanWorksMoverConnect();
	bool ScanWorksMoverDisconnect();
	void ShowScanWorksToolBar();
	void HideScanWorksToolBar();
	void CleanUpPerceptron();
	//bool ReConnectToArm();
	bool SendBufferedCloudDataAndReconnect();
	virtual void PostUpdateScanDlg(CString msg);
	void OnUpdateScanDlg();
	void CloseScanDlg();

protected:
	RDSWindowsMessenger& wm;
	CString scanMsg;
};
