#pragma once
#include "afxwin.h"
#include "KreonDefines.h"

#define		WM_SOCKET_MESSAGE		(WM_APP + 0x1000)
#define CLOSE_SCAN_DLG (WM_APP + 4)
#define UPDATE_SCAN_DLG (WM_APP + 5)
#define SEND_BUFFERED_DATA_AND_RECONNECT	(WM_APP + 6)

class KreonScannerArm;

class KreonCmdWnd :
	public CWnd
{
	DECLARE_DYNAMIC(KreonCmdWnd)

public:
	KreonCmdWnd(KreonScannerArm* _owner, bool _simulate);
	virtual ~KreonCmdWnd(void);

	bool MakeValidWindow(); // call once to make the window for message handling
	bool windowValid;
	static HWND		m_StatichWnd;

	bool	Init();
	void ShutDown();

	void OpenLicenseDlg();

	void PopProbeCalWindow(KR_TOUCH_PROBE* probes, int probeSize);
	void PopScannerSphereCalWindow();

	int GetButtonCount();
	bool* GetButtonStatesFromCurrentPosition();
	bool* GetButtonStatesFromTriggeredPosition();
	bool* GetButtonStatesOnly();
	bool GetProbeTipPos(double* matrix);
	bool GetProbeTipPosAndJointAnglesAndButtonState(double* matrix, int * nbJoints, double ** jointAngles, bool * buttons);

	bool VideoSetup();
	bool ScannerProperties();
	bool StartScan();
	bool StopScan();
	bool IsScanning();

	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	afx_msg LRESULT OnDataSocket(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
	afx_msg void OnTimer(UINT_PTR nIDEvent);

protected:
	KreonScannerArm& owner;
	CriticalSectionWrapper& scannerCS;
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

private:
	bool	m_bKreonInitialized;
	bool simulate;
	int NbButtons;
};
