//	---------------------------------------------------------------------------
//	KreonHL.h
//
//	KREON Technologies toolkit
//	High level functions definition
//	---------------------------------------------------------------------------
#ifndef	__KREON_HL__
#define	__KREON_HL__



//	---------------------------------------------------------------------------
//	Datatypes
//	---------------------------------------------------------------------------
#ifdef __cplusplus
#define _KR_API extern "C"
#else
#define _KR_API extern
#endif
#define _KR_CALL __cdecl


typedef void (*KRHL_SCAN_COMPLETE_CALLBACK)(UINT NbLaserLine);



//	---------------------------------------------------------------------------
//	Functions
//	---------------------------------------------------------------------------
_KR_API bool _KR_CALL KRHL_InitializeKreonToolkit(char *ServerPath,
												  UINT ClientCode,HWND ParentWnd);
_KR_API void _KR_CALL KRHL_VideoSetup(void);
_KR_API void _KR_CALL KRHL_Positioning(void);
_KR_API void _KR_CALL KRHL_Scan(KRHL_SCAN_COMPLETE_CALLBACK ScanCallback);
_KR_API void _KR_CALL KRHL_Options(void);
_KR_API bool _KR_CALL KRHL_GetLaserLine(unsigned int Index,unsigned int* NbPoints,
										double* Data,double* Matrix);
_KR_API void _KR_CALL KRHL_EndKREON(bool bSwitchOffSensor);
#define KRHL_License KRHL_Licence
_KR_API void _KR_CALL KRHL_Licence(void);
_KR_API char* _KR_CALL KRHL_DisplayLastError(void);



#endif