#include "stdafx.h"
#include "KreonProbeCalibrations.h"

KreonProbeCalibrations::KreonProbeCalibrations(void)
{
	count = 0;
	memset( probe, 0, sizeof(probe) );	// clear the memory!
	selectedScannerCal = -1;
}

KreonProbeCalibrations::~KreonProbeCalibrations(void)
{
}

int KreonProbeCalibrations::AddProbe(KR_TOUCH_PROBE& newProbe)
{
	if (count >= KR_TOUCH_PROBE_NUMPROBES)		// we only allow this many definitions to exist
		return -1;

	// just allow one probe def. for now...
	KR_TOUCH_PROBE& tp = probe[count];
	tp = newProbe;	
	return count++;		// increment count!

	//KR_TOUCH_PROBE& tp = probe[0];
	//tp = newProbe;	
	//count = 1;
	//return 1;
}

void KreonProbeCalibrations::Serialize(CArchive& ar)
{
	BYTE Schema = 0;
	BYTE LoadSchema = 0;
	Schema = 1; // 2017.10.23 - added selectedScannerCal

	UINT probesSize = sizeof(probe);
	if (ar.IsStoring())
	{ 
		ar << Schema;
		ar << count;
		ar << probesSize;
		ar.Write(probe, probesSize);
		TRACE2("write Kreon probes, size %d, count %d\n",probesSize,count);
		ar << selectedScannerCal;
	}
	else
	{
		ar >> LoadSchema;
		ar >> count;
		UINT inProbesSize =0;
		ar >> inProbesSize;
		if (inProbesSize != probesSize)
		{
			TRACE2("KreonProbeCalibrations::Serialize -- size mismatch: %d, s/b %d\n",inProbesSize,probesSize);
			throw 1;
		}
		UINT num = ar.Read(probe, inProbesSize);
		TRACE3(" read Kreon Probes, size %d, done %d, count %d\n",inProbesSize,num,count);
		if(LoadSchema >= 1)
			ar >> selectedScannerCal;
	}

} 
IMPLEMENT_SERIAL( KreonProbeCalibrations, CObject, 0 );