#pragma once
#include "armbase.h"
#include "Kreon/KreonDefines.h"

class KreonScannerArm :
	public ArmBase
{
public:
	KreonScannerArm(void);
	virtual ~KreonScannerArm(void);

	friend class KreonCmdWnd;

	virtual bool ConnectToArm(const int dof);
	virtual BOOL DisconnectFromHardware();

	virtual void DoPostInitOperations();

	virtual void OpenKreonDongleLicenseDlg();

	virtual int GetButtonCount();

	virtual BOOL GetAllData();
	virtual BOOL GetPos();	// and button states, 2009.05.20 - and joint angles as of Kreon Toolkit 2.1.0.5 Beta
	virtual BOOL GetJoints(bool simulate=true) {return FALSE;}
	virtual int GetButtonStates();
	int ProcessButtonStates(bool* pState);

	virtual void DoCal();	// scanner
	virtual void DoArmSettings();
	// hard probe cal stuff
	virtual void ProbeCalSet();
	int AddOrEditProbeCal(KR_TOUCH_PROBE probe);
	void GetProbeCals(KR_TOUCH_PROBE& probe, int& probeSize);

	virtual BOOL ScannerSettings();
	int thinningFactor;
	bool VideoSetup();
	bool ScannerProperties();
	void SetScannerCalMatrix(const double calMatrix[4][4]);
	void GetScannerCalMatrix(double calMatrix[4][4] ) const;

	virtual BOOL StartScannerMeas();
	virtual BOOL StopScannerMeas();
	virtual void PostUpdateScanDlg(CString msg);
	void OnUpdateScanDlg();
	void CloseScanDlg();
	void RestartQueryTimer();

	virtual BOOL IsKreonScannerArm() {return TRUE;}

	///////////////////////////////////////////////
	// hardware interface level....
protected:
	KreonCmdWnd& cw;
	CString scanMsg;

private:
	DWORD buttontime;
	BOOL LongDown;
};
