// jmc log
// LogFile.cpp: implementation of the LogFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "nrkapp.h"
#include "LogFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LogFile::LogFile()
{

}

LogFile::~LogFile()
{

}
BOOL LogFile::GetLogFile( CStdioFile* f )
{
	// open or create the log file and move to the end!
	
	if (!f->Open(Path,CFile::modeWrite))
	{
		if (!f->Open(Path,CFile::modeCreate | CFile::modeWrite))
		{
			//AfxMessageBox("Could not create or append the log file!"));
			return FALSE;
		}
	}
	f->SeekToEnd();

	if (f->GetLength() == 0)
		f->WriteString(_T("New River Kinematics Portable CMM Log File\n\n"));

	return TRUE;
}

void LogFile::Clear()
{
	CStdioFile f;
	if (!GetLogFile( &f ))
		return;
	f.SeekToBegin();
	f.SetLength(0);		// truncate the file!
	f.Close();
}

void LogFile::Log( const char* p )
{
	// write a string to the log file (automatically add a newline character).
	CStdioFile f;
	if (!GetLogFile( &f ))
		return;

	CString a;
	GetStamp( a );
	a += "   ";
	a += p;
	a += "\n";
 	f.WriteString(a);
	f.Close();
}
void LogFile::Log( CStringArray& str )
{
	// write an array of strings
	CStdioFile f;
	if (!GetLogFile( &f ))
		return;

	CString a;
	GetStamp( a );
	a += "\n";
 	f.WriteString(a);
	for (int i=0;i<str.GetSize();i++)
	{
		a.Format(_T("   %s\n"),str[i]);
		f.WriteString(a);
	}
	f.Close();
}
void LogFile::GetStamp( CString& a )
{
	a.Format(_T("%s%s"),UserName,CTime::GetCurrentTime().Format(_T("(%c)")));
}

