#pragma once
#include "armbase.h"

class MetrisGardaArm :
	public ArmBase
{
public:
	MetrisGardaArm(void);
	virtual ~MetrisGardaArm(void);

	virtual bool ConnectToArm(const int dof);
	virtual BOOL DisconnectFromHardware();

	virtual int GetButtonCount();

	virtual BOOL GetAllData();
	virtual BOOL GetPos();
	virtual BOOL GetJoints(bool simulate=true);
	virtual int GetButtonStates();
	virtual BOOL CheckButton(int but, int* duration);
	bool IsButtonDown(int but);

	virtual BOOL ValidateCurrentProbe();

	virtual void DoCal();
	//virtual bool IsProbeValid();

	virtual BOOL IsRemoteMouseEnabled();
	virtual void ToggleRemoteMouse();
	virtual void RemoteMouse(BOOL flag);
	virtual void DoArmSettings();

	//virtual BOOL ScannerSettings();
	//virtual BOOL StartScannerMeas();

	virtual BOOL IsRomer();
	virtual BOOL IsFaro();
	virtual BOOL IsFaroUSB();
	virtual BOOL IsFrenchRomer();
	virtual BOOL IsSNL();
	virtual BOOL IsMetrisGarda();
};
