/*
Permission to use, copy, modify, and distribute this software and its documentation 
may be granted by written permission only; interested parties are encouraged 
to request permission from

            Immersion Corporation

            801 Fox Lane

            San Jose, California 95131
*/


//code constants returned from MUS-X-PLUS
#define REAL_TIME_POINT 1
#define LATCHED_POINT 2
#define STREAM_POINT 3

//////////////////////////////////////////////////////////
//
// Data structure
//
/////////////////////////////////////////////////////////

//Structure for CooXYZ get from socket
typedef struct {
			double XYZ[3];
			double EXT[3];
} cms_coord;
cms_coord Cms_Xyz;
cms_coord* pCms_Xyz=&Cms_Xyz;

//Structure for probe data
//Structure for probe type
typedef struct {
	short Renishaw;
	double Length;
	double Radius;
} ProbeInfo;


typedef struct {
	int isConn;
	int isMouseMode;
	int isStream;
}ConnectionInfo;
ConnectionInfo ConnInfo;
ConnectionInfo* pConnInfo=&ConnInfo;




//////////////////////////////////////////////////////////
//
// Functions imported from CMS_SOCKET.DLL
//
/////////////////////////////////////////////////////////

//Initialize the dll 
int __cdecl cms_startup(HWND hWnd);

//Terminate the dll
void __cdecl cms_Stop(HWND hWnd);

//Function that start mouse mode
void __cdecl StartMouseMode(void);

//Function that stop mouse mode
void __cdecl StopMouseMode(void);

//Function for change the active software ID probe code and material ID
double __cdecl cms_ChangeProbe(int *cambia, int *material);


//Function to get the data probe list of the arm
void __cdecl cms_ProbeInfo(ProbeInfo* pProbeInfo);


//Function to get the zero Axis's state of the arm
//True = arm zeroed - False = arm not zeroed
bool __cdecl cms_Azzeramento(int *Azzera);

//Function to get the state of the 3 buttons of the arm (latch button,red and blue button)
void __cdecl cms_Buttons(bool *Button1, bool *Button2, bool *Button3);

//Function that get the CooXYZ returned from arm
int __cdecl cms_xyz_PI(cms_coord* pCms_Xyz);

//Function that get the Connection Info
void __cdecl cms_ConnectionState(ConnectionInfo* pConnectionInfo);



//Start stream mode 
void __cdecl StartStreamMode(void);
//Stop stream mode
void __cdecl StopStreamMode(void);

//Show MUS-X-PLUS test window
void __cdecl ShowTestWindow(void);

//Hide MUS-X-PLUS window
void __cdecl HideTestWindow(void);

//Get the active probe code ID
int __cdecl GetProbe(void);

//Get the active material code ID
int __cdecl GetMaterial(void);


//Connect to MUS-X-PLUS
void __cdecl Connect();

//Disconnect ro MUS-X-PLUS
void __cdecl Disconnect();

int __cdecl GetAnglesJoint(int * ang,int * numeroAssi);

//************************************************
//************************************************
//Support functions (external from MUS-X-PLUS SDK)

//This function play a "beep" sound from speacker of PC
void __cdecl PlaySounds(long Freq, long Durata);

