// BLOBMessage.cpp: implementation of the CBLOBMessage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BLOBMessage.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBLOBMessage::CBLOBMessage()
{
	m_nRemoteMessageType = CRemoteMessage::RMT_BLOB;
}

CBLOBMessage::~CBLOBMessage()
{
	if (m_pImage)
		delete m_pImage;

}

// ////////////////////////////////////////////////////////
//
// Serialize
//
void CBLOBMessage::Serialize(CArchive& ar)
{
	long nImageSize;
    BYTE *pBitmapBits;
	BITMAP bm;

	CRemoteMessage::Serialize( ar );

	if ( ar.IsStoring() ) {

#ifndef _WIN32_WCE

		ar << m_nStaticID;

		m_pImage->GetBitmap( &bm );

		ar << bm.bmType;
		ar << bm.bmPlanes;
		ar << bm.bmWidth;
		ar << bm.bmHeight;
		ar << bm.bmWidthBytes;
		ar << bm.bmBitsPixel;

		nImageSize = bm.bmHeight * bm.bmWidthBytes;
		pBitmapBits = new BYTE[nImageSize];

		m_pImage->GetBitmapBits( nImageSize, pBitmapBits );

		ar.Write( pBitmapBits, nImageSize );

#endif

	} else {

		ar >> m_nStaticID;

		ar >> bm.bmType;
		ar >> bm.bmPlanes;
		ar >> bm.bmWidth;
		ar >> bm.bmHeight;
		ar >> bm.bmWidthBytes;
		ar >> bm.bmBitsPixel;

		nImageSize = bm.bmHeight * bm.bmWidthBytes;
		pBitmapBits = new BYTE[nImageSize];

		ar.Read( pBitmapBits, nImageSize );
		m_pImage = new CBitmap;
		m_pImage->CreateBitmap( bm.bmWidth, bm.bmHeight, bm.bmPlanes, bm.bmBitsPixel, pBitmapBits );

	}


} 
IMPLEMENT_SERIAL( CBLOBMessage, CRemoteMessage, 0 );
