// RemoteStatic.cpp: implementation of the CRemoteStatic class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RemoteStatic.h"
#include "RemoteUIManager.h"
#include "RemoteUIDefs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRemoteStatic::CRemoteStatic():
	CRemoteWnd()
{
	m_nWndType = WT_STATIC;

}

CRemoteStatic::~CRemoteStatic()
{

}

// ////////////////////////////////////////////////////////
//
// Create
//
// Instruct the object to 'create' itself remotely.  This
//  involves registering itself with the RemoteUIManager,
//  and forming a RemoteUI message to send to the remote 
//  system.
//
BOOL CRemoteStatic::Create( CRemoteUIManager* pRemUIMgr, LPCTSTR lpszText, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID )
{
	// verify that needed pointers were passed in
	if ( pRemUIMgr == NULL )
		return FALSE;
	if ( pParentWnd == NULL )
		return FALSE;
	m_pRemUIMgr = pRemUIMgr;
	m_pWndParent = pParentWnd;

	// first, populate local values
	m_pWndParent = pParentWnd;
	m_nID = nID;
	m_strCaption = lpszText;
	m_wndRect = rect;
	m_dwStyle = dwStyle;

	// next, request that the remote ui manager create this button
	return ( m_pRemUIMgr->CreateRemoteWindow(this) );
}
