// RemoteUIManager.h: interface for the CRemoteUIManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REMOTEUIMANAGER_H__DB9CAD5C_D36E_4930_98EF_EFD699E0B44C__INCLUDED_)
#define AFX_REMOTEUIMANAGER_H__DB9CAD5C_D36E_4930_98EF_EFD699E0B44C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>

class SocketManagerPDA;
class CRemoteWnd;
class CRemoteBitmap;

// a map of control ids and their associated hWnds
typedef CMap<UINT, UINT, CWnd*, CWnd*> TWindowMap;

class CRemoteUIManager : public CWnd  
{
public:

	BOOL CreateRemoteBing();
	BOOL SetRemoteWindowOwnerText( LPCTSTR lpszString );
	DWORD RemoteContext;		// jmc - allows us to know which dialog is up on the PDA.
	void EndGrouping();
	void StartGrouping();
	BOOL SetRemoteCheckState( UINT nID, int nState );
	BOOL GetRemoteCheckState( UINT nID );
	BOOL GetCurrentRemoteWindowText( UINT nID );
	BOOL DeleteAllRemoteWindows();
	BOOL AddRemoteString( UINT nID, CString strText );
	BOOL DeleteRemoteWindow( UINT nID );
	BOOL DisableRemoteWindow( UINT nID );
	BOOL EnableRemoteWindow( UINT nID );
	BOOL GetRemoteWindowText( UINT nID );
	BOOL SetRemoteWindowText( UINT nID, LPCTSTR lpszString );
	BOOL CreateRemoteBitmap( UINT nBitmapID, UINT nStaticID );
	BOOL CreateRemoteBitmap( CBitmap* pBitmap, UINT nStaticID );
	void ForwardCommand( WPARAM wParam, LPARAM lParam );
	BOOL CreateRemoteDialog( int nIDD);
	CRemoteUIManager();
	virtual ~CRemoteUIManager();

	BOOL InitToListen( CWnd* pWndOwner, int Port );
	BOOL InitToConnect( CString strAddress, int Port, CWnd* pWndOwner );
	BOOL CreateRemoteWindow(CRemoteWnd* pWndRemote);

	SocketManagerPDA* m_pSockMgr;

protected:
	// Generated message map functions
	//{{AFX_MSG(CRemoteUIManager)
	//}}AFX_MSG
	afx_msg LRESULT OnRemoteMessage( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnRemoteConnect( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
private:
	bool m_bPostponeDelivery;
	TWindowMap m_mapWindows;
	CWnd* m_pWndOwner;
	CFont m_fntSystem;
};

#endif // !defined(AFX_REMOTEUIMANAGER_H__DB9CAD5C_D36E_4930_98EF_EFD699E0B44C__INCLUDED_)
