// UIMessage.h: interface for the CUIMessage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UIMESSAGE_H__DF1B7368_623F_40A0_B925_7416F48A6D81__INCLUDED_)
#define AFX_UIMESSAGE_H__DF1B7368_623F_40A0_B925_7416F48A6D81__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RemoteMessage.h"

class CUIMessage : public CRemoteMessage  
{
public:
	CUIMessage();
	virtual ~CUIMessage();
	virtual void Serialize(CArchive& ar);	

	// UI message types
	enum {
		UMT_CREATE = 1,		// create a window
		UMT_DELETE,			// delete a window
		UMT_DELETEALL,		// delete all remotely created windows
		UMT_GETTEXT,		// get the text from a window
		UMT_GETCURTEXT,		// get text currently selected in a list box
		UMT_SETTEXT,		// set a window's text
		UMT_SETOWNERTEXT,	// set the text of the owner window
		UMT_NOTIFY,			// a remote window is notifying its peer
		UMT_ENABLE,			// enable a window
		UMT_DISABLE,		// disable a window
		UMT_GETCHECK,		// get the check state of a remote button
		UMT_SETCHECK,		// set the check state of a remote button
		UMT_ADDSTRING,		// add a string to a list box
		UMT_BING			// 'bing' the speaker
	} UIMESSATE_TYPE;

	int		m_nUIMessageType;
	int		m_nControlType;
	UINT	m_nControlID;
	RECT	m_wndRect;
	DWORD	m_nStyle;
	CString	m_strCaption;

	int		m_nCheckState;	// used for UMT_SETCHECK

protected:
	DECLARE_SERIAL( CUIMessage );
};

#endif // !defined(AFX_UIMESSAGE_H__DF1B7368_623F_40A0_B925_7416F48A6D81__INCLUDED_)
