// Pak.cpp: implementation of the PacketSocket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "nrkapp.h"
//#include "Pak.h"
#include "DPCMMdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CListeningSocket::CListeningSocket()
{
}

/////////////////////////////////////////////////////////////////////////////
// CListeningSocket Overridable callbacks

void CListeningSocket::OnAccept(int nErrorCode)
{
	CSocket::OnAccept(nErrorCode);
	UINT Port = 0;
	CString Name;
	GetSockName(Name, Port);
}

/////////////////////////////////////////////////////////////////////////////
// CSocket Implementation

IMPLEMENT_DYNAMIC(CListeningSocket, CSocket)

PacketSocket::~PacketSocket()
{
	CloseSocketAndFile();
}

void PacketSocket::CloseSocketAndFile()
{
	if (BufFileOpen)
	{
		BufFileOpen = FALSE;
		SockBuf.Close();
		CFile::Remove(SockBuf.GetFilePath());
	}
	if(Active)
	{
		Close();
		Active = FALSE;
	}
}


void PacketSocket::Close()
{
	CSocket::Close();
	Active = FALSE;
	CloseSocketAndFile();
}

BOOL PacketSocket::Connect(LPCTSTR lpszHostAddress,UINT nHostPort)
{
	if(!CSocket::Connect(lpszHostAddress,nHostPort))
		Active = FALSE;
	else
		Active = TRUE;
	return Active;
}

void PacketSocket::OnClose( int Err )
{
	Detach();		// detach the handle.
	CloseSocketAndFile(); 
	PostQuitMessage(0);
}
PacketSocket::PacketSocket()
{
	MaxPacketSize = sizeof( Packet );
	HeaderSize = MaxPacketSize - sizeof( Packet.Data );
	DataSize = 0;
	Active = FALSE;

	//SendAck = FALSE;
	NextSend = 0;
	EndOfFile = 0;
	WaitingForAck = FALSE;
	BufFileOpen = FALSE;
	sent = 0;
	rcvd = 0;
}

WORD PacketSocket::SendPacket()
{
	if (!PrepareToSend())
	{
		return 0;
	}
	Packet.Size = DataSize + HeaderSize;
	if (!BufFileOpen)
	{
		int sent = Send(&Packet,Packet.Size+PAK_SAFETY);
		if (sent == SOCKET_ERROR)
		{		
			int e = GetLastError();
			CString m;
			m.Format("Error sending packet! Code = %d",e);
			AfxMessageBox(m);
			return 0;
		}
		else	//2/17/98 diagnostic
		{
			//print packet to file
		}
	}
	else
	{
		// add to the file!
		DWORD len = SockBuf.Seek( 0, CFile::end );// store the beginning location!
		SockBuf.Write( &Packet, Packet.Size );
		EndOfFile = len + Packet.Size;
//		if(WaitingForAck)
//			TRACE("WaitingForAck = TRUE\n");
//		else
	//		TRACE("WaitingForAck = FALSE\n");
			
		if (!WaitingForAck)
			DrainBuffer();
	}
	return Packet.Size; 
	//BugPacket();
	//int sent = Send(&Packet,Packet.Size+PAK_SAFETY);
	//sent -= PAK_SAFETY;
	//if (sent != Packet.Size)
	//{
	//	AfxMessageBox("Sent a packet with the incorrect size!");
	//}
	//return sent; 

}

BYTE PacketSocket::DrainBuffer()
{
	//EndOfFile = SockBuf.Seek( 0, CFile::end );

	if (NextSend >=EndOfFile)
	{
		// nothing to send!

		// clear the file!
		SockBuf.Seek( 0, CFile::begin );		// get to packet.
		SockBuf.SetLength( 0 );
		//TRACE("file truncated!\n");
		EndOfFile = NextSend = 0;

		return FALSE;
	}
	SockBuf.Seek( NextSend, CFile::begin );		// get to packet.
	WORD count = 0;
	int size = sizeof(WORD);
	int read = SockBuf.Read( &count, size );		// read size of packet
	if (read < size)
		return 0;
	FileCache[0] = LOBYTE( count );
	FileCache[1] = HIBYTE( count );
	read = SockBuf.Read( &FileCache[2], count - size );		// read the packet itself.
	if (read < count - size)
		return 0;

	NextSend += count;		// increment pointer!
	int sent = Send(&FileCache,count+PAK_SAFETY);			// send the packet!
	WaitingForAck = TRUE;											// now, we're waiting!
	if (sent == SOCKET_ERROR)
	{		
		int e = GetLastError();
		CString m;
		m.Format("Error sending packet! Code = %d",e);
		AfxMessageBox(m);
		return FALSE;
	}
	PacketSocket::sent += 1;
	return TRUE; 
}

WORD PacketSocket::ReceivePacket()	// fcn changed 2000.08.29
{
	WORD NumRead=0;
	WORD Size=0;
	NumRead = Receive(&Packet,MaxPacketSize);	 
	if(NumRead<=0)
	{
		CString m;
		m.Format("Receive Error %d", GetLastError());	//bt 2000.07.27
		AfxMessageBox(m);
		DataSize = 0;
		return 0;		
	}
	DataSize = Packet.Size - HeaderSize; // bt 2000.07.27

	TRACE("\n******PacketSocket::ReceivePacket(), return = %d, DataSize = %d, command %d*****\n\n", NumRead, DataSize, Packet.Command);

	// 2000.08.28  In 'single Receive world' all packets must behave as Ack's
	// for polling, automeasure, data observer, any mode in which SA asks for
	// data, we could loose an ack.  SA processes the packet and THEN sends the ack
	// That means the instrument may get a packet which consists of a request for the
	// next measurement with the Ack for the last one tacked on at the end!
	WaitingForAck = FALSE;  // jmc real hacky
	DrainBuffer();
	
	if((Packet.Command == PAK_ACK) )
		return 0;	// VERY important!!  added 10/1/99

	return Packet.Size;	//bt 2000.07.27
}

void PacketSocket::TkrDebug(BYTE sending)
{
/*	CString PathName;
	PathName.Format("%sPackets.txt",(LPCTSTR)theApp.PersistenceDirectory);

	FILE *pack;
	pack = fopen( (const char *)PathName, "a");
	if( pack == NULL )
	{
		AfxMessageBox("Could not open TkrDebug file.");
		return;
	}

	if(sending)
		fprintf(pack,"%s ","Sent");
	else
		fprintf(pack,"%s ","Received");

	switch (Packet.Command)
	{
	case PAK_FLAGS:
		fprintf(pack,"%s\n","PAK_FLAGS");
		break;
	case PAK_UPDATE:
		fprintf(pack,"%s\n","PAK_UPDATE");
		break;
	case PAK_MEASUREMENT:
		fprintf(pack,"%s\n","PAK_MEASUREMENT");
		break;
	case PAK_TEXT:
		fprintf(pack,"%s\n","PAK_TEXT");
		break;
	case PAK_SIGNON:
		fprintf(pack,"%s\n","PAK_SIGNON");
		break;
	case PAK_CONTAINER:
		fprintf(pack,"%s\n","PAK_CONTAINER");
		break;
	case PAK_ORIENT_THEO:
		fprintf(pack,"%s\n","PAK_ORIENT_THEO");
		break;
	case PAK_BEGIN_ORIENT:
		fprintf(pack,"%s\n","PAK_BEGIN_ORIENT");
		break;
	case PAK_ACK:
		fprintf(pack,"%s\n","PAK_ACK");
		break;

	default:
		return;
	}
	fclose(pack);*/
}

BYTE PacketSocket::BugPacket()
{
	return TRUE;		  // for speed
	// assumes the packet data is valid!
	switch (Packet.Command)
	{
	case PAK_MEASUREMENT:
		TRACE("Measurement\n");
		break;
	case PAK_UPDATE:
		TRACE("update\n");
		break;
	case PAK_TEXT:		// assume NULL terminated!
		TRACE("txt: %s\n",Packet.Data.Raw);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BYTE PacketSocket::PrepareToSend()
{
	// prepare the sockets data for transmission!!
	// basically, set the DataSize parameter!
	switch (Packet.Command)
	{
	case PAK_FLAGS:
		DataSize = sizeof( Packet.Data.Flags );
		break;
	case PAK_UPDATE:
		DataSize = sizeof( Packet.Data.Update );
		break;
	case PAK_MEASUREMENT:
		DataSize =  sizeof( Packet.Data.Meas );
		break;
	case PAK_TEXT:
		DataSize = strlen( Packet.Data.Raw ) + 1; // include terminator!
		break;
	case PAK_SIGNON:
		DataSize =  sizeof( Packet.Data.SignOn );
		break;
	case PAK_ORIENT_THEO:
		DataSize =  sizeof( Packet.Data.OrientTheo );
		break;
	case PAK_BEGIN_ORIENT:
		DataSize =  sizeof( Packet.Data.BeginOrient );
		break;
	case PAK_ACK:
		DataSize =  sizeof( Packet.Data.Ack );
		break;
	case PAK_MVCLR:		// jmc mvp
		DataSize =  sizeof( Packet.Data.MVClr );
		break;
	case PAK_CLOUD:		// jmc mvp
		DataSize =  sizeof( Packet.Data.Cloud );
		break;
	///////////////////// jmc pak //////////////
	case PAK_WORKING_FRAME:	
		DataSize =  sizeof( Packet.Data.BaseAndWorking );
		break;
	case PAK_MAKE_LINE:	
		DataSize =  sizeof( Packet.Data.MakeLine );
		break;
	case PAK_MAKE_CIRCLE:	
		DataSize =  sizeof( Packet.Data.MakeCircle );
		break;
	case PAK_MAKE_SPHERE:	
		DataSize =  sizeof( Packet.Data.MakeSphere);
		break;
	case PAK_MAKE_CYLINDER:	
		DataSize =  sizeof( Packet.Data.MakeCylinder );
		break;
	case PAK_MAKE_PLANE:	
		DataSize =  sizeof( Packet.Data.MakePlane );
		break;
	case PAK_MEAS_GROUP:	
		DataSize =  sizeof( Packet.Data.MeasGroup );
		break;
	case PAK_INSPECT_OBJECT:
		DataSize = sizeof( Packet.Data.InspectObject );
		break;
	case PAK_STRING_ARRAY:
		DataSize = Packet.Data.StringArray.Size + 2;
		break;

	default:
		DataSize = 0;
		return FALSE;
	}
	return TRUE;
}
int PacketSocket::Receive(void* lpBuf, int nBufLen, int nFlags)
{
	// taken from the MCF SockCore code.  replaced the WOULDBLOCK to return
	// zero to override the csocket behavior of waiting for data!
	// we don't wait, we just return zero!!
	if (m_pbBlocking != NULL)
	{
		WSASetLastError(WSAEINPROGRESS);
		return  FALSE;
	}
	int nResult;
	while ((nResult = CAsyncSocket::Receive(lpBuf, nBufLen, nFlags)) == SOCKET_ERROR)
	{
		if (GetLastError() == WSAEWOULDBLOCK)
		{
			return 0;
		}
		else
			return SOCKET_ERROR;
	}
	return nResult;
}

void PacketSocket::OnReceive(int nErrorCode)
{
	//TRACE("In PS OnRecv\n");
	CSocket::OnReceive(nErrorCode);
	app.pA->ProcessPendingRead();  // handle the packet.
}

BOOL PacketSocket::SetSocketOptions(DWORD SendBufSize,DWORD RecBufSize,BOOL MakeSocFile,CString socfileprefix)
{
	BOOL ret = FALSE;
	//new buffer sizing stuff
	int size;
	size = sizeof(DWORD);
	if(!SetSockOpt( SO_SNDBUF, (void *) &SendBufSize, size, SOL_SOCKET ) )
	{
		CString s;
		s.Format("Could not set socket send buffer to %d bytes. Proceeding anyway.", SendBufSize);
		AfxMessageBox(s);
	}
	if(!SetSockOpt( SO_RCVBUF, (void *) &RecBufSize, size, SOL_SOCKET ) )
	{
		CString s;
		s.Format("Could not set socket receive buffer to %d bytes. Proceeding anyway.", RecBufSize);
		AfxMessageBox(s);
	}
	//////////////////
	BufFileOpen = FALSE;
	if(MakeSocFile)
	{
		/////New code for unique buf file names
		char bufname[1000];
		char tmppath[1000];
		GetTempPath(1000,tmppath);
		GetTempFileName(tmppath,socfileprefix.GetBuffer(500),0,bufname);
		socfileprefix.ReleaseBuffer();
		if (!SockBuf.Open( bufname,CFile::modeCreate | CFile::modeReadWrite | CFile::typeBinary) )
		{
			BufFileOpen = FALSE;
			AfxMessageBox("Problem allocating socket buffer file!");
			return FALSE;
		}
		else
			BufFileOpen = TRUE;  
	}
	return TRUE;
}
// stringarray packet handler functions.
void PacketSocket::CStringArrayToPak(CStringArray& csa)
{
	int MaxIndex = MAX_PACKET_DATA-50;  // just a little cushion.. probably only need -3, but we want to add trunc
	int index = 0;
	BOOL Full = FALSE;
	for (int i=0; i<csa.GetSize() && !Full;i++)
	{
		CString& s = csa.GetAt(i);
		TRACE("processing string %d, = %s\n",i,csa[i]);
		for (int j=0;j<s.GetLength();j++)
		{
			Packet.Data.StringArray.buf[index++] = s[j];
			if (index >= MaxIndex)
			{
				Full = TRUE;
				break;
			}
		}
		// done with line, add terminator.
		Packet.Data.StringArray.buf[index++] = NULL;
	}
	if (Full)
	{
		CString t("...[truncated]...");
		for (int j=0;j<t.GetLength();j++)
			Packet.Data.StringArray.buf[index++] = t[j];
		Packet.Data.StringArray.buf[index++] = NULL;	
	}
	Packet.Data.StringArray.Size = index + 1;
}
void PacketSocket::PakToCStringArray(CStringArray* pcsa)
{
	CString t;
	for (int index=0;index < Packet.Data.StringArray.Size;index++)
	{
		if (Packet.Data.StringArray.buf[index] == NULL)
		{
			pcsa->Add(t);
			t.Empty();
		}
		else
			t += Packet.Data.StringArray.buf[index];
	}
}


