// OptionButton.cpp: implementation of the OptionButton class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\\nrkapp.h"
#include "OptionButton.h"
#include "..\\DOptions.h"
#include "..\\DPCMM.h"
#include "..\\DPCMMDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OptionButton::OptionButton()
{
	Icon = IDI_OPTIONICON;  
}

OptionButton::~OptionButton()
{

}
BEGIN_MESSAGE_MAP(OptionButton, PictureButton)
	//{{AFX_MSG_MAP(OptionButton)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	ON_WM_RBUTTONDOWN()  // jmc pb
	ON_WM_LBUTTONDOWN()  // jmc pb
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TestButton message handlers
void OptionButton::HandleRButton()  // jmc pb
{
	// override me!
	//AfxMessageBox(" handle r button called... \n"));

}

void OptionButton::HandleLButton()  // jmc pb
{
	CDPCMMDlg& d = *((CDPCMMDlg*)app.m_pMainWnd);
	d.StopQueryTimer();
	Delay(0.2,TRUE);

	DOptions diag;
	diag.distunits = app.saarm.units.distunits;
	diag.m_Interval = app.saarm.Data.Interval/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.m_TNSN = app.saarm.Data.TargetNameStartNumber;
	diag.m_ButOne = app.saarm.Data.ButtonOneMode;
	diag.m_ButTwo = app.saarm.Data.ButtonTwoMode;
	diag.m_ButThree = app.saarm.Data.ButtonThreeMode;
	diag.m_IntervalUnits.Format(_T("%s"), app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	diag.m_PatchShiftUnits.Format(_T("%s"), app.saarm.units.DistUnitNames[app.saarm.units.distunits]);
	diag.m_AutoDetectProbe = app.saarm.Data.AutoDetectProbe;
	diag.distunits = app.saarm.units.distunits;
	diag.m_AddExtraPatchShift = app.saarm.Data.AddExtraPatchShift;
	diag.m_ExtraPatchShift = app.saarm.Data.ExtraPatchShift/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.m_FirePointsToo = app.saarm.Data.FirePointsToo;
	diag.updateSA = app.saarm.Data.alwaysupdateSA;
	diag.probeDia = app.saarm.Data.TipDia/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.useShankForAutoProx = app.saarm.Data.useShankForAutoProxMeas ? TRUE : FALSE;
	diag.shankDia = (app.saarm.Data.shankRadius*2.0)/app.saarm.units.UnitToMeters[app.saarm.units.distunits];
	diag.measfreq = 1.0/app.saarm.Data.meastimerperiodsec;
	diag.updatefreq = 1.0/app.saarm.Data.updatetimerperiodsec;
	diag.updatethreshold = app.saarm.Data.jtUpdateThreshold;
	diag.SendGeom = app.saarm.Data.SendGeom;
	diag.FaroAuxOn = app.saarm.Data.FaroAuxOn;
	diag.sendAllPtsAsCloudPts = app.saarm.Data.sendAllPtsAsCloudPts;
	diag.UseScanStripeClouds = app.saarm.Data.useScanStripeClouds ? TRUE : FALSE;
	
//	diag.m_ProbeNum = D.RomeServ.m_iCurrentProbeFile;
//	if(D.ComputerSound)
//		diag.m_CompSpkr = 0;
//	else 
//		diag.m_CompSpkr = 1;

	if(diag.DoModal()==IDOK)
	{
		app.saarm.units.distunits = diag.distunits;
		app.saarm.Data.FirePointsToo = diag.m_FirePointsToo;
		app.saarm.Data.Interval = diag.m_Interval*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
		app.saarm.Data.TargetNameStartNumber = diag.m_TNSN;

		app.saarm.Data.ButtonOneMode = diag.m_ButOne;
		app.saarm.Data.ButtonTwoMode = diag.m_ButTwo;
		if(app.pA->GetButtonCount() > 2 || app.pA->IsAPIBacesAxxis())
			app.saarm.Data.ButtonThreeMode = diag.m_ButThree; 

		app.saarm.Data.buttonOneMain = app.saarm.Data.ButtonOneMode;
		app.saarm.Data.buttonTwoMain = app.saarm.Data.ButtonTwoMode;
		app.saarm.Data.buttonThreeMain = app.saarm.Data.ButtonThreeMode;

		app.saarm.Data.AutoDetectProbe	= diag.m_AutoDetectProbe;
		app.saarm.Data.AddExtraPatchShift = diag.m_AddExtraPatchShift;
		app.saarm.Data.ExtraPatchShift = diag.m_ExtraPatchShift*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
		app.saarm.Data.alwaysupdateSA = diag.updateSA;
		app.saarm.Data.updatetimerperiodsec = 1.0/diag.updatefreq;
		app.saarm.Data.jtUpdateThreshold = diag.updatethreshold;
		app.saarm.Data.meastimerperiodsec = 1.0/diag.measfreq;
		app.saarm.Data.FaroAuxOn = diag.FaroAuxOn;
		app.saarm.Data.sendAllPtsAsCloudPts = diag.sendAllPtsAsCloudPts;
		app.saarm.Data.useScanStripeClouds = diag.UseScanStripeClouds ? true : false;

		if(!app.pA->IsRomer() && !app.pA->IsFrenchRomer() && !app.pA->IsKreonScannerArm())
			app.saarm.Data.TipDia = diag.probeDia*app.saarm.units.UnitToMeters[app.saarm.units.distunits];

		if(app.saarm.Data.AutoDetectProbe)
			app.pA->SetProbeAutoDetect(TRUE);
		else
			app.pA->SetProbeAutoDetect(FALSE);

		app.saarm.Data.useShankForAutoProxMeas = diag.useShankForAutoProx ? true : false;
		app.saarm.Data.shankRadius = (diag.shankDia/2.0)*app.saarm.units.UnitToMeters[app.saarm.units.distunits];
		if (app.saarm.Data.useShankForAutoProxMeas)
			app.saarm.Data.useScannerForAutoProxMeas = false;

		app.saarm.Data.SendGeom = diag.SendGeom;
	}

	if(!app.pA->trackArmActive)
		d.StartQueryTimer(app.saarm.Data.updatetimerperiodsec);

	SetState(FALSE);

//	D.SpkrVolume = diag.m_Volume;
//	if(RomeServ.IsConnectionEstablished())
//		RomeServ.m_iVolumeLevel = (int)(D.SpkrVolume*(4.0/10.0));
//	RomeServ.SetVolumeLevel();
//	if(diag.m_CompSpkr ==0)
//		D.ComputerSound = TRUE;
//	else 
//		D.ComputerSound = FALSE;
//set probe values as manual settings
//	RomeServ.m_bProbeAutoDetect = FALSE;  //don't let it autodetect
//	RomeServ.m_iCurrentProbeFile = diag.m_ProbeNum;  //set probe id to edit control

//	if(!RomeServ.ValidateCurrentProbe())  //if it doesnt validate
//	{
//		CString temp;
//		temp.Format(_T("Warning!  - Probe not validated"));
//		AfxMessageBox(temp,MB_ICONSTOP);
//	}

}