// PlaneObj.h: interface for the PlaneObj class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLANEOBJ_H__8101CD40_57CE_11D3_B7E1_00A0CC3992F9__INCLUDED_)
#define AFX_PLANEOBJ_H__8101CD40_57CE_11D3_B7E1_00A0CC3992F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GeometryObj.h"

class PlaneObj : public GeometryObj
{
public:
	PlaneObj();
	virtual ~PlaneObj();
	double A;
	double B;
	double C;
	double D;
	double patchShift;
	CString PlaneText;
	CString timeStamp;
	VectorArray oldPPts;	// backward compatibility
	ArmPointArray PPts;
	
	BOOL ComputePlane(ArmPointArray* VA);
	void MapCoefficientsToWorking(double* a, double* b, double* c, double* d);
	void ProjectPointsToPlane(VectorArray& VA,VectorArray* pPtsOut);
	void ProjectPointToPlane(Vector& pIn,Vector* pOut);
	double QueryPointToPlane(Vector& pt);
	void SetFromSAIPGeomPlane(const SAIPGeomPlane& saipPlane);
	void GetSAIPGeomPlane(SAIPGeomPlane& saipPlane);

	virtual void operator=(const GeometryObj& geOb);

	virtual void Serialize(CArchive& ar);
protected:
	DECLARE_SERIAL( PlaneObj );
};

#endif // !defined(AFX_PLANEOBJ_H__8101CD40_57CE_11D3_B7E1_00A0CC3992F9__INCLUDED_)
