// ArmQuickSock.cpp: implementation of the ArmQuickSock class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\DPCMM.h"
#include "..\DPCMMDlg.h"
#include "QSMeasRequest.h"
#include "ArmQuickSock.h"
#include "QSFrame.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ArmQuickSock::ArmQuickSock()
{
}

ArmQuickSock::~ArmQuickSock()
{

}

void ArmQuickSock::Init()
{
	// initialize quick sockets
	if (!ListenForPackets(new QuickSockListen))// make a listener to allow connetions. 
	{
		AfxMessageBox("Unable to Listen For QuickSock Connections.");
	}			
	//  send a packet to SA to let it know what quick sockets are alive and well for this interface.
	OutboundComputer = app.pA->Data.SAComputer;
	OutboundPort = app.pA->Data.SAPort;
	CObArray Obj;
	AddHeader(&Obj);
	if (!SendPacket(Obj,app.pA->Data.SAComputer,app.pA->Data.SAPort))
	{
		AfxMessageBox("Could not send batch packet initialization.");
	}
	delete Obj[0];  // clear out the header.
/*
// Test QuickSock - be sure we can send a frame to SA
	Transform test;
	Vector p[3];
	p[0].x = 1.0;
	p[0].x = 1.0;
	p[0].x = 1.0;
	p[1].x = 2.0;
	p[1].x = 2.0;
	p[1].x = 2.0;
	p[2].x = 3.0;
	p[2].x = 3.0;
	p[2].x = 3.0;
	test.Set(p);
	CStringArray note;
	note.Add("This is a test frame from DTrack.");
	SendFrameToSA(test, note);
*/
}

void ArmQuickSock::ProcessPacket(CObArray* pObjs)
{
	QuickHeader* pHead = ProcessPacketHeader(pObjs);
	
	// need to process the object array of packet entities.
	TRACE("scan sock! received %d objects\n",pObjs->GetSize());
	for (int i=0;i<pObjs->GetSize();i++)
	{
		CObject* po = pObjs->GetAt(i);
		
		if (po->IsKindOf(RUNTIME_CLASS(QSMeasRequest)))
		{
			OnQSMeasRequest(pHead, po);
		}
	}

	if (pHead != NULL)
		delete pHead;

	pObjs->RemoveAll();
	delete pObjs;		// removes the array of packets, but does not delete individuals This // must be done in
							// OnReceived handlers, or elsewhere at the user's discretion.

}

void ArmQuickSock::OnQSMeasRequest(QuickHeader* pHead, CObject* pobj)
{
	QSMeasRequest& qsmr = *((QSMeasRequest*)pobj);
//	if(qsmr.RequestType==UPDATE_FRAME)
//		((CDPCMMDlg*)pArmDlg)->OnRequestFrame();
//	else if(qsmr.RequestType==MEAS_FRAME)
//		((CDPCMMDlg*)pArmDlg)->SendFrameMeasurement(qsmr.Name);

	delete pobj;
}
BOOL ArmQuickSock::SendFrameToSA(Transform& t, CStringArray& notes)
{
	QSFrame pack;
//	pack.Name.Format("%s::%s",app.pA->Data.Group,app.pA->Data.Target);
	for (int i=0;i<notes.GetSize();i++)
		pack.Notes.Add(notes[i]);
	pack.FrameInInst.Set( t );

	return SendQuickSockPacket(pack);
}
BOOL ArmQuickSock::SendReportItem(CString& Title, CString& Type, CStringArray& BodyText)
{	
	QSReportItem rep;
//	rep.Title.Format("Tracker SN %d %s %s %s %s",
//		d.Data.TrackerSN, app.VString, d.InstIndex, CTime::GetCurrentTime().Format("(%c)"), Title);
	rep.Title.Format("%s %s", Title, CTime::GetCurrentTime().Format("(%c)"));
	rep.Type.Format("%s", Type);
	for( int i=0; i<BodyText.GetSize(); i++ )
		rep.BodyText.Add(BodyText[i]);

	return SendQuickSockPacket(rep);
}

BOOL ArmQuickSock::SendReportItem(CString& Title, CString& Type, CString& BodyText)
{	
	QSReportItem rep;
//	rep.Title.Format("Tracker SN %d %s %s %s %s",
//		d.Data.TrackerSN, app.VString, d.InstIndex, CTime::GetCurrentTime().Format("(%c)"), Title);
	rep.Title.Format("%s %s", Title, CTime::GetCurrentTime().Format("(%c)"));
	rep.Type.Format("%s", Type);
	rep.BodyText.Add(BodyText);

	return SendQuickSockPacket(rep);
}

BOOL ArmQuickSock::SendReportItem(const char* Title, const char* Type, CStringArray& BodyText)
{	
	QSReportItem rep;
//	rep.Title.Format("Tracker SN %d %s %s %s %s",
//		d.Data.TrackerSN, app.VString, d.InstIndex, CTime::GetCurrentTime().Format("(%c)"), Title);
	rep.Title.Format("%s %s", Title, CTime::GetCurrentTime().Format("(%c)"));
	rep.Type.Format("%s", Type);
	for( int i=0; i<BodyText.GetSize(); i++ )
		rep.BodyText.Add(BodyText[i]);

	return SendQuickSockPacket(rep);
}

BOOL ArmQuickSock::SendReportItem(const char* Title, const char* Type, CString& BodyText)
{	
	QSReportItem rep;
//	rep.Title.Format("Tracker SN %d %s %s %s %s",
//		d.Data.TrackerSN, app.VString, d.InstIndex, CTime::GetCurrentTime().Format("(%c)"), Title);
	rep.Title.Format("%s %s", Title, CTime::GetCurrentTime().Format("(%c)"));
	rep.Type.Format("%s", Type);
	rep.BodyText.Add(BodyText);

	return SendQuickSockPacket(rep);
}

