#pragma once
//#define RDS_API_UNICODE
#include "HexagonRDS/RDS_API.h"		// RDS API include

// RDSWindowsMessenger

class HexagonRDS;

// Perceptron scanner
#define CLOSE_SCAN_DLG (WM_APP + 4)
#define UPDATE_SCAN_DLG (WM_APP + 5)
#define SEND_BUFFERED_DATA_AND_RECONNECT	(WM_APP + 6)

class RDSWindowsMessenger : public CDialog
{
	DECLARE_DYNAMIC(RDSWindowsMessenger)

public:
	RDSWindowsMessenger(HexagonRDS* _owner);
	virtual ~RDSWindowsMessenger();

	friend class HexagonRDS;

	bool MakeValidWindow();		// call once to initialize the window for message handling.
	bool windowValid;

	void ProcessArmData(bool reliablePos, sRDSPosition& p);

	void RunProbeCal();
	void DoArmSettings();

	void OutputSpeakerSound( int frequency, int duration );
	void ArmBeep(int sound);

	BOOL IsRemoteMouseEnabled();
	void RemoteMouse(BOOL flag);
	void ToggleRemoteMouse();

	void OnPostInit();
	bool IsConfiguredForTracker() {return configuredForTracker;}
	int GetProbeType() {return probeType;}

	void Disconnect(); // 2018.02.09 - added for use with new criticalNetError in QuickSock - not used yet
	void Reconnect();  // 2018.02.09 - added for use with new criticalNetError in QuickSock - not used yet

protected:
	bool		firstMessageReceieved;
	bool		armDisconnectedShutDownInProgress;

	BOOL		m_bButton1State;
	BOOL		m_bButton2State;
	BOOL		m_bButton3State;
	BOOL		m_bEventSyncd, m_bEventEasy, m_bRemoteMouseON;
	BOOL		m_bServerAvailable;
	BOOL		m_bVCRunning;
	BOOL		m_bPreviewing;
	BOOL		m_bScanning;

	Transform armFrame;
	sRDSPosition	m_Position;
	BOOL m_bHeadLightIsOn;

	CriticalSectionWrapper& scannerCS;

	int probeType;
	int previousProbeType;  // we have to police for probe changes - rds will send probe data as many as 4 times when the probe changes!
	CString probeName;

	RDS_ADD_VARIABLES

	void AddToLog(LPCTSTR criticity, LPCTSTR format, ...);

	DECLARE_MESSAGE_MAP()
	HexagonRDS& owner;
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

private:
//	DWORD TubeProbeState;
	bool configuredForTracker;
	bool syncedScanData;
};


