//______________________________________________________________________________

// File: RomErrs.h


#ifndef __ROMERRS_H__		//{
#define __ROMERRS_H__

#define ROMER_ERROR_BASE	0x25145000		// For User codes Bit 29 must be on

enum r6sc_error_labels								// Range: 000 - 1FF
{
	R6SC_ERROR_BASE = ROMER_ERROR_BASE + 0x000,

	R6SC_ERROR_CONTROLLER_ERROR = R6SC_ERROR_BASE,
					// R6SC controller errors are in the range: 0x000-0x0ff

	R6SC_ERROR_CONNECTION_ALREADY_OPEN = R6SC_ERROR_BASE + 0x100,
	R6SC_ERROR_MEMORY_ALLOCATION,
	R6SC_ERROR_CTS_OFF,
	R6SC_ERROR_CONNECTION_ALREADY_CLOSED,
	R6SC_ERROR_RECEIVE_WAIT_FAILURE,
	R6SC_ERROR_RECEIVE_WAIT_TIMEOUT,
	R6SC_ERROR_SEND_WAIT_FAILURE,
	R6SC_ERROR_SEND_WAIT_TIMEOUT,
	R6SC_ERROR_CONNECTION_NOT_OPEN,
	R6SC_ERROR_DISCONNECTED,

	R6SC_ERROR_MISSING_MSG_HEADER,
	R6SC_ERROR_UNEXPECTED_MSG_LENGTH,
	R6SC_ERROR_INCORRECT_MSG_CHECKSUM,
	R6SC_ERROR_UNRECOGNIZED_MSG,
	R6SC_ERROR_NO_ACTIVE_COUNTER,
	R6SC_ERROR_INVALID_COUNTER,
	R6SC_ERROR_RESET_NOT_DONE,
	R6SC_ERROR_SPECIAL_RECORD_NOT_SUPPORTED,

	R6SC_ERROR_RECEIVE_RETRY_FAILURE,
	R6SC_ERROR_SEND_RETRY_FAILURE,

	R6SC_ERROR_MAX_ERROR,
};


enum rdensc_error_labels								// Range: 200 - 4FF
{
	RDENSC_ERROR_BASE = ROMER_ERROR_BASE + 0x200,

	RDENSC_ERROR_SYSTEMCOM_ERROR = RDENSC_ERROR_BASE,
					// RDENSC System Com errors are in the range: 0x200-0x2ff
	RDENSC_ERROR_CONTROLLER_ERROR = RDENSC_ERROR_BASE + 0x100,
					// RDENSC controller errors are in the range: 0x300-0x3ff

					// other RDENSC errors are in the range: 0x400-0x4ff

	RDENSC_ERROR_CONFIG_FILE_NOT_OPENED = RDENSC_ERROR_BASE + 0x200,
	RDENSC_ERROR_CONFIG_FILE_INVALID,
	RDENSC_ERROR_CONFIG_FILE_NO_COUNTERS,
	RDENSC_ERROR_CONNECTION_ALREADY_OPEN,
	RDENSC_ERROR_MEMORY_ALLOCATION,
	RDENSC_ERROR_CONNECTION_ALREADY_CLOSED,
	RDENSC_ERROR_RECEIVE_WAIT_FAILURE,
	RDENSC_ERROR_RECEIVE_WAIT_TIMEOUT,
	RDENSC_ERROR_SEND_WAIT_FAILURE,
	RDENSC_ERROR_SEND_WAIT_TIMEOUT,
	RDENSC_ERROR_CONNECTION_NOT_OPEN,
	RDENSC_ERROR_DISCONNECTED,

	RDENSC_ERROR_REPLY_NODE_ID,
	RDENSC_ERROR_INCORRECT_MSG_CHECKSUM,

	RDENSC_ERROR_CHANGED_EVENT_CODE,
	RDENSC_ERROR_INVALID_COUNTER,
	RDENSC_ERROR_RESET_NOT_DONE,
	RDENSC_ERROR_SPECIAL_RECORD_NOT_SUPPORTED,

	RDENSC_ERROR_SEND_RETRY_FAILURE,

	RDENSC_ERROR_NOT_INITIALIZED,
	RDENSC_ERROR_NO_BOARDS_FOUND,
	RDENSC_ERROR_ALL_BOARDS_NOT_FOUND,	// added bjf 03/29/02 to support new rxxc.dll
	RDENSC_ERROR_RECORD_DATA_COUNT,
	RDENSC_ERROR_SOFT_COMM,
	RDENSC_ERROR_HARD_COMM,
	RDENSC_ERROR_CE_BREAK,
	RDENSC_ERROR_CE_FRAME,
	RDENSC_ERROR_CE_IOE,
	RDENSC_ERROR_CE_OVERRUN,
	RDENSC_ERROR_CE_RXOVER, 
	RDENSC_ERROR_CE_RXPARITY,

	RDENSC_ERROR_NO_USB_DEVICES_FOUND,
	RDENSC_ERROR_NO_USB_FIRMWARE_FILE,
	RDENSC_ERROR_INVALID_PID_OR_VID,
	RDENSC_ERROR_USB_HARDWARE_ERROR,

	RDENSC_ERROR_TCP_CANNOT_CREATE_SOCKET,
	RDENSC_ERROR_TCP_CANNOT_CONNECT,
	RDENSC_ERROR_TCP_INVALID_IP_ADDRESS,

	RDENSC_ERROR_OUT_OF_ARM_SPECS_MEMORY,
	RDENSC_ERROR_USB_FIRMWARE_WRONG_VERSION,
	RDENSC_ERROR_LOADING_USB_FIRMWARE_FILE,

	RDENSC_ERROR_TCP_CANNOT_COMMUNICATE,

	RDENSC_ERROR_NO_EPROM,
	RDENSC_ERROR_NO_SERIAL_NUMBER_PGM,
	RDENSC_ERROR_EPROM_CRC_ERROR,
	RDENSC_ERROR_BAD_ID_SWITCH,

	RDENSC_ERROR_NO_WIFI_CONNECTION,


	RDENSC_ERROR_MAX_ERROR,
};

enum stinger_error_labels								// Range: A00 - CFF
{
	STINGER_ERROR_BASE = ROMER_ERROR_BASE + 0xA00,

	STINGER_ERROR_SYSTEMCOM_ERROR = STINGER_ERROR_BASE,
					// STINGER System Com errors are in the range: 0xA00-0xAff
	STINGER_ERROR_CONTROLLER_ERROR = STINGER_ERROR_BASE + 0x100,
					// STINGER controller errors are in the range: 0xB00-0xBff

					// other STINGER errors are in the range: 0xC00-0xCff

	STINGER_ERROR_CONFIG_FILE_NOT_OPENED = STINGER_ERROR_BASE + 0x200,
	STINGER_ERROR_CONFIG_FILE_INVALID,
	STINGER_ERROR_CONFIG_FILE_NO_COUNTERS,
	STINGER_ERROR_CONNECTION_ALREADY_OPEN,
	STINGER_ERROR_MEMORY_ALLOCATION,
	STINGER_ERROR_CONNECTION_ALREADY_CLOSED,
	STINGER_ERROR_RECEIVE_WAIT_FAILURE,
	STINGER_ERROR_RECEIVE_WAIT_TIMEOUT,
	STINGER_ERROR_SEND_WAIT_FAILURE,
	STINGER_ERROR_SEND_WAIT_TIMEOUT,
	STINGER_ERROR_CONNECTION_NOT_OPEN,
	STINGER_ERROR_DISCONNECTED,

	STINGER_ERROR_REPLY_NODE_ID,
	STINGER_ERROR_INCORRECT_MSG_CHECKSUM,

	STINGER_ERROR_CHANGED_EVENT_CODE,
	STINGER_ERROR_INVALID_COUNTER,
	STINGER_ERROR_RESET_NOT_DONE,
	STINGER_ERROR_SPECIAL_RECORD_NOT_SUPPORTED,

	STINGER_ERROR_SEND_RETRY_FAILURE,

	STINGER_ERROR_NOT_INITIALIZED,
	STINGER_ERROR_NO_BOARDS_FOUND,

	STINGER_ERROR_MAX_ERROR,
};


enum calib_error_labels								// Range: 700 - 7FF
{
	XDAT_ERROR_BASE = ROMER_ERROR_BASE + 0x700,

	XDAT_ERROR_PROBE_FILE_NOT_OPENED = XDAT_ERROR_BASE,
	XDAT_ERROR_PROBE_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_ARMSPECS_FILE_NOT_OPENED,
	XDAT_ERROR_PROBE_FILE_CORRUPTED,
	XDAT_ERROR_PROBE_DATA_FILE_CORRUPTED,
	XDAT_ERROR_ARMSPECS_FILE_CORRUPTED,
	XDAT_ERROR_ARM_CONFIGURATION_FILE_NOT_OPENED,
	XDAT_ERROR_PLANE1,
	XDAT_ERROR_PLANE2,
	XDAT_ERROR_STATIC_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_STATIC_DATA_FILE_CORRUPTED,
	XDAT_ERROR_LEAPFROG_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_LEAPFROG_DATA_FILE_CORRUPTED,
	XDAT_ERROR_LEAPFROG_DATA_CORRUPTED,
	XDAT_ERROR_LEAPFROG_DATA_COMPUTABLE,
	XDAT_ERROR_CALIBRATE_FILE_NOT_OPENED,
	XDAT_ERROR_XREFERENCE_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_XREFERENCE_DATA_FILE_CORRUPTED,
	XDAT_ERROR_LEAPFROG_DATA_NOT_COMPUTABLE,
	XDAT_ERROR_LINEAR_AXIS_FILE_NOT_OPENED,
	XDAT_ERROR_LINEAR_AXIS_FILE_CORRUPTED,
	XDAT_ERROR_GRIDLOCK_POINTS_FILE_NOT_OPEN,
	XDAT_ERROR_GRIDLOCK_POINTS_FILE_CORRUPTED,
	XDAT_ERROR_GRIDLOCK_NOMINAL_FILE_NOT_OPEN,
	XDAT_ERROR_GRIDLOCK_NOMINAL_FILE_CORRUPTED,
	XDAT_ERROR_GRIDLOCK_PATTERN_NOT_FOUND,
	XDAT_ERROR_GRIDLOCK_PATTERN_INDETERMINANT,
	XDAT_ERROR_GRIDLOCK_REFERENCE_CORRUPTED,
	XDAT_ERROR_LINEAR_AXIS_SET_UP_PROBLEM,
	XDAT_ERROR_LINEAR_AXIS_DATA_OUT_OF_RANGE,
	XDAT_ERROR_LINEAR_AXIS_BEST_FIT_EXCEEDS_LIMIT,
	XDAT_ERROR_TUNEUP_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_TUNEUP_SPEC_FILE_NOT_OPENED,
	XDAT_ERROR_TUNEUP_SPEC_FILE_CORRUPTED,
	XDAT_ERROR_TUNEUP_PROCESS_FAILED,
	XDAT_ERROR_REPAIR_DATA_FILE_CORRUPTED,
	XDAT_ERROR_FINE_TUNE_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_FINE_TUNE_DATA_FILE_CORRUPTED,
	XDAT_ERROR_FINE_TUNE_SPEC_FILE_NOT_OPENED,
	XDAT_ERROR_FINE_TUNE_SPEC_FILE_CORRUPTED,
	XDAT_ERROR_FINE_TUNE_PROCESS_FAILED,
	XDAT_ERROR_ROTARY_AXIS_FILE_NOT_OPENED,
	XDAT_ERROR_ROTARY_AXIS_FILE_CORRUPTED,
	XDAT_ERROR_ROTARY_AXIS_SET_UP_PROBLEM,
	XDAT_ERROR_ROTARY_AXIS_DATA_OUT_OF_RANGE,
	XDAT_ERROR_ROTARY_AXIS_BEST_FIT_EXCEEDS_LIMIT,
	XDAT_ERROR_PROFILE_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_PROFILE_PROCESS_FAILED,
	XDAT_ERROR_PROFILE_FILE_NOT_OPENED,
	XDAT_ERROR_PROFILE_FILE_CORRUPTED,
	XDAT_ERROR_PROFILE_FILE_UNWRITEABLE,
	XDAT_ERROR_PROFILE_DATA_FILES_OUT_OF_RANGE,
	XDAT_ERROR_CALIBRATE_FILE_CORRUPTED,
	XDAT_ERROR_TEMP_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_TEMP_PROCESS_FAILED,
	XDAT_ERROR_PLANE_BAR_DATA_FILE_NOT_OPENED,
	XDAT_ERROR_PLANE_BAR_PROCESS_FAILED,
	XDAT_ERROR_PLANE_BAR_FILE_NOT_OPENED,
	XDAT_ERROR_PLANE_BAR_FILE_CORRUPTED,
	XDAT_ERROR_PLANE_BAR_FILE_UNWRITEABLE,
	XDAT_ERROR_PLANE_BAR_DATA_FILES_OUT_OF_RANGE,
	XDAT_ERROR_MAX_ERROR,
};


enum winrds_error_labels								// Range: 800 - FFF
{
	WINRDS_ERROR_BASE = ROMER_ERROR_BASE + 0x800,

	WINRDS_ERROR_NOT_AN_AFXAPP = WINRDS_ERROR_BASE,
	WINRDS_ERROR_PROBE_FILE_NOT_OPENED,
	WINRDS_ERROR_PROBE_FILE_FORMAT,
	WINRDS_ERROR_ARMSPECS_FILE_NOT_OPENED,
	WINRDS_ERROR_ARMSPECS_FILE_FORMAT,
	WINRDS_ERROR_RESET_CANCELLED_BY_USER,
	WINRDS_ERROR_MOUSE_SUSPENSION,
	WINRDS_ERROR_CONNECTION_NOT_ESTABLISHED,
	WINRDS_ERROR_CONNECTION_ALREADY_ESTABLISHED,
	WINRDS_ERROR_PROBE_ID_MISMATCH,
	WINRDS_ERROR_ENCODER_INDEX,
	WINRDS_ERROR_SPECIAL_MEASURE_DISABLED,
	WINRDS_ERROR_LINEAR_AXIS_SPECS_BAD_LABEL,
	WINRDS_ERROR_LINEAR_AXIS_UNAVAILABLE,
	WINRDS_ERROR_STATIC_XREFS_UNAVAILABLE,
	WINRDS_ERROR_STATIC_XREF_NUMBER_INVALID,
	WINRDS_ERROR_LINRAXIS_XRF_FILE_NOT_OPENED,
	WINRDS_ERROR_LINRAXIS_XRF_FILE_FORMAT,
	WINRDS_ERROR_STATIC_XRF_FILE_NOT_OPENED,
	WINRDS_ERROR_STATIC_XRF_FILE_FORMAT,
	WINRDS_ERROR_BOARD_DIRECTIONS_FILE_NOT_OPENED,
	WINRDS_ERROR_BOARD_DIRECTIONS_FILE_FORMAT,

	WINRDS_ERROR_ARM_OVER_LIMIT,

	// Firmware download and arm diagnosis
	WINRDS_ERROR_CONNECTION_ALREADY_OPEN,
	WINRDS_ERROR_MEMORY_ALLOCATION,
	WINRDS_ERROR_COM_PORT_NOT_OPEN,
	WINRDS_ERROR_CTS_OFF,
	WINRDS_ERROR_CONNECTION_ALREADY_CLOSED,
	WINRDS_ERROR_RECEIVE_WAIT_FAILURE,
	WINRDS_ERROR_RECEIVE_WAIT_TIMEOUT,
	WINRDS_ERROR_SEND_WAIT_FAILURE,
	WINRDS_ERROR_SEND_WAIT_TIMEOUT,
	WINRDS_ERROR_FIRMWARE_FILE_NOT_OPEN,
	WINRDS_ERROR_DOWNLOAD_CANCELLED_BY_USER,
	WINRDS_ERROR_WRONG_ECHO,
	WINRDS_ERROR_NOT_AVAILABLE_FOR_2000_SERIES,
	WINRDS_ERROR_INVALID_COMMAND_RESPONSE,
	WINRDS_ERROR_INCORRECT_PACKET_SIZE,
	WINRDS_ERROR_INVALID_ID_RESPONSE,
	WINRDS_ERROR_INCORRECT_PACKET_CHECKSUM,
	WINRDS_ERROR_SYSTEM_CONTROLLER_ERROR,
	WINRDS_ERROR_ARM_VERSION,

	WINRDS_ERROR_CANT_COMMUNICATE,
	WINRDS_ERROR_USER_PERMISSION_INADEQUATE,
	WINRDS_ERROR_SIMULTANEOUS_EVENTS,
	WINRDS_ERROR_XDAT_DATA_ERROR,
	WINRDS_ERROR_ROTARY_AXIS_SPECS_BAD_LABEL,
	WINRDS_ERROR_ROTARY_AXIS_UNAVAILABLE,
	WINRDS_ERROR_ROTRAXIS_XRF_FILE_NOT_OPENED,
	WINRDS_ERROR_ROTRAXIS_XRF_FILE_FORMAT,
	WINRDS_ERROR_EVENT_NOISE_FILTER,
	WINRDS_ERROR_ARM_INTERPOLATION_ERROR,
	WINRDS_ERROR_ARM_TIMEOUT,
	WINRDS_ERROR_LICENSE_DENIED,
	WINRDS_NOT_INSTALLED,
	WINRDS_CANNOT_FIND_ARMSPECS,
	WINRDS_SERIAL_NUMBER_MISMATCH,
	WINRDS_INVALID_SERIAL_NUMBER,
	WINRDS_NEED_RDENSCDLL,
	WINRDS_NEED_R6SCDLL,
	WINRDS_SCANNER_KEEP_GOING,
	WINRDS_MODEL_MISMATCH,
	WINRDS_RUNCODE_VERSION_TOO_LOW,
	WINRDS_PROBE_NOT_CALIBRATED,
	WINRDS_BAD_ARGUMENT,
	/////////////////////

	WINRDS_ERROR_SECURITY_BASE = ROMER_ERROR_BASE + 0x900,

	WINRDS_ERROR_SECURITY_INIT_FIND = WINRDS_ERROR_SECURITY_BASE,
	WINRDS_ERROR_SECURITY_WRITE,
	WINRDS_ERROR_SECURITY_READ_VALIDATE,
	WINRDS_ERROR_SECURITY_WRITE_VALIDATE,
	WINRDS_ERROR_SECURITY_SYSTEM_DATE_MISMATCH,
	WINRDS_ERROR_SECURITY_EXPIRED_KEY,
	WINRDS_ERROR_SECURITY_SLAVE_EXPIRED,
	WINRDS_ERROR_SECURITY_OFFLINE_KEY,
	WINRDS_ERROR_SECURITY_NO_WINRDS,
	WINRDS_ERROR_SECURITY_SS_CODE,
	WINRDS_ERROR_SECURITY_NO_RAIL_CODE,
	WINRDS_ERROR_SECURITY_NO_GRIDLOCK_CODE,
	WINRDS_ERROR_SECURITY_NO_ROTATE_CODE,


	WINRDS_ERROR_MAX_ERROR,
};

#endif		//}
