
#ifndef GDSDLL_ENTRY_POINT
#define GDSDLL_ENTRY_POINT

#ifndef GDSEXPORT
#define GDSEXPORT 
#endif

#ifdef __cplusplus
extern "C"  {
#endif

#define ACTIVEREFRENCE		1
#define SETIP_AND_MASK		2


#define CAPTEURV			0x01
#define CAPTEURCONTACT		0x02
#define CAPTEURPLA			0x03
#define CAPTEURRENISHAW		0x04
#define CAPTEURUDT			0x05
#define CAPTEURVERTEX			0x06
#define CAPTEURROTATIF			0x07
#define CAPTEURVIDEOPROBEV2		0x09
#define CAPTEURVIDEOPROBEV3		0x0a


#define EVENTBP2B2			0x01 
#define EVENTBP1			0x02
#define EVENTB1PLA			0x04

#define SWITCH1				1
#define SWITCH2BEAM2			0
#define BEAM1				2

typedef long (__cdecl* tgdsResetEvents)(void);
typedef long (__cdecl* tgdsPoint)(double FAR* tabXYZABC,double FAR* Analog,BOOL WithEvents);
typedef long (__cdecl* tgdsLatchCounter)(double FAR* Counter,double FAR* Analog,BOOL WithEvents);	// 2005.12.28 - blt - added to make jt. angles work
typedef long (__cdecl* tgdsSound)(long Frequency, long Duration);
typedef long (__cdecl* tgdsSetEvents)(int NbLatchs);
typedef long (__cdecl* tgdsButtonState)(short Button,BOOL WithEvents);
typedef LPCTSTR (__cdecl* tgdsGetErrorMessage)(long ErrorNumber);
typedef void (__cdecl* tgdsSetMouseMode)(BOOL State);
typedef long (__cdecl* tgdsUseEventSound)(BOOL Use);
typedef long (__cdecl* tgdsArmResetDisplayed)(BOOL bForceReset);
typedef long (__cdecl* tgdsConnect)(void);
typedef long (__cdecl* tgdsSetUserID)(int);
typedef long (__cdecl* tgdsDisConnect)(void);
typedef long (__cdecl* tgdsConfigArm)(void);
typedef long (__cdecl* tgdsSetProbeIndex)(int ProbeIndex);
typedef long (__cdecl* tgdsVideoProbeFunctions)(long Action,double *Parameters);
typedef long (__cdecl* tgdsGetVideoProbePoints)(double *Points,long *NbPoints,BOOL Calulated);
typedef long (__cdecl* tgdsGetProbeType)(void);
//////////////////////////////////////////////////////////////
// 2007.01.03 - blt - added all the following...
typedef double(__cdecl* tgdsGetProbeDiameter)(void);
typedef long(__cdecl* tgdsGetProbeIndex)();
typedef BOOL(__cdecl* tgdsSetProbeDetection)(BOOL used);
typedef BOOL(__cdecl* tgdsGetProbeDetection)(void);
typedef BOOL(__cdecl* tgdsGetMouseMode)(void);
typedef void (__cdecl* tgdsSetAutomaticMouse)(BOOL state);
typedef BOOL (__cdecl* tgdsGetAutomaticMouse)(void);
typedef void (__cdecl* tgdsSetMouseModeEx)(int state);
typedef int (__cdecl* tgdsGetMouseModeEx)(void);
typedef void (__cdecl* tgdsSetUseMouse)(BOOL state);
typedef BOOL (__cdecl* tgdsGetUseMouse)(void);
typedef long (__cdecl* tgdsGetNewProbe)(void);
///////////////////////////////////////////////////////////////

enum SpecialFunctions
{
	LEAPFROG	=0x04,
};

enum VideoProbeFuntions
{
	//Autorize the acquisition of points and bufferize when Bp1 is pressed
	VPF_START_ACQUISITION= 0x01,
	//Stop the bufferization
	VPF_STOP_ACQUISITION= 0x02,
	//Clean the buffer
	VPF_CLEAR_BUFFER= 0x03,
	//Calibration Function1
	VPF_CALF1=0x04,
	//Calibration Function2
	VPF_CALF2=0x05,
	//Calibration Function3
	VPF_CALF3=0x06,
	//Calibration Function4
	VPF_CALF4=0x07,
	//Setup the camera to get points without BP1 pressed
	VPF_GET_DATA_WITHOUT_BP1_PRESSED= 0x08,
	//Return the serial number of the camera
	VPF_GET_CAMERA_SERIAL_NUMBER =0x0A,
	//Retrun  the camera data
	VPF_GET_CAMERA_INFO =0x0B,

	//Display the real time video of the camera
	VPF_DISPLAY_THE_CAMERA_VIEW_ON =0x21,
	VPF_LEVEL_MANAGEMENT_GET=0x22,
	VPF_GAIN_MANAGEMENT_GET=0x24,
	VPF_CAMERAEXPOSURE_MANAGEMENT_GET=0x26,
	VPF_MINMMAXHEIGHT_MANAGEMENT_GET=0x28,
	VPF_SETTINGS_MANAGEMENT_GET=0x2A,
	VPF_GET_DATA_WITHOUT_BP1_OFF=0x2C,

	//Display the real time video of the camera
	VPF_DISPLAY_THE_CAMERA_VIEW_OFF =0x20,
	VPF_LEVEL_MANAGEMENT_SET=0x23,
	VPF_GAIN_MANAGEMENT_SET=0x25,
	VPF_CAMERAEXPOSURE_MANAGEMENT_SET=0x27,
	VPF_MINMMAXHEIGHT_MANAGEMENT_SET=0x29,
	VPF_SETTINGS_MANAGEMENT_SET=0x2B,
	VPF_GET_DATA_WITHOUT_BP1_ON=0x2D

};

/*#Define LA 		220
#Define SIb 	234
#Define DO 		249
#Define DOd 	265
#Define RE 		283
#Define REd 	301
#Define MI 		321
#Define FA 		341
#Define FAd 	364
#Define SOL 	387
#Define SOLd 	413
#Define LA 		440
#Define SIb 	468
#Define DO 		499
#Define DOd 	531
#Define RE 		566
#Define REd 	602
#Define MI 		642
#Define FA 		683
#Define FAd 	728
#Define SOL 	775
#Define SOLd 	826
#Define LA 		880
#Define SIb 	937
#Define DO 		998
#Define DOd 	1063
#Define RE 		1132
#Define REd 	1205
#Define MI 		1284
#Define FA 		1367
#Define FAd 	1456
#Define SOL 	1551
#Define SOLd 	1652
#Define LA 		1760*/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to give your user number
//
//		Fonction permettant d'indiquer votre numro d'utilisateur
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters
//
//				Indidentification of the driver's user
//
//		Paramtres entre : 
//
//				Identification de l'utilisateur du driver
//
//-----------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSetUserID(int User);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to run the arm communication
//
//		Fonction permettant de lancer la communication avec le bras
//
//-----------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters : 
//
//		Paramtres entre : 
//
//-----------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsConnect(); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Function which allows to stop the communication with the arm
//		
//		Fonction permettant de Stopper la communication avec le bras
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters : 
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsDisConnect();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to reset the machine
//
//		Fonction permettant de lancer l'initialisation de machine (RESET)
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//	In parameters :
//
//				TRUE the reset of the machine is automatically requested
//				FALSE the reset of the machine is requested when the feeding of the arm is turned off
//
//	Paramtres entre : 
//
//				TRUE	l'initialisation de la machine est demand systmatiquement
//				FALSE	L'initialisation de la machine est demand que si l'alimentation du bras  t coupe
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsArmResetDisplayed(BOOL bForceReset);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to recover information in the machine
//
//		Fonction permettant de rcuprer des information sur la machine
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
///
//		In parameters :
//
//				if you get the authorisation to use the machine
//				the type of the electronic board used with the machine
//				the serial number of the machine
//				the number of availabe encoders
//				the number of available probes
//				the diameter of each probe
//				the type of each probe
//
//		Paramtres entre : 
//
//				Si l'autorisation d'utiliser la machine est accorde
//				Le Type de carte lectronique utilis dans la machine
//				Le numro de srie de la machine
//				Le Nombre de codeurs disponibles
//				Le nombre de capteurs disponibles
//				Le Diamtre de chaque capteur
//				Le Type de chaque capteur
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsGetArmInfo(long *Autorisation,long *BoardType,long *SerialNumber,long *NbCounters,long *NbProbes ,double * ProbesDiameters,long * ProbesType); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to define the events which cause the hardware latch
//
//		Fonction permettant de positionner les vnements conditions de declenchement du latch Matriel
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				The number of latch realised on an event
//
//		Paramtres entre : 
//
//				Le nombre de Latchs effectuer sur un vnement
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//		concerning the number of latchs
//			It differs from the type of used probe
//				#define CAPTEURV		0x01	1 latch
//				#define CAPTEURCONTACT		0x02	until 5 latchs
//				#define CAPTEURPLA		0x03	1 latch
//				#define CAPTEURRENISHAW		0x04	1 latch
//
//		Note :
//
//		Pour le nombre de latchs
//			Il diffre suivant le type de capteur utilis
//				#define CAPTEURV		0x01	1 lacths
//				#define CAPTEURCONTACT		0x02	jusqu'a 5 lacths
//				#define CAPTEURPLA		0x03	1 lacths
//				#define CAPTEURRENISHAW		0x04	1 lacths
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSetEvents(int NbLatchs);
long GDSEXPORT gdsSetEventsEx(int NbLatchs);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to inhibit latch conditions
//
//		Fonction permettant d'inhiber les conditions de dclenchements
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsResetEvents();
long GDSEXPORT gdsResetEventsEx();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to recover values of each encoder and analogical values on a Hardware signal or on a Software signal
//
//		Fonction permettant de rcuprer des valeurs de chaques codeurs et les valeurs analogiques sur un signal Matriel ou Logiciel
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				encoders values (50 maxi)
//				analogical values (20 maxi)
//				Boolean pointing out if we can recover values on a Hardware signal or on a Software signal
//				current value
//
//		Paramtres entre : 
//
//				Les valeurs de  codeurs (50 maxi)
//				Les valeurs analogiques (20 maxi)
//				Le Boolean indiquant si on veut un rcuprer les valeurs sur un signal matriel ( Lacth sur Evnement BP1 B B2) ou sur un signal Logiciel 
//				Valeur courante
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsLatchCounter(double FAR* Counter,double FAR* Analog,BOOL WithEvents) ; 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to recover values of the sphere center point and analogical values on a Hardware signal or on a Software signal
//
//		Fonction permettant de rcuprer des valeurs du point centre Sphere et les valeurs analogiques sur un signal Matriel ou Logiciel
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				encoders values (30 maxi)  XYZ AzBzCz Xperceval Yperceval Zperceval AxBxCx AyByCy 
//				analogical values (20 maxi)
//				Boolean pointing out if we can recover values on a Hardware signal (latch on BP1 B B2 event)or on a Software signal
//				current value
//
//		Paramtres entre : 
//
//				Les valeurs de  codeurs (30 maxi)  XYZ AzBzCz Xperceval Yperceval Zperceval AxBxCx AyByCy 
//				Les valeurs analogiques (20 maxi)
//				Le Boolean indiquant si on veut un rcuprer les valeurs sur un signal matriel ( Latch sur Evnement BP1 B B2) ou sur un signal Logiciel 
//				Valeur courante
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsPoint(double FAR* tabXYZABC,double FAR* Analog,BOOL WithEvents) ; 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to recover the button state on a Hardware signal or on a current value
//
//		Fonction permettant de rcuprer l'tat d'un bouton sur un signal Matriel ou valeur Courante
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				index of from 1 to 4 choosen button
//				Boolean pointing out if we can recover values on a Hardware signal (latch on BP1 B B2 event)or on a Software signal
//				current value
//
//		Paramtres entre : 
//
//				l'indice du bouton Choisi de 1  4
//				Le Boolean indiquant si on veut un rcuprer les valeurs sur un signal matriel ( Lacth sur Evnement BP1 B B2) ou sur un signal Logiciel 
//				Valeur Courante
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//		For Button, use
//			#define SWITCH1				1
//			#define SWITCH2BEAM2		0
//			#define BEAM1				2
//
//		Note :
//
//		Pour Button Utiliser
//			#define SWITCH1				1
//			#define SWITCH2BEAM2		0
//			#define BEAM1				2
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsButtonState(short Button,BOOL WithEvents) ;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to emit sound
//
//		Fonction permettant d'mettre un son
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				sound frequency from 100 to 5600 Hertz
//				duration from 0 to 255
//
//		Paramtres entre : 
//
//				La frquence du son de 100  5600 Hertz
//				la dure de 0  255  
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//		Concerning the duration
//			0 value allows to emit a sound with infinite duration 
//			1 = 4 Ms and 255   1020ms
//
//		Note :
//
//		Pour la dure
//			la valeur 0 permet d'emettre un son de manire continue
//			1 vaut 4 Ms et 255  1020ms
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSound(long Frequency, long Duration); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to inhibit or not the mouse
//
//		Fonction permettant d'inhiber ou non la souris
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			Flag state : True the mouse is enable and works according to the modes defined in  AutomticMouse and MouseMode, MouseMode and MouseModeEx
//						 False the mouse is inhibited and don't take care of the modes defined in  AutomticMouse and MouseMode, MouseMode and MouseModeEx
//
//		Paramtres entre : 
//
//			L'tat du Flag : Vrai la souris est active selon les modes dfinis avec AutomticMouse and MouseMode, MouseMode and MouseModeEx 
//							 Faux la souris est dsactive quelque soit les modes dfinis avec AutomticMouse and MouseMode, MouseMode and MouseModeEx 			
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note : AutomticMouse and MouseMode, MouseMode and MouseModeEx values are very closed
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
void GDSEXPORT gdsSetUseMouse(BOOL State); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the state of the Flag, which indicates if the mouse through the measuring arm is inhibited or not
//
//		Fonction permettant d'obtenir l'tat du Flag indiquant si la souris  distance est inhibe ou non
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				Flag state
//
//		Paramtres retourn :
//
//				L'tat du Flag
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
BOOL GDSEXPORT gdsGetUseMouse(); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the state of the Flag, which indicates if the mouse through the measuring arm is used or not
//
//		Fonction permettant d'obtenir l'tat du Flag indiquant si la souris  distance est utilise ou non
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				Flag state
//
//		Paramtres retourn :
//
//				L'tat du Flag
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note : AutomticMouse and MouseMode, MouseMode and MouseModeEx values are very closed
//
//	AutomaticMouse				MouseModeEx			MouseMode
//		True						1					True	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 simulating mouse left switch
//
//		True						1					False	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 for point taking
//
//		False						1					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating mouse left switch and Switch simulating the right switch of the mouse
//
//		False						1					False	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 for the point taking and switch simulating the left switch of the mouse
//
//		False						2					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating the left switch of the mouse and Switch simulating the right switch of the mouse
//
//		False						2					False	The software can switch from measure mode to mouse mode with button 2 and then the software is in mouse mode
//																Switch 1 for point taking
//
//		Note : Les valeurs AutomaticMouse et MouseMode et MouseModeEx sont trs lies
//
//	AutomaticMouse				MouseModeEx			MouseMode 
//
//		True						1					True		L'utilisateur gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Souris
//																	Bouton 1 simulant le bouton gauche de la souris
//
//		True						1					False		L'utilisateur Gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Mesure
//																	Bouton 1 pour la prise de points 
//
//		False						1					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						1					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points et Bouton Simulant le bouton Gauche de la souris
//
//		False						2					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						2					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL GDSEXPORT gdsGetMouseMode(); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the state of the flag, indicating if the mouse through the measuring arm is used or not
//
//		Fonction permettant de positionner l'tat du Flag indiquant si la souris  distance est utilise ou non
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			Flag state
//
//		Paramtres entre : 
//
//			L'tat du Flag
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note : AutomticMouse and MouseMode, MouseMode and MouseModeEx values are very closed
//
//	AutomaticMouse				MouseModeEx			MouseMode
//		True						1					True	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 simulating mouse left switch
//
//		True						1					False	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 for point taking
//
//		False						1					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating mouse left switch and Switch simulating the right switch of the mouse
//
//		False						1					False	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 for the point taking and switch simulating the left switch of the mouse
//
//		False						2					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating the left switch of the mouse and Switch simulating the right switch of the mouse
//
//		False						2					False	The software can switch from measure mode to mouse mode with button 2 and then the software is in mouse mode
//																Switch 1 for point taking
//
//		Note : Les valeurs AutomaticMouse et MouseMode et MouseModeEx sont trs lies
//
//	AutomaticMouse				MouseModeEx			MouseMode 
//
//		True						1					True		L'utilisateur gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Souris
//																	Bouton 1 simulant le bouton gauche de la souris
//
//		True						1					False		L'utilisateur Gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Mesure
//																	Bouton 1 pour la prise de points 
//
//		False						1					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						1					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points et Bouton Simulant le bouton Gauche de la souris
//
//		False						2					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						2					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GDSEXPORT gdsSetMouseMode(BOOL State); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Function which gives the working state of the mouse		
//
//		Fonction permettant d'obtenir l'tat de fonctionnement de la souris
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				working state
//
//		Paramtres retourn :
//
//				L'tat de fonctionnement
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note : AutomticMouse and MouseMode, MouseMode and MouseModeEx values are very closed
//
//	AutomaticMouse				MouseModeEx			MouseMode
//		True						1					True	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 simulating mouse left switch
//
//		True						1					False	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 for point taking
//
//		False						1					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating mouse left switch and Switch simulating the right switch of the mouse
//
//		False						1					False	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 for the point taking and switch simulating the left switch of the mouse
//
//		False						2					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating the left switch of the mouse and Switch simulating the right switch of the mouse
//
//		False						2					False	The software can switch from measure mode to mouse mode with button 2 and then the software is in mouse mode
//																Switch 1 for point taking
//
//		Note : Les valeurs AutomaticMouse et MouseMode et MouseModeEx sont trs lies
//
//	AutomaticMouse				MouseModeEx			MouseMode 
//
//		True						1					True		L'utilisateur gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Souris
//																	Bouton 1 simulant le bouton gauche de la souris
//
//		True						1					False		L'utilisateur Gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Mesure
//																	Bouton 1 pour la prise de points 
//
//		False						1					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						1					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points et Bouton Simulant le bouton Gauche de la souris
//
//		False						2					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						2					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int GDSEXPORT gdsGetMouseModeEx(); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to define the state of the flag, indicating if the mouse trough the measuring arm is used or not
//
//		Fonction permettant de positionner l'tat du Flag indiquant si la souris  distance est utilise ou non
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			Flag state
//
//		Paramtres entre : 
//
//			L'tat du Flag
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note : AutomticMouse and MouseMode, MouseMode and MouseModeEx values are very closed
//
//	AutomaticMouse				MouseModeEx			MouseMode
//		True						1					True	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 simulating mouse left switch
//
//		True						1					False	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 for point taking
//
//		False						1					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating mouse left switch and Switch simulating the right switch of the mouse
//
//		False						1					False	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 for the point taking and switch simulating the left switch of the mouse
//
//		False						2					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating the left switch of the mouse and Switch simulating the right switch of the mouse
//
//		False						2					False	The software can switch from measure mode to mouse mode with button 2 and then the software is in mouse mode
//																Switch 1 for point taking
//
//		Note : Les valeurs AutomaticMouse et MouseMode et MouseModeEx sont trs lies
//
//	AutomaticMouse				MouseModeEx			MouseMode 
//
//		True						1					True		L'utilisateur gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Souris
//																	Bouton 1 simulant le bouton gauche de la souris
//
//		True						1					False		L'utilisateur Gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Mesure
//																	Bouton 1 pour la prise de points 
//
//		False						1					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						1					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points et Bouton Simulant le bouton Gauche de la souris
//
//		False						2					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						2					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GDSEXPORT gdsSetMouseModeEx(int State); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the state of the flag indicating if the crossing from mouse mode into measure mode is made by the user with the second switch of the machine or if it is automatically made trough the software.
//
//		Fonction permettant d'obtenir l'tat du Flag indiquant si le passage de mode souris vers mode mesure est effectu manuellement par l'utilisateur 
//		avec le deuxime bouton de la machine ou automatiquement par le programme 
//		
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//		Paramtres retourn :
//				L'tat du Flag
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note : AutomticMouse and MouseMode, MouseMode and MouseModeEx values are very closed
//
//	AutomaticMouse				MouseModeEx			MouseMode
//		True						1					True	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 simulating mouse left switch
//
//		True						1					False	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 for point taking
//
//		False						1					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating mouse left switch and Switch simulating the right switch of the mouse
//
//		False						1					False	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 for the point taking and switch simulating the left switch of the mouse
//
//		False						2					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating the left switch of the mouse and Switch simulating the right switch of the mouse
//
//		False						2					False	The software can switch from measure mode to mouse mode with button 2 and then the software is in mouse mode
//																Switch 1 for point taking
//
//		Note : Les valeurs AutomaticMouse et MouseMode et MouseModeEx sont trs lies
//
//	AutomaticMouse				MouseModeEx			MouseMode 
//
//		True						1					True		L'utilisateur gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Souris
//																	Bouton 1 simulant le bouton gauche de la souris
//
//		True						1					False		L'utilisateur Gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Mesure
//																	Bouton 1 pour la prise de points 
//
//		False						1					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						1					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points et Bouton Simulant le bouton Gauche de la souris
//
//		False						2					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						2					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL GDSEXPORT gdsGetAutomaticMouse(); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	
//		Function which allows to obtain the state of the flag indicating if the crossing from mouse mode into measure mode is made by the user with the second switch of the machine or if it is automatically made trough the software.
//
//		Fonction permettant de positionner l'tat du Flag indiquant si le passage de mode souris vers mode mesure est effectu manuelement par l'utilisateur 
//		avec le deuxime bouton de la machine ou automatiquement par le programme 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			Flag state
//
//		Paramtres entre : 
//
//			L'tat du Flag
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note : AutomticMouse and MouseMode, MouseMode and MouseModeEx values are very closed
//
//	AutomaticMouse				MouseModeEx			MouseMode
//		True						1					True	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 simulating mouse left switch
//
//		True						1					False	The user can switch from measure mode to mouse mode with button 2 and then the user is in mouse mode
//																Switch 1 for point taking
//
//		False						1					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating mouse left switch and Switch simulating the right switch of the mouse
//
//		False						1					False	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 for the point taking and switch simulating the left switch of the mouse
//
//		False						2					True	The Software can switch from measure mode to mouse mode and then the software is in mouse mode
//																Switch 1 simulating the left switch of the mouse and Switch simulating the right switch of the mouse
//
//		False						2					False	The software can switch from measure mode to mouse mode with button 2 and then the software is in mouse mode
//																Switch 1 for point taking
//
//		Note : Les valeurs AutomaticMouse et MouseMode et MouseModeEx sont trs lies
//
//	AutomaticMouse				MouseModeEx			MouseMode 
//
//		True						1					True		L'utilisateur gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Souris
//																	Bouton 1 simulant le bouton gauche de la souris
//
//		True						1					False		L'utilisateur Gre le passage de mode mesure au mode souris avec le bouton 2 et se trouve en mode Mesure
//																	Bouton 1 pour la prise de points 
//
//		False						1					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						1					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points et Bouton Simulant le bouton Gauche de la souris
//
//		False						2					True		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 simulant le bouton gauche de la souris et Bouton Simulant le bouton droite de la souris
//
//		False						2					False		Le logiciel gere le passage du mode mesure au mode souris et se trouve en mode souris
//																	Bouton 1 Pour la prise de points 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GDSEXPORT gdsSetAutomaticMouse(BOOL State); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to define the state of the flag indicating if the sound are active when the arm is near to the mechanical stops
//
//		Fonction permettant de positionner l'tat du Flag indiquant si les butes sonores sont actives lorsque bras est proche des butes mcaniques
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			Flag state
//
//		Paramtres entre : 
//
//			L'tat du Flag
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GDSEXPORT gdsSetMechanicalStop(BOOL State);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to define the state of the flag indicating if the sound are active when the arm is near to the mechanical stops
//
//		Fonction permettant d'obtenir l'tat du Flag indiquant si les butes sonores sont actives lorsque bras est proche des butes mcaniques
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			Flag state
//
//		Paramtres retourn :
//
//			L'tat du Flag				
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL GDSEXPORT gdsGetMechanicalStop();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the encoder index which is on mechanical stop 
//
//		Fonction permettant d'obtenir l'indice du codeur qui en bute mcanique
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			Flag state
//
//		Paramtres retourn :
//
//			L'tat du Flag				
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsGetCounterStopped();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the diameter of the used probe
//
//		Fonction permettant d'obtenir le diamtre du capteur utilis
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			diameter of the used probe
//
//		Paramtres retourn :
//
//			le Diamtre du capteur utilis
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

double GDSEXPORT gdsGetProbeDiameter(); 
double GDSEXPORT gdsGetProbeBeamOffset();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the index of the used probe
//
//		Fonction permettant de positionner l'indice du capteur utilis
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//			
//			Probe Index
//
//		Paramtres entre : 
//
//			L'indice du capteur utilis
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSetProbeIndex(int ProbeIndex); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the index of the used probe
///
//		Fonction permettant d'obtenir l'indice du capteur utilis
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			index of the used probe
//
//		Paramtres retourn :
//
//			L'indice du capteur utilis
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsGetProbeIndex(); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the type of the used probe
//
//		Fonction permettant d'obtenir le type de capteur utilis
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			The Probe Type used
//
//		Paramtres retourn :
//
//			Le type de capteur utilis
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//			Types of available probes 
//				#define CAPTEURV			0x01
//				#define CAPTEURCONTACT		0x02
//				#define CAPTEURPLA			0x03
//				#define CAPTEURRENISHAW		0x04
//
//		Note :
//
//			Types de capteurs actuellement supports
//				#define CAPTEURV			0x01
//				#define CAPTEURCONTACT		0x02
//				#define CAPTEURPLA			0x03
//				#define CAPTEURRENISHAW		0x04
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsGetProbeType();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the patch to specific data of the arm
//
//		Fonction permettant d'obtenir le chemin d'accs aux donnes spcifiques du bras
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			Acces path
//
//		Paramtres retourn :
//
//			Le chemin d'accs
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

LPCSTR GDSEXPORT gdsGetPathToFiles();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the patch to specific data of the arm
//
//		Fonction permettant de positionner le chemin d'accs au donnes spcifiques du bras
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			Access path
//
//		Paramtres entre : 
//
//			Le chemin d'accs
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GDSEXPORT gdsSetPathToFiles(LPCSTR Path);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the index of the communication port
//
//		Fonction permettant de positionner l'indice du port de communication 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			communication port 
//
//		Paramtres entre : 
//
//			l'indice du port
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSetSerialPort(int Port); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the index of the communication port during the utilization
//
//		Fonction permettant d'obtenir l'indice du port de communication en cours d'utilisation
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			port index
//
//		Paramtres retourn :
//
//			l'indice du port
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int GDSEXPORT gdsGetSerialPort(); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the volume value
//
//		Fonction permettant de positionner la valeur du volume
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//			volume value
//
//		Paramtres retourn :
//
//			la valeur du volume
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int GDSEXPORT gdsGetVolume(); 	

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the volume value
//
//		Fonction permettant d'obtenir la valeur du volume
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			volume value
//
//		Paramtres entre : 
//
//			la valeur du volume
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//		Paramtres retourn :
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSetVolume(int Volume);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the parameters of sounds on an event
//		Fonction permettant positionner les paramtres des sons sur un vnement donn
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//			event type
//			frequency
//			volume
//			duration
//
//		Paramtres entre : 
//
//			le type d'vnement
//			la frequence
//			le volume
//			la dure
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//			Concerning the event type, use
//			#define EVENTBP2B2			0x01 
//			#define EVENTBP1			0x02
//			#define EVENTB1PLA			0x04
//
//		Note :
//
//			Pour le type d'vnement Utiliser
//			#define EVENTBP2B2			0x01 
//			#define EVENTBP1			0x02
//			#define EVENTB1PLA			0x04
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSetEventSound(int Event, int Frequency,int Volume,int Duration  );

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the flag which indicates that the sounds on events are authorized.
//
//		Fonction permettant de positionner le Flag indiquant que les sons sur vnements sont autoriss 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsUseEventSound(BOOL Use);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set the flag indicating that the end of the sound has to be reached before the sending another one
//
//		Fonction permettant de positionner le Flag indiquant que la fin du son en cours doit tre atteinte avant d'en envoyer un autre
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsWaitEndOfSound(BOOL Wait);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to display a dialog box containing driver's parameters
//
//		Fonction permettant d'afficher une boite de dialogue contenant les paramtrages du driver
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsConfigArm();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to run a GDS Functionnality as LeapFrog
//
//		Fonction permettant de lancer une des fonctions intgre de GDS comme le LeapForg
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :	The function Number (Describe in the enum SpecialFunctions)
//
//		Paramtres entre : L'identifiant de la fonction (Decris dans l'enum SpecialFunction)
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
long GDSEXPORT gdsSpecialFunctions(long Function);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to run the display of the two leds of the arm box
//
//		Fonction permettant de grer l'affichage des deux Leds prsents sur le boitier du bras
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				state of led, number 1
//				state of led, number 2
//
//		Paramtres entre : 
//
//				L'tat de la Led numro 1 
//				L'tat de la Led numro 2
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//			TRUE for on and FALSE for off
//
//		Note :
//
//			TRUE pour allume et FALSE pour Eteinte
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsDisplayLed(BOOL Led1,BOOL Led2);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to set a reference under GDS
//
//		Fonction permettant d'activer un rfrentiel au sein de GDS
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				reference index
//
//		Paramtres entre : 
//
//				l'indice du rfrentiel
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//			TRUE for on and FALSE for off
//
//		Note :
//
//			TRUE pour allume et FALSE pour Eteinte
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsSetActiveReference(int Reference);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to obtain the index of under GDS active reference
//
//		Fonction permettant dobtenir l'indice du  rfrentiel activ au sein de GDS
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Paramtres entre : 
//
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				Reference index
//				
//		Paramtres retourn :
//
//				l'indice du rfrentiel
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//			TRUE to ligth on and FALSE to ligth off
//
//		Note :
//
//			TRUE pour allume et FALSE pour Eteinte
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsGetActiveReference();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	
//		Function which allows to realise processes on references	
//
//		Fonction permettant d'effectuer des oprations sur les rfrentiels
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//				reference name
//				matrix values
//				operation to do
//
//		Paramtres entre : 
//
//				Le nom du rfrentiel
//				les valeurs de la matrice
//				L'action  effectuer
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Out parameters :
//
//				error code (Long) 0 if no error
//
//		Paramtres retourn :
//
//				Le code Erreur (Long) 0 si pas d'erreur
//				
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Note :
//
//			Only one operation is now available #define ACTIVEREFERENCE		1
//			the In reference is automatically active and will only be inactive with the gdsSetActiveReference function or during the next connexion.
//
//		Note :
//
//			actuellement seule une action est disponible #define ACTIVEREFERENCE		1 
//			selon laquelle le refrentiel pass est activ automatiquement et ne sera dsactiv qu'avec la fonction gdsSetActiveReference ou lors d'une nouvelle connection
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long GDSEXPORT gdsReferenceAction(LPCSTR Name,double FAR *Matice,int Action);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to load a new software in the board of the machine
//
//		Fonction permettant de charger un nouveau programme dans la carte de la machine
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Paramtres retourn :
//
//		Out parameters :
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
long GDSEXPORT gdsLoadProm();
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		
//		Function which allows to get one VertexID
//
//		Fonction permettant d' obtenir l'ID d'un vertex 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		In parameters :
//
//		Paramtres entre : 
//
//------------------------------------------------------------------------------------------------------------------------------------------------------		
//
//		Paramtres retourn :
//
//			l'identifiant du vertex de 1  63 le reste etant une erreur
//			0 aucun vertex trouv
//			> 63 Code Erreur GDS 
//
//		Out parameters :
//			
//			The vertex ID from 1 to 63 other is an error
//			0 No vertex Found
//			> 63 GDS Error code
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
long GDSEXPORT gdsGetVertexID();
long GDSEXPORT gdsCINIT(int NbPositions,int NbLatchs,int ProbeUsed,LPCSTR Path,int NbReferences);
long GDSEXPORT gdsCADD(LPCSTR Path);
long GDSEXPORT gdsCADDREF(LPCSTR Ref);
long GDSEXPORT gdsCSTART(double *Param,BOOL Display,int NbMaxIter);
long GDSEXPORT gdsCSEND();
long GDSEXPORT gdsCP(double *C,double *A,double *P);
long GDSEXPORT gdsMInit(BOOL Used);
long GDSEXPORT gdsMSpeed(char Speed);
long GDSEXPORT gdsGetNewProbe();
BOOL GDSEXPORT gdsSetProbeDetection(BOOL Used);
BOOL GDSEXPORT gdsGetProbeDetection();
long GDSEXPORT gdsGetVideoProbePoints(double *Points,long *NbPoints,BOOL Calulated);
long GDSEXPORT gdsVideoProbeFunctions(long Action, double *Parameters);

LPCTSTR GDSEXPORT gdsGetErrorMessage(long ErrorNumber);

int GDSEXPORT gdsGetBoardType();
long GDSEXPORT gdsSetBoardType(int BoardType);

LPCTSTR GDSEXPORT gdsGetMask();
LPCTSTR GDSEXPORT gdsGetIP();
long GDSEXPORT gdsSetIPMask(LPCSTR IP,LPCSTR Mask);

#ifdef __cplusplus
}
#endif
#endif



