#include "stdafx.h"
#include "nrkapp.h"
#include "RomerEuropeArm.h"
#include "DPCMMDlg.h"

RomerEuropeArm::RomerEuropeArm(void)
{
	ConnectedToArm = FALSE;
	Measuring = FALSE;

	app.saarm.CMMString = _T("RomerFrance");
	app.saarm.SettingsFileName = _T("SA_RomerFrance_ArmSettings.bin");
	LogFileName = _T("RomerFrance.log");
}

RomerEuropeArm::~RomerEuropeArm(void)
{
}

HINSTANCE hDLLGDS;
tgdsConnect pgdsConnect;
tgdsResetEvents pgdsResetEvents;
tgdsPoint pgdsPoint;
tgdsLatchCounter pgdsLatchCounter;
tgdsSound pgdsSound;
tgdsSetEvents pgdsSetEvents;
tgdsButtonState pgdsButtonState;
tgdsGetErrorMessage pgdsGetErrorMessage;
tgdsSetMouseMode pgdsSetMouseMode;
tgdsUseEventSound pgdsUseEventSound;
tgdsArmResetDisplayed pgdsArmResetDisplayed;
tgdsSetUserID pgdsSetUserID;
tgdsDisConnect pgdsDisConnect;
tgdsConfigArm pgdsConfigArm;
tgdsSetProbeIndex pgdsSetProbeIndex;
tgdsVideoProbeFunctions pgdsVideoProbeFunctions;
tgdsGetVideoProbePoints pgdsGetVideoProbePoints;
tgdsGetProbeType pgdsGetProbeType;
tgdsGetProbeDiameter pgdsGetProbeDiameter;//
tgdsGetProbeIndex pgdsGetProbeIndex;
tgdsSetProbeDetection pgdsSetProbeDetection;
tgdsGetProbeDetection pgdsGetProbeDetection;
tgdsGetMouseMode pgdsGetMouseMode;
tgdsSetAutomaticMouse pgdsSetAutomaticMouse;
tgdsGetAutomaticMouse pgdsGetAutomaticMouse;
tgdsGetMouseModeEx pgdsGetMouseModeEx;
tgdsSetMouseModeEx pgdsSetMouseModeEx;
tgdsGetUseMouse pgdsGetUseMouse;
tgdsSetUseMouse pgdsSetUseMouse;
tgdsGetNewProbe pgdsGetNewProbe;

void CreateInstanceGDS(CString path)
{
	// 2007.01.08 - just load straight from the exe's path (see notes in ConnectToArm below)
	hDLLGDS = LoadLibrary(_T("GDSDLL.dll"));	// if SetExePath() did its job, this should work
	//if(hDLLGDS == NULL)	// try the relative path
	//{
	//	hDLLGDS = LoadLibrary(_T(".\\RomerEurope\\GDSDLL"));
	//}
	//if(hDLLGDS == NULL)	// try the absolute path
	//{
	//	CString dllPath;
	//	dllPath.Format(_T("%s\\RomerEurope\\GDSDLL.dll"), path);
	//	AfxMessageBox(dllPath);
	//	hDLLGDS = LoadLibrary(dllPath);
	//}		
	if (hDLLGDS != NULL)
	{
		pgdsSetUserID = (tgdsSetUserID)GetProcAddress(hDLLGDS, "gdsSetUserID");
		pgdsConnect = (tgdsConnect)GetProcAddress(hDLLGDS, "gdsConnect");
		pgdsResetEvents = (tgdsResetEvents)GetProcAddress(hDLLGDS, "gdsResetEvents");
		pgdsPoint = (tgdsPoint)GetProcAddress(hDLLGDS, "gdsPoint");
		pgdsLatchCounter = (tgdsLatchCounter)GetProcAddress(hDLLGDS, "gdsLatchCounter");
		pgdsSound = (tgdsSound)GetProcAddress(hDLLGDS, "gdsSound");
		pgdsSetEvents = (tgdsSetEvents)GetProcAddress(hDLLGDS, "gdsSetEvents");
		pgdsButtonState = (tgdsButtonState)GetProcAddress(hDLLGDS, "gdsButtonState");
		pgdsGetErrorMessage = (tgdsGetErrorMessage)GetProcAddress(hDLLGDS, "gdsGetErrorMessage");
		pgdsSetMouseMode = (tgdsSetMouseMode)GetProcAddress(hDLLGDS, "gdsSetMouseMode");
		pgdsUseEventSound = (tgdsUseEventSound)GetProcAddress(hDLLGDS, "gdsUseEventSound");
		pgdsArmResetDisplayed = (tgdsArmResetDisplayed)GetProcAddress(hDLLGDS, "gdsArmResetDisplayed");
		pgdsDisConnect = (tgdsDisConnect)GetProcAddress(hDLLGDS, "gdsDisConnect");
		pgdsConfigArm = (tgdsConfigArm)GetProcAddress(hDLLGDS, "gdsConfigArm");
		pgdsSetProbeIndex = (tgdsSetProbeIndex)GetProcAddress(hDLLGDS, "gdsSetProbeIndex");
		pgdsVideoProbeFunctions = (tgdsVideoProbeFunctions)GetProcAddress(hDLLGDS, "gdsVideoProbeFunctions");
		pgdsGetVideoProbePoints = (tgdsGetVideoProbePoints)GetProcAddress(hDLLGDS, "gdsGetVideoProbePoints");
		pgdsGetProbeType = (tgdsGetProbeType)GetProcAddress(hDLLGDS, "gdsGetProbeType");
		pgdsGetProbeDiameter = (tgdsGetProbeDiameter)GetProcAddress(hDLLGDS, "gdsGetProbeDiameter");//
		pgdsGetProbeIndex = (tgdsGetProbeIndex)GetProcAddress(hDLLGDS, "gdsGetProbeIndex");
		pgdsSetProbeDetection = (tgdsSetProbeDetection)GetProcAddress(hDLLGDS, "gdsSetProbeDetection");
		pgdsGetProbeDetection = (tgdsGetProbeDetection)GetProcAddress(hDLLGDS, "gdsGetProbeDetection");
		pgdsGetMouseMode = (tgdsGetMouseMode)GetProcAddress(hDLLGDS, "gdsGetMouseMode");
		pgdsSetAutomaticMouse = (tgdsSetAutomaticMouse)GetProcAddress(hDLLGDS, "gdsSetAutomaticMouse");
		pgdsGetAutomaticMouse = (tgdsGetAutomaticMouse)GetProcAddress(hDLLGDS, "gdsGetAutomaticMouse");
		pgdsGetMouseModeEx = (tgdsGetMouseModeEx)GetProcAddress(hDLLGDS, "gdsGetMouseModeEx");
		pgdsSetMouseModeEx = (tgdsSetMouseModeEx)GetProcAddress(hDLLGDS, "gdsSetMouseModeEx");
		pgdsGetUseMouse = (tgdsGetUseMouse)GetProcAddress(hDLLGDS, "gdsGetUseMouse");
		pgdsSetUseMouse = (tgdsSetUseMouse)GetProcAddress(hDLLGDS, "gdsSetUseMouse");
		pgdsGetNewProbe = (tgdsGetNewProbe)GetProcAddress(hDLLGDS, "gdsGetNewProbe");
	}
	else
	{
		CString path;
		path = app.saarm.ProgramDirectory + _T("RomerEurope\\Readme.txt");
		ShellExecute(0,_T("open"),path,0,0,SW_SHOW);
	}

}

bool RomerEuropeArm::ConnectToArm(const int dof)
{
	// 2007.01.08 - unfortunately, this does not work.  It sets the exe path just fine, but when their gdsdll.dll loads the old api dlls,
	// it looks in the same path as the exe!!  Can't find a way to control where dll's look to load other dll's, so we'll just have to have
	// the users unzip the french romer dll's right into the SA install folder, thus overwriting the 3 common api dll's, and therefore breaking
	// api's with the french romer.  Hopefully, people will complain so they'll have to get the api dll's the heck out of their build!!
	//if(!SetExePath())	// this is due to the fact that the French Romer dll's include some OLD API dll's, and it won't run without them!
	//{
	//	AfxMessageBox(_T("Could not set path for Arm App."), MB_ICONSTOP);
	//	return false;
	//}
	CreateInstanceGDS(app.saarm.ProgramDirectory);
	if(hDLLGDS == NULL)
		return false;
	long Error=0;
	//m_pThreadMeasure=NULL;

	
	//gdsSetUserID(514387);
	gdsSetUserID(23522);	// 2007.02.06 - Laurent Desforges responded to questions today.  Setting this user id will enable auto-probe detection to work - tested it, it does work

	Error=gdsConnect();
	//gdsSetProbeIndex(1);

	if (!Error)
		gdsUseEventSound(TRUE);

	// see Gdsdllex.h for an expaination of this mess...
	gdsSetMouseMode(FALSE);
	gdsSetMouseModeEx(2);
	gdsSetAutomaticMouse(FALSE);
	
	gdsSetUseMouse(FALSE);

	SetProbeAutoDetect(TRUE);
	//gdsGetNewProbe();

	//app.saarm.Data.TipDia = gdsGetProbeDiameter()/1000.0;
	//CString m;
	//m.Format(_T("probe diameter = %f"), app.saarm.Data.TipDia);
	//AfxMessageBox(m);

	if (Error)
	{
		AfxMessageBox(gdsGetErrorMessage(Error));
		return false;
	}

	gdsArmResetDisplayed(TRUE);	

	ConnectedToArm = TRUE;
	return true;
}

BOOL RomerEuropeArm::DisconnectFromHardware()
{
	pgdsDisConnect();
	return FreeLibrary(hDLLGDS);
}

BOOL RomerEuropeArm::GetAllData()
{
	if( !ConnectedToArm )
		return ArmBase::GetAllData();

	GetPos();
	GetJoints();
	if(!overrideArmButtons && app.pA->armButtons.ButtonsEnabled())
		GetButtonStates();
	//GetTemp();

	return TRUE;
}
BOOL RomerEuropeArm::GetPos()
{
	if( !ConnectedToArm )
		return ArmBase::GetPos();

	//long lProbeType = gdsGetProbeType();
	//Sleep(10);

	//CriticalSectionLock lock( scannerCS );
	//if (gdsSetEvents(lProbeType)!=0 )
	//{
	//	TRACE0("could not set gds events\n");
	//	return FALSE;
	//}
	//Sleep(10);
	//transform into consistent coords
	//and scale to meters
	double armData[30], analog[20];
	if (gdsPoint(armData,analog,FALSE)!=0)	// TRUE is with events, i.e. for renishaw, call gdsSetEvents(4), and pt. will only be taken when probe is touched (see gds Integration.pdf)
	{
		TRACE0("could not get gds pt\n");
		//gdsResetEvents(); 
		return FALSE;
	}

	X = armData[0]/1000.0;
	Y = armData[1]/1000.0;
	Z = armData[2]/1000.0;

	//Vector xComp, yComp, zComp;

	//xComp.x  = armData[9];
	//xComp.y  = armData[10];
	//xComp.z  = armData[11];

	//yComp.x  = armData[12];
	//yComp.y  = armData[13];
	//yComp.z  = armData[14];

	//zComp.x  = armData[3];
	//zComp.y  = armData[4];
	//zComp.z  = armData[5];

	TRACE3("Raw Data: X=%f,Y=%f,Z=%f\n",X,Y,Z);

	Vector RomerCoord( X,Y,Z ); //raw data
	Vector AnalyzerCoord;
	//rot and trans to analyzer coords
	NativeArmToSA.Multiply( RomerCoord, &AnalyzerCoord );
	X = AnalyzerCoord.x;
	Y = AnalyzerCoord.y;
	Z = AnalyzerCoord.z;

	// 2007.07.02 - no longer use this as the probe tip vector, see below...
	//II = armData[3];	
	//JJ = armData[4];	
	//KK = -armData[5];

	CurrentTransform.SetRotation(Vector(armData[12],armData[13],armData[14]),Vector(armData[9],armData[10],armData[11]),Vector(-armData[3],-armData[4],-armData[5]));
	//CurrentTransform.SetRotation(Vector(-Pos.dYI,-Pos.dYJ,Pos.dYK),Vector(-Pos.dXI,-Pos.dXJ,Pos.dXK),Vector(Pos.dZI,Pos.dZJ,-Pos.dZK));
	CurrentTransform.SetTranslation(Vector(X,Y,Z));

	// 2007.07.02 - get the normal from the transform...
	Vector zz = CurrentTransform.GetZAxis();
	zz.Normalize();
	II = zz.x;
	JJ = zz.y;
	KK = zz.z;

	//gdsResetEvents(); 

	return TRUE;
}
BOOL RomerEuropeArm::GetJoints(bool simulate/*=true*/)
{
	if( !ConnectedToArm )
		return ArmBase::GetJoints(simulate);

	if( !app.saarm.receivedSignOn )	// assigns size of J GenVec per arm type
		return FALSE;

	double armData[30], analog[20];
	//romereuropearm.obj : error LNK2019: unresolved external symbol _gdsLatchCounter referenced in function "public: virtual int __thiscall RomerEuropeArm::GetJoints(void)" (?GetJoints@RomerEuropeArm@@UAEHXZ)
	if (gdsLatchCounter(armData,analog,FALSE)!=0)	// TRUE is with events, i.e. for renishaw, call gdsSetEvents(4), and jts. will only be returned when probe is touched (see gds Integration.pdf)
	{
		TRACE0("could not get gds joint values\n");
		return FALSE;
	}

	TRACE3("joint values:\n 1=%f, 2=%f, 3=%f, ", armData[1], armData[2], armData[3]);
	TRACE3("4=%f, 5=%f, 6=%f \n", armData[4], armData[5], armData[6]);

		
	J.x[0] = armData[1]/1750.0 + 135.0;
	J.x[1] = -armData[2]/1750.0;
	J.x[2] = armData[3]/1750.0 + 180.0;
	J.x[3] = -armData[4]/1750.0;
	J.x[4] = armData[5]/1750.0;
	J.x[5] = -armData[6]/1750.0;

	return TRUE;
}
int RomerEuropeArm::GetButtonStates()
{
	if( !ConnectedToArm )
		return ArmBase::GetButtonStates();

	int duration=0;
	buttonstate = 0;

	if( CheckButton(1, &duration) )	// button near probe tip
	{
		buttonstate = 1;
		buttonstate += duration;
	}
	else if( CheckButton(0, &duration) )	// either button away from probe tip
	{
		buttonstate = 2;
		buttonstate += duration;
	}
	TRACE1("returning button state %d\n", buttonstate);
	return buttonstate;
}
BOOL RomerEuropeArm::CheckButton(int but, int* duration)
{
	if( !ConnectedToArm )
		return ArmBase::CheckButton(but, duration);

	if(pgdsButtonState((short)but, FALSE) == 1)
	{
		TRACE1("Button %d down\n",but);
		DWORD Start = ::GetCurrentTime();
		while((pgdsButtonState((short)but, FALSE) == 1)&&((::GetCurrentTime() - Start) < LONG_DURATION))
		{
		}
		if(pgdsButtonState((short)but, FALSE))
		{
			*duration = BUTTON_LONG;
			OutputSpeakerSound(3000,100);
			while(pgdsButtonState((short)but, FALSE) == 1)
			{
			}
			return TRUE;
		}
		else if(!IsRemoteMouseEnabled())
			*duration = BUTTON_SHORT;
	}
	else
		return FALSE;
	return TRUE;
}
int RomerEuropeArm::GetProbeNumber()
{
	if( !ConnectedToArm )
		return ArmBase::GetProbeNumber();

	int probenum = 0;
	probenum = gdsGetProbeIndex();
	app.saarm.Data.TipDia = gdsGetProbeDiameter()/1000.0;
	return probenum;
}
int RomerEuropeArm::GetButtonCount()
{
	return 2; // 3 buttons, but 2 unique return values: button near probe returns 1, and other 2 both return 0
}
void RomerEuropeArm::SetProbeNumber(int ProbeNum)
{
	if( !ConnectedToArm )
	{
		ArmBase::SetProbeNumber(ProbeNum);
		return;
	}

	gdsSetProbeIndex(ProbeNum);
	app.saarm.Data.TipDia = gdsGetProbeDiameter()/1000.0;
}
BOOL RomerEuropeArm::ValidateCurrentProbe()
{
	//gdsGetNewProbe();
	app.saarm.Data.TipDia = gdsGetProbeDiameter()/1000.0;
	//CString m;
	//m.Format(_T("probe diameter = %f, probe index = %d"), app.saarm.Data.TipDia, GetProbeNumber());
	//AfxMessageBox(m);
	return TRUE;
}
void RomerEuropeArm::SetProbeAutoDetect(BOOL ad)
{
	if( !ConnectedToArm )
	{
		ArmBase::SetProbeAutoDetect(ad);
		return;
	}

	gdsSetProbeDetection(ad);
}

//BOOL RomerEuropeArm::SetVolumeLevel( int VolumeLevel )
//{
//
//}
void RomerEuropeArm::OutputSpeakerSound( int frequency, int duration )
{
	gdsSound(frequency, duration);
}
void RomerEuropeArm::ArmBeep(int sound)
{
	switch(sound)
	{
	case REC_OK:
		{
			gdsSound(1400,120);
			//theApp.TTS.PlayTone(1400,120);
			break;
		}
	case CALC_OK:
		{
			gdsSound(2000,80);
			//theApp.TTS.PlayTone(1400,120);
			break;
		}
	case UNDO_OK:
		{
			gdsSound(800,200);
			//theApp.TTS.PlayTone(800,200);
			break;
		}
	case UNDO_FAIL:
		{
			gdsSound(600,100);
			//theApp.TTS.PlayTone(600,100);
			break;
		}
	case JT_LIMIT:
		{
			gdsSound(3000,250);
			Delay(0.1,TRUE);
			gdsSound(2500,250);
		}
	}
}

BOOL RomerEuropeArm::IsRemoteMouseEnabled()
{
	return gdsGetUseMouse();
}
void RomerEuropeArm::ToggleRemoteMouse()
{
	if(gdsGetUseMouse())
	{
		gdsSetMouseMode(FALSE);
		gdsSetUseMouse(FALSE);
	}
	else
	{
		gdsSetMouseMode(TRUE);
		gdsSetUseMouse(TRUE);
	}
}
void RomerEuropeArm::RemoteMouse(BOOL flag)
{
	gdsSetMouseMode(flag);
	gdsSetUseMouse(flag);
}

void RomerEuropeArm::DoArmSettings()
{
	if(!ConnectedToArm)
	{
		ArmBase::DoArmSettings();
		return;
	}
	gdsConfigArm();
}

BOOL RomerEuropeArm::IsRomer()
{
	return FALSE;
}
BOOL RomerEuropeArm::IsFaro()
{
	return FALSE;
}
BOOL RomerEuropeArm::IsFaroUSB()
{
	return FALSE;
}
BOOL RomerEuropeArm::IsFrenchRomer()
{
	return TRUE;
}
BOOL RomerEuropeArm::IsSNL()
{
	return FALSE;
}
BOOL RomerEuropeArm::IsMetrisGarda()
{
	return FALSE;
}

bool RomerEuropeArm::SetExePath()	// this is due to the fact that the French Romer dll's include some OLD API dll's, and it won't run without them!
{
	// here's our path to the French dll's
	CString path;
	path = app.saarm.ProgramDirectory + _T("RomerEurope\\");
	CString exePath;
	exePath = app.saarm.ProgramDirectory + _T("SA Arms.exe");

	if( SetRegistryValue(HKEY_LOCAL_MACHINE, 
			_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\SA Arms.exe"), 
			_T("Path"), path.GetBuffer(), exePath.GetBuffer()) )
		return true;
	else
		return false;
}
BOOL RomerEuropeArm::SetRegistryValue( HKEY hOpenKey, LPCTSTR szKey, LPCTSTR szValue, LPCTSTR szData, LPCTSTR exePath )
{
	// validate input
	if( !hOpenKey || !szKey || !szKey[0] ||
		!szValue || !szData )
	{
			::SetLastError(E_INVALIDARG);
			return FALSE;
	}

	BOOL 	bRetVal = FALSE;
	DWORD	dwDisposition;
	DWORD	dwReserved = 0;
	HKEY  	hTempKey = (HKEY)0;

	// length specifier is in bytes, and some TCHAR
	// are more than 1 byte each
	DWORD	dwBufferLength = lstrlen(szData) * sizeof(TCHAR);
	DWORD dwExePathLength = lstrlen(exePath) * sizeof(TCHAR);

	// Open key of interest
	// Assume all access is okay and that all keys will be stored to file
	// Utilize the default security attributes
	if( ERROR_SUCCESS == ::RegCreateKeyEx(hOpenKey, szKey, dwReserved,
		(LPTSTR)0, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, 0,
		&hTempKey, &dwDisposition) )
	{

		// dwBufferLength must include size of terminating null
		// character when using REG_SZ with RegSetValueEx function
		dwBufferLength += sizeof(TCHAR);

		// default path
		if( ERROR_SUCCESS == ::RegSetValueEx(hTempKey, _T(""),
			dwReserved, REG_SZ, (LPBYTE)exePath, dwExePathLength) )
				bRetVal = TRUE;

		// path
		if( ERROR_SUCCESS == ::RegSetValueEx(hTempKey, (LPTSTR)szValue,
			dwReserved, REG_SZ, (LPBYTE)szData, dwBufferLength) )
				bRetVal = TRUE;
	}

	// close opened key
	if( hTempKey )
	{
		::RegCloseKey(hTempKey);
	}

	return bRetVal;
}

/////////////////////////////////////////////////////////////////////////
// gds low level...
long gdsResetEvents()
{
	if (pgdsResetEvents)
		return pgdsResetEvents();
	else
		return -1;
}

long gdsPoint(double FAR* tabXYZABC,double FAR* Analog,BOOL WithEvents)
{
	return  pgdsPoint(tabXYZABC, Analog, WithEvents);
}

long gdsLatchCounter(double FAR* Counter,double FAR* Analog,BOOL WithEvents)
{
	return pgdsLatchCounter(Counter, Analog, WithEvents);
}

long gdsSound(long Frequency, long Duration)
{
	return  pgdsSound(Frequency, Duration);
}

long gdsSetEvents(int NbLatchs)
{
	return pgdsSetEvents(NbLatchs);
}

long gdsButtonState(short Button,BOOL WithEvents)
{
	long ret = pgdsButtonState(Button, WithEvents);
	if(WithEvents)
		TRACE("button %d WithEvents: button state = %ld\n", Button, ret);
	else
		TRACE("button %d NOTWithEvents: button state = %ld\n", Button, ret);
	return ret;
}

LPCTSTR gdsGetErrorMessage(long ErrorNumber)
{
	return pgdsGetErrorMessage(ErrorNumber);
}

void gdsSetMouseMode(BOOL State)
{
	pgdsSetMouseMode(State);
}

long gdsUseEventSound(BOOL Use)
{
	return pgdsUseEventSound(Use);
}


long gdsArmResetDisplayed(BOOL bForceReset)
{
	return pgdsArmResetDisplayed(bForceReset);
}

long gdsConnect()
{
	if(pgdsConnect)
		return pgdsConnect();
	else
		return -1;
}

long gdsSetUserID(int User)
{
	if(pgdsSetUserID)
		return pgdsSetUserID(User);
	else
		return -1;
}

long gdsDisConnect()
{
	if(pgdsDisConnect)
		return pgdsDisConnect();
	else
		return -1;
}

long gdsConfigArm()
{
	if (pgdsConfigArm)
		return pgdsConfigArm();
	else
		return -1;
}

long gdsSetProbeIndex(int ProbeIndex)
{
	if (pgdsSetProbeIndex)
		return pgdsSetProbeIndex(ProbeIndex);
	else
		return -1;
}

long gdsVideoProbeFunctions(long Action, double *Parameters)
{
	if (pgdsVideoProbeFunctions)
		return pgdsVideoProbeFunctions(Action, Parameters);
	else
		return -1;
}

long gdsGetVideoProbePoints(double *Points,long *NbPoints,BOOL Calulated)
{
	if (pgdsGetVideoProbePoints)
		return pgdsGetVideoProbePoints(Points, NbPoints, Calulated);
	else
		return -1;
}

long gdsGetProbeType()
{
	if(pgdsGetProbeType)
		return pgdsGetProbeType();
	else
		return -1;
}

double gdsGetProbeDiameter()
{
	return pgdsGetProbeDiameter();
}

long gdsGetProbeIndex()
{
	return pgdsGetProbeIndex();
}

BOOL gdsSetProbeDetection(BOOL used)
{
	return pgdsSetProbeDetection(used);
}

BOOL gdsGetProbeDetection()
{
	return pgdsGetProbeDetection();
}

BOOL gdsGetMouseMode()
{
	return pgdsGetMouseMode();
}

void gdsSetAutomaticMouse(BOOL state)
{
	pgdsSetAutomaticMouse(state);
}

BOOL gdsGetAutomaticMouse()
{
	return pgdsGetAutomaticMouse();
}

void gdsSetMouseModeEx(int state)
{
	pgdsSetMouseModeEx(state);
}

int gdsGetMouseModeEx()
{
	return pgdsGetMouseModeEx();
}

void gdsSetUseMouse(BOOL state)
{
	pgdsSetUseMouse(state);
}

BOOL gdsGetUseMouse()
{
	return pgdsGetUseMouse();
}

long gdsGetNewProbe()
{
	return pgdsGetNewProbe();
}
// end gds low level
//////////////////////////////////////////////////////////////////////////////////////////////

