#pragma once
#include "armbase.h"
#include "RomerEurope/Gdsdllex.h"

class RomerEuropeArm :
	public ArmBase
{
public:
	RomerEuropeArm(void);
	virtual ~RomerEuropeArm(void);

	virtual bool ConnectToArm(const int dof);
	//virtual bool PopCommSettingsDlg();
	virtual BOOL DisconnectFromHardware();
	virtual BOOL GetAllData();
	virtual BOOL GetPos();
	virtual BOOL GetJoints(bool simulate=true);
	virtual int GetButtonStates();
	virtual BOOL CheckButton(int but, int* duration);
	//virtual BOOL GetTemp();
	virtual int GetProbeNumber();
	virtual int GetButtonCount();

	virtual void SetProbeNumber(int ProbeNum);
	virtual BOOL ValidateCurrentProbe();
	virtual void SetProbeAutoDetect(BOOL ad);

	//virtual BOOL SetVolumeLevel( int VolumeLevel );
	virtual void OutputSpeakerSound( int frequency, int duration );
	virtual void ArmBeep(int sound);

	virtual BOOL IsRemoteMouseEnabled();
	virtual void ToggleRemoteMouse();
	virtual void RemoteMouse(BOOL flag);

	virtual void DoArmSettings();

	virtual BOOL IsRomer();
	virtual BOOL IsFaro();
	virtual BOOL IsFaroUSB();
	virtual BOOL IsFrenchRomer();
	virtual BOOL IsSNL();
	virtual BOOL IsMetrisGarda();

private:
	BOOL SetRegistryValue(HKEY hOpenKey, LPCTSTR szKey, LPCTSTR szValue, LPCTSTR szData, LPCTSTR exePath);
	bool SetExePath();	// this is due to the fact that the French Romer dll's include some OLD API dll's, and it won't run without them!
};
