// RomerPathSet.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "RomerPathSet.h"
#include "RomerPathSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// RomerPathSetApp

BEGIN_MESSAGE_MAP(RomerPathSetApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// RomerPathSetApp construction

RomerPathSetApp::RomerPathSetApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only RomerPathSetApp object

RomerPathSetApp theApp;


// RomerPathSetApp initialization

BOOL RomerPathSetApp::InitInstance()
{
	//AfxMessageBox(_T("RomerPathSetApp::InitInstance..."));

	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	//SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	//AfxMessageBox(_T("calling SetRomerAppPath..."));
	SetRomerAppPath();

	//RomerPathSetDlg dlg;
	//m_pMainWnd = &dlg;
	//INT_PTR nResponse = dlg.DoModal();
	//if (nResponse == IDOK)
	//{
	//	// TODO: Place code here to handle when the dialog is
	//	//  dismissed with OK
	//}
	//else if (nResponse == IDCANCEL)
	//{
	//	// TODO: Place code here to handle when the dialog is
	//	//  dismissed with Cancel
	//}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
bool RomerPathSetApp::SetRomerAppPath()
{
	//AfxMessageBox(_T("in SetRomerAppPath..."));

	// get the WinRDS install path...
	HKEY hRDSKey;
	if (!RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\Romer\\WinRDS\\2.2\\General"), 0, KEY_READ, &hRDSKey) == ERROR_SUCCESS)	// 2003.10.21 - Brian Frohlich @ Romer promises this will never change!!
	{
		TRACE0("Could not open WinRDS key.  Maybe Cimcore is not installed.");
		CString m;
		m.Format(_T("Could not OPEN WinRDS registry key.\nRe-install Romer Cimcore (3.1 or later) and try again."));
		AfxMessageBox(m);
		return false;
	}

	DWORD reg_type;
	DWORD buf_size = MAX_PATH;
	TCHAR buf[MAX_PATH];
	buf[0]=NULL;
	// 2003.10.27 - NOTE - This was reading the "Directory" instead of the "InstallDirectory", per Brian's advise.  It should read the InstallDirectory though, that is ALWAYS where the
	// dll's will be.  The "Directory" is in fact the "destination folder which will contain the ArmData folder" selected by the user when Romer's LoadArmData.exe is run
	if (!RegQueryValueEx(hRDSKey, _T("InstallDirectory"), 0, &reg_type, (LPBYTE)buf, &buf_size) == ERROR_SUCCESS)	// 2003.10.21 - again, Brian Frohlich @ Romer promises this will never change!!
	{
		TRACE0("Could not query WinRDS key.  Maybe Cimcore is not installed.");
		CString m;
		m.Format(_T("Could not QUERY WinRDS registry key.\nRe-install Romer Cimcore (3.1 or later) and try again."));
		AfxMessageBox(m);
		RegCloseKey(hRDSKey);
		return false;
	}
	CString RDSDir;
	RDSDir.Format(_T("%s"), buf);
	TRACE1("Romer InstallDirectory = %s\n", RDSDir );
	RegCloseKey(hRDSKey);

	if(RDSDir.IsEmpty())
	{
		TRACE0("Empty Directory sub-key in Romer's key...\n");
		CString m;
		m.Format(_T("Romer WinRDS registry key is empty.\nThis normally indicates that Romer Cimcore has been un-installed.\nRe-install Romer Cimcore (2.3.5 or later) and try again."));
		AfxMessageBox(m);
		return false;
	}

	// set the SA Arms.exe App Path...
	HKEY key;
	TRACE0("Opening key...\n");
	LONG r = RegOpenKeyEx( HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\SA Arms.exe"), 0, KEY_READ | KEY_WRITE, &key );
	if (r != ERROR_SUCCESS)
	{
		TRACE0("(1) Could not open SA Arms.exe path key...\n");
		SECURITY_ATTRIBUTES sa;
		PSECURITY_DESCRIPTOR pSD = NULL;

		// Initialize a security attributes structure.
		sa.nLength = sizeof (SECURITY_ATTRIBUTES);
		sa.lpSecurityDescriptor = pSD;
		sa.bInheritHandle = FALSE;
		HKEY hkSub = NULL;
		DWORD dwDisposition;

		r = RegCreateKeyEx(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\SA Arms.exe"), 0, _T(""), 0, KEY_READ | KEY_WRITE, &sa, &hkSub, &dwDisposition);
		if (r != ERROR_SUCCESS)
		{
			TRACE0("Could not create SA Arms.exe path key...\n");
			CString m;
			m.Format(_T("Could not CREATE SA Romer registry key."));
			AfxMessageBox(m);
			return false;
		}
	}

	r = RegOpenKeyEx( HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\SA Arms.exe"), 0, KEY_READ | KEY_WRITE, &key );
	if (r != ERROR_SUCCESS)
	{
		TRACE0("(2) Could not open SA Arms.exe path key...\n");
		CString m;
		m.Format(_T("Could not OPEN SA Romer registry key."));
		AfxMessageBox(m);
		return false;
	}

	DWORD valtype = REG_SZ;

	TRACE2("buf = %s, bufsize = %d\n", buf, buf_size);

	CString defsubkey;	// empty string sets the "(Default)" key value

	//CString diag;
	//diag.Format(_T("REDDir = %s, buf = %s, size = %d"), RDSDir, buf, buf_size);
	//AfxMessageBox(diag);

	r = RegSetValueEx(key, defsubkey, 0, valtype, (LPBYTE)buf, buf_size);
	if (r != ERROR_SUCCESS)
	{
		TRACE0("Could not set SA Arms.exe Default key value...\n");
		//return false;
	}
	
	// ...and finally, set the Path key...
	CString subkey("Path");
	r = RegSetValueEx(key, subkey, 0, valtype, (LPBYTE)buf, buf_size);
	//diag.Format(_T("REDDir = %s, buf = %s, size = %d"), RDSDir, buf, buf_size);
	//AfxMessageBox(diag);
	if (r != ERROR_SUCCESS)
	{
		TRACE0("Could not set SA Arms.exe Path key value...\n");
		CString m;
		m.Format(_T("Could not SET SA Romer registry sub-key Path value."));
		AfxMessageBox(m);
		return false;
	}

	RegCloseKey( key );

	// Now get rid of those Romer dll's in our install directory.  They have to be there now, so the 'unified' SA Arms.exe will run the other arms!

	// 2004.09.07 - now, we are Delay-Loading the arm specific dll's, so we can now remove the 'dummy' dll's from the SA install 
	// (see see CDPCMMApp::EstablishArm_Romer() for more info), so we can disable the following code which deletes the 'dummy' dll's
	// in BOTH the current dir, and the SA install dir (generally, they would be the same directory)...

/*
	// Get the SA exe path (same as the Romer dll's)...
	CString regexepath(_T("EXE Path"));
	// attempt to locate SA exe
	HKEY hKey;
	CString regentry ("Software\\New River Kinematics\\Spatial Analyzer\\Log");
	if (!RegOpenKeyEx(HKEY_CURRENT_USER,regentry,0,KEY_READ,&hKey) == ERROR_SUCCESS)
	{
		CString m;
		m.Format(_T("Could not open SA path key."));
		AfxMessageBox(m);
		return false;
	}
	
	DWORD sa_reg_type;
	DWORD sa_buf_size = MAX_PATH;
	TCHAR sa_buf[MAX_PATH];
	sa_buf[0]=NULL;
	if (!RegQueryValueEx(hKey,regexepath,0,&sa_reg_type,(LPBYTE)sa_buf,&sa_buf_size) == ERROR_SUCCESS)
	{
		CString m;
		m.Format(_T("Could not query SA path key."));
		AfxMessageBox(m);
		RegCloseKey(hKey);
		return false;
	}
	CString SAPath(sa_buf);
	RegCloseKey(hKey);
	int slash = SAPath.ReverseFind('\\');
	CString SADirectory(SAPath.Left(slash));
	SADirectory += _T("\\");

	// ...AND, delete those in the current directory (should be the same thing)...
	CString thisPath(AfxGetApp()->m_pszHelpFilePath);
	slash = thisPath.ReverseFind('\\');
	CString thisDirectory(thisPath.Left(slash));
	thisDirectory += _T("\\");

	// Now delete the 'placeholder' dll's.  Report error deleting, but ONLY if error in current dir, SA dir from reg. MAY not be valid (ideally, will be the same folder!)...
	bool ret = true;

	CString lgpsPath(thisDirectory);
	lgpsPath += _T("Lgps.dll");
	if(!DeleteFile(LPCTSTR(lgpsPath)))
	{
		TRACE1("could not delete '%s'\n", lgpsPath);
		ret = false;
	}
	lgpsPath = SADirectory;
	lgpsPath += _T("Lgps.dll");
	DeleteFile(LPCTSTR(lgpsPath));

	CString rxxcPath(thisDirectory);
	rxxcPath += _T("RXXC.DLL");
	if(!DeleteFile(LPCTSTR(rxxcPath)))
	{
		TRACE1("could not delete '%s'\n", rxxcPath);
		ret = false;
	}
	rxxcPath = SADirectory;
	rxxcPath += _T("RXXC.DLL");
	DeleteFile(LPCTSTR(rxxcPath));

	CString wrdsPath(thisDirectory);
	wrdsPath += _T("WINRDS.DLL");
	if(!DeleteFile(LPCTSTR(wrdsPath)))
	{
		TRACE1("could not delete '%s'\n", wrdsPath);
		ret = false;
	}
	wrdsPath = SADirectory;
	wrdsPath += _T("WINRDS.DLL");
	DeleteFile(LPCTSTR(wrdsPath));

	CString xdatPath(thisDirectory);
	xdatPath += _T("xdat.dll");
	if(!DeleteFile(LPCTSTR(xdatPath)))
	{
		TRACE1("could not delete '%s'\n", xdatPath);
		ret = false;
	}
	xdatPath = SADirectory;
	xdatPath += _T("xdat.dll");
	DeleteFile(LPCTSTR(xdatPath));

	CString m,n;
	m.Format(_T("SA Romer interface will now look in\n%s\nfor Romer RDS dll's."), buf);
	if(ret)
		n.Format(_T("\n\nPlace holder Romer dll's have been removed from\n%s"), thisDirectory);
	else
		n.Format(_T("\n\nCould not delete all place holder Romer dll's from\n'%s'\nUnless they are already deleted, ensure that all are NOT read only, and try again."), thisDirectory);
	m += n;
	if(ret)
		AfxMessageBox(m, MB_ICONINFORMATION);
	else
		AfxMessageBox(m, MB_ICONEXCLAMATION);

	return true;
*/
	CString m;
	m.Format(_T("SA Romer interface will now look in\n%s\nfor Romer RDS dll's."), buf);
	AfxMessageBox(m, MB_ICONINFORMATION);
	return true;
}