#pragma once
#include "afx.h"

class PadCalPoint;

class EasyPadWrapper :
	public CObject
{
public:
	EasyPadWrapper();
	virtual ~EasyPadWrapper(void);

	friend class EasyPad;

	// build a pad
	void SetPadBoundaries(const Vector& topLeft, const Vector& bottomRight, const double& workingHeight, const double& hotHeight);
	DWORD_PTR AddRectangularPadButton(const Vector& topLeft, const Vector& bottomRight, const double& pressHeight);

	// Input commands, requests
	void BeginCal();
	void AddCalPt(const Vector& instXYZ, const double& instPlanarOffset);
	void ClearCalPts();
	bool CalibratePad();
	void CheckPosition(Vector instXYZ, double instOffset);
	bool IsPadCalibrated();
	bool IsOn();
	void SwitchOn();
	void SwitchOff();

	// Outputs
	virtual void OnEnterPadWorkingZone();
	virtual void OnEnterPadHotZone();
	virtual void OnExitPadZone();
	virtual void OnEnterButtonZone(DWORD_PTR buttonIdx);
	virtual void OnExitButtonZone(DWORD_PTR buttonIdx);
	virtual void OnPadButtonHit(DWORD_PTR buttonIdx);
	virtual void SetAllButtonZonesDead();	// to un-hilight all buttons if UI is showing

	virtual void Serialize(CArchive& ar);
protected:
	DECLARE_SERIAL( EasyPadWrapper );
	EasyPad& pad;

private:
	bool isCalibrating;
	bool isOn;
};
