#include "stdafx.h"
#include "PadButtonRectangular.h"
#include "PadRegionRectangular.h"

PadButtonRectangular::PadButtonRectangular(void)
: boundary(*new PadRegionRectangular)
{
}

PadButtonRectangular::PadButtonRectangular(const PadButtonRectangular& source)
: boundary(*new PadRegionRectangular)
{
	operator=(source);
}
void PadButtonRectangular::operator=(const PadButtonRectangular& source)
{
	boundary = source.boundary;
}

PadButtonRectangular::~PadButtonRectangular(void)
{
	delete &boundary;
}

void PadButtonRectangular::SetLocationInPad(const Vector& tL, const Vector& bR)
{
	boundary.topLeft = tL;
	boundary.bottomRight = bR;
}

bool PadButtonRectangular::CheckForPress(const Vector& xyz, bool& enterButtonZone, bool& exitButtonZone, bool& buttonDown)
{
	enterButtonZone = false;
	exitButtonZone = false;
	buttonDown = false;

	if(xyz.z >= pressHeight && pressed)
	{
		pressed = false;
		boundary.inHotZone = true;
		return true;
	}

	if(boundary.PointInRegion(xyz))
	{
		if(xyz.z < pressHeight)
		{
			if(!pressed)
			{
				//PlaySound(_T("Windows User Account Control.wav"), NULL, SND_FILENAME | SND_ASYNC);
				MessageBeep(MB_ICONWARNING);
				//Beep(900,100);
			}
			pressed = true;
			buttonDown = true;
			if(!boundary.inHotZone)
			{
				enterButtonZone = true;
			}
			boundary.inHotZone = true;
			return false;
		}

		if(!boundary.inHotZone)
		{
			enterButtonZone = true;
			boundary.inHotZone = true;
			return false;
		}
		boundary.inHotZone = true;
		return false;
	}
	if(boundary.inHotZone)
	{
		exitButtonZone = true;
	}
	boundary.inHotZone = false;
	return false;
}

void PadButtonRectangular::SetZonesDead()
{
	PadButton::SetZonesDead();
	boundary.inHotZone = false;
	boundary.inWorkingZone = false;
}