#if !defined(_TOOLS_H_)
#define _TOOLS_H_
#define  WM_BUTTONMESSAGE					  (WM_USER + 100)

#define  ALL_OK								  0x0000
#define  SCANWORKS_PART_CONNECT				  0x0D00
#define  SCANWORKS_PART_CONNECT_HS			  0x0D01
#define  SCANWORKS_PHASE_START				  0x0D10
#define  SCANWORKS_PHASE_START_HS			  0x0D11	
#define  SCANWORKS_SCAN_REGION_START		  0x0D20
#define  SCANWORKS_SCAN_REGION_START_HS		  0x0D21
#define  SCANWORKS_SCAN_LINE				  0x0D30
#define  SCANWORKS_SCAN_LINE_HS				  0x0D31
#define	 SCANWORKS_SCAN_DATA				  0x0D40
#define  SCANWORKS_SCAN_DATA_HS				  0x0D41
#define  SCANWORKS_TOUCH_HEADER				  0x0D52
#define  SCANWORKS_TOUCH_DATA				  0x0D53
#define  SCANWORKS_TOUCH_CURSOR				  0x0D54
#define  SCANWORKS_TOUCH_CURSOR_DATA		  0x0D55
#define  SCANWORKS_SCAN_REGION_STOP			  0x0E20
#define  SCANWORKS_SCAN_REGION_STOP_HS		  0x0E21
#define  SCANWORKS_PHASE_STOP				  0x0E10
#define  SCANWORKS_PHASE_STOP_HS			  0x0E11
#define	 SCANWORKS_PART_DISCONNECT			  0x0E00
#define	 SCANWORKS_PART_DISCONNECT_HS		  0x0E01
#define  SCANWORKS_MODEL_START				  0x0F20
#define  SCANWORKS_MODEL_STOP				  0x0F21
#define  SCANWORKS_CURSOR_SCANLINE			  0x0F22
#define  SCANWORKS_SCANLINE_CURSOR_DATA		  0x0F23
#define  SCANWORKS_STOP_SCAN				  0x0F40
#define  SCANWORKS_START_SCAN				  0x0F41
#define  SCANWORKS_SHOW_DIAGNOSTICS			  0x0F50
#define  SCANWORKS_SHOW_FUNCTIONS			  0x0F51
#define  SCANWORKS_SET_UNITS			      0x0F52
#define  SCANWORKS_GET_UNITS			      0x0F53
#define  SCANWORKS_SET_REMOTEMOUSE			  0x0F54
#define  SCANWORKS_GET_REMOTEMOUSE			  0x0F55
#define  SCANWORKS_GET_PROBEID				  0x0F56
#define  SCANWORKS_GET_PROBEINFO			  0x0F57
#define  SCANWORKS_GET_CURSOR				  0x0F58
#define  SCANWORKS_SET_CURSOR				  0x0F59
#define  SCANWORKS_GET_SOUND				  0x0F60
#define	 SCANWORKS_SET_SOUND				  0x0F61
#define  SCANWORKS_GET_VERSION				  0x0F62
#define  SCANWORKS_SHOW_SENSORSETTINGS		  0x0F70
#define  SCANWORKS_SHOW_CALDIAG				  0x0F71
#define  SCANWORKS_SHOW_AUTOEXPDIAG			  0x0F72
#define  SCANWORKS_SHOW_IDMDIAG				  0x0F73
#define  SCANWORKS_SHOW_TOOLBAR				  0x0F74
#define  SCANWORKS_HIDE_TOOLBAR				  0x0F75
#define  SCANWORKS_SHOW_STATUS				  0x0F76
#define  SCANWORKS_HIDE_STATUS				  0x0F77
#define  SCANWORKS_SET_PARENTHWND			  0x0F78
#define  SCANWORKS_SET_MOVERNOTIFY			  0x0F79
#define  SCANWORKS_MOVERNOTIFY				  0x0F7A
#define  SCANWORKS_MOVERNOTIFY_PART			  0x0F7B
#define  SCANWORKS_MOVERNOTIFY_HS			  0x0F7C
#define  SCANWORKS_GET_TOUCH_SETTINGS		  0x0F7D
#define  SCANWORKS_SET_TOUCH_SETTINGS		  0x0F7E
#define  SCANWORKS_SHOW_USERDIAG			  0x0F7F
#define  SCANWORKS_MOVER_CONNECT			  0x0F80
#define  SCANWORKS_MOVER_DISCONNECT			  0x0F81
#define  SCANWORKS_SET_STOP_SCAN_KEY		  0x0F82
#define  SCANWORKS_GET_PROBE				  0x0F83
#define  SCANWORKS_SET_PROBE				  0x0F84
#define  SCANWORKS_GET_PROFILES				  0x0F85
#define  SCANWORKS_GET_ACTIVE_PROFILE		  0x0F86
#define  SCANWORKS_SET_ACTIVE_PROFILE		  0x0F87
#define  SCANWORKS_GET_IDM_PROFILES			  0x0F88
#define  SCANWORKS_GET_ACTIVE_IDM_PROFILE	  0x0F89
#define  SCANWORKS_SET_ACTIVE_IDM_PROFILE	  0x0F90
#define  SCANWORKS_SET_PROBENOTIFY            0x0F91
#define  SCANWORKS_PROBENOTIFY                0x0F92
#define  SCANWORKS_PROBENOTIFY_PART	          0x0F93
#define  SCANWORKS_PROBENOTIFY_HS	          0x0F94
#define  SCANWORKS_TRANSFORM_VALID			  0x0F95
#define  SCANWORKS_GET_TIPQUALS             0x0F96
#define  SCANWORKS_GET_ACTIVE_TIPQUAL       0x0F97
#define  SCANWORKS_SET_ACTIVE_TIPQUAL       0x0F98

#define  SCANWORKS_CLOSE_NOTIFY				  0xFF00
#define  SCANWORKS_CLOSE_DIAGNOSTICS		  0xFF50
#define  SCANWORKS_CLOSE_FUNCTIONS			  0xFF51
#define  SCANWORKS_CLOSE_SENSORSETTINGS		  0xFF70
#define  SCANWORKS_CLOSE_CALDIAG			  0xFF71
#define  SCANWORKS_CLOSE_AUTOEXPDIAG		  0xFF72
#define  SCANWORKS_CLOSE_IDMDIAG			  0xFF73


#define MAX_FILE_NAME_LENGTH 256

typedef struct
{
	int			model_number;
	char		model_name[MAX_FILE_NAME_LENGTH];
	int			serial_number;
} stSWPartConnect;

typedef struct
{
	int			status;
	int			model_number;
	char		model_name[MAX_FILE_NAME_LENGTH];
	int			serial_number;
} stSWPartConnectHS;


typedef struct
{
	int			ID;
	float		diameter;
	float		X;
	float		Y;
	float		Z;
	float		Roll;
	float		Pitch;
	float		Yaw;
} stSWTouchprobeConnect;

typedef struct
{
	int			status;
	int			ID;
	float		diameter;
	float		X;
	float		Y;
	float		Z;
	float		Roll;
	float		Pitch;
	float		Yaw;
} stSWTouchprobeConnectHS;

typedef struct
{
	int			phase_number;
	char		phase_name[MAX_FILE_NAME_LENGTH];
} stSWPhase;

typedef struct
{
	int			status;
	int			phase_number;
	char		phase_name[MAX_FILE_NAME_LENGTH];
} stSWPhaseHS;


typedef struct
{
    int			scan_number;
	char		scan_name[MAX_FILE_NAME_LENGTH];
	int			process_switch;
} stSWScanRegion;

typedef struct
{
	int			status;
    int			scan_number;
	char		scan_name[MAX_FILE_NAME_LENGTH];
	int			process_switch;
} stSWScanRegionHS;


typedef struct
{
    char		sensor_id[MAX_FILE_NAME_LENGTH];
    int			acquisition_number;
    int			num_xyzs;
	int			Status;
	int			logical_machine;
	float		machine_X;
	float		machine_Y;
	float		machine_Z;
	float		machine_Roll;
	float		machine_Pitch;
	float		machine_Yaw;
} stSWScanLine;

typedef struct
{
	int			num_scanlines;
} stSWGridHeader;

typedef struct
{
	int			state;
} stSWRemoteMouse;

typedef struct
{
	int			state;
} stSWUnits;

typedef struct
{
	int			ID;
	float		diameter;
} stSWProbeInfo;

typedef struct
{
	int			ID;
	float		diameter;
	float		X;
	float		Y;
	float		Z;
	float		Roll;
	float		Pitch;
	float		Yaw;
} stSWProbeInfoEx;

typedef struct
{
	int			state;
} stSWSound;

typedef struct
{
	int			state;
} stSWCursor;

typedef struct
{
	int		Major;
	int		Minor;
	int		Build;
} stSWVersion;

#define MOVER_MBUTTON_NOTIFY 0x0001
#define MOVER_OBUTTON_NOTIFY 0x0002
#define MOVER_OBUTTON_HOLD_NOTIFY 0x0004

typedef struct
{
	int	ButtonFlags;
} stSWMoverInfo;

typedef struct
{
	int	ButtonFlag;
} stSWMoverButtons;

typedef struct
{
	int	status;
	int	ButtonFlag;
} stSWMoverButtonsHS;

typedef struct
{
	HWND	hWnd;
} stSWParentHWND;

#define TOUCH_SINGLE_POINT_MODE 0x0000
#define TOUCH_CONTINUTIOUS_TIME_MODE 0x0001
#define TOUCH_CONTINUTIOUS_DISTANCE_MODE 0x0002

typedef struct
{
	int	mode;
	int	TimeInterval;
	int	DistanceInterval;
} stSWTouchSettings;

typedef struct
{
	int	stopKey;
} stStopScanKey;

#define TOUCH_PROBE_TYPE 0x0000
#define SCAN_PROBE_TYPE 0x0001

typedef struct
{
	int	type;
} stSWProbeSettings;

typedef struct
{
	int	status;
	int	num_profiles;
} stSWGetProfilesReply;

typedef struct
{
	int	status;
	char	profile_name[MAX_FILE_NAME_LENGTH];
} stSWGetActiveProfileReply;

typedef struct
{
	char	profile_name[MAX_FILE_NAME_LENGTH];
} stSWSetActiveProfileRequest;

typedef struct
{
	int	status;
	char	profile_name[MAX_FILE_NAME_LENGTH];
} stSWSetActiveProfileReply;

typedef struct
{
	int	NotifyFlag;
} stSWProbeChangeNotify;

typedef struct
{
	int	type;                      // current stSWProbeSettings
	int	ID;                        // current stSWProbeInfo
	float	diameter;
	int	mode;                      // current stSWProbeTouchSettings
	int	TimeInterval;
	int	DistanceInterval;
} stSWProbeChange;

typedef struct
{
	int	status;
	int	type;                      // current stSWProbeSettings
	int	ID;                        // current stSWProbeInfo
	float	diameter;
	int	mode;                      // current stSWProbeTouchSettings
	int	TimeInterval;
	int	DistanceInterval;
} stSWProbeChangeHS;

typedef struct
{
	int State;
} stSWCloseNotify;

typedef struct
{
	int Valid;
} stSWIsTransformValid;

#endif // !defined(_TOOLS_H_)