// SocketGeometry.cpp: implementation of the SocketGeometry class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "nrkapp.h"
#include "SocketGeometry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SocketGeometry::SocketGeometry()
{
}

SocketGeometry::~SocketGeometry()
{

}
/*
void SocketGeometry::SetNameAndNotes(CString& Name, CStringArray& Notes, 
												 char name[NOTE_SIZE], WORD* numnotes, char  notes[NOTE_LINES][NOTE_SIZE] )
{
	sprintf(name, "%s", Name );
	*numnotes = Notes.GetSize();
	if (Notes.GetSize() > NOTE_LINES)
		*numnotes = NOTE_LINES;
	for (int i=0;i<*numnotes;i++)
		sprintf(notes[i],"%s",Notes[i]);
}
*/

BOOL SocketGeometry::SendLine(Vector& a, Vector& b, BYTE DrawArrow, CString& Name, CStringArray& Notes)
{
	Vector PtA(a);
	PtA.Scale(app.saarm.LocalToInches);
	Vector PtB(b);
	PtB.Scale(app.saarm.LocalToInches);
	SAIPGeomLine s;
	s.PtA= PtA;
	s.PtB = PtB;
	s.DrawArrow = DrawArrow;
	s.Name = Name;

	for(int i=0; i<Notes.GetSize(); i++)
		s.Notes.Add(Notes[i]);

	app.GetSAIB()->QS.SendPacket(s);

	return TRUE;
}

BOOL SocketGeometry::SendCircle( Transform& CircleTrans, double Radius, CString& Name, CStringArray& Notes, double Span)
{
	SAIPGeomCircle s;
	Vector pos;
	CircleTrans.GetTranslation(&pos);
	pos.Scale(app.GetSAIB()->LocalToInches);
	CircleTrans.SetTranslation(pos);
	s.ObjectToInst = CircleTrans;
	s.Radius = Radius * app.GetSAIB()->LocalToInches;
	s.Name = Name;

//	CString m;
//	m.Format("Sending Circle: Radius=%f, Pos: X=%f,Y=%f,Z=%f", Radius,pos.x,pos.y,pos.z);
//	AfxMessageBox(m);

	for(int i=0; i<Notes.GetSize(); i++)
		s.Notes.Add(Notes[i]);

	app.GetSAIB()->QS.SendPacket(s);

	return TRUE;
}

BOOL SocketGeometry::SendSphere( Vector& Center, double Radius, CString& Name, CStringArray& Notes)
{
	Vector cent(Center);
	cent.Scale(app.GetSAIB()->LocalToInches);
	
	SAIPGeomSphere s;
	s.Center = cent;
	s.Radius = Radius * app.GetSAIB()->LocalToInches;// * UnitsToMeters;

	s.Name = Name;

	for(int i=0; i<Notes.GetSize(); i++)
		s.Notes.Add(Notes[i]);

	app.GetSAIB()->QS.SendPacket(s);
	return TRUE;
}

BOOL SocketGeometry::SendCylinder( Vector& a, Vector& b, double Diameter, CString& Name, CStringArray& Notes)
{
	Vector PtA(a);
	PtA.Scale(app.GetSAIB()->LocalToInches);
	Vector PtB(b);
	PtB.Scale(app.GetSAIB()->LocalToInches);
	
	SAIPGeomCylinder s;
	s.PtA = PtA;
	s.PtB = PtB;
	s.Diameter = Diameter * app.saarm.LocalToInches;

	s.Name = Name;

	for(int i=0; i<Notes.GetSize(); i++)
		s.Notes.Add(Notes[i]);

	app.GetSAIB()->QS.SendPacket(s);
	
	return TRUE;
}

BOOL SocketGeometry::SendPlane( Transform& PlaneTrans, CObArray& pts, CString& Name, CStringArray& Notes)
{
	SAIPGeomPlane s;
	s.ObjectToInst.Set(PlaneTrans);
	s.ObjectToInst.Scale(app.GetSAIB()->LocalToInches);

	for (int i=0;i<pts.GetSize();i++)
	{
		Vector v = *((Vector*)pts[i]);
		v.Scale(app.GetSAIB()->LocalToInches);
		s.PerimPts.P.Add(new Vector(v));
	}

	s.Name = Name;

	for(int i=0; i<Notes.GetSize(); i++)
		s.Notes.Add(Notes[i]);

	app.GetSAIB()->QS.SendPacket(s);

	return TRUE;
}

BOOL SocketGeometry::SendCone( Transform& ConeTrans, double includedAngle, double graphicLength, CString& Name, CStringArray& Notes)
{
	SAIPGeomCone c;
	Vector pos;
	ConeTrans.GetTranslation(&pos);
	pos.Scale(app.GetSAIB()->LocalToInches);
	ConeTrans.SetTranslation(pos);
	c.ObjectToInst = ConeTrans;
	c.includedAngle = includedAngle;
	c.graphicLength = graphicLength * app.GetSAIB()->LocalToInches;
	c.Name = Name;

	//	CString m;
	//	m.Format("Sending Circle: Radius=%f, Pos: X=%f,Y=%f,Z=%f", Radius,pos.x,pos.y,pos.z);
	//	AfxMessageBox(m);

	for(int i=0; i<Notes.GetSize(); i++)
		c.Notes.Add(Notes[i]);

	app.GetSAIB()->QS.SendPacket(c);

	return TRUE;
}