//
// TextFile Class.
/////////////////////////////////////////////////////////////////////////////  

#include "stdafx.h"
#include "textfile.h"
#include <ctype.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif       
                           
TextFile::TextFile()
{
	LineNumber = 1;
	ReuseString = 0;
	CommentSignal = CString("//"); 			// c++ style commenting assumed.
	IgnoreComments = TRUE;
	ConvertTabsToSpaces = FALSE;
}
TextFile::~TextFile()
{}

// scan convert different numerical values to their data types.
void TextFile::ScanString( CString& a, double* pDbl )    
{
	*pDbl = _wtof( a );  
}
void TextFile::ScanString( CString& a, float* pFlt )    
{
	double x;
	x = _wtof(a);
	*pFlt = (float) x;					// typecast.    CFile
} 
void TextFile::ScanString( CString& a, int* pInt )    
{
	*pInt = _wtoi(a);  
}
// read the next string from a file.  skip comments, and indicate string type!
int TextFile::NextString( CString& OutString )
{  
	CString String;
	// gets the next string in the program  
	if (ReuseString)  
	{
		String = LastString;
		ReuseString = FALSE;        // jmc 9-25-95
	}
	else do
	{
		if (fscanf(m_pStream,"%s",buf) == EOF) 
			return IS_EOF;
		String = buf;  
		if (IgnoreComments)
			if (String.Find( _T("//") )== 0)       // if this string begins with a comment. 
			{             
				CString temp;
				if (GetLine(temp) == IS_EOF)              // get the rest of the line!
					return IS_EOF;   
				String = "";
				continue;			// fscanf another string from the stream to see if it is not a comment.
         }
	} while(String.GetLength()==0);			// ignore empty stings (blank lines!)	
   
   OutString = String;
	LastString = String;          // transfer
	ReuseString = FALSE; 
	// now, determine the string type!  return IS_NUMBER if -,digit,or .
	if (isdigit(String[0]) || String[0]=='-' || String[0]=='.' || String[0]=='+')
		return IS_NUMBER;
	return IS_OTHER;
}
int TextFile::GetLine( CString& OutString )
{  
	// gets the next line in the program    
	if (ReuseString)             // initialize to either last string, or other info. 
	{
		OutString = LastString;
		ReuseString = FALSE;
		return IS_OTHER;
	}
	do
	{
		if (ReadString(buf,MAX_TEXT_BUF) == NULL)  
			return IS_EOF;
		buf[ lstrlen(buf)-1 ] = ' ';		
		OutString = buf;
	}  while(OutString.GetLength()==0);			// ignore empty stings (blank lines!) 
	
	LastString = OutString;	
	return IS_OTHER;
} 
int TextFile::NextNumber( double* x )
{            
	CString txt;    
	int ret;
	if ( (ret=NextString( txt )) != IS_NUMBER)     
	{
		*x = 0.0;			// set to zero just in case user does not check the return value.
		return ret;       // get out if there is no number.
	} 
	ScanString( txt, x );			// extract the numeric value.
	return IS_NUMBER;	
}
int TextFile::NextNumber( float* x )
{            
	CString txt;    
	int ret;
	if ( (ret=NextString( txt )) != IS_NUMBER)     
	{
		*x = (float)0.0;			// set to zero just in case user does not check the return value.
		return ret;       // get out if there is no number.
	} 
	ScanString( txt, x );			// extract the numeric value.	
	return IS_NUMBER;	
}
int TextFile::NextNumber( int* x )
{            
	CString txt;    
	int ret;
	if ( (ret=NextString( txt )) != IS_NUMBER)     
	{
		*x = 0;			// set to zero just in case user does not check the return value.
		return ret;       // get out if there is no number.
	} 
	ScanString( txt, x );			// extract the numeric value.	
	return IS_NUMBER;	
}    
BOOL TextFile::Append( CString& path )
{
	// append the current text file with another text file! 
	TextFile f;
	if (!f.Open(path,CFile::modeRead))
	{  
		CString t("Could not open Text File: ");
		t += path;
		AfxMessageBox(t);
		return FALSE;
	}   
	Append( f );        
	f.Close();    
	return TRUE;
}
BOOL TextFile::Append( TextFile& f )
{   
	for (;;)
	{
		char a = getc( f.m_pStream );		// get an input character.
		if (ConvertTabsToSpaces && a=='\t')
			a = ' ';
		if (a==EOF)
			break;
		putc( a, m_pStream );			// write to THIS file.
	}
	return TRUE;
}
