// New River Kinematics 
//
// TextFile Class.
/////////////////////////////////////////////////////////////////////////////  
#define MAX_TEXT_BUF  400      // size of single string read buffer!

class TextFile : public CStdioFile
{
public:
	BYTE IgnoreComments;				// if true, the comment string signals that all other text on the line should be ignored.!  
	BYTE ConvertTabsToSpaces;
	CString CommentSignal;
	UINT LineNumber;        // keeps track of the lines passed since construction.! 
	BYTE ReuseString;			// if set to true, when a new string is requested, the calling function
									// is given the previous string instead.  
	CString LastString;

	TextFile();
	~TextFile(); 
	int GetLine( CString& string );  
	int NextNumber( double* x );
	int NextNumber( float* x );
	int NextNumber( int* x );
	int NextString( CString& string ); 
	void ScanString( CString& a, double* p );    
	void ScanString( CString& a, float* p );    
	void ScanString( CString& a, int* p );  
	BOOL Append( CString& path ) ;
	BOOL Append( TextFile& f ) ;
  

protected:
	TCHAR buf[MAX_TEXT_BUF];
};            

// string types that will be recognized upon reading.
#define IS_OTHER    0
#define IS_NUMBER   1
#define IS_EOF      7
