#if !defined(UNITS)
#define UNITS

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Units.h : header file
//

#define MAX_DISTUNITS		5
#define DISTUNITS_IN			0
#define DISTUNITS_M			1
#define DISTUNITS_MM			2
#define DISTUNITS_CM			3
#define DISTUNITS_FT			4

#define MAX_ANGUNITS			5
#define ANGUNITS_D			0
#define ANGUNITS_DMS			1
#define ANGUNITS_R			2
#define ANGUNITS_GG			3
#define ANGUNITS_M			4

#define MAX_PRESSUNITS		6
#define PRESSUNITS_HPA		0
#define PRESSUNITS_MMHG		1
#define PRESSUNITS_INH20	2
#define PRESSUNITS_INHG		3
#define PRESSUNITS_PSIA		4
#define PRESSUNITS_MBAR		5

#define MAX_TEMPUNITS		2
#define TEMPUNITS_C			0
#define TEMPUNITS_F			1


/////////////////////////////////////////////////////////////////////////////
// Units class

class Units : public CObject
{
private:
	
	
public:
	Units();
	virtual ~Units();

	double UnitToMeters[MAX_DISTUNITS];
	CString DistUnitNames[MAX_DISTUNITS];
	
	double UnitToDegrees[MAX_ANGUNITS];
	CString AngUnitNames[MAX_ANGUNITS];

	double UnitTommHg[MAX_PRESSUNITS];
	CString PressUnitNames[MAX_PRESSUNITS];

	double UnitToC[MAX_TEMPUNITS];
	CString TempUnitNames[MAX_TEMPUNITS];
	
	void MakeAngleDisplayString(double& degaz, double& degel, CString* azout, CString* elout);
	double ScaleDistUnits(int From, int To);

	double DegreesToUnit();	// 2011.02.09 - Mantis 3090 - support units for UDP packets
	double InchesToUnit();	// 2011.02.09 - Mantis 3090 - support units for UDP packets

	int distunits;		// designates units for display
	int angunits;
	int pressunits;
	int tempunits;

	double DTR;	// constant, degrees to radians
	double InchesToLocal;	

	static bool		toolBarModeOn;

	virtual void Serialize(CArchive& ar);

protected:   
	DECLARE_SERIAL( Units );

};

/////////////////////////////////////////////////////////////////////////////
#endif // !defined(UNITS)
