#ifndef PERSISTENTWND
#define PERSISTENTWND

namespace PersistentWnd
{
	//-------------------------- routines that you'll most likely use.

	void SaveWndRect(LPCTSTR section, LPCTSTR window, CWnd * pWnd);
	void SaveWndPos(LPCTSTR section, LPCTSTR window, CWnd * pWnd);
	void SaveWndSize(LPCTSTR section, LPCTSTR window, CWnd * pWnd);

	void RestoreWndRect(LPCTSTR section, LPCTSTR window, CWnd * pWnd, BOOL checkVisible = TRUE);
	void RestoreWndPos(LPCTSTR section, LPCTSTR window, CWnd * pWnd, BOOL checkVisible = TRUE);
	void RestoreWndSize(LPCTSTR section, LPCTSTR window, CWnd * pWnd, BOOL checkVisible = TRUE);

	//-------------------------- use internally by the above routines

	BOOL _LoadWndPos(LPCTSTR section, LPCTSTR window, CPoint & pos);
	BOOL _LoadWndSize(LPCTSTR section, LPCTSTR window, CSize & size);
	void _SaveWndPos(LPCTSTR section, LPCTSTR window, CPoint pos);
	void _SaveWndSize(LPCTSTR section, LPCTSTR window, CSize size);

	BOOL WndRectValid(CRect wr);
};

#endif